<?php 

  // Importamos sistema
  require("../sistema.php");

  // Verificamos si es necesario
  verificarFunciónActual(1);

  // Establecemos variables
  $Tipo = $_GET['Tipo'];

  // Vemos que tipo es la consulta
  if($Tipo == 'obtenerActividades'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];

    // Realizamos la petición a la base de datos
    $Sql = "SELECT Id, Titulo, Años, RecursosOnline, Descripcion, Categoria, Etiquetas FROM `Actividades__Actividades`";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      // Establecemos los recursos online   
      $Actividades = array();
      while($Actividad = mysqli_fetch_array($Resultado)){

        $Actividades[] = array(
          "Id" => $Actividad['Id'],
          "Titulo" => $Actividad['Titulo'],
          "Años" => json_decode($Actividad['Años'], true),
          "RecursosOnline" => json_decode($Actividad['RecursosOnline'], true),
          "Descripcion" => $Actividad['Descripcion'],
          "Categoria" => $Actividad['Categoria'],
          "Etiquetas" => json_decode($Actividad['Generos'], true),
        );
      }

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $Actividades;
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-205';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }


  }else if($Tipo == 'obtenerActividad'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Actividad = $_GET['Id'];

    // Realizamos la petición a la base de datos
    $Sql = "SELECT Titulo, Actividades FROM `Actividades__Actividades` WHERE Id = '$Actividad'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Actividad = mysqli_fetch_array($Resultado);

      $Preguntas = array();

      for($i = 0; $i < count($Actividad); $i++){
        $Opciones = array();

        for($o = 0; $o < count($Actividad[$i]['Respuestas']); $o++){
          $Opciones[] = $Actividad[$i]['Respuestas'][$o]['Opcion'];
        }

        $Preguntas = array(
          "Tipo" => $Actividad[$i]['Tipo'],
          "Titulo" => $Actividad[$i]['Titulo'],
          "Opciones" => $Opciones,
        );
      }
      
      // SELECT Ejercicio FROM `Actividades__Pasos` WHERE IdUsuario = "58" ORDER BY Ejercicio DESC LIMIT 1

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $Preguntas;
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-206';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }


  }else{
    $Respuesta['estado'] = 'error';
    $Respuesta['detalle'] = 'Petición errónea';
    $Respuesta['codigo'] = 'API-000';
    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
  }

?>