<?php 

  // Importamos sistema
  require("../sistema.php");

  // Establecemos variables
  $Tipo = $_GET['Tipo'];

  // Vemos que tipo es la consulta
  if($Tipo == 'obtenerDispositivos'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $Institucion = $_SESSION['Institucion'];

    // Validamos que tenga permisos obtenerDispositivos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);
    $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

    if($Datos['obtenerDispositivos'] == true){

      // Obtenemos los dispositivos de la institución
      $Sql = "SELECT * FROM `Dispositivos` WHERE Institucion = '$Institucion'";
      $Resultado = mysqli_query($Conexión, $Sql);

      if($Resultado){

        $Dispositivos = array();

        while($Dispositivo = mysqli_fetch_array($Resultado)){
  
          $Dispositivos[] = array(
            'Id' => $Dispositivo['Id'],
            'Usuario' => $Dispositivo['Usuario'],
            'Institucion' => $Dispositivo['Institucion'],
            'Tipo' => $Dispositivo['Tipo'],
            'Nombre' => $Dispositivo['Nombre'],
            'FechaDeCreacion' => $Dispositivo['FechaDeCreacion'],
            'Version' => $Dispositivo['Version'],
            'Token' => $Dispositivo['Token']
          );
  
        }

        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = $Dispositivos;
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta)); 

      }else{

        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = 'API-098';
        print_r(json_encode($Respuesta)); 

      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Careces de permisos para obtener los dispositivos';
      $Respuesta['codigo'] = 'API-403';
      print_r(json_encode($Respuesta)); 
    }



  }else if($Tipo == 'eliminarDispositivo'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $Institucion = $_SESSION['Institucion'];
    $Dispositivo = $_GET['Dispositivo'];

    // Validamos que tenga permisos obtenerDispositivos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);
    $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

    if($Datos['eliminarDispositivo'] == true){

      // Obtenemos los dispositivos de la institución
      $Sql = "DELETE FROM `Dispositivos` WHERE Id = '$Dispositivo' AND Institucion = '$Institucion'";
      $Resultado = mysqli_query($Conexión, $Sql);

      if($Resultado){

        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = "";
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta)); 

      }else{
    
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = 'API-099';
        print_r(json_encode($Respuesta)); 

      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Careces de permisos para obtener los dispositivos';
      $Respuesta['codigo'] = 'API-403';
      print_r(json_encode($Respuesta)); 
    }



  }else if($Tipo == 'añadirDispositivos'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $Institucion = $_SESSION['Institucion'];
    $Nombre = $_POST['Nombre'];
    $Tipo = $_POST['Tipo'];
    $Token = $_POST['Token'];
    $TokenSecreto = rand();

    // Validamos que tenga permisos obtenerDispositivos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);
    $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

    if($Datos['agregarDispositivos'] == true){

      // Obtenemos los dispositivos de la institución
      $Sql = "INSERT INTO `Dispositivos`(`Usuario`, `Institucion`, `Tipo`, `Nombre`, `FechaDeCreacion`, `Version`, `Token`, `TokenSecreto`, `Ip`) VALUES ('$Usuario','$Institucion','$Tipo','$Nombre','$Fecha','Pendiente de conexión con dispositivo.','$Token',$TokenSecreto,'')";
      $Resultado = mysqli_query($Conexión, $Sql);

      if($Resultado){

        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = "";
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta)); 

      }else{
    
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = 'API-100';
        print_r(json_encode($Respuesta)); 

      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Careces de permisos para obtener los dispositivos';
      $Respuesta['codigo'] = 'API-403';
      print_r(json_encode($Respuesta)); 
    }



  }else if($_GET['Tipo'] == 'crearTokenDispositivo'){

    // Generamos un token
    $Token = rand(00001,99999);

    $Respuesta['estado'] = 'exitoso';
    $Respuesta['detalle'] = str_pad($Token, 5, "0", STR_PAD_LEFT);
    $Respuesta['codigo'] = 'API-200';
    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    
  }else if($_GET['Tipo'] == 'VerificarToken'){

    // Establecemos variables
    $Ip = obtenerIP();
    $Token = $_GET['Token'];
    $IpSinNumero = str_replace(".", "", $Ip);
    $NuevoToken = intval($Token) * intval($IpSinNumero);

    // Verificamos si el token esta agregado
    $Sql = "SELECT Id FROM `Dispositivos` WHERE TokenSecreto = '$NuevoToken' AND Ip = '$Ip'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){
      if(mysqli_num_rows($Resultado) == 0){
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "No se ha encontrado un dispositivo";
        $Respuesta['codigo'] = "API-104";
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }else{
        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = "";
        $Respuesta['codigo'] = "API-200";
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }
    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = "API-105";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }else if($_GET['Tipo'] == 'verificarTokenVinculacion'){

    // Obtener versión
    $Version = $_GET['Version'];
    $Codigo = $_GET['Codigo'];
    $Ip = obtenerIP();
    $IpSinNumero = str_replace(".", "", $Ip);
    $NuevoToken = intval($Token) * intval($IpSinNumero);

    // Verificamos si el dispositivo fue agregado
    $Sql = "SELECT Id, Institucion, Nombre, TokenSecreto FROM `Dispositivos` WHERE Token = '$Codigo' AND Ip = ''";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      // Establecemos variables
      $Dispositivo = mysqli_fetch_array($Resultado);
      $IdDispositivo = $Dispositivo['Id'];
      $Institucion = $Dispositivo['Institucion'];
      $TokenSecreto = $Dispositivo['TokenSecreto'];
      $Ip = obtenerIP();
      $IpSinNumero = str_replace(".", "", $Ip);
      $NuevoToken = intval($TokenSecreto) * intval($IpSinNumero);

      // Verificamos si existe
      if(mysqli_num_rows($Resultado) == 1){

        // Actualizamos token secreto.
        $SqlActualizarEstado = "UPDATE `Dispositivos` SET `Version`='$Version', `TokenSecreto`='$NuevoToken', `Ip`='$Ip' WHERE Id = '$IdDispositivo'";
        $ResultadoActualizarEstado = mysqli_query($Conexión, $SqlActualizarEstado);

        if($ResultadoActualizarEstado){

          // Obtenemos datos de la institución.
          $SqlObtenerInstitucion = "SELECT Id, Nombre, Abreviado, Logo FROM `Instituciones` WHERE Id = '$Institucion'";
          $ResultadoObtenerInstitucion = mysqli_query($Conexión, $SqlObtenerInstitucion);
          $InstitucionDatos = mysqli_fetch_array($ResultadoObtenerInstitucion);

          if($InstitucionDatos){

            $Respuesta['estado'] = 'exitoso';
            $Respuesta['detalle'] = array(
              "Id" => $Dispositivo['Id'],
              "Institucion" => array(
                "NombreCompleto" => $InstitucionDatos['Nombre'],
                "NombreCorto" => $InstitucionDatos['Abreviado'],
                "Logo" => $InstitucionDatos['Logo'],
              ),
              "Token" => $Dispositivo['TokenSecreto'],
              "Nombre" => $Dispositivo['Nombre'],
              "Panel" => $InstitucionDatos['Panel'],
            );
            $Respuesta['codigo'] = 'API-200';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
  
            }else{
              $Respuesta['estado'] = 'error';
              $Respuesta['detalle'] = "Hubo un error interno";
              $Respuesta['codigo'] = 'API-102';
              print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
            }

          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = "Hubo un error interno";
            $Respuesta['codigo'] = 'API-103';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
          }

      }else{
        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = "no-agregado";
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{

      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = 'API-101';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 

    }

  }else if($_GET['Tipo'] == 'obtenerListaRecursos'){

    // Obtener versión
    $Version = $_GET['Version'];
    $Token = $_GET['Token'];
    $Ip = obtenerIP();
    $IpSinNumero = str_replace(".", "", $Ip);
    $NuevoToken = intval($Token) * intval($IpSinNumero);

    // Validamos token
    $Sql = "SELECT Id, Institucion, Nombre, TokenSecreto FROM `Dispositivos` WHERE TokenSecreto = '$NuevoToken'";
    $Resultado = mysqli_query($Conexión, $Sql);

    $Institucion = mysqli_fetch_array($Resultado);
    $Institucion = $Institucion['Institucion'];

    if($Resultado){

      // Obtenemos registros
      $SqlRegistros = "SELECT * FROM `RecursosFisicos__Registros` WHERE Institucion = '$Institucion'";
      $ResultadoRegistros = mysqli_query($Conexión, $SqlRegistros);

      if($ResultadoRegistros){

        $Registros = array();

        while($Registro = mysqli_fetch_array($ResultadoRegistros)){
          $Campo245 = json_decode($Registro['245'], true);
          $Campo100 = json_decode($Registro['100'], true);
          $DatosGeneral = json_decode($Registro['Datos'], true);
          $Campo260 = $DatosGeneral['Datos']['260'];

          $Campo = array();

          $Campo['Titulo'] = $Campo245['a'];

          if($Campo245['b'] !== undefined && $Campo245['b'] !== ''){$Campo['Subtitulo'] = ": " . $Campo245['b'];}

          if($Campo100['a'] !== undefined && $Campo100['a'] !== ''){$Campo['Autor'] = " - " . $Campo100['a'];}

          if($Campo260['b'] !== undefined && $Campo100['b'] !== ''){$Campo['Editorial'] = " ~ " . $Campo260['b'];}

          $Registros[] = array("Registro" => $Registro['Id'], "Linea" => $Campo);
        }

        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = $Registros;
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 

      }else{
       
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "Hubo un error interno";
        $Respuesta['codigo'] = 'API-107';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        
      }

    }else{

      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = 'API-106';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 

    }

  }else if($_GET['Tipo'] == 'obtenerRecursoEspecifico'){

    // Obtener versión
    $Version = $_GET['Version'];
    $Recurso = $_GET['Recurso'];
    $Token = $_GET['Token'];
    $Ip = obtenerIP();
    $IpSinNumero = str_replace(".", "", $Ip);
    $NuevoToken = intval($Token) * intval($IpSinNumero);

    // Validamos token
    $Sql = "SELECT Id, Institucion, Nombre, TokenSecreto FROM `Dispositivos` WHERE TokenSecreto = '$NuevoToken'";
    $Resultado = mysqli_query($Conexión, $Sql);

    $Institucion = mysqli_fetch_array($Resultado);
    $Institucion = $Institucion['Institucion'];

    if($Resultado){

      if(mysqli_num_rows($Conexión) !== 0){

        // Obtenemos el registro
        $SqlRegistros = "SELECT * FROM `RecursosFisicos__Registros` WHERE Id = '$Recurso' AND Institucion = '$Institucion'";
        $ResultadoRegistros = mysqli_query($Conexión, $SqlRegistros);

        if($ResultadoRegistros){

          $Registro = mysqli_fetch_array($ResultadoRegistros);

          // Obtenemos el ejemplar
          $RegistroID = $Registro['Id'];
          $SqlEjemplares = "SELECT * FROM `RecursosFisicos__Ejemplares` WHERE Registro = '$RegistroID'";
          $ResultadoEjemplares = mysqli_query($Conexión, $SqlEjemplares);
          $Ejemplar = mysqli_fetch_array($ResultadoEjemplares);

          $Ubicación = $Ejemplar['CampoL'];

          $Ejemplares = array();
          while($Ejemplar = mysqli_fetch_array($ResultadoEjemplares)){
            $Ejemplares[] = $Ejemplar['CampoA'];
          }
          

          $RegistroDatos = array(
            "Id" => $Registro['Id'],
            "Ejemplares" => $Ejemplares,
            "Ubicación" => $Ubicación,
            "Datos" => json_decode($Registro['Datos'], true),
          );
          
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = $RegistroDatos;
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 

        }else{
        
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = "Hubo un error interno";
          $Respuesta['codigo'] = 'API-109';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
          
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "Hubo un error interno";
        $Respuesta['codigo'] = 'API-110';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));       
      }

    }else{

      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = 'API-108';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 

    }

  }else if($_GET['Tipo'] == 'obtenerListaEjemplares'){

    // Obtener versión
    $Version = $_GET['Version'];
    $Token = $_GET['Token'];
    $Ip = obtenerIP();
    $IpSinNumero = str_replace(".", "", $Ip);
    $NuevoToken = intval($Token) * intval($IpSinNumero);

    // Validamos token
    $Sql = "SELECT Id, Institucion, Nombre, TokenSecreto FROM `Dispositivos` WHERE TokenSecreto = '$NuevoToken'";
    $Resultado = mysqli_query($Conexión, $Sql);
    $Institucion = mysqli_fetch_array($Resultado);
    $Institucion = $Institucion['Institucion'];

    if($Resultado){

      // Obtenemos registros
      $SqlRegistros = "SELECT * FROM `RecursosFisicos__Registros` WHERE Institucion = '$Institucion'";
      $ResultadoRegistros = mysqli_query($Conexión, $SqlRegistros);

      if($ResultadoRegistros){

        // Obtenemos ejemplares
        $SqlEjemplares = "SELECT * FROM `RecursosFisicos__Ejemplares` WHERE Institucion = '$Institucion'";
        $ResultadoEjemplares = mysqli_query($Conexión, $SqlEjemplares);

        if($ResultadoEjemplares){

          $Registros = array();
          $Ejemplares = array();

          while($Registro = mysqli_fetch_array($ResultadoRegistros)){
            $Registros[] = array(
              "Id" => $Registro['Id'],
              "Datos" => json_decode($Registro['Datos'], true),
            );
          }

          while($Ejemplar = mysqli_fetch_array($ResultadoEjemplares)){
            $Ejemplares[] = array(
              "Id" => $Ejemplar['Id'],
              "Registro" => $Ejemplar['Registro'],
              "CampoA" => $Ejemplar['CampoA'],
              "CampoB" => $Ejemplar['CampoB'],
              "CampoC" => $Ejemplar['CampoC'],
              "CampoD" => $Ejemplar['CampoD'],
              "CampoE" => $Ejemplar['CampoE'],
              "CampoF" => $Ejemplar['CampoF'],
              "CampoG" => $Ejemplar['CampoG'],
              "CampoH" => $Ejemplar['CampoH'],
              "CampoL" => $Ejemplar['CampoL'],
              "CampoM" => $Ejemplar['CampoM'],
              "CampoN" => $Ejemplar['CampoN'],
              "Estado" => $Ejemplar['Estado'],
            );
          }

          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = array("Registros" => $Registros, "Ejemplares" => $Ejemplares);
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = "Hubo un error interno";
          $Respuesta['codigo'] = 'API-113';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }
      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "Hubo un error interno";
        $Respuesta['codigo'] = 'API-112';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }
    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = 'API-111';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }

  }else if($Tipo == 'crearQrIngreso'){

    // Generamos petición
    $QrToken = bin2hex(random_bytes(25));
    $Fecha = date('Y-h-d H-i-s');

    $Sql = "INSERT INTO `IngresoConQR`(`Codigo`, `Creacion`, `Nota`) VALUES ('$QrToken','$Fecha', 'APP SIBAU')";
    $Resultado = mysqli_query($Conexión, $Sql);

    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "No se ha podido crear el QR";
      $Respuesta['codigo'] = 'API-114';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else{
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $QrToken;
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }

  }else if($_GET['Tipo'] == 'realizarRetiro'){

    // Obtener versión
    $Version = $_GET['Version'];
    $Token = $_GET['Token'];
    $Ip = obtenerIP();
    $IpSinNumero = str_replace(".", "", $Ip);
    $NuevoToken = intval($Token) * intval($IpSinNumero);
  
    // Validamos token
    $Sql = "SELECT Id, Institucion, Nombre, TokenSecreto FROM `Dispositivos` WHERE TokenSecreto = '$NuevoToken'";
    $Resultado = mysqli_query($Conexión, $Sql);
  
    $Institucion = mysqli_fetch_array($Resultado);
    $Institucion = $Institucion['Institucion'];
  
    if($Resultado){

        if(!isset($_GET['QR'])){

          // Establecemos datos
          $Usuario = $_POST['Ingreso']['Usuario'];
          $Contraseña = crypt($_POST['Ingreso']['Contraseña'], '$2a$07$firefoxedge2000NetKarmaNe$');
          $MetodoIngreso = '';
          if(strlen($Usuario) >= 7 && strlen($Usuario) <= 8){
            $MetodoIngreso = "DNI";
          }else if(strpos($Usuario, "@") !== false){
            $MetodoIngreso = "Correo";
          }else{
            $MetodoIngreso = "Usuario";
          }
          $Ejemplares = $_POST['Petición']['Ejemplares'];
          $TipoRetiro = $_POST['Petición']['TipoRetiro'];
          $FechaRetiro = $_POST['Petición']['FechaRetiro'];
          $FechaDevolición = $_POST['Petición']['FechaDevolición'];

          // Ejecutamos petición en busca del usuario
          $Sql = "SELECT * FROM `Usuarios` WHERE `$MetodoIngreso` = '$Usuario' AND Contraseña = '$Contraseña'";
          $Resultado = mysqli_query($Conexión, $Sql);
          $Usuario = mysqli_fetch_array($Resultado);
          $IdUsuario = $Usuario['Id'];
          $NombreUsuario = $Usuario['Nombre'];

          if($Resultado){

            if(mysqli_num_rows($Resultado) == 1){

              // Verificamos que todos los ejemplares estén disponibles para su retiro.
              $Sql = "SELECT Id, CampoA, Estado FROM `RecursosFisicos__Ejemplares` WHERE Institucion = '$Institucion'";
              $Resultado = mysqli_query($Conexión, $Sql);
              
              $ListaEjemplares = array();

              while($Ejemplar = mysqli_fetch_array($Resultado)){
                $ListaEjemplares[] = array($Ejemplar['Id'], array("Id" => $Ejemplar['Id'], "CampoA" => $Ejemplar['CampoA'], "Estado" => $Ejemplar['Estado']));
              }

              $Disponibilidad = 1;

              if($Disponibilidad !== 0){

                $Cuando = "WHERE Institucion = '$Institucion'";
                
                for($a = 0; $a < count($Ejemplares); $a++){
                  if($a > 0){$Cuando .= ' OR';}else{$Cuando .= ' AND';}
                  $Cuando .= " Id = '" . $Ejemplares[$a] . "'";
                }

                $Sql = "UPDATE `RecursosFisicos__Ejemplares` SET `Estado`=1 " . $Cuando;
                $Resultado = mysqli_query($Conexión, $Sql);

                if($Resultado){

                  $EjemplaresJson = json_encode($Ejemplares, JSON_UNESCAPED_UNICODE);
                  $Sql = "INSERT INTO `RecursosFisicos__Retiros`(`Institucion`, `IdUsuario`, `RecursosRetirados`, `FechaDeRetiro`, `FechaDeDevolucion`, `TipoDeRetiro`, `Estado`) VALUES ('$Institucion','$IdUsuario','$EjemplaresJson','$FechaRetiro','$FechaDevolición','$TipoRetiro',0)";
                  $Resultado = mysqli_query($Conexión, $Sql);

                  if($Resultado){
                    $Respuesta['estado'] = 'exitoso';
                    $Respuesta['detalle'] = $NombreUsuario;
                    $Respuesta['codigo'] = 'API-200';
                    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
                    generarNotificación("Has retirado " . count($Ejemplares) . " ejemplares de la biblioteca. Recuerda devolverlos en fecha y forma. Puedes consultar el plazo y el estado de tus préstamos desde el panel. Gracias por usar SIBAU. 😊", "fa-regular fa-arrow-up-from-bracket", $IdUsuario);
                  }else{
                    $Respuesta['estado'] = 'error';
                    $Respuesta['detalle'] = "Hubo un error interno";
                    $Respuesta['codigo'] = 'API-136';
                    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));   
                  }

                }else{
                  $Respuesta['estado'] = 'error';
                  $Respuesta['detalle'] = "Hubo un error interno";
                  $Respuesta['codigo'] = 'API-135';
                  print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));   
                }

              }else{
                $Respuesta['estado'] = 'error';
                if(count($Ejemplares) > 1){
                  $Respuesta['detalle'] = "Uno de los ejemplares seleccionados no esta disponible en este momento.";
                }else{
                  $Respuesta['detalle'] = "El ejemplar seleccionado no esta disponible en este momento.";
                }
                $Respuesta['codigo'] = 'API-134';
                print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
              }

            }else{
              $Respuesta['estado'] = 'error';
              $Respuesta['detalle'] = "Las credenciales son invalidas o el usuario inexistente.";
              $Respuesta['codigo'] = 'API-133';
              print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
            }

          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = "Hubo un error interno";
            $Respuesta['codigo'] = 'API-132';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
          }

        }
  
    }else{
  
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = 'API-131';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
  
    }
  
  }else if($_GET['Tipo'] == 'obtenerDevoluciones'){

    // Obtener versión
    $Version = $_GET['Version'];
    $Token = $_GET['Token'];
    $Usuario = str_replace(" ", "", $_POST['Usuario']);
    $Ip = obtenerIP();
    $IpSinNumero = str_replace(".", "", $Ip);
    $NuevoToken = intval($Token) * intval($IpSinNumero);
  
    // Validamos token
    $Sql = "SELECT Id, Institucion, Nombre, TokenSecreto FROM `Dispositivos` WHERE TokenSecreto = '$NuevoToken'";
    $Resultado = mysqli_query($Conexión, $Sql);
  
    $Institucion = mysqli_fetch_array($Resultado);
    $Institucion = $Institucion['Institucion'];
  
    if($Resultado){

      // Establecemos el condicional
      $Cuando = "WHERE Institucion = '$Institucion' AND ";

      // Verificamos si es Usuario, DNI o Correo
      if(strlen($Usuario) >= 7 && strlen($Usuario) <= 8 && is_numeric($Usuario)){
        $Cuando .= "DNI";
      }else if(strpos($_POST['Usuario'], "@") !== false){
        $Cuando .= "Correo";
      }else{
        $Cuando .= "Usuario";
      }

      // Enviamos la petición
      $Sql = "SELECT Id, DNI, Nombre, Usuario, Correo FROM `Usuarios`" . $Cuando . " = '$Usuario'";
      $Resultado = mysqli_query($Conexión, $Sql);

      // Verificamos estado de petición
      if($Resultado){

        $DatoUsuario = mysqli_fetch_array($Resultado);

        // Verificamos si se encontró usuario
        if(mysqli_num_rows($Resultado) == 1){

          // Establecemos nombre
          $Nombre = $DatoUsuario['Nombre'];
          $Id = $DatoUsuario['Id'];

          // Buscamos devoluciones pendientes
          $Sql = "SELECT * FROM `RecursosFisicos__Retiros` WHERE Institucion = '$Institucion' AND IdUsuario = '$Id' AND Estado = '0'";
          $Resultado = mysqli_query($Conexión, $Sql);

          if($Resultado){

            if(mysqli_num_rows($Resultado) > 0){

              $SqlRegistros = "SELECT Id, `245` FROM `RecursosFisicos__Registros` WHERE Institucion = '$Institucion'";
              $ResultadoRegistros = mysqli_query($Conexión, $SqlRegistros);

              $SqlEjemplares = "SELECT Id, Registro, CampoA, CampoL FROM `RecursosFisicos__Ejemplares` WHERE Institucion = '$Institucion'";
              $ResultadoEjemplares = mysqli_query($Conexión, $SqlEjemplares);

              $Registros = array();
              $Ejemplares = array();

              while($Registro = mysqli_fetch_array($ResultadoRegistros)){
                $Registros[] = array(
                  "Id" => $Registro['Id'],
                  "Titulo" => json_decode($Registro['245'], true)['a'],
                );
              }

              while($Ejemplar = mysqli_fetch_array($ResultadoEjemplares)){
                $Ejemplares[] = array(
                  "Id" => $Ejemplar['Id'],
                  "Registro" => $Registros[array_search($Ejemplar['Registro'], array_column($Registros, 'Id'))]['Titulo'],
                  "CampoA" => $Ejemplar['CampoA'],
                  "CampoL" => $Ejemplar['CampoL'],
                );
              }

              $Devoluciones = array();

              while($Retiro = mysqli_fetch_array($Resultado)){
                $EjemplaresIntra = array();
                $RecursosRetirados = json_decode($Retiro['RecursosRetirados'], true);
                for($b = 0; $b < count($RecursosRetirados); $b++){
                  $EjemplaresIntra[] = $Ejemplares[array_search($RecursosRetirados[$b], array_column($Ejemplares, 'Id'))];
                }
                $Devoluciones[] = array(
                  "Id" => $Retiro['Id'],
                  "RecursosRetirados" => $EjemplaresIntra,
                  "FechaDeRetiro" => $Retiro['FechaDeRetiro'],
                  "FechaDeDevolucion" => $Retiro['FechaDeDevolucion'],
                  "TipoDeRetiro" => $Retiro['TipoDeRetiro'],
                  "Estado" => $Retiro['Estado'],
                );
              }

              $Respuesta['estado'] = 'exitoso'; 
              $Respuesta['detalle'] = $Devoluciones;
              $Respuesta['codigo'] = 'API-200';
              print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    

            }else{
              $Respuesta['estado'] = 'exitoso'; 
              $Respuesta['detalle'] = $Nombre;
              $Respuesta['codigo'] = 'API-200';
              print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
            }

          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = "Hubo un error interno.";
            $Respuesta['codigo'] = 'API-143';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
          }

        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = "No se ha podido encontrar tu usuario.";
          $Respuesta['codigo'] = 'API-142';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }


      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "Hubo un error interno";
        $Respuesta['codigo'] = 'API-141';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
      }

    }else{
  
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = 'API-140';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
  
    }
  
  }else if($_GET['Tipo'] == 'devolverRetiro'){

    // Obtener versión
    $Version = $_GET['Version'];
    $Token = $_GET['Token'];
    $Ip = obtenerIP();
    $IpSinNumero = str_replace(".", "", $Ip);
    $NuevoToken = intval($Token) * intval($IpSinNumero);
  
    // Validamos token
    $Sql = "SELECT Id, Institucion, Nombre, TokenSecreto FROM `Dispositivos` WHERE TokenSecreto = '$NuevoToken'";
    $Resultado = mysqli_query($Conexión, $Sql);
  
    $Institucion = mysqli_fetch_array($Resultado);
    $Institucion = $Institucion['Institucion'];
  
    if($Resultado){

      // Establecemos variables
      $Usuario = $_POST['Usuario'];
      $Contraseña = crypt($_POST['Contraseña'], '$2a$07$firefoxedge2000NetKarmaNe$');
      $Retiro = $_POST['Operacion'];
      $Observación = $_POST['Observación'];
      $Reseña = $_POST['Reseña'];
      $FechaDevolición = date();
      
      $MetodoIngreso = "";

      if(strlen($Usuario) >= 7 && strlen($Usuario) <= 8){
        $MetodoIngreso = "DNI";
      }else if(strpos($Usuario, "@") !== false){
        $MetodoIngreso = "Correo";
      }else{
        $MetodoIngreso = "Usuario";
      }

      // Ejecutamos petición en busca del usuario
      $Sql = "SELECT Id, Nombre FROM `Usuarios` WHERE `$MetodoIngreso` = '$Usuario' AND Contraseña = '$Contraseña'";
      $Resultado = mysqli_query($Conexión, $Sql);
      
      // Verificamos estado de la petición
      if($Resultado){

        // Verificamos si el usuario existe
        if(mysqli_num_rows($Resultado) == 1){

          // Establecemos variables
          $Usuario = mysqli_fetch_array($Resultado);
          $IdUsuario = $Usuario['Id'];
          $NombreUsuario = $Usuario['Nombre'];

          // Marcamos el retiro como devuelto
          $Sql = "UPDATE `RecursosFisicos__Retiros` SET `Observacion`='$Observación', `Reseña`='$Reseña', `DevolucionReal`='$Fecha' WHERE Institucion = '$Institucion' AND Id = '$Retiro' AND IdUsuario = '$IdUsuario'";
          $Resultado = mysqli_query($Conexión, $Sql);

          // Verificamos estado de la petición
          if($Resultado){

            // Obtenemos el listado de Recursos Retirados
            $Sql = "SELECT RecursosRetirados FROM `RecursosFisicos__Retiros` WHERE Institucion = '$Institucion' AND Id = '$Retiro' AND IdUsuario = '$IdUsuario'";
            $Resultado = mysqli_query($Conexión, $Sql);

            // Verificamos el estado de la petición
            if($Resultado){

              // Establecemos variables
              $RecursosRetirados = json_decode(mysqli_fetch_array($Resultado)['RecursosRetirados'], true);

              $In = "";
              for($i = 0; $i < count($RecursosRetirados); $i++){
                if($i > 0){$In .= ", ";}
                $In .= $RecursosRetirados[$i];
              }
              
              // Marcamos todos los recursos como devueltos
              $Sql = "UPDATE `RecursosFisicos__Ejemplares` SET `Estado`='0' WHERE Institucion = '$Institucion' AND Id IN ($In)";
              $Resultado = mysqli_query($Conexión, $Sql);

              if($Resultado){
                
                // Marcamos el retiro como devuelto
                $Sql = "UPDATE `RecursosFisicos__Retiros` SET `Estado`='1' WHERE Institucion = '$Institucion' AND Id = '$Retiro' AND IdUsuario = '$IdUsuario'";
                $Resultado = mysqli_query($Conexión, $Sql);

                if($Resultado){
  
                  $Respuesta['estado'] = 'exitoso';
                  $Respuesta['detalle'] = $NombreUsuario;
                  $Respuesta['codigo'] = 'API-200';
                  print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
                  generarNotificación("Has devuelto un retiro de la biblioteca. Muchas gracias por confiar en SIBAU. 😇 Esperamos que hayas disfrutado de la lectura y te invitamos a seguir explorando nuestro catálogo de recursos. Recuerda que puedes valorar los libros que has leído y dejarnos tus comentarios o sugerencias. 😊", "fa-regular fa-arrow-down-to-bracket",  $IdUsuario);
  
                }else{
                  $Respuesta['estado'] = 'error';
                  $Respuesta['detalle'] = "Hubo un error interno";
                  $Respuesta['codigo'] = 'API-153';
                  print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
                }

              }else{
                $Respuesta['estado'] = 'error';
                $Respuesta['detalle'] = "Hubo un error interno";
                $Respuesta['codigo'] = 'API-152';
                print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
              }

            }else{
              $Respuesta['estado'] = 'error';
              $Respuesta['detalle'] = "Hubo un error interno";
              $Respuesta['codigo'] = 'API-151';
              print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
            }

          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = "Hubo un error interno";
            $Respuesta['codigo'] = 'API-150';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
          }

        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = "Usuario inexistente o credenciales invalidas.";
          $Respuesta['codigo'] = 'API-149';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "Hubo un error interno";
        $Respuesta['codigo'] = 'API-148';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }
  
    }else{
  
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = 'API-131';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
  
    }
  
  }else if($_GET['Tipo'] == 'valorar'){

    // Obtener versión
    $Version = $_GET['Version'];
    $Operación = $_GET['Operación'];
    $Valoracion = $_GET['Valoración'];
    
    // Validamos token
    $Sql = "INSERT INTO `Experiencia__Valoraciones`(`Operación`, `Fecha`, `Versión`, `Valoración`) VALUES ('$Operación','$Fecha','$Version','$Valoracion')";
    $Resultado = mysqli_query($Conexión, $Sql);
  
  }else if($_GET['Tipo'] == 'nunevaBusqueda'){

    // Establecemos variables
    $Version = $_GET['Version'];
    $Tipob = $_GET['Tipob'];
    $Token = $_GET['Token'];
    $Ip = obtenerIP();
    $IpSinNumero = str_replace(".", "", $Ip);
    $NuevoToken = intval($Token) * intval($IpSinNumero);

    // Verificamos Token
    $Sql = "SELECT Id, Institucion FROM `Dispositivos` WHERE TokenSecreto = '$NuevoToken'";
    $Resultado = mysqli_query($Conexión, $Sql);
    
    // Verificamos la petición
    if($Resultado){

      // Establecemos variable
      $Institucion = mysqli_fetch_array($Resultado)['Institucion'];

      // Verificamos si hubo resultados
      if(mysqli_num_rows($Resultado) == 1){

        // Verificamos tipo de búsqueda
        if($Tipob == "Simple"){

          // Establecemos variable
          $Titulo = $_GET['Titulo'];

          // Realizamos petición
          $Sql = "SELECT Id, `245`, Datos FROM `RecursosFisicos__Registros` WHERE Institucion = '$Institucion'";
          $Resultado = mysqli_query($Conexión, $Sql);

          // Verificamos la petición
          if($Resultado){

            $Registros = array();

            while($Registro = mysqli_fetch_array($Resultado)){
              $RTEMP = json_decode($Registro['Datos'], true);
              $TituloRegi;
              $Subtitulo;
              $Autor;
              $ISBN;

              $Niveles = array();

              if($RTEMP['Datos']['521'] !== undefined && count($RTEMP['Datos']['521']) > 0){
                for($i = 0; $i < count($RTEMP['Datos']['521']); $i++){
                  if(is_array($RTEMP['Datos']['521'][$i])){
                    $Niveles[] = $RTEMP['Datos']['521'][$i]['a'];
                  }else{
                    $Niveles[] = $RTEMP['Datos']['521'][$i];
                  }
                }
              }

              $Resumen = array();

              if($RTEMP['Datos']['520'] !== undefined && count($RTEMP['Datos']['520']) > 0){
                for($a = 0; $a < count($RTEMP['Datos']['520']); $a++){
                  if(is_array($RTEMP['Datos']['520'][$a])){
                    $Resumen[] = $RTEMP['Datos']['520'][$a]['a'];
                  }else{
                    $Resumen[] = $RTEMP['Datos']['520'][$a];
                  }
                }
              }

              if($RTEMP['Datos']['245'] !== undefined && $RTEMP['Datos']['245']['a'] !== undefined){$TituloRegi = $RTEMP['Datos']['245']['a'];}else{$TituloRegi = "";}
              if($RTEMP['Datos']['245'] !== undefined && $RTEMP['Datos']['245']['b'] !== undefined){$Subtitulo = $RTEMP['Datos']['245']['b'];}else{$Subtitulo = "";}
              if($RTEMP['Datos']['020'] !== undefined && count($RTEMP['Datos']['020']) > 0){$ISBN = $RTEMP['Datos']['020'][0]['a'];}else{$ISBN = "";}
              if($RTEMP['Datos']['100'] !== undefined && $RTEMP['Datos']['100']['a'] !== undefined){$Autor = $RTEMP['Datos']['100']['a'];}else{$Autor = "";}
              $Registros[] = array(
                "Id" => $Registro['Id'],
                "Titulo" => $TituloRegi,
                "Subtitulo" => $Subtitulo,
                "Autor" => $Autor !== null ? $Autor : "",
                "ISBN" => $ISBN,
                "Niveles" => $Niveles,
                "Resumen" => $Resumen,
              );
            }

            // Crear un array con los términos de búsqueda, separando los términos por espacios
            $terminosDeBusqueda = preg_split('/\s+/', strtolower(trim($Titulo)));

            // Crear un array con los resultados de búsqueda
            $resultadosDeBúsqueda = array_filter($Registros, function($Registros) use ($terminosDeBusqueda) {

                // Crear un string con todos los campos a buscar
                $Termino = strtolower($Registros['Titulo'] . " " . $Registros['Subtitulo'] . " " . $Registros['Autor'] . " " . $Registros['ISBN']);

                // Verificar si todos los términos de búsqueda están incluidos en el string
                return count(array_filter($terminosDeBusqueda, function($búsqueda) use ($Termino) {
                  return strpos($Termino, $búsqueda) !== false;
                })) === count($terminosDeBusqueda);

            });

            $Respuesta['estado'] = 'exitoso';
            $detalle = array();
            foreach ($resultadosDeBúsqueda as $resultado) {
                $detalle[] = $resultado;
            }
            $Respuesta['detalle'] = $detalle;
            $Respuesta['codigo'] = 'API-200';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 


          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = 'Hubo un error interno';
            $Respuesta['codigo'] = 'API-209';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
          }


        }else if($Tipob == "DatosAdicionales"){
        
          // Establecemos variable
          $IdRegistro = $_GET['IdRegistro'];

          // Realizamos petición
          $Sql = "SELECT Id, CampoA, CampoL, Estado FROM `RecursosFisicos__Ejemplares` WHERE Registro = '$IdRegistro'";
          $Resultado = mysqli_query($Conexión, $Sql);

          // Verificamos la petición
          if($Resultado){

            // Creamos array
            $Ejemplares = array();

            // Cargamos datos al array
            while($Registro = mysqli_fetch_array($Resultado)){
              $Ejemplares[] = array(
                "Id" => $Registro['Id'],
                "CampoA" => $Registro['CampoA'],
                "CampoL" => $Registro['CampoL'],
                "Estado" => $Registro['Estado'],
              );
            }

            $Respuesta['estado'] = 'exitoso';
            $Respuesta['detalle'] = $Ejemplares;
            $Respuesta['codigo'] = 'API-200';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

          }else{

          }

        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = 'API-208';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-207';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }
  
  }else{
    $Respuesta['estado'] = 'error';
    $Respuesta['detalle'] = 'Petición errónea';
    $Respuesta['codigo'] = 'API-000';
    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
  }

?>