<?php 

  // Importamos sistema
  require("../sistema.php");

  // Establecemos variables
  $Tipo = $_GET['Tipo'];

  // Vemos que tipo es la consulta
  if($Tipo == 'obtenerListado'){

    // Realizamos la petición a la base de datos
    $Sql = "SELECT Id, Nombre, Abreviado, Logo FROM `Instituciones`";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){
    
      $Instituciónes = array();
      while($Institución = mysqli_fetch_array($Resultado)){
        $Instituciónes[] = array(
          "Id" => $Institución['Id'],
          "Nombre" => $Institución['Nombre'],
          "Abreviado" => $Institución['Abreviado'],
          "Logo" => $Institución['Logo'],
        );
      }

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $Instituciónes;
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-192';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }


  }else if($Tipo == 'obtenerDatos'){

    // Establecemos variable
    $Institución = $_SESSION['Institucion'];

    // Requerimos sesión
    apiRequireSesion();

    if(verificarPermisosActualizados("gestion_configuraciones")){

      // Realizamos la petición a la base de datos
      $Sql = "SELECT I.Id, I.Nombre, I.Abreviado, U.Nombre AS NombreGestor, U.Apellido AS ApellidoGestor, I.Correo AS CorreoABC, U.Correo,
      I.Estado, I.FechaDeInscripcion, I.CUE, I.Logo, Configuracion FROM `Instituciones` I INNER JOIN Usuarios U ON I.UsuarioEncargado = U.Id WHERE I.Id = $Institución";
      $Resultado = mysqli_query($Conexión, $Sql);

      // Verificamos el estado de la petición
      if($Resultado){

        $Institución = mysqli_fetch_array($Resultado);
      
        $Array = array(
          "Id" => $Institución['Id'],
          "Nombre" => $Institución['Nombre'],
          "Abreviado" => $Institución['Abreviado'],
          "Gestor" => $Institución['NombreGestor'] . " " . $Institución['ApellidoGestor'],
          "GestorCorreo" => $Institución['Correo'],
          "CorreoABC" => $Institución['CorreoABC'],
          "Estado" => $Institución['Estado'],
          "FechaDeInscripcion" => $Institución['FechaDeInscripcion'],
          "CUE" => $Institución['CUE'],
          "Logo" => $Institución['Logo'],
          "Configuracion" => json_decode($Institución['Configuracion']),
        );

        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = $Array;
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = 'API-198';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }

    }


  }else if($Tipo == 'actualizarDatos'){

    // Establecemos variable
    $Institución = $_SESSION['Institucion'];
    $Funciones = $_GET['Funciones'];

    // Requerimos sesión
    apiRequireSesion();

    if(verificarPermisosActualizados("gestion_configuraciones")){

      // Obtenemos la configuración de la cuenta
      $Sql = "SELECT Configuracion FROM `Instituciones` WHERE Id = $Institución";
      $Resultado = mysqli_query($Conexión, $Sql);

      // Verificamos el estado de la petición
      if($Resultado){

        // Establecemos variables
        $Configuracion = json_decode(mysqli_fetch_array($Resultado)[0], true);
        $Limitaciones = $Configuracion['Limitaciones'];
        $NuevosFunciones = array();

        // Validamos las nuevas funciones
        for ($i = 0; $i < count($Funciones); $i++) {
          if($Funciones[$i] == true && $Limitaciones[$i] !== true) {
            $NuevosFunciones[$i] = false;
          }else{
            $NuevosFunciones[$i] = $Funciones[$i];
          }
        }       
        
        // Actualizamos la configuración
        $Configuracion = json_encode(array("Funciones" => $NuevosFunciones, "Limitaciones" => $Limitaciones), JSON_FORCE_OBJECT);
        $Sql = "UPDATE `Instituciones` SET Configuracion='$Configuracion' WHERE Id = $Institución";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = '';
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno' . mysqli_error($Conexión);
          $Respuesta['codigo'] = 'API-201';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = 'API-199';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }

    }

  }else{
    $Respuesta['estado'] = 'error';
    $Respuesta['detalle'] = 'Petición errónea';
    $Respuesta['codigo'] = 'API-000';
    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
  }

?>