<?php 

  // Importamos sistema
  require("../sistema.php");

  // Establecemos variables
  $Tipo = $_GET['Tipo'];

  // Vemos que tipo es la consulta
  if($Tipo == 'Obtener'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];

    // Realizamos la petición a la base de datos
    $Sql = "SELECT * FROM `RecursosFisicos__Registros` WHERE Institucion = '$Institucion'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      // Realizamos la petición a la base de datos
      $SqlEjemplares = "SELECT * FROM `RecursosFisicos__Ejemplares` WHERE Institucion = '$Institucion' ORDER BY `CampoA` ASC";
      $ResultadoEjemplares = mysqli_query($Conexión, $SqlEjemplares);

      $Registros = array();
      $Ejemplares = array();

      while($Registro = mysqli_fetch_array($Resultado)){

        $Registros[] = array(
          "Id" => $Registro['Id'],
          "Usuario" => $Registro['Usuario'],
          "245" => json_decode($Registro['245'], true),
          "100" => json_decode($Registro['100'], true),
          "659" => json_decode($Registro['659'], true),
          "650" => json_decode($Registro['650'], true),
          "653" => json_decode($Registro['653'], true),
          "Datos" => json_decode($Registro['Datos'], true),
        );

      }

      while($Ejemplar = mysqli_fetch_array($ResultadoEjemplares)){

        $Ejemplares[] = array(
          "Id" => $Ejemplar['Id'],
          "Registro" => $Ejemplar['Registro'],
          "Usuario" => $Ejemplar['Usuario'],
          "Institucion" => $Ejemplar['Institucion'],
          "CampoA" => $Ejemplar['CampoA'],
          "CampoB" => $Ejemplar['CampoB'],
          "CampoC" => $Ejemplar['CampoC'],
          "CampoD" => $Ejemplar['CampoD'],
          "CampoE" => $Ejemplar['CampoE'],
          "CampoF" => $Ejemplar['CampoF'],
          "CampoG" => $Ejemplar['CampoG'],
          "CampoH" => $Ejemplar['CampoH'],
          "CampoL" => $Ejemplar['CampoL'],
          "CampoM" => $Ejemplar['CampoM'],
          "CampoN" => $Ejemplar['CampoN'],
          "Fecha" => $Ejemplar['Fecha'],
          "Estado" => $Ejemplar['Estado'],
        );

      }

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = array("Registros" => $Registros, "Ejemplares" => $Ejemplares);
      $Respuesta['codigo'] = 'API-049';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = 'API-092';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }
    

  }else if($Tipo == 'obtenerCirculación'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Usuario = $_SESSION['Id'];

    if(verificarPermisosActualizados("gestion_recursosfisicos_circulacion_obtener")){
     

      $Sql = "SELECT RecursosFisicos__Retiros.Reseña AS Reseña, RecursosFisicos__Retiros.Observacion AS Observacion, RecursosFisicos__Retiros.Id, Usuarios.Nombre AS Nombre, Usuarios.Apellido AS Apellido, RecursosFisicos__Retiros.RecursosRetirados, RecursosFisicos__Retiros.FechaDeRetiro, RecursosFisicos__Retiros.FechaDeDevolucion, RecursosFisicos__Retiros.TipoDeRetiro, RecursosFisicos__Retiros.Estado, RecursosFisicos__Retiros.Reseña, RecursosFisicos__Retiros.Observacion FROM `RecursosFisicos__Retiros` JOIN Usuarios WHERE RecursosFisicos__Retiros.Institucion = '$Institucion' AND Usuarios.Id = RecursosFisicos__Retiros.IdUsuario ORDER BY FechaDeRetiro DESC";
      $Resultado = mysqli_query($Conexión, $Sql);

      if($Resultado){

        // Obtenemos los ejemplares con sus titulos
        $SqlNombres = "SELECT RecursosFisicos__Ejemplares.Id, RecursosFisicos__Ejemplares.CampoA, RecursosFisicos__Registros.245 FROM RecursosFisicos__Ejemplares INNER JOIN RecursosFisicos__Registros ON RecursosFisicos__Ejemplares.Registro = RecursosFisicos__Registros.Id AND RecursosFisicos__Registros.Institucion = '$Institucion'";
        $ResultadoNombres = mysqli_query($Conexión, $SqlNombres);

        if($Resultado){

          $Ejemplares = array();

          while($Ejemplar = mysqli_fetch_array($ResultadoNombres)){
            $Eje = json_decode($Ejemplar['245'], true);
            $Ejemplares[$Ejemplar['Id']] = "#" . $Ejemplar['CampoA'] . " - " . $Eje['a'] . " ~ "  . $Eje['b'] . " " . $Eje['n'];
          }

          $Circulación = array();

          while($Retiros = mysqli_fetch_array($Resultado)){

            $RecursosRetirados = array();

            for($i = 0; $i < count(json_decode($Retiros['RecursosRetirados'], true)); $i++){ 
              $RecursosRetirados[] = $Ejemplares[json_decode($Retiros['RecursosRetirados'], true)[$i]];
            }
    
            $Circulación[] = array(
              "Id" => $Retiros['Id'],
              "Usuario" => $Retiros['Nombre'] . " " . $Retiros['Apellido'],
              "RecursosRetirados" => $RecursosRetirados,
              "FechaDeRetiro" => $Retiros['FechaDeRetiro'],
              "FechaDeDevolucion" => $Retiros['FechaDeDevolucion'],
              "TipoDeRetiro" => $Retiros['TipoDeRetiro'],
              "Estado" => $Retiros['Estado'],
              "Reseña" => $Retiros['Reseña'],
              "Observacion" => $Retiros['Observacion'],
            );   

          }

          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = $Circulación;
          $Respuesta['codigo'] = 'API-138';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

        }else{

          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno.';
          $Respuesta['codigo'] = 'API-197';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 

        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno.';
        $Respuesta['codigo'] = 'API-138';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }

  }else if($Tipo == 'ObtenerListadoRetiro'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Usuario = $_SESSION['Id'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la petición
    if($Resultado){

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['gestion_recursosfisicos_circulacion_generar'] == true){

        // Realizamos petición
        $Sql = "SELECT RecursosFisicos__Ejemplares.Id AS IdEjemplar, RecursosFisicos__Ejemplares.CampoA AS Inventario, Registros.`245` AS Titulo, RecursosFisicos__Ejemplares.Estado FROM `RecursosFisicos__Ejemplares` JOIN RecursosFisicos__Registros Registros ON RecursosFisicos__Ejemplares.Registro = Registros.Id";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){

          $Ejemplares = array();

          while($Ejemplar = mysqli_fetch_array($Resultado)){
            $Ejemplares[] = array(
              "Id" => $Ejemplar['IdEjemplar'],
              "Inventario" => $Ejemplar['Inventario'],
              "Titulo" => json_decode($Ejemplar['Titulo'], true),
              "Estado" => $Ejemplar['Estado'],
            );
          }
        
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = $Ejemplares;
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  

        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno';
          $Respuesta['codigo'] = 'API-162';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para obtener la lista de ejemplares.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-161';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }else if($Tipo == 'agregarEjemplar'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Usuario = $_SESSION['Id'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la peticion
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-095';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['gestion_recursosfisicos_ejemplar_agregar'] == true){

        // Establecemos petición
        $Registro = $_POST['Registro'];
        $CampoA = $_POST['CampoA'];
        $CampoB = $_POST['CampoB'];
        $CampoC = $_POST['CampoC'];
        $CampoD = $_POST['CampoD'];
        $CampoE = $_POST['CampoE'];
        $CampoF = $_POST['CampoF'];
        $CampoG = $_POST['CampoG'];
        $CampoH = $_POST['CampoH'];
        $CampoL = $_POST['CampoL'];
        $CampoM = $_POST['CampoM'];
        $CampoN = $_POST['CampoN'];

        // Verificamos si existe un ejemplar con un numero de inventario
        if(mysqli_num_rows(mysqli_query($Conexión, "SELECT CampoA FROM `RecursosFisicos__Ejemplares` WHERE CampoA = $CampoA")) == 0){

          // Ejecutamos petición
          $Sql = "INSERT INTO `RecursosFisicos__Ejemplares`(`Registro`, `Usuario`, `Institucion`, `CampoA`, `CampoB`, `CampoC`, `CampoD`, `CampoE`, `CampoF`, `CampoG`, `CampoH`, `CampoL`, `CampoM`, `CampoN`, `Fecha`, `Estado`) VALUES ('$Registro','$Usuario','$Institucion','$CampoA','$CampoB','$CampoC','$CampoD','$CampoE','$CampoF','$CampoG','$CampoH','$CampoL','$CampoM','$CampoN','$Fecha','0')";
          $Resultado = mysqli_query($Conexión, $Sql);

          if($Resultado){
            $Respuesta['estado'] = 'exitoso';
            $Respuesta['detalle'] = 'Ejemplar agregado con éxito.';
            $Respuesta['codigo'] = 'API-200';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = 'Hubo un error interno';
            $Respuesta['codigo'] = 'API-097' . mysqli_error($Conexión);
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
          }

        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Ese numero de inventario esta en uso.';
          $Respuesta['codigo'] = 'API-096';
          print_r(json_encode($Respuesta)); 
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para crear ejemplares.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta)); 
      }

    }

  }else if($Tipo == 'generarRetiro'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Usuario = $_SESSION['Id'];
    $UsuarioRetiro = $_GET['Usuario'];
    $Ejemplares = $_GET['Ejemplares'];
    $TipoRetiro = $_GET['TipoRetiro'];
    $FechaRetiro = $_GET['FechaRetiro'];
    $FechaDevolición = $_GET['FechaDevolición'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la petición
    if($Resultado){

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['gestion_recursosfisicos_circulacion_generar'] == true){
      
        // Verificamos que todos los ejemplares estén disponibles para su retiro.
        $Sql = "SELECT Id, CampoA, Estado FROM `RecursosFisicos__Ejemplares` WHERE Institucion = '$Institucion'";
        $Resultado = mysqli_query($Conexión, $Sql);
        
        $ListaEjemplares = array();

        while($Ejemplar = mysqli_fetch_array($Resultado)){
          $ListaEjemplares[$Ejemplar['Id']] = array($Ejemplar['Id'], array("Id" => $Ejemplar['Id'], "CampoA" => $Ejemplar['CampoA'], "Estado" => $Ejemplar['Estado']));
        }

        $Disponibilidad = "1";

        for($i = 0; $i < count($Ejemplares); $i++){
          if($ListaEjemplares[$Ejemplares[$i]][1]['Estado'] !== "0"){
            $Disponibilidad = "0";
          };
        }

        if($Disponibilidad == "1"){

          $Cuando = "WHERE Institucion = '$Institucion'";
          
          for($a = 0; $a < count($Ejemplares); $a++){
            if($a > 0){$Cuando .= ' OR';}else{$Cuando .= ' AND';}
            $Cuando .= " Id = '" . $Ejemplares[$a] . "'";
          }

          $Sql = "UPDATE `RecursosFisicos__Ejemplares` SET `Estado`=1 " . $Cuando;
          $Resultado = mysqli_query($Conexión, $Sql);

          if($Resultado){

            $EjemplaresJson = json_encode($Ejemplares, JSON_UNESCAPED_UNICODE);
            $Sql = "INSERT INTO `RecursosFisicos__Retiros`(`Institucion`, `IdUsuario`, `RecursosRetirados`, `FechaDeRetiro`, `FechaDeDevolucion`, `TipoDeRetiro`, `Estado`, `Observacion`) VALUES ('$Institucion','$UsuarioRetiro','$EjemplaresJson','$FechaRetiro','$FechaDevolición','$TipoRetiro',0,'Retirado generado por #$Usuario')";
            $Resultado = mysqli_query($Conexión, $Sql);

            if($Resultado){
              $Respuesta['estado'] = 'exitoso';
              $Respuesta['detalle'] = '';
              $Respuesta['codigo'] = 'API-200';
              print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));   
            }else{
              $Respuesta['estado'] = 'error';
              $Respuesta['detalle'] = "Hubo un error interno";
              $Respuesta['codigo'] = 'API-166';
              print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));   
            }

          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = "Hubo un error interno";
            $Respuesta['codigo'] = 'API-165';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));   
          }

        }else{
          $Respuesta['estado'] = 'error';
          if(count($Ejemplares) > 1){
            $Respuesta['detalle'] = "Uno de los ejemplares seleccionados no esta disponible en este momento.";
          }else{
            $Respuesta['detalle'] = "El ejemplar seleccionado no esta disponible en este momento.";
          }
          $Respuesta['codigo'] = 'API-164';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para generar retiros.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }
      
    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-163';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }else if($Tipo == 'marcarRetiroDevuelto'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Usuario = $_SESSION['Id'];
    $Operación = $_GET['Operación'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la petición
    if($Resultado){

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['gestion_recursosfisicos_circulacion_devolver'] == true){

        // Establecemos petición
        $Sql = "UPDATE `RecursosFisicos__Retiros` SET `Estado`='1', `DevolucionReal`='$Fecha' WHERE Institucion = '$Institucion' AND Id = '$Operación'";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){

          // Obtenemos el listado de Recursos Retirados
          $Sql = "SELECT RecursosRetirados FROM `RecursosFisicos__Retiros` WHERE Institucion = '$Institucion' AND Id = '$Operación'";
          $Resultado = mysqli_query($Conexión, $Sql);

          // Verificamos el estado de la petición
          if($Resultado){

            // Establecemos variables
            $RecursosRetirados = json_decode(mysqli_fetch_array($Resultado)['RecursosRetirados'], true);

            $In = "";
            for($i = 0; $i < count($RecursosRetirados); $i++){
              if($i > 0){$In .= ", ";}
              $In .= $RecursosRetirados[$i];
            }
            
            // Marcamos todos los recursos como devueltos
            $Sql = "UPDATE `RecursosFisicos__Ejemplares` SET `Estado`='0' WHERE Institucion = '$Institucion' AND Id IN ($In)";
            $Resultado = mysqli_query($Conexión, $Sql);

            if($Resultado){
              
              $Respuesta['estado'] = 'exitoso';
              $Respuesta['detalle'] = "";
              $Respuesta['codigo'] = 'API-200';
              print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

            }else{
              $Respuesta['estado'] = 'error';
              $Respuesta['detalle'] = "Hubo un error interno";
              $Respuesta['codigo'] = 'API-170';
              print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
            }

          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = "Hubo un error interno";
            $Respuesta['codigo'] = 'API-169';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
          }

        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno';
          $Respuesta['codigo'] = 'API-168';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  
        }
      
      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para generar retiros.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }
      
    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-167';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }elseif($Tipo == 'descargarBackup'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $Institucion = $_SESSION['Institucion'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);
    
    // Verificamos el estado de la petición
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-115';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Establecemos permisos
      $Permisos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      if($Permisos['descargarBackup'] == true){

        // Obtenemos registros
        $SqlRegistros = "SELECT * FROM `RecursosFisicos__Registros` WHERE Institucion = '$Institucion'";
        $ResultadoRegistros = mysqli_query($Conexión, $SqlRegistros);

        // Obtenemos ejemplares
        $SqlEjemplares = "SELECT * FROM `RecursosFisicos__Ejemplares` WHERE Institucion = '$Institucion'";
        $ResultadoEjemplares = mysqli_query($Conexión, $SqlEjemplares);

        // Obtenemos retiros
        $SqlRetiros = "SELECT * FROM `RecursosFisicos__Retiros` WHERE Institucion = '$Institucion'";
        $ResultadoRetiros = mysqli_query($Conexión, $SqlRetiros);

        // Creamos archivos
        $Registros = tmpfile();
        $Ejemplares = tmpfile();
        $Retiros = tmpfile();

        $Registros = fopen('registros.csv', 'w');
        while ($fila = mysqli_fetch_assoc($ResultadoRegistros)) {
            fputcsv($Registros, $fila);
        }

        fclose($Registros);
        

        $Ejemplares = fopen('ejemplares.csv', 'w');
        while ($fila = mysqli_fetch_assoc($ResultadoEjemplares)) {
            fputcsv($Ejemplares, $fila);
        }

        fclose($Ejemplares);

        $Retiros = fopen('retiros.csv', 'w');
        while ($fila = mysqli_fetch_assoc($ResultadoRetiros)) {
            fputcsv($Retiros, $fila);
        }

        fclose($Retiros);

        // Creamos archivo ZIP
        $Archivo = new ZipArchive();
        $NombreArchivo = 'Backup-RecursosFisicos-' . $Fecha . '.zip';

        if($Archivo->open($NombreArchivo, ZipArchive::CREATE) === TRUE){

          // Agregar los archivos temporales a la instancia
          $Archivo->addFile('registros.csv');
          $Archivo->addFile('ejemplares.csv');
          $Archivo->addFile('retiros.csv');


          // Agregamos el leemé
          $leeme = 'Este archivo corresponde a un backup de los Recursos Físicos de su institución y deberá ser utilizado en caso de cualquier fallo en el sistema. Para realizar la carga del archivo, es necesario enviarlo adjunto a un correo electrónico a hola@sibau.com.ar utilizando la dirección de correo electrónico de la institución correspondiente.

Es importante destacar que solamente se autorizará la carga del archivo si es enviado desde la dirección de correo electrónico mencionada previamente.
              
Agradecemos su confianza en SIBAU para la gestión de su biblioteca y quedamos a su disposición para cualquier consulta o necesidad.
              
Todos los derechos reservados © ' . date('Y') . ' SIBAU. Diseñado y desarrollado por Bautista Izaguirre.';
          $Archivo->addFromString('LÉEME.txt', $leeme);

          // Cerrar el archivo ZIP
          $Archivo->close();

          // Mostramos ZIP
          header('Content-Type: application/zip');
          header('Content-disposition: attachment; filename=' . $NombreArchivo);
          header('Content-Length: ' . filesize($NombreArchivo));
          readfile($NombreArchivo);

          // Eliminamos archivo temporal.
          unlink($NombreArchivo);
          unlink("registros.csv");
          unlink("ejemplares.csv");
          unlink("retiros.csv");

        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para descargar Backups.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }
    
    }
    

  }else if($Tipo == 'editarEjemplar'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Usuario = $_SESSION['Id'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la peticion
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-095';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['gestion_recursosfisicos_ejemplar_editar'] == true){

        // Establecemos petición
        $Ejemplar = $_POST['Ejemplar'];
        $CampoA = $_POST['CampoA'];
        $CampoB = $_POST['CampoB'];
        $CampoC = $_POST['CampoC'];
        $CampoD = $_POST['CampoD'];
        $CampoE = $_POST['CampoE'];
        $CampoF = $_POST['CampoF'];
        $CampoG = $_POST['CampoG'];
        $CampoH = $_POST['CampoH'];
        $CampoL = $_POST['CampoL'];
        $CampoM = $_POST['CampoM'];
        $CampoN = $_POST['CampoN'];

        // Ejecutamos petición
        $Sql = "UPDATE `RecursosFisicos__Ejemplares` SET `CampoA`='$CampoA',`CampoB`='$CampoB',`CampoC`='$CampoC',`CampoD`='$CampoD',`CampoE`='$CampoE',`CampoF`='$CampoF',`CampoG`='$CampoG',`CampoH`='$CampoH',`CampoL`='$CampoL',`CampoM`='$CampoM',`CampoN`='$CampoN' WHERE Id = '$Ejemplar' AND Institucion = '$Institucion'";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = 'Ejemplar editado con éxito.';
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno';
          $Respuesta['codigo'] = 'API-128';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para editar ejemplares.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta)); 
      }

    }

  }else if($Tipo == 'eliminarRegistro'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $MFN = $_GET['MFN'];
    $Usuario = $_SESSION['Id'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la petición
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-139';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['gestion_recursosfisicos_registros_eliminar'] == true){

        // Ejecutamos petición
        $Sql = "DELETE FROM `RecursosFisicos__Registros` WHERE Id = '$MFN'";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = 'Ejemplar editado con éxito.';
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno';
          $Respuesta['codigo'] = 'API-129';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para eliminar registros.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta)); 
      }

    }

  }else if($Tipo == 'eliminarEjemplar'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $MFN = $_GET['MFN'];
    $Usuario = $_SESSION['Id'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la petición
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-185';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['gestion_recursosfisicos_ejemplar_eliminar'] == true){

        // Ejecutamos petición
        $Sql = "DELETE FROM `RecursosFisicos__Ejemplares` WHERE Id = '$MFN' AND Institucion = $Institucion";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = 'Ejemplar editado con éxito.';
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno';
          $Respuesta['codigo'] = 'API-186';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para eliminar ejemplares.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta)); 
      }

    }

  }else if($Tipo == 'certificadoLibreDeudas'){

    // Establecemos variables
    $DNI = $_GET['DNI'];

    // Buscamos el usuario en la base de datos
    $Sql = "SELECT Id, Nombre, Apellido, DNI FROM `Usuarios` WHERE DNI = '$DNI'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){
 
      if(mysqli_num_rows($Resultado) == 1){

        // Verificamos si el usuario tiene permisos
        $IdUsuario = mysqli_fetch_array($Resultado)['Id'];
        $Sql = "SELECT Id FROM `RecursosFisicos__Retiros` WHERE IdUsuario = '$IdUsuario' AND Estado = '0'";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){

          if(mysqli_num_rows($Resultado) == 0){
            $Respuesta['estado'] = 'exitoso';
            $Respuesta['detalle'] = '';
            $Respuesta['codigo'] = 'API-200';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = 'No eres apto debido a que debe ' . mysqli_num_rows($Resultado) . " recursos a la biblioteca.";
            $Respuesta['codigo'] = 'API-147';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
          }

        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno';
          $Respuesta['codigo'] = 'API-144';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'No se ha encontrado el usuario.';
        $Respuesta['codigo'] = 'API-146';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }

      
    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-145';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }else if($Tipo == 'obtenerListado'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Usuario = $_SESSION['Id'];

    // Realizamos petición
    $Sql = "SELECT Id, Datos FROM `RecursosFisicos__Registros` WHERE Institucion = '$Institucion'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Registros = array();

      while($Registro = mysqli_fetch_array($Resultado)){
        $Registros[] = array("Id" => $Registro['Id'], "Datos" => json_decode($Registro['Datos']));
      }
        
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $Registros;
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-171';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
    }

  }else if($Tipo == 'obtenerEjemplares'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Registro = $_GET['Registro'];

    // Realizamos petición
    $Sql = "SELECT Id, CampoA, CampoL, Estado FROM `RecursosFisicos__Ejemplares` WHERE Registro = '$Registro'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Ejemplares = array();

      while($Ejemplar = mysqli_fetch_array($Resultado)){
        $Ejemplares[] = array("Id" => $Ejemplar['Id'], "CampoA" => $Ejemplar['CampoA'], "CampoL" => $Ejemplar['CampoL'], "Estado" => $Ejemplar['Estado']);
      }
        
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = array("Ejemplares" => $Ejemplares, "Cantidad" => mysqli_num_rows($Resultado));
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-172';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
    }

  }else if($Tipo == 'agregarRegistro'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Usuario = $_SESSION['Id'];
    $Datos = json_encode($_GET['Datos'], JSON_UNESCAPED_UNICODE);
    $DatosConvertidos = json_encode(array(
      "UUID" => "afce48a4-0645-49eb-a604-753f9ce0af3a",
      "Modificacion" => time(),
      "Modificador" => $Usuario,
      "Creacion" => time(),
      "Creador" => $Usuario,
      "Datos"=> $_GET['Datos'],
    ), JSON_UNESCAPED_UNICODE);
    $Datos245 = json_encode($_GET['DatosAdicionales']['245'], JSON_UNESCAPED_UNICODE);
    $Datos100 = json_encode($_GET['DatosAdicionales']['100'], JSON_UNESCAPED_UNICODE);
    $Datos659 = json_encode($_GET['DatosAdicionales']['659'], JSON_UNESCAPED_UNICODE);
    $Datos650 = json_encode($_GET['DatosAdicionales']['650'], JSON_UNESCAPED_UNICODE);
    $Datos653 = json_encode($_GET['DatosAdicionales']['653'], JSON_UNESCAPED_UNICODE);

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la petición
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-175';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['gestion_recursosfisicos_registros_agregar'] == true){

        // Ejecutamos petición
        $Sql = "INSERT INTO `RecursosFisicos__Registros`(`Institucion`, `Usuario`, `245`, `100`, `659`, `650`, `653`, `Datos`, `Fecha`) VALUES ('$Institucion','$Usuario','$Datos245','$Datos100','$Datos659','$Datos650','$Datos653','$DatosConvertidos','$Fecha')";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = 'Registro agregado con éxito.';
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno';
          $Respuesta['codigo'] = 'API-176';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para agregar registros.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta)); 
      }

    }

  }else if($Tipo == 'obtenerListadoEjemplares'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];

    // Realizamos petición
    $Sql = "SELECT Ejemplar.Id, Ejemplar.Registro AS RegistroId, Registro.245 AS Registro, Registro.100 AS Autor, Ejemplar.CampoA, Ejemplar.CampoB, Ejemplar.CampoC, Ejemplar.CampoD, Ejemplar.CampoE, Ejemplar.CampoF, Ejemplar.CampoG, Ejemplar.CampoH, Ejemplar.CampoL, Ejemplar.CampoM, Ejemplar.CampoN, Ejemplar.Estado FROM RecursosFisicos__Ejemplares Ejemplar INNER JOIN RecursosFisicos__Registros Registro ON Ejemplar.Registro = Registro.Id WHERE Ejemplar.Institucion = $Institucion";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Ejemplares = array();

      while($Ejemplar = mysqli_fetch_array($Resultado)){
        $Ejemplares[] = array(
          "Id" => $Ejemplar['Id'],
          "RegistroId" => $Ejemplar['RegistroId'],
          "Registro" => array(
            "Titulo" => json_decode($Ejemplar['Registro'], true),
            "Autor" => json_decode($Ejemplar['Autor'], true),
          ),
          "CampoA" => $Ejemplar['CampoA'],
          "CampoB" => $Ejemplar['CampoB'],
          "CampoC" => $Ejemplar['CampoC'],
          "CampoD" => $Ejemplar['CampoD'],
          "CampoE" => $Ejemplar['CampoE'],
          "CampoF" => $Ejemplar['CampoF'],
          "CampoG" => $Ejemplar['CampoG'],
          "CampoH" => $Ejemplar['CampoH'],
          "CampoL" => $Ejemplar['CampoL'],
          "CampoM" => $Ejemplar['CampoM'],
          "CampoN" => $Ejemplar['CampoN'],
          "Estado" => $Ejemplar['Estado']
        );
      }
        
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = array("Ejemplares" => $Ejemplares, "Cantidad" => mysqli_num_rows($Resultado));
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno' . mysqli_error($Conexión);
      $Respuesta['codigo'] = 'API-180';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
    }

  }else if($Tipo == 'obtenerListadoRegistro'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];

    // Realizamos petición
    $Sql = "SELECT Id, `245`, `100`, `659`, `650`, `653`, Datos FROM RecursosFisicos__Registros WHERE Institucion = $Institucion";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Registros = array();

      while($Registro = mysqli_fetch_array($Resultado)){
        $Registros[] = array(
          "Id" => $Registro['Id'],
          "245" => json_decode($Registro['245'], true),
          "100" => json_decode($Registro['100'], true),
          "659" => json_decode($Registro['659'], true),
          "650" => json_decode($Registro['650'], true),
          "653" => json_decode($Registro['653'], true),
          "Datos" => json_decode($Registro['Datos'], true),
        );
      }
        
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = array("Registros" => $Registros, "Cantidad" => mysqli_num_rows($Resultado));
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-181';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
    }

  }else if($Tipo == 'obtenerRegistroEspecifico'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Registro = $_GET["Registro"];

    // Realizamos petición
    $Sql = "SELECT Id, `245`, `100`, `659`, `650`, `653`, Datos FROM RecursosFisicos__Registros WHERE Institucion = $Institucion AND Id = $Registro";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Registro = mysqli_fetch_array($Resultado);
        
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = array(
        "Registro" => array(
          "Id" => $Registro['Id'],
          "245" => json_decode($Registro['245'], true),
          "100" => json_decode($Registro['100'], true),
          "659" => json_decode($Registro['659'], true),
          "650" => json_decode($Registro['650'], true),
          "653" => json_decode($Registro['653'], true),
          "Datos" => json_decode($Registro['Datos'], true),
          "cantidadEjemplares" => $Registro['cantidadEjemplares'],
        ),
        "Cantidad" => mysqli_num_rows($Resultado)
      );
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-182';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
    }

  }else if($Tipo == 'obtenerRegistroEspecificoEdicion'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Registro = $_GET["Registro"];

    // Realizamos petición
    $Sql = "SELECT Id, `245`, `100`, `659`, `650`, `653`, Datos FROM RecursosFisicos__Registros WHERE Institucion = $Institucion AND Id = $Registro";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Registro = mysqli_fetch_array($Resultado);
        
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = array(
        "Registro" => array(
          "Id" => $Registro['Id'],
          "245" => json_decode($Registro['245'], true),
          "100" => json_decode($Registro['100'], true),
          "659" => json_decode($Registro['659'], true),
          "650" => json_decode($Registro['650'], true),
          "653" => json_decode($Registro['653'], true),
          "Datos" => json_decode($Registro['Datos'], true),
          "cantidadEjemplares" => $Registro['cantidadEjemplares'],
        ),
        "Cantidad" => mysqli_num_rows($Resultado)
      );
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-182';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
    }

  }else if($Tipo == 'obtenerNotasDeContenido'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Registro = $_GET["Registro"];

    // Realizamos petición
    $Sql = "SELECT Datos FROM RecursosFisicos__Registros WHERE Institucion = $Institucion AND Id = $Registro";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Registro = mysqli_fetch_array($Resultado);

      $Datos = json_decode($Registro['Datos'], true);

      $Notas = array();

      if($Datos['Datos']['505'] !== undefined){
        if(count($Datos['Datos']['505']) > 0){
          for($i = 0; $i < count($Datos['Datos']['505']); $i++){
            $t = "";
            $r = "";
            if($Datos['Datos']['505'][$i]["t"] !== ""){
              $t = $Datos['Datos']['505'][$i]["t"];
            }
            if($Datos['Datos']['505'][$i]["r"] !== ""){
              $r = $Datos['Datos']['505'][$i]["r"];
            }
            $Notas[] = array("t" => $t, "r" => $r);
          } 
        }
      }
        
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $Notas;
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-183';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
    }

  }else if($Tipo == 'obtenerListadoEjemplaresEspecifico'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Registro = $_GET["Registro"];

    // Realizamos petición
    $Sql = "SELECT Id, CampoA, CampoH, CampoD, CampoL, CampoM, CampoN, Estado FROM `RecursosFisicos__Ejemplares` WHERE Institucion = $Institucion AND Registro = $Registro";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Ejemplares = array();

      while($Ejemplar = mysqli_fetch_array($Resultado)){

        $Ejemplares[] = array(
          "Id" => $Ejemplar["Id"],
          "CampoA" => $Ejemplar["CampoA"],
          "CampoH" => $Ejemplar["CampoH"],
          "CampoD" => $Ejemplar["CampoD"],
          "CampoL" => $Ejemplar["CampoL"],
          "CampoM" => $Ejemplar["CampoM"],
          "CampoN" => $Ejemplar["CampoN"],
          "Estado" => $Ejemplar["Estado"],
        );

      }
        
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $Ejemplares;
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-183';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
    }

  }else if($Tipo == 'obtenerEjemplar'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Ejemplar = $_GET["Ejemplar"];

    // Realizamos petición
    $Sql = "SELECT Id, Registro, CampoA, CampoB, CampoC, CampoD, CampoE, CampoF, CampoG, CampoH, CampoL, CampoM, CampoN, Estado FROM `RecursosFisicos__Ejemplares` WHERE Institucion = $Institucion AND Id = $Ejemplar";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Ejemplar = mysqli_fetch_array($Resultado);
        
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = array(
        "Id" => $Ejemplar["Id"],
        "Registro" => $Ejemplar["Registro"],
        "CampoA" => $Ejemplar["CampoA"],
        "CampoB" => $Ejemplar["CampoB"],
        "CampoC" => $Ejemplar["CampoC"],
        "CampoD" => $Ejemplar["CampoD"],
        "CampoE" => $Ejemplar["CampoE"],
        "CampoF" => $Ejemplar["CampoF"],
        "CampoG" => $Ejemplar["CampoG"],
        "CampoH" => $Ejemplar["CampoH"],
        "CampoL" => $Ejemplar["CampoL"],
        "CampoM" => $Ejemplar["CampoM"],
        "CampoN" => $Ejemplar["CampoN"],
        "Estado" => $Ejemplar["Estado"],
      );
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-184';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
    }

  }else if($Tipo == 'busquedaInterBibliotecaria'){

    // Se requiere sesión
    apiRequireSesion();

    // Verificamos tipo de petición
    $Insti = "";
    if($_GET['TipoInsti'] == 1){
      $Insti .= "WHERE R.Institucion IN (";
      for($i = 0; $i < count($_GET['Institucion']); $i++){
        if($i > 0){$Insti .= ",";}
        $Insti .= $_GET['Institucion'][$i];
      }
      $Insti .= ")";
    }

    // Realizamos la petición
    $Sql = "SELECT R.Id, R.Institucion, R.Datos, COUNT(E.Id) AS Cantidad FROM RecursosFisicos__Registros R JOIN RecursosFisicos__Ejemplares E ON R.Id = E.Registro $Insti GROUP BY R.Id, R.Institucion, R.Datos;";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos estado de le petición
    if($Resultado){

      $Registros = array();

      while($Registro = mysqli_fetch_array($Resultado)){
        $Registros[] = array(
          "Id" => $Registro["Id"],
          "Institucion" => $Registro["Institucion"],
          "Datos" => json_decode($Registro["Datos"]),
          "Cantidad" => $Registro["Cantidad"],
        );
      }

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $Registros;
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  
    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno.";
      $Respuesta['codigo'] = 'API-193';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
    }

  }else if($Tipo == 'obtenerMisRetiros'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];

    // Verificamos si la institución tiene habilitada la función
    if(verificarFunción(8)){

      // Obtenemos los retiros
      $SqlRetiro = "SELECT * FROM `RecursosFisicos__Retiros` WHERE IdUsuario = '$Usuario' ORDER BY FechaDeRetiro DESC";
      $ResultadoRetiro = mysqli_query($Conexión, $SqlRetiro);

      if($ResultadoRetiro){
        
        // Guardamos los recursos que ha retirado
        $RecursosABuscar = array();
        $Retiros = array();
        while($Retiro = mysqli_fetch_array($ResultadoRetiro)){
          $Recursos = json_decode($Retiro['RecursosRetirados']);
          for($i = 0; $i < count($Recursos); $i++){
            $RecursosABuscar[] = $Recursos[$i];
          }
          $Retiros[] = array(
            "Id" => $Retiro['Id'],
            "RecursosRetirados" => json_decode($Retiro['RecursosRetirados'], true),
            "FechaDeRetiro" => $Retiro['FechaDeRetiro'],
            "FechaDeDevolucion" => $Retiro['FechaDeDevolucion'],
            "TipoDeRetiro" => $Retiro['TipoDeRetiro'],
            "Estado" => $Retiro['Estado'],
            "Reseña" => $Retiro['Reseña'],
            "Observacion" => $Retiro['Observacion'],
            "RetiroReal" => $Retiro['RetiroReal'],
            "DevolucionReal" => $Retiro['DevolucionReal'],
          );
        }
        $VariableBusqueda = "";
        for($i = 0; $i < count($RecursosABuscar); $i++){
          if($i > 0){$VariableBusqueda .= ",";}
          $VariableBusqueda .= $RecursosABuscar[$i];
        }

        // Buscamos los recursos retirados
        $Sql = "SELECT E.Id, E.Registro AS RegistroID, E.CampoA AS EjemplarA, E.CampoB AS EjemplarB, E.CampoC AS EjemplarC, E.CampoD AS EjemplarD, E.CampoE AS EjemplarE, E.CampoF AS EjemplarF, E.CampoG AS EjemplarG, E.CampoH AS EjemplarH, E.CampoL AS EjemplarL, E.CampoM AS EjemplarM, E.CampoN AS EjemplarN, E.Estado AS EstadoEjemplar, R.Datos AS Registro FROM `RecursosFisicos__Ejemplares` E INNER JOIN RecursosFisicos__Registros R ON E.Registro = R.Id WHERE E.Id IN($VariableBusqueda)";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){
          
          // Establecemos variables
          $Registros = array();

          while($Registro = mysqli_fetch_array($Resultado)){
            $Registros[] = array(
              "Id" => $Registro["Id"],
              "RegistroID" => $Registro["RegistroID"],
              "EjemplarA" => $Registro["EjemplarA"],
              "EjemplarB" => $Registro["EjemplarB"],
              "EjemplarC" => $Registro["EjemplarC"],
              "EjemplarD" => $Registro["EjemplarD"],
              "EjemplarE" => $Registro["EjemplarE"],
              "EjemplarF" => $Registro["EjemplarF"],
              "EjemplarG" => $Registro["EjemplarG"],
              "EjemplarH" => $Registro["EjemplarH"],
              "EjemplarL" => $Registro["EjemplarL"],
              "EjemplarM" => $Registro["EjemplarM"],
              "EjemplarN" => $Registro["EjemplarN"],
              "EstadoEjemplar" => $Registro["EstadoEjemplar"],
              "Registro" => json_decode($Registro["Registro"], true),
            );
          }

          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = array("Retiros" => $Retiros, "Registros" => $Registros);
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    

        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = "Hubo un error interno";
          $Respuesta['codigo'] = 'API-204';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "Hubo un error interno";
        $Respuesta['codigo'] = 'API-203';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "La institución tiene deshabilitada esta función.";
      $Respuesta['codigo'] = 'API-202';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));    
    }

  }else{
    $Respuesta['estado'] = 'error';
    $Respuesta['detalle'] = 'Petición errónea';
    $Respuesta['codigo'] = 'API-000';
    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
  }

?>