<?php 

  // Importamos sistema
  require("../sistema.php");

  // Establecemos variables
  $Tipo = $_GET['Tipo'];
  require_once "vendor/autoload.php";

  // Vemos que tipo es la consulta
  if($Tipo == 'Obtener'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Usuario = $_SESSION['Id'];

    $Sql = "SELECT * FROM `RecursosOnline` WHERE Institucion = '$Institucion' OR Despliegue = 1 Order BY Id DESC";

    // Ejecutamos la peticion
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos estado de la peticion
    if($Resultado){

      // Establecemos los datos
      $Datos = array();

      // Obtenemos institucion
      $SqlInstitucion = "SELECT Id, Estado, Nombre, Abreviado FROM `Instituciones` WHERE Id = '$Institucion'";
      $ResultadoInstitucion = mysqli_query($Conexión, $SqlInstitucion);
      $InstitucionDatos = mysqli_fetch_array($ResultadoInstitucion);

      $DatosTotal = mysqli_num_rows($Resultado);

      while($Online = mysqli_fetch_array($Resultado)) { 

        $ID = $Online['Usuarios'];
 
        $SqlUsuarios = "SELECT Id, Nombre, Apellido, Usuario, ImagenPerfil, Estado FROM `Usuarios` WHERE Id = '$ID'";
        $ResultadoUsuarios = mysqli_query($Conexión, $SqlUsuarios);
        $Usuario = mysqli_fetch_array($ResultadoUsuarios);

        $Datos[] = array(
          "Id" => $Online['Id'],
          "Visitas" => $Online['Visitas'],
          "Institucion" => $Online['Institucion'],
          "Usuario" => $Usuario['Usuario'],
          "EstadoUsuario" => $Usuario['Estado'],
          "Categoria" => $Online['Categoria'],
          "Titulo" => $Online['Titulo'],
          "Descripcion" => $Online['Descripcion'],
          "Etiquetas" => explode(",", $Online['Etiquetas']),
          "IdDrive" => $Online['IdDrive'],
          "Fecha" => $Online['Fecha'],
          "Despliegue" => $Online['Despliegue'],
          "NombreInstitucion" => $InstitucionDatos['Nombre'],
          "NombreInstitucionAbreviacion" => $InstitucionDatos['Abreviado'],
          "Nombre" => $Usuario['Nombre'] . " " . $Usuario['Apellido'],
          "ImagenPerfil" => $Usuario['ImagenPerfil'],
          "Tipo" => $Online['Tipo'],
        );

        /*
          
          Tipos:
            0: Imagen (Drive)
            1: PDF (Drive)
            2: Word (Drive)
            3: Excel (Drive)
            4: Power Point  (Drive)
            5: Video (Drive)
            6: Video (Youtube)
        
        */

      }

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = array("Datos" => $Datos, "Total" => $DatosTotal);
      $Respuesta['codigo'] = "API-043";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = "API-200";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }else if($Tipo == 'ObtenerDeInstitucion'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
  
    // Establecemos petición
    $Sql = "SELECT RecursosOnline.Id, CONCAT(Usuarios.Nombre, ' ', Usuarios.Apellido) AS Usuario, RecursosOnline.Titulo, RecursosOnline.Descripcion, RecursosOnline.Etiquetas, RecursosOnline.IdDrive, RecursosOnline.Fecha, RecursosOnline.Despliegue, RecursosOnline.Comentarios, RecursosOnline.Tipo, RecursosOnline.Visitas, RecursosOnline.Categoria FROM RecursosOnline JOIN Usuarios ON RecursosOnline.Usuarios = Usuarios.Id WHERE RecursosOnline.Institucion = '$Institucion'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos estado de la peticion
    if($Resultado){

      // Establecemos los datos
      $Datos = array();

      while($Recurso = mysqli_fetch_array($Resultado)) { 

        $Datos[] = array(
          "Id" => $Recurso['Id'],
          "Usuario" => $Recurso['Usuario'],
          "Titulo" => $Recurso['Titulo'],
          "Descripcion" => $Recurso['Descripcion'],
          "Etiquetas" => $Recurso['Etiquetas'],
          "IdDrive" => $Recurso['IdDrive'],
          "Fecha" => $Recurso['Fecha'],
          "Despliegue" => $Recurso['Despliegue'],
          "Comentarios" => $Recurso['Comentarios'],
          "Tipo" => $Recurso['Tipo'],
          "Visitas" => $Recurso['Visitas'],
          "Categoria" => $Recurso['Categoria'],
        );

      }

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $Datos;
      $Respuesta['codigo'] = "API-200";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno' . $Sql;
      $Respuesta['codigo'] = "API-093";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }elseif($Tipo == 'ObtenerMinuatura'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Miniatura = $_GET['Miniatura'];

    if($_GET['TipoRecurso'] == '6'){

      $Datos = file_get_contents("https://www.googleapis.com/youtube/v3/videos?id=" . $Miniatura . "&key=AIzaSyCv_IXH-iimViA32mFRLrYSeuGeeC2Y-Fs&fields=items(snippet(thumbnails))&part=snippet");

      $NuevosDatos = json_decode($Datos, true);
      
      header('Content-type:image/jpeg');
      readfile($NuevosDatos['items'][0]["snippet"]["thumbnails"]['high']['url']);

    }else{

      $accessToken = "AIzaSyCv_IXH-iimViA32mFRLrYSeuGeeC2Y-Fs";
      $fileInfoUrl = "https://www.googleapis.com/drive/v3/files/$Miniatura?key=$accessToken&fields=thumbnailLink";
      $fileInfo = json_decode(file_get_contents($fileInfoUrl));
      $posterUrl = $fileInfo->thumbnailLink;

      // Obtener la imagen en formato WebP
      header('Content-Type: image/webp');
      $imgData = file_get_contents($posterUrl);

      // Convertir la imagen a formato WebP
      $im = imagecreatefromstring($imgData);
      imagewebp($im);

      // Liberar memoria
      imagedestroy($im);

    }

  }elseif($Tipo == 'ObtenerTitulo'){

    // Se requiere sesión
    apiRequireSesion();

    if(isset($_GET['IdVideo'])){

      $Datos = json_decode(file_get_contents("https://www.googleapis.com/youtube/v3/videos?id=" . $_GET['IdVideo'] . "&key=AIzaSyCv_IXH-iimViA32mFRLrYSeuGeeC2Y-Fs&part=snippet"), true);
        
      echo $Datos['items'][0]['snippet']['title'];

    }else if(isset($_GET['IdDrive'])){
      
      $Datos = json_decode(file_get_contents("https://content.googleapis.com/drive/v3/files/" . $_GET['IdDrive'] . "?key=AIzaSyCv_IXH-iimViA32mFRLrYSeuGeeC2Y-Fs"), true);

      echo json_encode($Datos, JSON_UNESCAPED_UNICODE);

    }
    

  }elseif($Tipo == 'ObtenerEspecifico'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Recurso = $_GET['Recurso'];
    $Institucion = $_SESSION['Institucion'];

    // Realizamos petición
    $Sql = "SELECT * FROM `RecursosOnline` WHERE Id = '$Recurso' AND Institucion = '$Institucion' OR Id = '$Recurso' AND Despliegue = 1";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la peticion
    if(!$Recurso){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno al momento de cargar el recurso.';
      $Respuesta['codigo'] = 'API-044';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Verificamos la cantidad de resultados
      if(mysqli_num_rows($Resultado) == 0){
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'El recurso que buscas es inexistente o no esta disponible para tu institucion.';
        $Respuesta['codigo'] = 'API-045';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }else{

        $Online = mysqli_fetch_array($Resultado);
        $Usuario = $Online['Usuarios'];
        $Institucion = $Online['Institucion'];

        $SqlUsuarios = "SELECT Id, Nombre, Apellido, Usuario, ImagenPerfil, Estado FROM `Usuarios` WHERE Id = '$Usuario'";
        $ResultadoUsuarios = mysqli_query($Conexión, $SqlUsuarios);
        $UsuarioRecurso = mysqli_fetch_array($ResultadoUsuarios);

        $SqlInstitucion = "SELECT Id, Estado, Nombre, Abreviado FROM `Instituciones` WHERE Id = '$Institucion'";
        $ResultadoInstitucion = mysqli_query($Conexión, $SqlInstitucion);
        $InstitucionDatos = mysqli_fetch_array($ResultadoInstitucion);

        $SqlComentarios = "SELECT * FROM `Comentarios` WHERE IdRecurso = '$Recurso' AND Estado = '1' OR IdRecurso = '$Recurso' AND Estado = '2' ORDER BY Fecha DESC";
        $ResultadoComentarios = mysqli_query($Conexión, $SqlComentarios);

        $Comentarios = array();
        while($Comentario = mysqli_fetch_array($ResultadoComentarios)) { 
          $Id = $Comentario['IdUsuario'];
          $SqlUsuario = "SELECT Nombre, Apellido, Usuario, ImagenPerfil, Estado FROM `Usuarios` WHERE Id = '$Id'";
          $ResultadoUsuario = mysqli_query($Conexión, $SqlUsuario);
          $Usuario = mysqli_fetch_array($ResultadoUsuario);

          $Comentarios[] = array('Id' => $Comentario['Id'], 'Usuario' => array('Nombre' => $Usuario['Nombre'], 'Apellido' => $Usuario['Apellido'], 'Usuario' => $Usuario['Usuario'], 'ImagenPerfil' => $Usuario['ImagenPerfil'], 'Estado' => $Usuario['Estado']), 'Comentario' => $Comentario['Comentario'], 'Hace' => haceTiempo($Comentario['Fecha']));

        }

        $Datos = array(
          "Id" => $Online['Id'],
            "Institucion" => $Online['Institucion'],
            "Usuario" => $UsuarioRecurso['Usuario'],
            "EstadoUsuario" => $UsuarioRecurso['Estado'],
            "IdUsuario" => $UsuarioRecurso['Id'],
            "Titulo" => $Online['Titulo'],
            "Categoria" => $Online['Categoria'],
            "Visitas" => $Online['Visitas']+1,
            "Descripcion" => $Online['Descripcion'],
            "Etiquetas" => explode(",", $Online['Etiquetas']),
            "IdDrive" => $Online['IdDrive'],
            "Fecha" => $Online['Fecha'],
            "Despliegue" => $Online['Despliegue'],
            "Comentarios" => $Online['Comentarios'],
            "NombreInstitucion" => $InstitucionDatos['Nombre'],
            "NombreInstitucionAbreviado" => $InstitucionDatos['Abreviado'],
            "Nombre" => $UsuarioRecurso['Nombre'] . " " . $UsuarioRecurso['Apellido'],
            "ImagenPerfil" => $UsuarioRecurso['ImagenPerfil'],
            "Tipo" => $Online['Tipo'],
            "ComentariosLista" => $Comentarios,
          );

          /*
           
            Tipos:
              0: Imagen (Drive)
              1: PDF (Drive)
              2: Word (Drive)
              3: Excel (Drive)
              4: Power Point (Drive)
              5: Video (Drive)
              6: Video (Youtube)
              7: Link externo
            
            */

          // Mostramos estatado
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = $Datos;
          $Respuesta['codigo'] = "API-200";
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

          // Agregamos visita
          $NV = $Datos['Visitas'];
          $Sql = "UPDATE `RecursosOnline` SET `Visitas`='$NV' WHERE Id = '$Recurso'";
          $Resultado = mysqli_query($Conexión, $Sql);
        

      }

    }

  }elseif($Tipo == 'Reportar'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Opcion = $_GET['Opcion'];
    $Detalles = $_GET['Detalles'];
    $Usuario = $_SESSION['Id'];
    $Recurso = $_GET['Recurso'];

    // Validamos si cumple con los requisitos
    if(!isset($_GET['Opcion']) && $_GET['Opcion'] < 1 && $_GET['Opcion'] > 13){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Debes seleccionar una opcion valida";
      $Respuesta['codigo'] = 'API-046';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(strlen($_GET['Detalles']) < 5){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "La descripcion es corta, ¿Crees que puedes extenderla?";
      $Respuesta['codigo'] = 'API-047';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));  
    }else if(strlen($_GET['Detalles']) > 1000){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "La descripcion es larga, ¿Crees que puedes resumirla?";
      $Respuesta['codigo'] = 'API-048';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Establecemos datos del reporte
      $DatosDelReporte = json_encode(array("Opcion" => $Opcion, "Detalles" => $Detalles), JSON_UNESCAPED_UNICODE);

      // Realizamos peticion
      $Sql = "INSERT INTO `Reportes`(`Reportador`, `Reportado`, `Detalles`) VALUES ('$Usuario','$Recurso','$DatosDelReporte')";
      $Resultado = mysqli_query($Conexión, $Sql);

      if(!$Resultado){
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "Error interno central.";
        $Respuesta['codigo'] = 'API-049';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }else{
        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = mysqli_insert_id($Conexión);
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }
    }

  }elseif($Tipo == 'agregarComentario'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $Recurso = $_GET['Recurso'];
    $Comentario = $_GET['Comentario'];
    $Fecha = date('Y-h-d H-i-s');

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);
    
    // Verificamos el estado de la peticion
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-050';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{
      
      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['agregarComentario'] == true){

      // Verificamos si el comentario tiene palabras malsonantes
      if(verificarMalsonantes($Comentario) == 'Moderado'){
        $ComentarioVerificado = "-||-MODERADO-||-";
        $EstadpoComentario = '2';
      }else{
        $ComentarioVerificado = $Comentario;
        $EstadpoComentario = '1';
      }

      /*
       Estados de comentarios
        1. Enviado
        2. Se a detectado palabras malsonantes
        3. Editado
        4. Editado, se ha detectado palabras malsonantes
        5. Comentario verificado por un moderador
        6. Comentario eliminado
        7. Comentario eliminado por un moderador
      */

      // Ejecutamos consulta
      $Sql = "INSERT INTO `Comentarios`(`IdUsuario`, `IdRecurso`, `Comentario`, `ComentarioOriginal`, `Estado`, `Fecha`) VALUES ('$Usuario','$Recurso','$ComentarioVerificado','$Comentario','$EstadpoComentario','$Fecha')";
      $Resultado = mysqli_query($Conexión, $Sql);

      // Verificamos si la consulta fue exitosa
      if(!$Resultado){
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = 'API-051';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }else{
        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = verificarMalsonantes($Comentario);
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Careces de permisos para enviar comentarios.';
      $Respuesta['codigo'] = 'API-403';
      print_r(json_encode($Respuesta)); 
    }
    
    }
    

  }elseif($Tipo == 'agregar'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);
    
    // Verificamos el estado de la peticion
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-052';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Establecemos permisos
      $Permisos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      if($Permisos['agregarRecursoOnline'] == true){

        // Establecemos variables
        $Titulo = $_POST['Titulo'];
        $Descripción = $_POST['Descripción'];
        $Archivo = $_POST['Archivo'];
        $Etiquetas = $_POST['Etiquetas'];
        $Despliegue = $_POST['Despliegue'];
        $Comentarios = $_POST['Comentarios'];
        $Categoria = $_POST['Categoria'];
        $Tipo = $_POST['Tipo'];
        $Fecha = date('Y-h-d H-i-s');
        $Usuario = $_SESSION['Id'];
        $Institucion = $_SESSION['Institucion'];
        
        if(strlen($Titulo) < 5){
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'El titulo ingresa es demaciado corto.';
          $Respuesta['codigo'] = 'API-053';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }else if(strlen($Titulo) > 300){
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'El titulo ingresa es demaciado largo.';
          $Respuesta['codigo'] = 'API-054';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }else if(strlen($Descripción) > 1000){
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'La descripcion ingresada es muy larga.';
          $Respuesta['codigo'] = 'API-055';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }else if(strlen($Archivo) < 1){
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Debe ingresar un Id de Archivo';
          $Respuesta['codigo'] = 'API-056';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }else{

          // Verificamos si esta activo el despliegue y comentarios
          if($Despliegue == "on"){$Despliegue = '1';}else{$Despliegue = '0';}
          if($Comentarios == "on"){$Comentarios = '1';}else{$Comentarios = '0';}

          // Realizamos peticion
          $Sql = "INSERT INTO `RecursosOnline`(`Institucion`, `Usuarios`, `Titulo`, `Descripcion`, `Etiquetas`, `IdDrive`, `Fecha`, `Despliegue`, `Comentarios`, `Tipo`, `Categoria`) VALUES ('$Institucion','$Usuario','$Titulo','$Descripción','$Etiquetas','$Archivo','$Fecha','$Despliegue','$Comentarios','$Tipo', '$Categoria')";
          $Resultado = mysqli_query($Conexión, $Sql);

          if($Resultado){
            $Respuesta['estado'] = 'exitoso';
            $Respuesta['detalle'] = mysqli_insert_id($Conexión);
            $Respuesta['codigo'] = 'API-200';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = 'Hubo un error interno';
            $Respuesta['codigo'] = 'API-057';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
          }
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para añadir Recursos Online.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }
    
    }
    

  }elseif($Tipo == 'descargarBackup'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $Institucion = $_SESSION['Institucion'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);
    
    // Verificamos el estado de la peticion
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-094';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Establecemos permisos
      $Permisos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      if($Permisos['descargarBackup'] == true){

        // Realizamos peticion
        $Sql = "SELECT * FROM `RecursosOnline` WHERE Institucion = '$Institucion'";
        $Resultado = mysqli_query($Conexión, $Sql);

        $Archivo = tmpfile();

        while ($Recurso = mysqli_fetch_assoc($Resultado)) {
          fputcsv($Archivo, $Recurso);
        }

        $Fecha = date("d-m-y-H-i-s");

        header('Content-Type: text/csv');
        header('Content-Disposition: attachment; filename="Backup-RecursosOnline-' . $Fecha . '.csv"');
        header('Pragma: no-cache');
        header('Expires: 0');

        rewind($Archivo);
        fpassthru($Archivo);
        fclose($Archivo);


      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para descargar Backups.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }
    
    }
    

  }elseif($Tipo == 'editar'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $Recurso = $_GET['Recurso'];

    // Establecemos variables
    $Titulo = $_POST['Titulo'];
    $Descripción = $_POST['Descripción'];
    $Archivo = $_POST['Archivo'];
    $Etiquetas = $_POST['Etiquetas'];
    $Despliegue = $_POST['Despliegue'];
    $Comentarios = $_POST['Comentarios'];
    $Categoria = $_POST['Categoria'];
    $Tipo = $_POST['Tipo'];
    $Fecha = date('Y-h-d H-i-s');
    $Usuario = $_SESSION['Id'];
    $Institucion = $_SESSION['Institucion'];
        
    if(strlen($Titulo) < 5){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El titulo ingresa es demaciado corto.';
      $Respuesta['codigo'] = 'API-082';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else if(strlen($Titulo) > 300){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El titulo ingresa es demaciado largo.';
      $Respuesta['codigo'] = 'API-083';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else if(strlen($Descripción) > 1000){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'La descripcion ingresada es muy larga.';
      $Respuesta['codigo'] = 'API-084';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else if(strlen($Archivo) < 1){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Debe ingresar un Id de Archivo';
      $Respuesta['codigo'] = 'API-085';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else{

      // Verificamos si esta activo el despliegue y comentarios
      if($Despliegue == "on"){$Despliegue = '1';}else{$Despliegue = '0';}
      if($Comentarios == "on"){$Comentarios = '1';}else{$Comentarios = '0';}

      // Realizamos peticion
      $Sql = "UPDATE `RecursosOnline` SET `Titulo`='$Titulo',`Descripcion`='$Descripción',`Etiquetas`='$Etiquetas',`IdDrive`='$Archivo',`Despliegue`='$Despliegue',`Comentarios`='$Comentarios',`Tipo`='$Tipo',`Categoria`='$Categoria' WHERE Usuarios = '$Usuario' AND Id = '$Recurso'";
      $Resultado = mysqli_query($Conexión, $Sql);

      if($Resultado){
        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = '';
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = 'API-086';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }
    }

  }elseif($Tipo == 'obtenerDatos'){

    // Se requiere sesión
    apiRequireSesion();

    $client = new Google_Client();
    $client->setApplicationName("SIBAU");
    $client->setDeveloperKey("AIzaSyCv_IXH-iimViA32mFRLrYSeuGeeC2Y-Fs");

    $service = new Google_Service_Drive($client);

    function printFile($service, $fileId) {
      try {
        $file = $service->files->get($fileId);
    
        print_r($file['thumbnailLink']);
        /*print "Title: " . $file->getTitle();
        print "Description: " . $file->getDescription();
        print "MIME type: " . $file->getMimeType();*/
      } catch (Exception $e) {
        print "An error occurred: " . $e->getMessage();
      }
    }

    printFile($service, "1osU9r-krGmDHGSPukkGqqCVdyXzWnEMq");
    


  }else{
    $Respuesta['estado'] = 'error';
    $Respuesta['detalle'] = 'Petición errónea';
    $Respuesta['codigo'] = 'API-000';
    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
  }

?>