<?php 

  /*

    Tipos de usuarios:

    0. Usuario sin correo verificado.
    1. Usuario sin verificar.
    2. Usuario verificado.
    3. Auxiliar de biblioteca.
    4. Equipo directivo.
    5. Desarrollador.
    6. Beta Tester.
    7. Desarrollador y Fundador.
    8. Usuario bloqueado.

  */

  // Importamos sistema
  require("../sistema.php");

  // Importamos librerias
  use PHPMailer\PHPMailer\PHPMailer;
  use PHPMailer\PHPMailer\SMTP;
  use PHPMailer\PHPMailer\Exception;
  require_once "vendor/autoload.php";

  // Establecemos variables
  $Tipo;
  if(isset($_GET['Tipo'])){
    $Tipo = $_GET['Tipo'];
  }else{
    $Tipo = $_POST['Tipo'];
  }

  // Vemos que tipo es la consulta
  if($Tipo == 'Registro'){

    // Datos enviados
    $Nombre = $_POST['Nombre'];
    $Apellido = $_POST['Apellido'];
    $DNI = $_POST['DNI'];
    $Correo = $_POST['Correo'];
    $Contraseña = $_POST['Contraseña'];
    $RepetirContraseña = $_POST['RepetirContraseña'];
    $Usuario = $_POST['Usuario'];
    $Genero = $_POST['Genero'];
    $Telefono = $_POST['Telefono'];
    $Institucion = $_POST['Institucion'];
    $ImagenDePerfil = $_POST['ImagenDePerfil'];

    // Verificamos si la peticion cumple con los requisitos
    if(!preg_match("/^[a-z A-ZÀ-ÿ\s]+$/", $Nombre)){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El nombre cuenta con caracteres inválidos.';
      $Respuesta['codigo'] = 'API-006';
      $Respuesta['caja'] = 'ErrorNombre';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(strlen($Nombre) < 3){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El nombre es demasiado corto,';
      $Respuesta['codigo'] = 'API-007';
      $Respuesta['caja'] = 'ErrorNombre';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(strlen($Nombre) > 20){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El nombre es demasiado largo,';
      $Respuesta['codigo'] = 'API-008';
      $Respuesta['caja'] = 'ErrorNombre';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(!preg_match("/^[a-z A-ZÀ-ÿ\s]+$/", $Apellido)){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El apellido cuenta con caracteres inválidos.';
      $Respuesta['codigo'] = 'API-009';
      $Respuesta['caja'] = 'ErrorApellido';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(strlen($Apellido) < 3){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El apellido es demasiado corto.';
      $Respuesta['codigo'] = 'API-010';
      $Respuesta['caja'] = 'ErrorApellido';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(strlen($Apellido) > 50){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El apellido es demasiado largo.';
      $Respuesta['codigo'] = 'API-011';
      $Respuesta['caja'] = 'ErrorApellido';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(!preg_match("/^[0-9\s]+$/", $DNI)){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El DNI cuenta con caracteres invalidos';
      $Respuesta['codigo'] = 'API-012';
      $Respuesta['caja'] = 'ErrorDNI';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(strlen($DNI) == 0){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Debe ingresar un DNI.';
      $Respuesta['codigo'] = 'API-013';
      $Respuesta['caja'] = 'ErrorDNI';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(!preg_match("/^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}$/", $Correo)){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El Correo cuenta con caracteres invalidos';
      $Respuesta['codigo'] = 'API-014';
      $Respuesta['caja'] = 'ErrorCorreo';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(!preg_match("/^[a-zA-Z0-9\-*?!@#$\/(){}=.;,:\s]+$/", $Contraseña)){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'La contraseña cuenta con caracteres invalidos';
      $Respuesta['codigo'] = 'API-015';
      $Respuesta['caja'] = 'ErrorContraseña';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(strlen($Contraseña) < 8){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'La contraseña es demasiado corta.';
      $Respuesta['codigo'] = 'API-016';
      $Respuesta['caja'] = 'ErrorContraseña';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(strlen($Contraseña) > 50){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'La contraseña es demasiado larga.';
      $Respuesta['codigo'] = 'API-017';
      $Respuesta['caja'] = 'ErrorContraseña';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(!preg_match("/[A-Z]/", $Contraseña) || !preg_match("/[a-z]/", $Contraseña) || !preg_match("/[0-9]/", $Contraseña)){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'La contraseña no cumple con la regla de almenos una mayuscula, minuscula y un numero.';
      $Respuesta['codigo'] = 'API-018';
      $Respuesta['caja'] = 'ErrorContraseña';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if($Contraseña !== $RepetirContraseña){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Repetir contraseña no es igual a la contraseña';
      $Respuesta['codigo'] = 'API-019';
      $Respuesta['caja'] = 'ErrorRepetirContraseña';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else if(mysqli_num_rows(mysqli_query($Conexión, "SELECT Estado FROM `Instituciones` WHERE Id = '$Institucion' AND Estado = '1'")) !== 1){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error a la hora de validar la institucion';
      $Respuesta['codigo'] = 'API-019';
      $Respuesta['caja'] = 'ErrorInstitucion';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Encriptamos contraseña
      $ContraseñaEncriptada = crypt($Contraseña, '$2a$07$firefoxedge2000NetKarmaNe$');
      
      // Generamos token
      $Token = bin2hex(random_bytes(25));

      // Establecemos los datos
      $Datos = json_encode(array('Genero' => $Genero, 'Telefono' => $Telefono), JSON_UNESCAPED_UNICODE);

      // Ya validado ejecutamos consulta en MySQL
      $Sql = "INSERT INTO `Usuarios`(`Nombre`, `Apellido`, `DNI`, `Usuario`, `Correo`, `Contraseña`, `ImagenPerfil`, `Registro`, `Institucion`, `Confirmacion`, `Datos`, `Permisos`) VALUES ('$Nombre', '$Apellido', '$DNI', '$Usuario', '$Correo', '$ContraseñaEncriptada','$ImagenDePerfil','$Fecha','$Institucion','$Token','$Datos','{}')";
      $Resultado = mysqli_query($Conexión, $Sql);

      if(!$Resultado){
        
        if(substr(mysqli_error($Conexión), -4) == "DNI'"){
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = "El DNI ingresado ya se encuentra en uso.";
          $Respuesta['codigo'] = 'API-022';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }else if(substr(mysqli_error($Conexión), -7) == "Correo'"){
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = "El Correo ingresado ya se encuentra en uso.";
          $Respuesta['codigo'] = 'API-023';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }else if(substr(mysqli_error($Conexión), -8) == "Usuario'"){
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = "El Usuario ingresado ya se encuentra en uso.";
          $Respuesta['codigo'] = 'API-024';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = "Hubo un error al realizar la petición.";
          $Respuesta['codigo'] = 'API-020';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }

      }else{

        // Creamos variables SMTP
        $SMTP_Dominio = 'cpanel118.wnpservers.net';
        $SMTP_Puerto = '587';
        $SMTP_Usuario = 'no-responde@sibau.com.ar';
        $SMTP_Envio = 'no-responde@sibau.com.ar';
        $SMTP_Contraseña = 'UxKevoO2-{V!BjBPE~';
        $SMTP_Seguridad = 'tls';
        $SMTP_Nombre = 'SIBAU - Sistema Integral Bibliotecario';
        $RespondeA = 'no-responde@sibau.com.ar';
        $Token2 = "a";

        // Creamos mail
        $mail = new PHPMailer(true);

        // UTF-8
        $mail->CharSet = 'UTF-8';
        $mail->Encoding = "base64";

        // Establecemos Debug
        $mail->SMTPDebug = 0; 

        // Establecemos que es SMTP
        $mail->isSMTP();            

        // Establecemos el dominio SMTP                     
        $mail->Host = $SMTP_Dominio;

        // Habilitamos la autenticación
        $mail->SMTPAuth = true;        

        // Establecemos el usuario SMTP 
        $mail->Username = $SMTP_Usuario;
        
        // Establecemos la contraseña SMTP
        $mail->Password = $SMTP_Contraseña;
        
        // Establecemos conexión
        $mail->SMTPAutoTLS = false;
        $mail->SMTPSecure = false;   

        // Establecemos el puerto
        $mail->Port = $SMTP_Puerto;   
        
        // Establecemos correo de envió
        $mail->From = $SMTP_Envio;

        // Establecemos nombre de correo de envió
        $mail->FromName = $SMTP_Nombre;

        // Establecemos la respuesta
        $mail->addReplyTo($RespondeA);

        // Agregamos destinatario    
        $mail->addAddress($Correo);

        // Establecemos que el contenido es HTML
        $mail->isHTML(true);

        // Establecemos Asunto
        $mail->Subject = 'Sibau - Verifica tu correo electrónico';

        // Establecemos Cuerpo
        $mail->Body = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml" xmlns:o="urn:schemas-microsoft-com:office:office" style="font-family:arial, "helvetica neue", helvetica,sans-serif"><head><meta charset="UTF-8"><meta content="width=device-width, initial-scale=1" name="viewport"><meta name="x-apple-disable-message-reformatting"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta content="telephone=no" name="format-detection"><title>Nuevo mensaje 4</title><!--[if (mso 16)]><style type="text/css">     a {text-decoration: none;}     </style><![endif]--><!--[if gte mso 9]><style>sup { font-size: 100% !important; }</style><![endif]--><!--[if gte mso 9]><xml> <o:OfficeDocumentSettings> <o:AllowPNG></o:AllowPNG> <o:PixelsPerInch>96</o:PixelsPerInch> </o:OfficeDocumentSettings> </xml><![endif]--><!--[if !mso]><!-- --><link href="https://fonts.googleapis.com/css2?family=Imprima&display=swap" rel="stylesheet"><!--<![endif]--><style type="text/css">#outlook a {	padding:0;}.es-button {	mso-style-priority:100!important;	text-decoration:none!important;}a[x-apple-data-detectors] {	color:inherit!important;	text-decoration:none!important;	font-size:inherit!important;	font-family:inherit!important;	font-weight:inherit!important;	line-height:inherit!important;}.es-desk-hidden {	display:none;	float:left;	overflow:hidden;	width:0;	max-height:0;	line-height:0;	mso-hide:all;}@media only screen and (max-width:600px) {p, ul li, ol li, a { line-height:150%!important } h1, h2, h3, h1 a, h2 a, h3 a { line-height:120% } h1 { font-size:30px!important; text-align:left } h2 { font-size:24px!important; text-align:left } h3 { font-size:20px!important; text-align:left } .es-header-body h1 a, .es-content-body h1 a, .es-footer-body h1 a { font-size:30px!important; text-align:left } .es-header-body h2 a, .es-content-body h2 a, .es-footer-body h2 a { font-size:24px!important; text-align:left } .es-header-body h3 a, .es-content-body h3 a, .es-footer-body h3 a { font-size:20px!important; text-align:left } .es-menu td a { font-size:14px!important } .es-header-body p, .es-header-body ul li, .es-header-body ol li, .es-header-body a { font-size:14px!important } .es-content-body p, .es-content-body ul li, .es-content-body ol li, .es-content-body a { font-size:14px!important } .es-footer-body p, .es-footer-body ul li, .es-footer-body ol li, .es-footer-body a { font-size:14px!important } .es-infoblock p, .es-infoblock ul li, .es-infoblock ol li, .es-infoblock a { font-size:12px!important } *[class="gmail-fix"] { display:none!important } .es-m-txt-c, .es-m-txt-c h1, .es-m-txt-c h2, .es-m-txt-c h3 { text-align:center!important } .es-m-txt-r, .es-m-txt-r h1, .es-m-txt-r h2, .es-m-txt-r h3 { text-align:right!important } .es-m-txt-l, .es-m-txt-l h1, .es-m-txt-l h2, .es-m-txt-l h3 { text-align:left!important } .es-m-txt-r img, .es-m-txt-c img, .es-m-txt-l img { display:inline!important } .es-button-border { display:block!important } a.es-button, button.es-button { font-size:18px!important; display:block!important; border-right-width:0px!important; border-left-width:0px!important; border-top-width:15px!important; border-bottom-width:15px!important } .es-adaptive table, .es-left, .es-right { width:100%!important } .es-content table, .es-header table, .es-footer table, .es-content, .es-footer, .es-header { width:100%!important; max-width:600px!important } .es-adapt-td { display:block!important; width:100%!important } .adapt-img { width:100%!important; height:auto!important } .es-m-p0 { padding:0px!important } .es-m-p0r { padding-right:0px!important } .es-m-p0l { padding-left:0px!important } .es-m-p0t { padding-top:0px!important } .es-m-p0b { padding-bottom:0!important } .es-m-p20b { padding-bottom:20px!important } .es-mobile-hidden, .es-hidden { display:none!important } tr.es-desk-hidden, td.es-desk-hidden, table.es-desk-hidden { width:auto!important; overflow:visible!important; float:none!important; max-height:inherit!important; line-height:inherit!important } tr.es-desk-hidden { display:table-row!important } table.es-desk-hidden { display:table!important } td.es-desk-menu-hidden { display:table-cell!important } .es-menu td { width:1%!important } table.es-table-not-adapt, .esd-block-html table { width:auto!important } table.es-social { display:inline-block!important } table.es-social td { display:inline-block!important } .es-desk-hidden { display:table-row!important; width:auto!important; overflow:visible!important; max-height:inherit!important } }</style></head><body style="width:100%;font-family:arial, "helvetica neue", helvetica, sans-serif;-webkit-text-size-adjust:100%;-ms-text-size-adjust:100%;padding:0;Margin:0"><div class="es-wrapper-color" style="background-color:#4E73DF"><!--[if gte mso 9]><v:background xmlns:v="urn:schemas-microsoft-com:vml" fill="t"> <v:fill type="tile" color="#4e73df"></v:fill> </v:background><![endif]--><table class="es-wrapper" width="100%" cellspacing="0" cellpadding="0" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;padding:0;Margin:0;width:100%;height:100%;background-repeat:repeat;background-position:center top;background-color:#4E73DF"><tr><td valign="top" style="padding:0;Margin:0"><table cellpadding="0" cellspacing="0" class="es-footer" align="center" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;table-layout:fixed !important;width:100%;background-color:transparent;background-repeat:repeat;background-position:center top"><tr><td align="center" style="padding:0;Margin:0"><table bgcolor="#bcb8b1" class="es-footer-body" align="center" cellpadding="0" cellspacing="0" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;background-color:#FFFFFF;width:600px"><tr><td align="left" bgcolor="#4e73df" style="Margin:0;padding-top:20px;padding-bottom:20px;padding-left:40px;padding-right:40px;background-color:#4e73df"><table cellpadding="0" cellspacing="0" width="100%" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="center" valign="top" style="padding:0;Margin:0;width:520px"><table cellpadding="0" cellspacing="0" width="100%" role="presentation" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="center" style="padding:0;Margin:0;font-size:0px"><a target="_blank" href="https://sibau.com.ar/" style="-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;text-decoration:underline;color:#2D3142;font-size:14px"><img src="https://sibau.com.ar/Recursos/Logo.png" alt="Logo" style="display:block;border:0;outline:none;text-decoration:none;-ms-interpolation-mode:bicubic" height="90" title="Logo"></a></td></tr></table></td></tr></table></td></tr></table></td></tr></table><table cellpadding="0" cellspacing="0" class="es-content" align="center" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;table-layout:fixed !important;width:100%"><tr><td align="center" style="padding:0;Margin:0"><table bgcolor="#ffffff" class="es-content-body" align="center" cellpadding="0" cellspacing="0" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;background-color:#ffffff;border-radius:20px 20px 0px 0px;width:600px"><tr><td align="left" style="padding:0;Margin:0;padding-top:20px;padding-left:40px;padding-right:40px"><table cellpadding="0" cellspacing="0" width="100%" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="center" valign="top" style="padding:0;Margin:0;width:520px"><table cellpadding="0" cellspacing="0" width="100%" bgcolor="#fafafa" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:separate;border-spacing:0px;background-color:#fafafa;border-radius:10px" role="presentation"><tr><td align="left" style="padding:20px;Margin:0"><h3 style="Margin:0;line-height:34px;mso-line-height-rule:exactly;font-family:Imprima, Arial, sans-serif;font-size:28px;font-style:normal;font-weight:bold;color:#2D3142">Bienvenido, ' . $Nombre . '</h3><p style="Margin:0;-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;font-family:Imprima, Arial, sans-serif;line-height:27px;color:#2D3142;font-size:18px"><br></p><p style="Margin:0;-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;font-family:Imprima, Arial, sans-serif;line-height:27px;color:#2D3142;font-size:18px">Hemos recibido una solicitud de registro con este correo electrónico.</p><p style="Margin:0;-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;font-family:Imprima, Arial, sans-serif;line-height:27px;color:#2D3142;font-size:18px"><br></p><p style="Margin:0;-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;font-family:Imprima, Arial, sans-serif;line-height:27px;color:#2D3142;font-size:18px">Haga clic en el siguiente botón para verificar su correo electrónico.</p></td></tr></table></td></tr></table></td></tr></table></td></tr></table><table cellpadding="0" cellspacing="0" class="es-content" align="center" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;table-layout:fixed !important;width:100%"><tr><td align="center" style="padding:0;Margin:0"><table bgcolor="#efefef" class="es-content-body" align="center" cellpadding="0" cellspacing="0" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;background-color:#EFEFEF;width:600px"><tr><td align="left" bgcolor="#ffffff" style="Margin:0;padding-top:30px;padding-bottom:40px;padding-left:40px;padding-right:40px;background-color:#ffffff"><table cellpadding="0" cellspacing="0" width="100%" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="center" valign="top" style="padding:0;Margin:0;width:520px"><table cellpadding="0" cellspacing="0" width="100%" role="presentation" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="center" style="padding:0;Margin:0"><!--[if mso]><a href="https://panel.sibau.com.ar/Api/Usuarios?Tipo=validarCorreo&Codigo=' . $Token . '" target="_blank" hidden> <v:roundrect xmlns:v="urn:schemas-microsoft-com:vml" xmlns:w="urn:schemas-microsoft-com:office:word" esdevVmlButton href="https://panel.sibau.com.ar/Api/Usuarios?Tipo=validarCorreo&Codigo=' . $Token . '" style="height:56px; v-text-anchor:middle; width:520px" arcsize="50%" stroke="f" fillcolor="#4e73df"> <w:anchorlock></w:anchorlock> <center style="color:#ffffff; font-family:Imprima, Arial, sans-serif; font-size:22px; font-weight:700; line-height:22px; mso-text-raise:1px">Confirmar correo electronico</center> </v:roundrect></a><![endif]--><!--[if !mso]><!-- --><span class="msohide es-button-border" style="border-style:solid;border-color:#2CB543;background:#4e73df;border-width:0px;display:block;border-radius:30px;width:auto;mso-hide:all"><a href="https://panel.sibau.com.ar/Api/Usuarios?Tipo=validarCorreo&Codigo=' . $Token . '" class="es-button msohide" target="_blank" style="mso-style-priority:100 !important;text-decoration:none;-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;color:#FFFFFF;font-size:22px;display:block;background:#4e73df;border-radius:30px;font-family:Imprima, Arial, sans-serif;font-weight:bold;font-style:normal;line-height:26px;width:auto;text-align:center;padding:15px 20px 15px 20px;mso-hide:all;padding-left:5px;padding-right:5px;border-color:#4e73df">Confirmar correo electronico</a></span><!--<![endif]--></td></tr></table></td></tr></table></td></tr></table></td></tr></table><table cellpadding="0" cellspacing="0" class="es-content" align="center" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;table-layout:fixed !important;width:100%"><tr><td align="center" style="padding:0;Margin:0"><table bgcolor="#efefef" class="es-content-body" align="center" cellpadding="0" cellspacing="0" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;background-color:#EFEFEF;border-radius:0 0 20px 20px;width:600px"><tr><td class="esdev-adapt-off" align="left" bgcolor="#ffffff" style="Margin:0;padding-top:20px;padding-bottom:20px;padding-left:40px;padding-right:40px;background-color:#ffffff;border-radius:0px 0px 20px 20px"><table cellpadding="0" cellspacing="0" class="esdev-mso-table" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;width:520px"><tr><td class="esdev-mso-td" valign="top" style="padding:0;Margin:0"><table cellpadding="0" cellspacing="0" align="left" class="es-left" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;float:left"><tr><td align="center" valign="top" style="padding:0;Margin:0;width:47px"><table cellpadding="0" cellspacing="0" width="100%" role="presentation" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="center" class="es-m-txt-l" style="padding:0;Margin:0;font-size:0px"><a target="_blank" href="https://viewstripo.email" style="-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;text-decoration:underline;color:#2D3142;font-size:18px"><img src="https://ogmrfd.stripocdn.email/content/guids/CABINET_ee77850a5a9f3068d9355050e69c76d26d58c3ea2927fa145f0d7a894e624758/images/group_4076325.png" alt="Demo" style="display:block;border:0;outline:none;text-decoration:none;-ms-interpolation-mode:bicubic" width="47" title="Demo"></a></td></tr></table></td></tr></table></td><td style="padding:0;Margin:0;width:20px"></td><td class="esdev-mso-td" valign="top" style="padding:0;Margin:0"><table cellpadding="0" cellspacing="0" class="es-right" align="right" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;float:right"><tr><td align="center" valign="top" style="padding:0;Margin:0;width:453px"><table cellpadding="0" cellspacing="0" width="100%" role="presentation" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="left" style="padding:0;Margin:0"><p style="Margin:0;-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;font-family:Imprima, Arial, sans-serif;line-height:24px;color:#2D3142;font-size:16px">Ante cualquier duda comuníquese mediante correo electrónico a hola@sibau.com.ar</p></td></tr></table></td></tr></table></td></tr></table></td></tr></table></td></tr></table><table cellpadding="0" cellspacing="0" class="es-footer" align="center" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;table-layout:fixed !important;width:100%;background-color:transparent;background-repeat:repeat;background-position:center top"><tr><td align="center" style="padding:0;Margin:0"><table bgcolor="#bcb8b1" class="es-footer-body" align="center" cellpadding="0" cellspacing="0" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;background-color:#FFFFFF;width:600px"><tr><td align="left" bgcolor="#4e73df" style="Margin:0;padding-left:20px;padding-right:20px;padding-bottom:30px;padding-top:40px;background-color:#4e73df"><table cellpadding="0" cellspacing="0" width="100%" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="left" style="padding:0;Margin:0;width:560px"><table cellpadding="0" cellspacing="0" width="100%" role="presentation" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="center" class="es-m-txt-c" style="padding:0;Margin:0;padding-bottom:20px;font-size:0px"><img src="https://sibau.com.ar/Recursos/Logo.png" alt="Logo" style="display:block;border:0;outline:none;text-decoration:none;-ms-interpolation-mode:bicubic;font-size:12px" title="Logo" height="60"></td></tr><tr><td align="center" class="es-m-txt-c" style="padding:0;Margin:0;padding-top:10px;padding-bottom:20px;font-size:0"><table cellpadding="0" cellspacing="0" class="es-table-not-adapt es-social" role="presentation" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="center" valign="top" style="padding:0;Margin:0"><a target="_blank" href="https://twitter.com/SistemaSibau" style="-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;text-decoration:underline;color:#2D3142;font-size:14px"><img src="https://ogmrfd.stripocdn.email/content/assets/img/social-icons/logo-white/twitter-logo-white.png" alt="Tw" title="Twitter" height="24" style="display:block;border:0;outline:none;text-decoration:none;-ms-interpolation-mode:bicubic"></a></td></tr></table></td></tr><tr><td align="center" style="padding:0;Margin:0"><p style="Margin:0;-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;font-family:Imprima, Arial, sans-serif;line-height:21px;color:#ffffff;font-size:14px"><a target="_blank" style="-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;text-decoration:none;color:#ffffff;font-size:14px" href="https://sibau.com.ar/politica-privacidad.pdf">Política de privacidad</a></p></td></tr><tr><td align="center" style="padding:0;Margin:0;padding-top:20px"><p style="Margin:0;-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;font-family:Imprima, Arial, sans-serif;line-height:21px;color:#ffffff;font-size:14px"><a target="_blank" style="-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;text-decoration:none;color:#ffffff;font-size:14px" href=""></a>Todos los derechos reservados © 2023 SIBAU. Diseñado y desarrollado por Bautista Izaguirre.<a target="_blank" style="-webkit-text-size-adjust:none;-ms-text-size-adjust:none;mso-line-height-rule:exactly;text-decoration:none;color:#ffffff;font-size:14px" href=""></a></p></td></tr></table></td></tr></table></td></tr></table></td></tr></table><table cellpadding="0" cellspacing="0" class="es-footer" align="center" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;table-layout:fixed !important;width:100%;background-color:transparent;background-repeat:repeat;background-position:center top"><tr><td align="center" style="padding:0;Margin:0"><table bgcolor="#ffffff" class="es-footer-body" align="center" cellpadding="0" cellspacing="0" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px;background-color:#FFFFFF;width:600px"><tr><td align="left" style="padding:20px;Margin:0"><table cellpadding="0" cellspacing="0" width="100%" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="left" style="padding:0;Margin:0;width:560px"><table cellpadding="0" cellspacing="0" width="100%" style="mso-table-lspace:0pt;mso-table-rspace:0pt;border-collapse:collapse;border-spacing:0px"><tr><td align="center" style="padding:0;Margin:0;display:none"></td></tr></table></td></tr></table></td></tr></table></td></tr></table></td></tr></table></div></body></html>';

        // Establecemos Alternativo Cuerpo
        $mail->AltBody = "ERROR: Use una version nueva de su mail para poder ver este mensaje.";

        // Intentamos enviar el correo
        try{
          guardarAccion(mysqli_insert_id($Conexión),3);
          $mail->send();
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = "";
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }catch(Exception $e){
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = "Hubo un error al enviar el correo de validación, comuníquese con soporte para validar su cuenta.";
          $Respuesta['codigo'] = 'API-021';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
        }



      }

    }

  }else if($Tipo == 'Ingresar'){
    
    // Establecemos las variables
    $Usuario = $_POST['Usuario'];
    $Contraseña = $_POST['Contrasena'];

    if($Usuario == null OR strlen($Usuario) == 0 OR $Usuario = ''){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El campo usuario/correo esta vació. Llénalo e inténtelo nuevamente.';
      $Respuesta['codigo'] = 'API-004';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else if($_POST['Contrasena'] == null OR strlen($_POST['Contrasena']) == 0 OR $_POST['Contrasena'] = ''){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'El campo contraseña esta vació. Llénalo e inténtelo nuevamente.';
      $Respuesta['codigo'] = 'API-005';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else{

      // Encriptamos la contraseña
      $ContraseñaEncriptada = crypt($Contraseña, '$2a$07$firefoxedge2000NetKarmaNe$');
      $Usuario = $_POST['Usuario'];
      $MetodoIngreso = "";
      // Verificamos si es usuario o correo
      if(strlen($Usuario) >= 7 && strlen($Usuario) <= 8 && is_numeric($Usuario)){
        $MetodoIngreso = "U.DNI";
      }else if(strpos($_POST['Usuario'], "@") !== false){
        $MetodoIngreso = "U.Correo";
      }else{
        $MetodoIngreso = "U.Usuario";
      }

      // Consulta MySql
      $Sql = "SELECT U.Id, U.Nombre, U.Apellido, U.DNI, U.Usuario, U.Correo, U.ImagenPerfil, U.Registro, U.Estado, U.Permisos, U.Institucion, I.Nombre AS NombreInstitucion, I.Abreviado AS InstitucionAbreviado FROM `Usuarios` U INNER JOIN Instituciones I ON U.Institucion = I.Id AND $MetodoIngreso = '$Usuario' AND U.Contraseña = '$ContraseñaEncriptada'";
      $Resultado = mysqli_query($Conexión, $Sql);
      $Usuario = mysqli_fetch_array($Resultado);

      if($Resultado){

        // Verificamos si hay un usuario existente
        if(mysqli_num_rows($Resultado) == 1){

          if($Usuario["Estado"] == '0'){
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = 'Correo electrónico sin verificar.';
            $Respuesta['codigo'] = 'API-078';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
          }else if($Usuario["Estado"] == '8'){
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = 'Usuario bloqueado';
            $Respuesta['codigo'] = 'API-079';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
          }else if($Usuario["Estado"] == '1' OR $Usuario["Estado"] == '2' OR $Usuario["Estado"] == '3' OR $Usuario["Estado"] == '4' OR $Usuario["Estado"] == '5' OR $Usuario["Estado"] == '6' OR $Usuario["Estado"] == '7'){

            if($Resultado){
              $_SESSION['Id'] = $Usuario['Id'];
              $_SESSION['Nombre'] = $Usuario['Nombre'];
              $_SESSION['Apellido'] = $Usuario['Apellido'];
              $_SESSION['DNI'] = $Usuario['DNI'];
              $_SESSION['Usuario'] = $Usuario['Usuario'];
              $_SESSION['Correo'] = $Usuario['Correo'];
              $_SESSION['ImagenPerfil'] = $Usuario['ImagenPerfil'];
              $_SESSION['Registro'] = $Usuario['Registro'];
              $_SESSION['Estado'] = $Usuario['Estado'];
              $_SESSION['Institucion'] = $Usuario['Institucion'];
              $_SESSION['InstitucionNombre'] = $Usuario['NombreInstitucion'];
              $_SESSION['InstitucionAbreviado'] = $Usuario['InstitucionAbreviado'];
              $_SESSION['Permisos'] = json_decode($Usuario['Permisos'], true);

              guardarAccion($Usuario['Id'],1);
              $Respuesta['estado'] = 'exitoso';
              $Respuesta['detalle'] = "";
              $Respuesta['codigo'] = 'API-200';
              print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 

            }else{
              $Respuesta['estado'] = 'error';
              $Respuesta['detalle'] = 'Hubo un error interno.';
              $Respuesta['codigo'] = 'API-003';
              print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
            }


          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = 'Hubo un error interno.';
            $Respuesta['codigo'] = 'API-080';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
          }

        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Usuario inexistente o credenciales incorrectas.';
          $Respuesta['codigo'] = 'API-002';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));   
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno.';
        $Respuesta['codigo'] = 'API-001';
        $Respuesta['a'] = mysqli_error($Conexión);
        $Respuesta['b'] = $Sql;
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }
    
  }else if($Tipo == 'ingresoGoogle'){

    // Importamos ingreso google
    $google_client = new Google_Client();

    //Set the OAuth 2.0 Client ID
    $google_client->setClientId('696001074739-r0g6drfdk9ubugomf9podam5pmqjkthd.apps.googleusercontent.com');

    //Set the OAuth 2.0 Client Secret key
    $google_client->setClientSecret('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');

    //Set the OAuth 2.0 Redirect URI
    $google_client->setRedirectUri($Configuracion['URL']['Panel'] . 'ingresar');

    // to get the email and profile 
    $google_client->addScope('email');

    $google_client->addScope('profile');
    
    // Establecemos las variables
    $Codigo = $_GET['Codigo'];

    // Obtenemos token
    $token = $google_client->fetchAccessTokenWithAuthCode($Codigo);
    
    // Verificamos si hubo un error
    if(!isset($token['error'])){

      // Establecemos token
      $google_client->setAccessToken($token['access_token']);

      $google_service = new Google_Service_Oauth2($google_client);

      $data = $google_service->userinfo->get();

      $Correo = $data['email'];

      // Consulta MySql
      $Sql = "SELECT Usuarios.Id, Usuarios.Nombre, Usuarios.Apellido, Usuarios.DNI, Usuarios.Usuario, Usuarios.Correo, Usuarios.ImagenPerfil, Usuarios.Registro, Usuarios.Estado, Usuarios.Permisos, Usuarios.Institucion, Instituciones.Nombre AS NombreInstitucion, Instituciones.Abreviado AS InstitucionAbreviado FROM `Usuarios` JOIN Instituciones ON Usuarios.Institucion = Instituciones.Id WHERE Usuarios.Estado != 0 AND Usuarios.Correo = '$Correo'";
      $Resultado = mysqli_query($Conexión, $Sql);

      if($Resultado){

        $Usuario = mysqli_fetch_array($Resultado);  

        // Verificamos si hay un usuario existente
        if(mysqli_num_rows($Resultado) == 1){

          if($Resultado){
            $_SESSION['Id'] = $Usuario['Id'];
            $_SESSION['Nombre'] = $Usuario['Nombre'];
            $_SESSION['Apellido'] = $Usuario['Apellido'];
            $_SESSION['DNI'] = $Usuario['DNI'];
            $_SESSION['Usuario'] = $Usuario['Usuario'];
            $_SESSION['Correo'] = $Usuario['Correo'];
            $_SESSION['ImagenPerfil'] = $Usuario['ImagenPerfil'];
            $_SESSION['Registro'] = $Usuario['Registro'];
            $_SESSION['Estado'] = $Usuario['Estado'];
            $_SESSION['Institucion'] = $Usuario['Institucion'];
            $_SESSION['InstitucionNombre'] = $Usuario['NombreInstitucion'];
            $_SESSION['InstitucionAbreviado'] = $Usuario['InstitucionAbreviado'];
            $_SESSION['Permisos'] = json_decode($Usuario['Permisos'], true);

            guardarAccion($Usuario['Id'],3);
            $Respuesta['estado'] = 'exitoso';
            $Respuesta['detalle'] = $_SESSION;
            $Respuesta['codigo'] = 'API-200';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 

          }else{
            $Respuesta['estado'] = 'error';
            $Respuesta['detalle'] = 'Hubo un error interno.';
            $Respuesta['codigo'] = 'API-072';
            print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
          }

        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Usuario inexistente.';
          $Respuesta['codigo'] = 'API-073';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));   
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno.';
        $Respuesta['codigo'] = 'API-074';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error externo.';
      $Respuesta['codigo'] = 'API-071';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }

  }else if($Tipo == 'crearQR'){

    // Generamos petición
    $QrToken = bin2hex(random_bytes(25));
    $Fecha = date('Y-h-d H-i-s');

    $Sql = "INSERT INTO `IngresoConQR`(`Codigo`, `Creacion`) VALUES ('$QrToken','$Fecha')";
    $Resultado = mysqli_query($Conexión, $Sql);

    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "No se ha podido crear el QR";
      $Respuesta['codigo'] = 'API-114';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else{
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $QrToken;
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }

  }elseif($Tipo == 'ObtenerListado'){

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $Institucion = $_SESSION['Institucion'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);
    
    // Verificamos el estado de la petición
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-116';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{
      
      // Establecemos permisos
      $Permisos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      if($Permisos['verUsuarios'] == true){

        $Sql = "SELECT Id, Nombre, Apellido, DNI, Usuario, Correo, Registro, Estado, ImagenPerfil FROM `Usuarios` WHERE Institucion = '$Institucion'";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){
          $Usuarios = array();
          while($Usuario = mysqli_fetch_array($Resultado)){ 
            $Usuarios[] = array('Id' => $Usuario['Id'], 'Nombre' => $Usuario['Nombre'], 'Apellido' => $Usuario['Apellido'], 'DNI' => $Usuario['DNI'], 'Usuario' => $Usuario['Usuario'], 'Correo' => $Usuario['Correo'], 'Registro' => $Usuario['Registro'], 'Estado' => $Usuario['Estado'], 'ImagenPerfil' => $Usuario['ImagenPerfil']);
          }

          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = $Usuarios;
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = "Hubo un error interno";
          $Respuesta['codigo'] = 'API-117';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para obtener el listado.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }

  }elseif($Tipo == 'descargarBackup'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $Institucion = $_SESSION['Institucion'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);
    
    // Verificamos el estado de la peticion
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-122';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Establecemos permisos
      $Permisos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      if($Permisos['descargarBackup'] == true){

        // Realizamos peticion
        $Sql = "SELECT * FROM `Usuarios` WHERE Institucion = '$Institucion'";
        $Resultado = mysqli_query($Conexión, $Sql);

        $Archivo = tmpfile();

        while ($Recurso = mysqli_fetch_assoc($Resultado)) {
          fputcsv($Archivo, $Recurso);
        }

        $Fecha = date("d-m-y-H-i-s");

        header('Content-Type: text/csv');
        header('Content-Disposition: attachment; filename="Backup-Usuarios-' . $Fecha . '.csv"');
        header('Pragma: no-cache');
        header('Expires: 0');

        rewind($Archivo);
        fpassthru($Archivo);
        fclose($Archivo);

        guardarAccion($Usuario,4);


      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para descargar Backups.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }
    
    }
    

  }elseif($Tipo == 'obtenerPermisos'){

    // Se requiere sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $MFN = $_GET['MFN'];
    $Institucion = $_SESSION['Institucion'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la peticion
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-123';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{

      // Establecemos permisos
      $Permisos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      if($Permisos['obtenerPermisos'] == true){

        $Sql = "SELECT Nombre, Apellido, Usuario, Estado, Permisos, ImagenPerfil FROM `Usuarios` WHERE Id = '$MFN' AND Institucion = '$Institucion'";
        $Resultado = mysqli_query($Conexión, $Sql);
        $Usuario = mysqli_fetch_array($Resultado);
        
        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = array("Permisos" => $Usuario['Permisos'], "Estado" => $Usuario['Estado']);
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));


      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para obtener los permisos del usuario.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }
    
  }else if($Tipo == 'validarCorreo'){

    // Establecemos variables
    $Token = $_GET['Codigo'];

    $Sql = "UPDATE `Usuarios` SET `Estado`='1', `Confirmacion` = '' WHERE Confirmacion = '$Token' AND Estado = '0'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno.";
      $Respuesta['codigo'] = 'API-075';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else{
      header("Location: " . $Configuracion['URL']['Panel']);
    }

  }else if($Tipo == 'VerificarQR'){

    // Establecemos variables
    $QrToken = $_GET['Codigo'];
    $Fecha = new DateTime();
    $Fecha->modify('+10 minute');
    $FechaFinal = $Fecha->format('Y-h-d H-i-s');
    $IdUsuario = $_SESSION['Id'];

    // Realizamos peticion
    $Sql = "SELECT * FROM `IngresoConQR` WHERE Codigo = '$QrToken'";
    $Resultado = mysqli_query($Conexión, $Sql);
    $Qr = mysqli_fetch_array($Resultado);

    // Verificamos si la peticion fue exitosa
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "No se ha podido validar el QR";
      $Respuesta['codigo'] = "API-026";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }elseif(mysqli_num_rows($Resultado) == 0){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "El código QR es inexistente o no pertenece a SIBAU©️";
      $Respuesta['codigo'] = "API-027";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else if($Qr['IdUsuario'] !== null){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Ese código QR ha sido escaneado con anterioridad.";
      $Respuesta['codigo'] = "API-028";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else if($Qr['Fecha'] > $FechaFinal){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "El código QR ha expirado.";
      $Respuesta['codigo'] = "API-029";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else{

      // Realizamos peticion
      $Sql = "UPDATE `IngresoConQR` SET `IdUsuario`='$IdUsuario' WHERE Codigo = '$QrToken'";
      $Resultado = mysqli_query($Conexión, $Sql);

      // Verificamos estado de la peticion
      if(!$Resultado){
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "No se ha podido validar el QR";
        $Respuesta['codigo'] = "API-030";
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }else{
        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = "";
        $Respuesta['codigo'] = "API-200";
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }

  }else if($Tipo == 'validarQR'){

    // Establecemos variables
    $QrToken = $_GET['Codigo'];

    // Realizamos peticion
    $Sql = "SELECT * FROM `IngresoConQR` WHERE Codigo = '$QrToken' AND IdUsuario != ''";
    $Resultado = mysqli_query($Conexión, $Sql);
    $Qr = mysqli_fetch_array($Resultado);

    // Verificamos si la peticion fue exitosa
    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "No se ha podido verificar el QR";
      $Respuesta['codigo'] = "API-031";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }elseif(mysqli_num_rows($Resultado) == 0){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "El codigo QR es inexistente";
      $Respuesta['codigo'] = "API-032";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else{

      // Establecemos variables
      $IdUsuario = $Qr['IdUsuario'];

      // Realizamos peticion
      $Sql = "SELECT Usuarios.Id, Usuarios.Nombre, Usuarios.Apellido, Usuarios.DNI, Usuarios.Usuario, Usuarios.Correo, Usuarios.ImagenPerfil, Usuarios.Registro, Usuarios.Estado, Usuarios.Permisos, Usuarios.Institucion, Instituciones.Nombre AS NombreInstitucion, Instituciones.Abreviado AS InstitucionAbreviado FROM `Usuarios` JOIN Instituciones ON Usuarios.Institucion = Instituciones.Id WHERE Usuarios.Estado != 0 AND Usuarios.Id = '$IdUsuario'";
      $Resultado = mysqli_query($Conexión, $Sql);
      $Usuario = mysqli_fetch_array($Resultado);

      // Verificamos estado de la peticion
      if(!$Resultado){
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "No se ha podido verificar el QR";
        $Respuesta['codigo'] = "API-033";
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }else{

        if($Resultado){
          $_SESSION['Id'] = $Usuario['Id'];
          $_SESSION['Nombre'] = $Usuario['Nombre'];
          $_SESSION['Apellido'] = $Usuario['Apellido'];
          $_SESSION['DNI'] = $Usuario['DNI'];
          $_SESSION['Usuario'] = $Usuario['Usuario'];
          $_SESSION['Correo'] = $Usuario['Correo'];
          $_SESSION['ImagenPerfil'] = $Usuario['ImagenPerfil'];
          $_SESSION['Registro'] = $Usuario['Registro'];
          $_SESSION['Estado'] = $Usuario['Estado'];
          $_SESSION['Institucion'] = $Usuario['Institucion'];
          $_SESSION['InstitucionNombre'] = $Usuario['NombreInstitucion'];
          $_SESSION['InstitucionAbreviado'] = $Usuario['InstitucionAbreviado'];
          $_SESSION['Permisos'] = json_decode($Usuario['Permisos'], true);

          guardarAccion($Usuario,5);
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = "";
          $Respuesta['codigo'] = "API-200";
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }

      }

    }

  }elseif($Tipo == 'obtenerPerfil'){


    // Establecemos variables
    $Usuario = $_GET['Usuario'];

    // Realizamos peticion
    $Sql = "SELECT Id, Nombre, Apellido, Datos, Privacidad, Usuario, ImagenPerfil, Institucion, Estado FROM `Usuarios` WHERE Usuario = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);
    $Usuario = mysqli_fetch_array($Resultado);

    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno.";
      $Respuesta['codigo'] = "API-034";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }elseif(mysqli_num_rows($Resultado) == 0){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "El usuario es inexistente";
      $Respuesta['codigo'] = "API-035";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else{

      // Establecemos variables
      $IdUsuInsti = $Usuario['Institucion'];

      // Realizamos peticion
      $SqlInstitucion = "SELECT Nombre, Abreviado FROM `Instituciones` WHERE Id = '$IdUsuInsti'";
      $ResultadoInstitucion = mysqli_query($Conexión, $SqlInstitucion);
      $InstitucionNombre = mysqli_fetch_array($ResultadoInstitucion);

      if(!$ResultadoInstitucion){
        $Respuesta['estado'] = 'error'; 
        $Respuesta['detalle'] = "Hubo un error interno";
        $Respuesta['codigo'] = "API-036";
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }elseif(mysqli_num_rows($ResultadoInstitucion) == 0){
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "La institucion es inexistente";
        $Respuesta['codigo'] = "API-037";
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }else{
      
        // Establecemos los datos
        $Data = json_decode($Usuario['Datos'], true);
        $Datos = array(
          'Id' => $Usuario['Id'],
          'Presentación' => $Data['Presentación'],
          'EscuelaNombre' => $InstitucionNombre['Nombre'],
          'EscuelaNombreAbreviado' => $InstitucionNombre['Abreviado'],
          'UsuarioEstado' => $Usuario['Estado'],
          'LibroFavorito' => $Data['LibroFavorito'],
          'ActorFavorito' => $Data['ActorFavorito'],
          'EscritorFavorito' => $Data['EscritorFavorito'],
          'Hobby' => $Data['Hobby'],
          'Privacidad' => $Usuario['Privacidad'],
          'ImagenDePerfil' => $Usuario['ImagenPerfil'],
          'Genero' => $Data['Genero'],
          'Usuario' => $Usuario['Usuario'],
          'Nombre' => $Usuario['Nombre'],
          'Apellido' => $Usuario['Apellido'],
        ); 

        if($_SESSION['Institucion'] == $IdUsuInsti){
          $Datos['CompartenInstitucion'] = true;
        }

        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = $Datos;
        $Respuesta['codigo'] = "API-200";
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 

      }
    }
    
  }elseif($Tipo == 'obtenerMisDatos'){

    // Establecemos variables
    $Usuario = $_SESSION['Id'];

    // Rezlizamos peticion
    $Sql = "SELECT Institucion, Datos, Privacidad, Usuario, ImagenPerfil FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);
    $Usuario = mysqli_fetch_array($Resultado);

    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = "API-038";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else{
      // Establecemos datos
      $Data = json_decode($Usuario['Datos'], true);
      $Datos = array(
        'Presentación' => $Data['Presentación'],
        'LibroFavorito' => $Data['LibroFavorito'],
        'ActorFavorito' => $Data['ActorFavorito'],
        'EscritorFavorito' => $Data['EscritorFavorito'],
        'Hobby' => $Data['Hobby'],
        'Privacidad' => $Usuario['Privacidad'],
        'ImagenDePerfil' => $Usuario['ImagenPerfil'],
        'Genero' => $Data['Genero'],
        'Telefono' => $Data['Telefono'],
        'Usuario' => $Usuario['Usuario'],
      );
      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $Datos;
      $Respuesta['codigo'] = "API-200";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }
    
  }elseif($Tipo == 'actualizarPermisos'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $MFN = $_GET['MFN'];
    $Institucion = $_SESSION['Institucion'];
    $Estado = intval($_GET['Estado']);
    if($Estado > 4){
      $Estado = 4;
    }
    $Permisos = json_encode($_POST, JSON_UNESCAPED_UNICODE);

    // Verificamos si el usuario tien permisos
    $Sql = "SELECT `Permisos` FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['actualizarPermisos'] == true){

        $Sql = "UPDATE `Usuarios` SET `Estado`='$Estado',`Permisos`='$Permisos' WHERE Id = '$MFN' AND Institucion = $Institucion";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){
          guardarAccion($Usuario['Id'],2,array("NuevosPermisos" => $Permisos, "EstadoNuevo" => $Estado, "UsuarioAfectado" => $MFN));
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = "";
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno'. mysqli_error($Conexión);
          $Respuesta['codigo'] = 'API-119';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para para gestionar usuarios.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-124';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }
    
  }elseif($Tipo == 'actualizarConfiguraciones'){
  
    // Establecemos datos
    $Datos = $_POST;
    $NombreUsuario = $_POST['General-Usuario'];
    $Privacidad = $_POST['General-Ver'];
    $Usuario = $_SESSION['Id'];

    // Verificamos si el nombre de usuario esta en uso
    $Sql = "SELECT * FROM `Usuarios` WHERE Usuario = '$NombreUsuario' AND Id != '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if(!$Resultado){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno.';
      $Respuesta['codigo'] = 'API-039';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else if(mysqli_num_rows($Resultado) !== 0){
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Nombre de usuario en uso.';
      $Respuesta['codigo'] = 'API-040';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }else{

      // Enviamos peticion
      $DatosSql = json_encode(array('Genero' => $_POST['General-Genero'], 'Telefono' => $_POST['General-Telefono'], 'ActorFavorito' => $_POST['SobreTi-ActorFavorito'], 'EscritorFavorito' => $_POST['SobreTi-EscritorFavorito'], 'Hobby' => $_POST['SobreTi-Hobby'], 'LibroFavorito' => $_POST['SobreTi-LibroFavorito'], 'Presentación' => $_POST['SobreTi-Presentación']), JSON_UNESCAPED_UNICODE);
      $Sql = "UPDATE `Usuarios` SET `Usuario`='$NombreUsuario',`Privacidad`='$Privacidad',`Datos`='$DatosSql' WHERE Id = '$Usuario'";
      $Resultado = mysqli_query($Conexión, $Sql);

      // Verificamos el estado de la peticion
      if(!$Resultado){
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = 'API-041';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }else{
        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = "";
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }

  }elseif($Tipo == 'actualizarImagenPerfil'){

    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];

    $Pelo = $_POST['Pelo'];
    $Bigote = $_POST['Bigote'];
    $ColorPelo = $_POST['ColorPelo'];
    $ColorPiel = $_POST['ColorPiel'];
    $ColorBigote = $_POST['ColorBigote'];
    $ColorRemera = $_POST['ColorRemera'];

    $NuevoLink = "?ColorPelo=" . $ColorPelo . "&TipoPelo=" . $Pelo . "&TipoBigote=" . $Bigote . "&ColorBigote=" . $ColorBigote . "&ColorRemera=" . $ColorRemera . "&ColorPiel=" . $ColorPiel;


    // Realizamos petición
    $Sql = "UPDATE `Usuarios` SET `ImagenPerfil`='$NuevoLink' WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      // Establecemos SESSION
      global $_SESSION;
      $_SESSION['ImagenDePerfil'] = $DatosPerfil;

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = "";
      $Respuesta['codigo'] = "API-200";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error desconocido';
      $Respuesta['codigo'] = "API-042";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }elseif($Tipo == 'obtenerCreditos'){

    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];

    // Obtenemos la cantidad
    $Sql = "SELECT SUM(Movimiento) FROM Creditos WHERE Afectado = $Usuario ORDER BY `Fecha` DESC";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      // Obtenemos ultimos  movimientos
      $SqlDetalles = "SELECT Descripcion, Movimiento, Fecha FROM Creditos WHERE Afectado = $Usuario ORDER BY `Fecha` DESC LIMIT 10";
      $ResultadoDetalles = mysqli_query($Conexión, $SqlDetalles);

      if($ResultadoDetalles){

        $Detalles = array();

        while($Detalle = mysqli_fetch_array($ResultadoDetalles)){
          $Detalles[] = array(
            "Descripcion" => $Detalle['Descripcion'],
            "Movimiento" => $Detalle['Movimiento'],
            "Fecha" => haceTiempo($Detalle['Fecha']),
          );
        }


        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = array("Total" => mysqli_fetch_array($Resultado)[0], "Detalles" => $Detalles);
        $Respuesta['codigo'] = "API-200";
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = "API-061";
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = "API-060";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }elseif($Tipo == 'obtenerNotificaciones'){

    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];

    // Obtenemos la cantidad
    $Sql = "SELECT * FROM `Notificaciones` WHERE Usuario = $Usuario ORDER By Fecha DESC LIMIT 10";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Notificaciones = array();

      while($Notificacion = mysqli_fetch_array($Resultado)) { 

        $Notificaciones[] = array(
          "Id" => $Notificacion['Id'],
          "Usuario" => $Notificacion['Usuario'],
          "Fecha" => haceTiempo($Notificacion['Fecha']),
          "Notificacion" => $Notificacion['Notificacion'],
          "Icono" => $Notificacion['Icono'],
          "Leido" => $Notificacion['Leido'],
        );
      }

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $Notificaciones;
      $Respuesta['codigo'] = "API-200";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = "API-061";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }elseif($Tipo == 'marcarNotificacionLeido'){

    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];

    // Obtenemos la cantidad
    $Sql = "UPDATE `Notificaciones` SET `Leido`=1 WHERE Usuario = $Usuario";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = "";
      $Respuesta['codigo'] = "API-200";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = "API-063";
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }elseif($Tipo == 'bloquearUsuario'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $MFN = $_GET['MFN'];
    $Institucion = $_SESSION['Institucion'];

    // Verificamos si el usuario tien permisos
    $Sql = "SELECT `Permisos` FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['bloquearUsuario'] == true){

        $Sql = "UPDATE `Usuarios` SET `Estado`='8' WHERE Id = '$MFN'";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = '';
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno';
          $Respuesta['codigo'] = 'API-119';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para para gestionar usuarios.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-118';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }elseif($Tipo == 'desbloquearUsuario'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $MFN = $_GET['MFN'];
    $Institucion = $_SESSION['Institucion'];

    // Verificamos si el usuario tien permisos
    $Sql = "SELECT `Permisos` FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['gestionarUsuarios'] == true){

        $Sql = "UPDATE `Usuarios` SET `Estado`='1' WHERE Id = '$MFN'";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = '';
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno';
          $Respuesta['codigo'] = 'API-120';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para para gestionar usuarios.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-121';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }elseif($Tipo == 'verificarUsuario'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $MFN = $_GET['MFN'];
    $Institucion = $_SESSION['Institucion'];

    // Verificamos si el usuario tien permisos
    $Sql = "SELECT `Permisos` FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['actualizarPermisos'] == true){

        $Sql = "UPDATE `Usuarios` SET `Estado`='2' WHERE Id = '$MFN'";
        $Resultado = mysqli_query($Conexión, $Sql);

        if($Resultado){
          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = '';
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno';
          $Respuesta['codigo'] = 'API-126';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para para gestionar usuarios.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-127';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }elseif($Tipo == 'buscarUsuario'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Institucion = $_SESSION['Institucion'];
    $Busqueda = $_GET['Busqueda'];

    // Realizamos la petición a la base de datos
    $Sql = "SELECT Usuarios.Id, Instituciones.Abreviado AS Institucion, Instituciones.Nombre AS InstitucionCompleta, CONCAT(Usuarios.Nombre, ' ', Usuarios.Apellido) AS Nombre, Usuarios.Usuario, Usuarios.Estado, ImagenPerfil FROM Usuarios JOIN Instituciones WHERE (CONCAT(Usuarios.Nombre, ' ', Usuarios.Apellido) LIKE '%$Busqueda%' OR Usuarios.Usuario LIKE '%$Busqueda%' OR Usuarios.Nombre LIKE '%$Busqueda%' OR Usuarios.Apellido LIKE '%$Busqueda%') AND Usuarios.Institucion = Instituciones.Id";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){
    
      $Usuarios = array();
      while($Usuario = mysqli_fetch_array($Resultado)){
        $Usuarios[] = array(
          "Id" => $Usuario['Id'],
          "Institucion" => $Usuario['Institucion'],
          "InstitucionCompleta" => $Usuario['InstitucionCompleta'],
          "Nombre" => $Usuario['Nombre'],
          "Usuario" => $Usuario['Usuario'],
          "Estado" => $Usuario['Estado'],
          "ImagenPerfil" => $Usuario['ImagenPerfil'],
        );
      }

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = $Usuarios;
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-160';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }


  }else if($Tipo == 'obtenerHistorial'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $ABuscar = $_GET['Usuario'];
    $Institucion = $_SESSION['Institucion'];

    // Verificamos si el usuario tien permisos
    $Sql = "SELECT `Permisos` FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      // Establecemos los datos
      $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      // Verificamos si el usuario tiene permisos
      if($Datos['gestion_usuarios_obtenerHistorial'] == true){

        // Realizamos la petición
        $Sql = "SELECT Accion.Id, Usuario.Nombre, Accion.TipoDeAccion AS Tipo, Accion.Accion, Accion.Fecha FROM `Usuarios__Acciones` Accion INNER JOIN Usuarios Usuario ON Accion.IdUsuario = Usuario.Id AND Accion.IdUsuario = '$ABuscar' ORDER BY `Fecha` DESC";
        $Resultado = mysqli_query($Conexión, $Sql);

        // Verificamos estado de la petición
        if($Resultado){

          $Acciones = array();

          while($Accion = mysqli_fetch_array($Resultado)){
            $Acciones[] = array(
              "Id" => $Accion["Id"],
              "Nombre" => $Accion["Nombre"],
              "Tipo" => $Accion["Tipo"],
              "Accion" => json_decode($Accion["Accion"], true),
              "Fecha" => $Accion["Fecha"],
            );
          }

          $Respuesta['estado'] = 'exitoso';
          $Respuesta['detalle'] = $Acciones;
          $Respuesta['codigo'] = 'API-200';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }else{
          $Respuesta['estado'] = 'error';
          $Respuesta['detalle'] = 'Hubo un error interno';
          $Respuesta['codigo'] = 'API-191';
          print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para para gestionar usuarios.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-190';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }else if($Tipo == 'cambiarContraseñaAdministrativamente'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $UsuarioAfectado = $_GET['Usuario'];
    $Contraseña = $_GET['Contraseña'];
    $NuevaContraseña = crypt($Contraseña, '$2a$07$firefoxedge2000NetKarmaNe$');

    if(verificarPermisosActualizados("gestion_usuarios_cambiarContraseña")){
      
      // Realizamos petición - Contraseña
      $Sql = "UPDATE `Usuarios` SET `Contraseña` = '$NuevaContraseña' WHERE `Usuarios`.`Id` = $UsuarioAfectado";
      $Resultado = mysqli_query($Conexión, $Sql);

      // Verificamos estado de la petición
      if($Resultado){
        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = "";
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = 'API-195';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }

    }

  }else{
    $Respuesta['estado'] = 'error';
    $Respuesta['detalle'] = 'Petición errónea';
    $Respuesta['codigo'] = 'API-000';
    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
  }

  /*
  
  Swal.fire({
  title: 'Submit your Github username',
  input: 'text',
  inputAttributes: {
    autocapitalize: 'off'
  },
  showCancelButton: true,
  confirmButtonText: 'Look up',
  showLoaderOnConfirm: true,
  preConfirm: (login) => {
    return fetch(`//api.github.com/users/${login}`)
      .then(response => {
        if (!response.ok) {
          throw new Error(response.statusText)
        }
        return response.json()
      })
      .catch(error => {
        Swal.showValidationMessage(
          `Request failed: ${error}`
        )
      })
  },
  allowOutsideClick: () => !Swal.isLoading()
}).then((result) => {
  if (result.isConfirmed) {
    Swal.fire({
      title: `${result.value.login}'s avatar`,
      imageUrl: result.value.avatar_url
    })
  }
})
  
  */

?>