<?php 

  // Agregamos el Sistema
  require("../sistema.php");

  // Variable
  $Tipo = $_GET['Tipo'];

  if($Tipo == 'obtenerAsignaturas'){

    // Requerimos sesión
    apiRequireSesion();

    // Obtenemos las asignaturas
    $Sql = "SELECT Id, Nombre, Url, Detalles, Icono FROM `Aula__Asignatura`";
    $Resultado = mysqli_query($Conexión, $Sql);

    if($Resultado){

      $Asignaturas = array();

      while($Asignatura = mysqli_fetch_array($Resultado)){

        if($Videos[0] !== 0){
          $Asignaturas[] = array(
            "Id" => $Asignatura['Id'],
            "Url" => $Asignatura['Url'],
            "Nombre" => $Asignatura['Nombre'],
            "Icono" => $Asignatura['Icono'],
            "Detalles" => $Asignatura['Detalles']
          );
        }
      
      }

      $Respuesta['estado'] = 'exitoso';
      $Respuesta['detalle'] = json_encode($Asignaturas, JSON_UNESCAPED_UNICODE);
      $Respuesta['codigo'] = 'API-200';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));


    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = 'API-064';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }
    

  }elseif($Tipo == 'obtenerAsignatura'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Asignatura = $_GET['Asignatura'];

    // Realizamos petición
    $Sql = "SELECT Id, Nombre, Url, Detalles, Icono FROM `Aula__Asignatura` WHERE Url = '$Asignatura'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos estado de la petición
    if($Resultado){

      // Verificamos si hubo un resultado
      if(mysqli_num_rows($Resultado) == 1){

        // Establecemos los datos de la petición
        $AsignaturaResultado = mysqli_fetch_array($Resultado);

        // Obtenemos los temas y lecciones
        $SqlContenidos = "SELECT Aula__Lecciones.Id AS 'LeccionID', Aula__Temas.Nombre AS 'NombreTema', Aula__Temas.IdInterno AS 'NumeroTema', Aula__Lecciones.Leccion AS 'NumeroLeccion', Aula__Lecciones.Titulo, Aula__Lecciones.Adjuntos, Aula__Temas.Estado AS EstadoTema FROM Aula__Lecciones JOIN Aula__Temas ON Aula__Lecciones.Asignatura =  Aula__Temas.Asignatura WHERE Aula__Lecciones.Tema = Aula__Temas.Id AND Aula__Temas.Estado > 0 AND Aula__Lecciones.Asignatura = '" . $AsignaturaResultado['Id'] . "'";
        $ResultadoContenidos = mysqli_query($Conexión, $SqlContenidos);

        $Contenidos = array();
        while($Contenido = mysqli_fetch_array($ResultadoContenidos)){
          $Contenidos[] = array(
            "LeccionID" => $Contenido['LeccionID'],
            "NombreTema" => $Contenido['NombreTema'],
            "NumeroTema" => $Contenido['NumeroTema'],
            "EstadoTema" => $Contenido['EstadoTema'],
            "NumeroLeccion" => $Contenido['NumeroLeccion'],
            "Titulo" => $Contenido['Titulo'],
            "Adjuntos" => $Contenido['Adjuntos'],
          );
        }

        $Datos = array(
          'Id' => $AsignaturaResultado['Id'],
          'Nombre' => $AsignaturaResultado['Nombre'],
          'Url' => $AsignaturaResultado['Url'],
          'Detalles' => $AsignaturaResultado['Detalles'],
          'Contenidos' => $Contenidos,
          'Icono' => $AsignaturaResultado['Icono'],
        );

        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = $Datos;
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = "No se ha encontrado la asignatura solicitada.";
        $Respuesta['codigo'] = 'API-153';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = "Hubo un error interno";
      $Respuesta['codigo'] = 'API-065';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }elseif($Tipo == 'obtenerLecciones'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Tema = $_GET['Tema'];

    // Obtenemos la lección
    $Sql = "SELECT Id, Leccion AS Numero, Titulo FROM `Aula__Lecciones` WHERE Tema = '$Tema'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la solicitud
    if($Resultado){

      if(mysqli_num_rows($Resultado) > 0){
        
        $Lecciones = array();

        while($Lección = mysqli_fetch_array($Resultado)){

          $Lecciones[] = array(
            "Id" => $Lección['Id'],
            "Numero" => $Lección['Numero'],
            "Titulo" => $Lección['Titulo'],
          );

        }

        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = $Lecciones;
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'No se han encontrado lecciones para ese tema.';
        $Respuesta['codigo'] = 'API-157';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno.';
      $Respuesta['codigo'] = 'API-156';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }


  }elseif($Tipo == 'obtenerLección'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $IdLeccion = $_GET['Lección'];

    // Obtenemos la lección
    $Sql = "SELECT Aula__Lecciones.Id, Aula__Asignatura.Nombre AS Asignatura, Aula__Asignatura.Url AS AsignaturaUrl, Aula__Temas.Nombre AS Tema, Aula__Temas.IdInterno AS TemaNumero, Aula__Lecciones.Leccion AS Numero, Aula__Lecciones.Titulo, Aula__Lecciones.Adjuntos FROM `Aula__Lecciones` JOIN Aula__Asignatura, Aula__Temas WHERE Aula__Lecciones.Id = '$IdLeccion' AND Aula__Asignatura.Id = Aula__Lecciones.Asignatura AND Aula__Temas.Id = Aula__Lecciones.Tema";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la solicitud
    if($Resultado){

      if(mysqli_num_rows($Resultado) == 1){
          
        $Datos =mysqli_fetch_array($Resultado);

        $Lección = [
          "Id" => $Datos['Id'],
          "Asignatura" => $Datos['Asignatura'],
          "AsignaturaUrl" => $Datos['AsignaturaUrl'],
          "Tema" => $Datos['Tema'],
          "TemaNumero" => $Datos['TemaNumero'],
          "Numero" => $Datos['Numero'],
          "Titulo" => $Datos['Titulo'],
          "Adjuntos" => $Datos['Adjuntos'],
        ];

        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = $Lección;
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'La lección que buscas es inexistente o ya no esta disponible.';
        $Respuesta['codigo'] = 'API-155';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno.';
      $Respuesta['codigo'] = 'API-154';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    }


  }else{

    $Respuesta['estado'] = 'error';
    $Respuesta['detalle'] = 'Petición errónea';
    $Respuesta['codigo'] = 'API-000';
    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));

  }
  
?>