<?php 

  // Importamos sistema
  require("../sistema.php");

  // Establecemos variables
  $Tipo = $_GET['Tipo'];

  // Vemos que tipo es la consulta
  if($Tipo == 'descargaDeBackupEspecifico'){

    // Se require sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $Tabla = $_GET['Tabla'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la petición
    if($Resultado){

      // Establecemos permisos
      $Permisos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      if($Permisos['gestion_general_descargaBackup'] == true){

        $ListaDeTablasAceptadas = array(
          "Acciones",
          "Actividades",
          "Articulos",
          "Audioteca",
          "Aula__Asignatura",
          "Aula__Lecciones",
          "Aula__Temas",
          "Comentarios",
          "Creditos",
          "Creditos__Canjes",
          "Creditos__Historial",
          "Dispositivos",
          "Ejemplares",
          "Experiencia__Valoraciones",
          "IngresoConQR",
          "Instituciones",
          "Mapoteca",
          "Notificaciones",
          "Recursos",
          "RecursosFisicos__Ejemplares",
          "RecursosFisicos__Registros",
          "RecursosFisicos__Retiros",
          "RecursosOnline",
          "Reportes",
          "Usuarios",
        );

        if(in_array($Tabla, $ListaDeTablasAceptadas) == true){
          $Sql = "SELECT * FROM `$Tabla`";
          $Resultado = mysqli_query($Conexión, $Sql);

          $Archivo = tmpfile();

          while ($Recurso = mysqli_fetch_assoc($Resultado)) {
            fputcsv($Archivo, $Recurso);
          }

          $Fecha = date("d-m-y-H-i-s");

          header('Content-Type: text/csv');
          header('Content-Disposition: attachment; filename="Backup-' . $Tabla . '-' . $Fecha . '.csv"');
          header('Pragma: no-cache');
          header('Expires: 0');

          rewind($Archivo);
          fpassthru($Archivo);
          fclose($Archivo);
      
        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para realizar esta operación.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-158';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }else if($Tipo == 'descargaDeBackupTotal'){

    // Se require sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la petición
    if($Resultado){

      // Establecemos permisos
      $Permisos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      if($Permisos['gestion_general_descargaBackup'] == true){

        $ListaDeTablasAceptadas = array(
          "Acciones",
          "Actividades",
          "Articulos",
          "Audioteca",
          "Aula__Asignatura",
          "Aula__Lecciones",
          "Aula__Temas",
          "Comentarios",
          "Creditos",
          "Creditos__Canjes",
          "Creditos__Historial",
          "Dispositivos",
          "Ejemplares",
          "Experiencia__Valoraciones",
          "IngresoConQR",
          "Instituciones",
          "Mapoteca",
          "Notificaciones",
          "Recursos",
          "RecursosFisicos__Ejemplares",
          "RecursosFisicos__Registros",
          "RecursosFisicos__Retiros",
          "RecursosOnline",
          "Reportes",
          "Usuarios",
        );

        $Registros = array();

        for($i = 0; $i < count($ListaDeTablasAceptadas); $i++){
          $Resultado = mysqli_query($Conexión, "SELECT * FROM `$ListaDeTablasAceptadas[$i]`");
          $Registros[$i] = tmpfile();
            
          $Registros[$i] = fopen($ListaDeTablasAceptadas[$i] . '.csv', 'w');
          while ($fila = mysqli_fetch_assoc($Resultado)) {
            fputcsv($Registros[$i], $fila);
          }

          fclose($Registros[$i]);
        }

        // Creamos archivo ZIP
        $Archivo = new ZipArchive();
        $NombreArchivo = 'BackupGeneral-' . $Fecha . '.zip';

        if($Archivo->open($NombreArchivo, ZipArchive::CREATE) === TRUE){

          // Agregar los archivos temporales a la instancia
          for($i = 0; $i < count($ListaDeTablasAceptadas); $i++){
            $Archivo->addFile($ListaDeTablasAceptadas[$i] . ".csv");
          }

          // Cerrar el archivo ZIP
          $Archivo->close();

          // Mostramos ZIP
          header('Content-Type: application/zip');
          header('Content-disposition: attachment; filename=' . $NombreArchivo);
          header('Content-Length: ' . filesize($NombreArchivo));
          readfile($NombreArchivo);

          // Eliminamos archivo temporal.
          unlink($NombreArchivo);
          for($i = 0; $i < count($ListaDeTablasAceptadas); $i++){
            unlink($ListaDeTablasAceptadas[$i] . ".csv");
          }

        }

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para realizar esta operación.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-158';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }else if($Tipo == 'obtenerListadoTablas'){

    // Se require sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];
    $Tablas = json_decode($_GET['Tablas'], true);

    // Verificamos si el usuario tiene permisos
    $Sql = "SELECT Id, Permisos FROM `Usuarios` WHERE Id = '$Usuario'";
    $Resultado = mysqli_query($Conexión, $Sql);

    // Verificamos el estado de la petición
    if($Resultado){

      // Establecemos permisos
      $Permisos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

      if($Permisos['gestion_general_basesdedatos'] == true){

        $ListaDeTablasAceptadas = array(
          "Acciones",
          "Actividades",
          "Articulos",
          "Audioteca",
          "Aula__Asignatura",
          "Aula__Lecciones",
          "Aula__Temas",
          "Comentarios",
          "Creditos",
          "Creditos__Canjes",
          "Creditos__Historial",
          "Dispositivos",
          "Ejemplares",
          "Experiencia__Valoraciones",
          "IngresoConQR",
          "Instituciones",
          "Mapoteca",
          "Notificaciones",
          "Recursos",
          "RecursosFisicos__Ejemplares",
          "RecursosFisicos__Registros",
          "RecursosFisicos__Retiros",
          "RecursosOnline",
          "Reportes",
          "Usuarios",
        );

        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = $ListaDeTablasAceptadas;
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
        

      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Careces de permisos para realizar esta operación.';
        $Respuesta['codigo'] = 'API-403';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      }

    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Hubo un error interno';
      $Respuesta['codigo'] = 'API-159';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    }

  }else if($Tipo == 'obtenerUsuarios'){

    // Requerimos sesión
    apiRequireSesion();

    // Establecemos variables
    $Usuario = $_SESSION['Id'];

    if(verificarPermisosActualizados("gestionGeneral_usuarios")){
      
      // Realizamos petición
      $Sql = "SELECT U.Id, U.Nombre, U.Apellido, U.DNI, U.Usuario, U.ImagenPerfil, U.Correo, U.Institucion, U.Estado, U.Permisos, U.Datos, I.Nombre AS InstiNombre, I.Abreviado AS InstiNombreAbreviado, I.Logo AS InstiLogo FROM Usuarios U INNER JOIN Instituciones I ON U.Institucion = I.Id";
      $Resultado = mysqli_query($Conexión, $Sql);

      // Verificamos estado de la petición
      if($Resultado){

        // Insertamos los usuarios a un array
        $Usuarios = array();

        while($Usuario = mysqli_fetch_array($Resultado)){
          $Usuarios[] = array(
            "Id" => $Usuario["Id"],
            "Nombre" => $Usuario["Nombre"],
            "Apellido" => $Usuario["Apellido"],
            "DNI" => $Usuario["DNI"],
            "Usuario" => $Usuario["Usuario"],
            "ImagenPerfil" => $Usuario["ImagenPerfil"],
            "Correo" => $Usuario["Correo"],
            "Institucion" => $Usuario["Institucion"],
            "Estado" => $Usuario["Estado"],
            "Permisos" => $Usuario["Permisos"],
            "Datos" => $Usuario["Datos"],
            "InstiNombre" => $Usuario["InstiNombre"],
            "InstiLogo" => $Usuario["InstiLogo"],
            "InstiNombreAbreviado" => $Usuario["InstiNombreAbreviado"],
          );
        }

        $Respuesta['estado'] = 'exitoso';
        $Respuesta['detalle'] = $Usuarios;
        $Respuesta['codigo'] = 'API-200';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }else{
        $Respuesta['estado'] = 'error';
        $Respuesta['detalle'] = 'Hubo un error interno';
        $Respuesta['codigo'] = 'API-196';
        print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
      }

    }

  }else{
    $Respuesta['estado'] = 'error';
    $Respuesta['detalle'] = 'Petición errónea';
    $Respuesta['codigo'] = 'API-000';
    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
  }

?>