<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('pelicula*' . $_GET['Id']);

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Película</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/css/Estilos.css?v2" rel="stylesheet">
  <link href="https://vjs.zencdn.net/8.0.4/video-js.css" rel="stylesheet">

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

  <!-- Manifiesto -->
  <link rel="manifest" href="<?php echo $Configuracion['URL']['Panel'] ?>manifest.json">
  <link rel="apple-touch-icon" href="https://sibau.com.ar/Recursos/Logo.png">
  <meta name="apple-mobile-web-app-status-bar" content="#F8F9FC">
  <meta name="theme-color" content="#4E73DF">

</head>
<body id="page-top">
  <div id="wrapper">

<style>
#Clase.vjs-16-9 {
  width: 100%;
  height: 0;
  padding-bottom: 0%;
  border-radius: 10px;
}
</style>
    
    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

      
        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->
 
        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

            <!-- Contenido -->
            <div style="display:none" id="Contenido">

              <!-- Titulo -->
              <div class="d-sm-flex align-items-center justify-content-between mb-4">
                <titulo class="h6 mb-0 text-gray-800"></titulo>
                <!--<a class="btn btn-danger btn-icon-split"><span class="icon text-white-50"><i class="fa-solid fa-flag"></i></span><span class="text">Reportar</span></a>-->
              </div>
              <!-- Fin de Titulo -->

              <!-- Video -->
              <div id="Video" class="col">
                <video id="Reproductor" class="video-js vjs-16-9" controls width="100%" height="0" preload="auto" poster="https://cdn-peliculas.sibau.com.ar/<?php echo $_GET['Id'] ?>/Portada2.webp">
                  <source src="https://cdn-peliculas.sibau.com.ar/Intro/Contenido.m3u8" type="application/x-mpegURL">
                </video>
              </div>
              <!-- Fin de Video -->

            </div>
            <!-- Fin de Contenido -->

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>"; var Asignatura = "<?php echo $_GET['Asignatura'] ?>"; var Lección = "<?php echo $_GET['Leccion'] ?>";</script>
    <script src="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/js/General.js?v2"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js" integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN" crossorigin="anonymous"></script>
    <script src="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/js/Carga.js"></script>
    <script src="https://vjs.zencdn.net/8.0.4/video.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/videojs-contrib-hls/3.0.2/videojs-contrib-hls.js"></script>
    <script>
  var reproductor;
// Obtenemos la pelicula
$.ajax({
  type: "GET",
  url: Url + "Api/Peliculas",
  data: {"Tipo": "obtenerPelicula", "Pelicula": window.location.href.split("/")[window.location.href.split("/").length-1]},
  success: function(Datos, textStatus, xhr){

    // Establecemos los datos
    Datos = $.parseJSON(Datos);

    // Verificamos el estado
    if(Datos['estado'] == 'exitoso'){

      // Creamos el Reproductor
      reproductor = videojs('Reproductor');

      // Detectamos cuando empeze y termine el video
      reproductor.on('play', function() {
      if(reproductor.src() == "https://cdn-peliculas.sibau.com.ar/Intro/Contenido.m3u8"){
        reproductor.controls(false);
      }
      });
      reproductor.on('ended', function() {
        if(reproductor.src() == "https://cdn-peliculas.sibau.com.ar/Intro/Contenido.m3u8"){
          reproductor.src(`https://cdn-peliculas.sibau.com.ar/${window.location.href.split("/")[window.location.href.split("/").length-1]}/Contenido.m3u8`);
          reproductor.controls(true);
          reproductor.load();
          reproductor.play();
        }
      });

      // Establecemos el titulo
      $("titulo").html(`<a style='color: #5a5c69 !important' href='${Url}'>SIBAU</a> / <a href="${Url}peliculas" style='color: #5a5c69 !important'>Películas </a> / <b>${Datos['detalle']['Titulo']}</b> <span class="badge bg-primary">${Datos['detalle']['Calificacion']}</span>`)
            
      // Quitamos el loader
      quitarLoader();

    }else if(Datos['estado'] == 'error'){
      errorLoader(Datos['detalle'], Datos['codigo']);
    }else{
      errorLoader();
    }

  },
  error: function(){
    errorLoader();
  }
})
/*
function irLección(Id){
  window.location.href = Url + "aula-virtual/" + Asignatura + "/" + Id;
}

function obtenerLecciones(Tema){
  $.ajax({
    type: "GET",
    data: {'Tipo': "obtenerLecciones", 'Tema': Tema},
    url: Url + 'Api/aulaVirtual',
    success: function(Datos, textStatus, xhr){
      
      // Establecemos los datos
      Datos = $.parseJSON(Datos);

      // Verificamos el estado
      if(Datos['estado'] == 'exitoso'){

        // Insertamos las lecciones
        for(var i = 0; i < Datos['detalle'].length; i++){
          console.log(Datos['detalle'][i]);
          if(Datos['detalle'][i]['Id'] == Lección){
            $(".Tema").append('<div class="Item Actual"><span><i style="color: #4E73DF;" class="fa-regular fa-compact-disc fa-spin"></i> <i> ' + Datos['detalle'][i]['Numero'] + '.</i> <b data-bs-toggle="tooltip" data-bs-title="' + Datos['detalle'][i]['Titulo'] + '">' + Datos['detalle'][i]['Titulo'] + '</b></span></div>');
          }else{
            $(".Tema").append('<div onclick="irLección(' + Datos['detalle'][i]['Id'] + ')" class="Item"><span><i> ' + Datos['detalle'][i]['Numero'] + '.</i> <b data-bs-toggle="tooltip" data-bs-title="' + Datos['detalle'][i]['Titulo'] + '">' + Datos['detalle'][i]['Titulo'] + '</b></span></div>');
          }
          $("[data-bs-toggle='tooltip']").tooltip();
        }

      }else if(Datos['estado'] == 'error'){
        $("#Temas p").text("Hubo un error: " + Datos['detalle'] + " [" + Datos['codigo'] + "]");
      }else{
        $("#Temas p").text("Hubo un error desconocido al obtener las lecciones.");
      }

      $(".Tema .Carga").remove();

      $("#Clase_html5_api").attr("src", "https://cdn-aula-virtual.sibau.com.ar/Clase" + Lección + ".mkv");

    },
    error: function(){
      $("#Temas p").text("Hubo un error desconocido al obtener las lecciones.");
      $("#Clase_html5_api").attr("src", "https://cdn-aula-virtual.sibau.com.ar/Clase" + Lección + ".mkv");
    }
  });
}
*/
</script>
</body>
</html>