<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('perfil*' . $_GET['Usuario']);

?>
<!DOCTYPE html>
<html lang="es">
<head>

<!-- UTF-8 -->
<meta charset="utf-8">

<!-- Edge -->
<meta http-equiv="X-UA-Compatible" content="IE=edge">

<!-- Responsive -->
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

<!-- Autor -->
<meta name="author" content="Bautista Izaguirre">

<!-- Titulo -->
<title>SIBAU - Perfil de <?php echo $_GET['Usuario'] ?></title>

<!-- FontAwesome -->
<link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">

<!-- Fonts -->
<link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

<!-- Estilos -->
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
<link href="../Recursos/css/Estilos.css" rel="stylesheet">
<link href="../Recursos/css/Perfil.css?v2<?php echo time(); ?>" rel="stylesheet">

<!-- Icono -->
<link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

<!-- Manifiesto -->
<link rel="manifest" href="../manifest.json">
<link rel="apple-touch-icon" href="https://sibau.com.ar/Recursos/Logo.png">
<meta name="apple-mobile-web-app-status-bar" content="#F8F9FC">
<meta name="theme-color" content="#4E73DF">

</head>
<body id="page-top">
<div id="wrapper">

  <!-- Menu lateral -->
  <?php include_once("./Recursos/navLateral.php") ?>
  <!-- Fin de Menu lateral -->

  <!-- Pagina -->
  <div id="content-wrapper" class="d-flex flex-column">
    <div id="content">

      <!-- Menu superior -->
      <?php include_once("./Recursos/navSuperior.php") ?>
      <!-- Fin de Nav -->

      <!-- Contenedor -->
      <div class="container-fluid" style="padding: 0">

        <!-- Loader -->
        <div id="Loader"></div>
        <!-- Fin de Loader -->

        <!-- Contenido -->
        <div style="display:none" id="Contenido">

          <!-- Cabecera -->
          <div class="Cabecera">
            <span class="badge text-bg-light compartenInstitucion" style="display:none" SibauMulti="perfil.comparten">Comparten institución</span>
          </div>
          <!-- Fin de Cabecera -->

          <div class="Datos">
            <img>
            <h3></h3>
            <h6 data-bs-toggle="tooltip" data-bs-title=""></h6>
          </div>

          <!-- Paneles -->
          <div class="Paneles" style="display: flex">

            <!-- Perfil -->
            <div class="Perfil">
              <div class="SubPerfil">

                <h5 class="sobre"></h5>

                <p class="ml-1" id="Presentación"><strong><i class="fa-light fa-hand-wave"></i> <span SibauMulti="perfil.sobre.presentacion">Presentación</span>:</strong> <dato data-bs-toggle="tooltip" data-bs-title=""></dato></p>

                <p class="ml-1" id="Escuela"><strong><i class="fa-light fa-school"></i> <span SibauMulti="perfil.sobre.escuela">Escuela</span>:</strong> <dato data-bs-toggle="tooltip" data-bs-title=""></dato></p>

                <p class="ml-1" id="LibroFavorito"><strong><i class="fa-light fa-book"></i> <span SibauMulti="perfil.sobre.libro">Libro favorito</span>:</strong> <dato></dato></p>

                <p class="ml-1" id="ActorFavorito"><strong><i class="fa-light fa-camera-movie"></i> <span SibauMulti="perfil.sobre.actor">Actor favorito</span>:</strong> <dato></dato></p>

                <p class="ml-1" id="EscritorFavorito"><strong><i class="fa-light fa-pen-nib"></i> <span SibauMulti="perfil.sobre.escritor">Escritor favorito</span>:</strong> <dato></dato></p>

                <p class="ml-1" id="Hobby"><strong><i class="fa-light fa-guitars"></i> <span SibauMulti="perfil.sobre.hobby">Hobby</span>:</strong> <dato></dato></p>

              </div>
            </div>
            <!-- Fin de Perfil -->

            <div></div>

          </div>
          <!-- Fin de Paneles -->

        </div>
        <!-- Fin de Contenido -->

      </div>
      <!-- Fin de Contenedor -->

    </div>

    <!-- Footer -->
    <?php include_once("./Recursos/footer.php") ?>
    <!-- End of Footer -->

  </div>
  <!-- Fin de Pagina -->

</div>

  <!-- Jquery -->
  <script src="../Recursos/vendor/jquery/jquery.min.js"></script>
  <script src="../Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>

  <!-- Bootstrap -->
  <script src="../Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    
  <!-- Generales -->
  <script src="../Recursos/js/Carga.js"></script>
  <script src="../Recursos/js/General.js?t=<?php echo time(); ?>"></script>
  
  <!-- Sweet2Alert -->
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.16/dist/sweetalert2.all.min.js"></script>

  <!-- Propios del archivo -->
  <script>var Usuario = '<?php echo substr($_GET['Usuario'], 1); ?>'; var UsuarioA = '<?php echo $_SESSION['Id']; ?>';</script>
  <script src="../Recursos/js/Perfil.js?t=<?php echo time(); ?>"></script>

</body>
</html>