<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion("recurso*" . $_GET['Id']);

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Recursos en linea</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="../Recursos/css/Estilos.css" rel="stylesheet">
  <link href="../Recursos/css/Recurso.css" rel="stylesheet">

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

  <!-- Manifiesto -->
  <link rel="manifest" href="../manifest.json">
  <link rel="apple-touch-icon" href="https://sibau.com.ar/Recursos/Logo.png">
  <meta name="apple-mobile-web-app-status-bar" content="#F8F9FC">
  <meta name="theme-color" content="#4E73DF">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" style="overflow: unset;" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->

        <!-- Contenedor -->
        <div class="container-fluid" style="position: relative; height: 100%;">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

          <!-- Contenido -->
          <div style="display:none" id="Contenido">

            <!-- Contenedor superior -->
            <div>

              <!-- Titulo -->
              <h2 style="font-size: 1rem" class="col h4 mb-3 text-gray-800"><strong>Recurso:</strong> <datos dato="Titulo"></datos></h2>

            </div>
            <!-- Fin de Contenedor superior -->


            <!-- Contenedor -->
            <div class="conteiner">

              <!-- Menu telefono -->
              <div class="menuTelefono row">

                <abbr id="editarRecursoIconoAbbr" class="col editarRecursoIcono" title="Editar recurso"><i class="editarRecursoIcono fa-solid fa-pen-to-square"></i></abbr>
                <abbr class="col" title="Reportar recurso"><i class="reportarRecursoIcono fa-solid fa-flag"></i></abbr>
                <abbr class="col" title="Compartir recurso"><i class="compartirRecursoIcono fa-solid fa-share"></i></abbr>
                <abbr class="col" title="Comentatios"><i class="comantarioRecursoIcono fa-solid fa-comments"></i></abbr>
                <abbr class="col" title="Informacion del recurso"><i class="infoRecursoIcono fa-solid fa-circle-info"></i></abbr>
                <abbr class="col" title="QR del recurso"><i class="qrRecurso fa-solid fa-qrcode"></i></abbr>

              </div>
              <!-- Fin de Menu telefono -->

              <!-- Comentarios -->
              <div class="modal fade" id="comantarioRecurso" tabindex="-1" aria-hidden="true">
                <div class="modal-dialog">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title">Comentarios</h5>
                      <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">

                      <?php if($_SESSION['Permisos']['agregarComentario'] == true){ ?>
                        <!-- Comentar -->
                        <div class="comantarCaja row" id="comantarCajaMovil">
                          <input type="text" class="col-10 form-control" id="nuevoComentarioMovil" placeholder="Comentario...">
                          <div onclick="enviarComentario('Movil')" class="col-1" style="padding-left: 10px"><button type="button" class="enviarComentario btn btn-primary"><i class="fa-solid fa-paper-plane"></i></button></div>
                        </div>
                        <p class="error-form errorComentario"></p>
                        <!-- Fin de Comentar -->
                      <?php } ?>

                      <!-- Comentarios --> 
                      <div class="comantariosMovil">
                        <p>Aun no hay comentarios. Se el primero!</p>
                      </div>
                      <!-- Fin de Comentarios -->

                    </div>
                  </div>
                </div>
              </div>
              <!-- Fin de Comentarios -->

              <!-- Informacion -->
              <div class="modal fade" id="informacionRecurso" tabindex="-1" aria-hidden="true">
                <div class="modal-dialog">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title">Informacion</h5>
                      <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body" id="datosUsuarioMovil">

                      <!-- Usuario -->
                      <div class="row" style="margin: 0; align-items: center">
                        <div class="col-2" style="padding: 0"><img dato="ImagenPerfil"></div>
                        <div class="col-10">
                          <p style="margin-bottom: 0; font-weight: bold"><datos dato="Nombre"></datos> <datos dato="Insignia"></datos></p>
                          <i class="fa-light fa-school"></i> <datos data-bs-toggle="tooltip" dato="Institucion"></datos>
                        </div>
                      </div>
                      <!-- Fin de Usuario -->

                      <hr style="border-top: 1px solid black;">

                      <p>
                        <strong>Fecha de subida:</strong> <datos dato="Fecha"></datos><br>
                        <strong>Visibilidad:</strong> <datos data-bs-toggle="tooltip" dato="Visiblidad"></datos><br>
                        <strong>Visitas:</strong> <datos dato="Visitas"></datos>
                      </p>

                      <hr style="border-top: 1px solid black;">

                      <!-- Descripcion -->
                      <div id="Descripcion">
                        <datos dato="Descripcion"></datos>
                      </div>
                      <!-- Fin de Descripcion -->

                      <hr style="border-top: 1px solid black;">

                    </div>
                  </div>
                </div>
              </div>
              <!-- Fin de Informacion -->

              <!-- Recurso -->
              <div class="Recurso">
                <iframe frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen allow="fullscreen"></iframe>
              </div>
              <!-- Fin de Recurso -->

              <!-- Detalles -->
              <div class="Detalles mt-3">

                <!-- Datos -->
                <div class="Datos">
                  <img dato="ImagenPerfil">
                  <div>
                    <h4><datos dato="Nombre"></datos> <datos dato="Insignia"></datos></h4>
                    <i class="fa-light fa-school"></i> <datos data-bs-toggle="tooltip" dato="Institucion"></datos>
                  </div>

                  <div class="Iconos"><i data-bs-toggle="tooltip" data-bs-title="Editar recurso" class="editarRecursoIcono fa-light fa-pen"></i>  <i style="margin-right: 1rem;" data-bs-toggle="tooltip" data-bs-title="QR" class="qrCodigo fa-light fa-qrcode"></i>  <i data-bs-toggle="tooltip" data-bs-title="Compartir recurso" class="compartirRecursoIcono fa-light fa-share"></i>  <i data-bs-toggle="tooltip" data-bs-title="Reportar recurso" class="reportarRecursoIcono fa-light fa-flag"></i></div>
                </div>
                <!-- Din de Datos -->

                <!-- Descripcion -->
                <div class="Descipcion">
                  <strong>Fecha de subida:</strong> <datos dato="Fecha"></datos><br>
                  <strong>Visibilidad:</strong> <datos data-bs-toggle="tooltip" dato="Visiblidad"></datos><br>
                  <strong>Visitas:</strong> <datos dato="Visitas"></datos><br><br>

                  <strong>Descripción:</strong><br>
                  <datos dato="Descripcion"></datos>
                </div>
                <!-- Fin Descripcion -->

                <?php if($_SESSION['Permisos']['agregarComentario'] == true){ ?>
                  <!-- Comentar -->
                  <div class="comantarCaja row" id="comantarCajaPc">
                    <input type="text" class="col-10 form-control" id="nuevoComentarioPc" placeholder="Comentario...">
                    <div onclick="enviarComentario('Pc')" class="col-1" style="padding-left: 10px"><button type="button" class="enviarComentario btn btn-primary"><i class="fa-solid fa-paper-plane"></i></button></div>
                  </div>
                  <p class="error-form errorComentario"></p>
                <!-- Fin de Comentar -->
                <?php } ?>

                <!-- Comentarios -->
                <div class="comantariosPc"></div>
                <!-- Fin de Comentarios -->

              </div>
              <!-- Fin de Detalles -->

            </div>
            <!-- Fin de Contenedor -->

          </div>
          <!-- FIn de Contenido -->
        

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

  <!-- Modal reportes -->
  <div class="modal" id="reportarRecuro" tabindex="-1">
    <div class="modal-dialog modal-lg">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Notificar mal uso del sistema de recursos en linea en SIBAU</h5>
          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <div class="modal-body">
          <form id="formularioReportes" name="formularioReportes">
            <p>En SIBAU© priorizamos la integridad de la comunidad, por lo que abrimos este espacio para que se puedan reportar mal uso del sistema de Recursos en linea.</p>
            <p>A continuacion indique la razon de su reporte.</p>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="1" name="Opcion" id="Opción1">
              <label class="form-check-label" for="Opción1">Spam</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="2" name="Opcion" id="Opción2">
              <label class="form-check-label" for="Opción2">Malware</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="3" name="Opcion" id="Opción3">
              <label class="form-check-label" for="Opción3">Suplantacion de identidad (Phishing)</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="4" name="Opcion" id="Opción4">
              <label class="form-check-label" for="Opción4">Violencia</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="5" name="Opcion" id="Opción5">
              <label class="form-check-label" for="Opción5">Incitacion al odio</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="6" name="Opcion" id="Opción6">
              <label class="form-check-label" for="Opción6">Contenido sobre organizaciones y movimientos violentos</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="7" name="Opcion" id="Opción7">
              <label class="form-check-label" for="Opción7">Acoso, intimidación y amenazas</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="8" name="Opcion" id="Opción8">
              <label class="form-check-label" for="Opción8">Material sexualmente explícito</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="9" name="Opcion" id="Opción9">
              <label class="form-check-label" for="Opción9">Suplantación de identidad e información engañosa</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="10" name="Opcion" id="Opción10">
              <label class="form-check-label" for="Opción10">Información personal y confidencial</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="11" name="Opcion" id="Opción11">
              <label class="form-check-label" for="Opción11">Actividades ilegales</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" value="12" name="Opcion" id="Opción12">
              <label class="form-check-label" for="Opción12">Infracción de derechos de autor</label>
            </div>
            <div class="form-check">
              <input class="form-check-input" type="radio" name="Opcion" id="Opción13">
              <label class="form-check-label" for="Opción13">Menores en peligro</label>
            </div>
            <p class="error-form" id="errorOpcion"></p>
            <div class="mb-3 mt-3">
              <label for="Detalles" class="form-label">Descríbenos el incumplimiento</label>
              <textarea class="form-control" id="Detalles" name="Detalles" rows="3" placeholder="Aquí debes detallar mas la infracción y por ejemplo debes indicar el minuto el cual se encuentra la infracción en caso de ser un video, la pagina en caso de ser un PDF."></textarea>
              <p class="error-form" id="errorDetalle"></p>
            </div>
            <div class="form-check mt-3">
              <input class="form-check-input" type="checkbox" value="1" required name="Entiendo" id="Entiendo">
              <label class="form-check-label" for="Entiendo">Yo <?php echo $_SESSION['Nombre'] . " " . $_SESSION['Apellido'] ?> entiendo que este reporte puede ocasionar una suspension temporal o permanente del sistema SIBAU© tanto al dueño del archivo en caso de ser verdadero el reporte como a tí en caso de ser un reporte falso.</label>
              <p class="error-form" id="errorEntendimiento"></p>
            </div>
          </form>          
        </div>
        <div class="modal-footer">
          <p class="error-form" id="errorGeneral"></p>
          <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cerrar</button>
          <button type="button" id="enviarReporte" onclick="$('#formularioReportes').submit()" class="btn btn-primary">Enviar reporte</button>
        </div>
      </div>
    </div>
  </div>
  <!-- Fin de Modal reportes -->

  <!-- Edición de recursos -->
  <div class="modal fade" id="editarRecuro" tabindex="-1" aria-hidden="true">
    <div class="modal-dialog modal-lg">
      <div class="modal-content">
        <div class="modal-header">
          <h1 class="modal-title fs-5">Editar recurso</h1>
          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <div class="modal-body">
          <form id="editarRecursoFormulario">
            <div class="mb-3">
              <label for="Titulo" class="form-label">Titulo <sup style="color:red">*</sup></label>
              <input type="text" class="form-control" required id="Titulo" name="Titulo" aria-describedby="TituloInfo">
              <div id="TituloAyuda" class="form-text">Este sera el nombre del archivo y sera visible para todos.</div>
                <a id="TituloError" class="error-form"></a>
              </div>
              <div class="mb-3">
                <label for="Descripción" class="form-label">Descripción</label>
                <textarea class="form-control" id="Descripción" name="Descripción"></textarea>
                <div id="DescripciónInfo" class="form-text">Debe ser entre 0 y 1.000 caracteres</div>
                <a id="DescripciónError" class="error-form"></a>
              </div>
              <div class="mb-3">
                <label for="Tipo" class="form-label">Tipo de recurso <sup style="color:red">*</sup></label>
                <select required class="form-select" id="Tipo" name="Tipo">
                  <option value="0">Imagen (Drive)</option>
                  <option value="1">PDF (Drive)</option>
                  <option value="2">Word (Drive)</option>
                  <option value="3">Excel (Drive)</option>
                  <option value="4">Power Point (Drive)</option>
                  <option value="5">Video (Drive)</option>
                  <option value="6">Video (Youtube)</option>
                  <option value="7">Link externo</option>
                </select>
              </div>
              <div class="mb-3">
                <label for="Categoria" class="form-label">Categoria <sup style="color:red">*</sup></label>
                <select required class="form-select" id="Categoria" name="Categoria">
                  <option value="1" selected>No aplica</option>
                  <option value="4">LITERATURA</option>
                  <option value="5">HISTORIA</option>
                  <option value="6">GEOGRAFÍA</option>
                  <option value="7">EFEMÉRIDES</option>
                  <option value="8">BIOLOGÍA</option>
                  <option value="9">CIENCIAS SOCIALES</option>
                  <option value="10">CONSTRUCCIÓN DE LA CIUDADANÍA</option>
                  <option value="11">LENGUA Y LITERATURA</option>
                  <option value="12">PRACTICAS DEL LENGUAJE</option>
                  <option value="13">INGLES</option>
                  <option value="14">FÍSICO-QUÍMICA</option>
                  <option value="15">MATEMÁTICA</option>
                  <option value="16">EDUCACIÓN FÍSICA</option>
                  <option value="17">ELECTRÓNICA</option>
                  <option value="18">PROGRAMACIÓN</option>
                  <option value="19">TALLER C.B.</option>
                  <option value="20">CIENCIAS NATURALES</option>
                  <option value="21">ARTE</option>
                </select>
              </div>
              <div class="mb-3">
                <label for="Archivo" class="form-label">Id Archivo <sup style="color:red">*</sup></label>
                <input type="text" placeholder="xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx" class="form-control" id="Archivo" name="Archivo">
                <a id="ArchivoError" class="error-form"></a>
              </div>
              <div class="mb-3">
                <label for="Etiquetas" class="form-label">Etiquetas <small>(En caso de ser mas de una, separelo con comas)</small></label>
                <input type="text" placeholder="Literatura, Novelas..." class="form-control" id="Etiquetas" name="Etiquetas">
              </div>
              <div class="mb-3 form-check">
                <input type="checkbox" class="form-check-input" id="Despliegue" name="Despliegue">
                <label class="form-check-label" for="Despliegue">Compartir con otras Instituciones (Debes tener en cuenta los Derechos de Autor)</label>
              </div>
              <div class="mb-3 form-check">
                <input type="checkbox" class="form-check-input" id="Comentarios" name="Comentarios">
                <label class="form-check-label" for="Comentarios">Habilitar comentarios</label>
              </div>
              <a class="error-form" id="ErrorOtro"></a>
            </form>
          <p>SIBAU se encargará  de los comentarios y su moderación. SIBAU se reserva el derecho de permanencia de los recursos y no acepta reclamos ante sus decisiones.</p>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cerrar</button>
          <button type="button" class="btn btn-primary" onclick="$('#editarRecursoFormulario').submit()">Editar recurso</button>
        </div>
      </div>
    </div>
  </div>
  <!-- Fin de Edición de recurso -->

        <!-- -->
        <style>
          :root {
  --color-first: #65587f;
  --color-second: #f18867;
  --color-third: #e85f99;
  --color-forth: #50bda1;
  --block-width: 300px;
  --block-height: 270px;
  --border-width: .625rem;
  --border-radius-outer: 8px;
  --border-radius-inner: calc(var(--border-radius-outer) / 2);
  --font-plain: "IBM Plex Sans", sans-serif;
  --font-special: "Fredoka One", sans-serif;
  box-sizing: border-box;
  line-height: 1.4;
}


.rainbow {
  width: 100%;
  height: 100%;
  -webkit-animation: o-rotate-360 linear 8s infinite;
          animation: o-rotate-360 linear 8s infinite;
}
.rainbow span {
  display: block;
  width: 100%;
  height: 100%;
  position: relative;
  transform: translate(-50%, -50%);
}
.rainbow span:after {
  display: block;
  content: "";
  width: 100%;
  height: 100%;
  position: absolute;
  left: 100%;
}
.rainbow span:first-child {
  background: var(--color-first);
}
.rainbow span:first-child:after {
  background: var(--color-second);
}
.rainbow span:last-child {
  background: var(--color-third);
}
.rainbow span:last-child:after {
  background: var(--color-forth);
}

.c-subscribe-box {
  width: var(--block-width);
  height: var(--block-height);
  overflow: hidden;
  position: relative;
  box-shadow: 0 10px 40px -10px rgba(0, 64, 128, 0.2);
  border-radius: var(--border-radius-outer);
}
.c-subscribe-box__wrapper {
  width: calc(100% - var(--border-width));
  height: calc(100% - var(--border-width));
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  background: #fff;
  padding: 1.2rem 1rem 1.8rem;
  display: flex;
  flex-direction: column;
  border-radius: var(--border-radius-inner);
}
.c-subscribe-box__title {
  font-size: 1.6rem;
}
.c-subscribe-box__desc {
  font-size: 0.935rem;
  margin: 0.7rem auto 1.8rem;
  max-width: 240px;
}
.c-subscribe-box__form {
  margin-top: auto;
}

.c-form--accent input:hover, .c-form--accent input:active, .c-form--accent input:focus {
  border-color: var(--color-third);
  box-shadow: 0 0 0 3px rgba(232, 94, 152, 0.25);
}
.c-form--accent [type=submit] {
  background: var(--color-third);
  border-color: var(--color-third);
  color: #fff;
}

@-webkit-keyframes o-rotate-360 {
  0% {
    transform: rotate(0);
  }
  100% {
    transform: rotate(360deg);
  }
}

@keyframes o-rotate-360 {
  0% {
    transform: rotate(0);
  }
  100% {
    transform: rotate(360deg);
  }
}
[type=submit] {
  margin-bottom: 0;
  font-family: var(--font-special);
  font-weight: normal;
  letter-spacing: 0.015em;
  font-size: 1.1rem;
}
[type=submit]:active {
  transform: scale(0.97);
}

input {
  font-family: inherit;
  color: inherit;
  outline: none;
  font-size: 93%;
  transition: all 300ms ease;
}

h3 {
  margin: 0;
  letter-spacing: -0.015em;
  font-family: var(--font-special);
  font-weight: normal;
  line-height: 1.4;
}

.u-align-center {
  text-align: center;
}
        </style>
        <div class="modal fade" id="compartirQR" tabindex="-1" aria-hidden="true">
          <div class="modal-dialog">
            <div style="border-radius: 12px; height: 80vh" class="modal-content">
              <div style="width: 100%; height: 100%" class="c-subscribe-box u-align-center">
                <div class="rainbow"><span></span><span></span></div>
                <div class="c-subscribe-box__wrapper">
                  <img class="compartirQRIMAGEN">
                </div>
              </div>
            </div>
          </div>
        </div>


    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>"; var Recurso = "<?php echo $_GET['Id']; ?>"; var ImagenPerfil = '<?php echo $_SESSION['ImagenPerfil'] ?>'; var Nombre = '<?php echo $_SESSION['Nombre'] . " " . $_SESSION['Apellido'] ?>'; var Estado = '<?php echo $_SESSION['Estado'] ?>'; var IdUsuario = '<?php echo $_SESSION['Id'] ?>';</script>
    <script src="../Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="../Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="../Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="../Recursos/js/General.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    <script src="../Recursos/js/Carga.js"></script>
    <script src="../Recursos/js/Recurso.js?sss4s44s4s"></script>

</body>
</html>