function obtenerMisDatos(){
  $.ajax({
    type: "GET",
    url: Url + 'Api/Usuarios?Tipo=obtenerMisDatos',
    success: function(Datos, textStatus, xhr){

      // Establecemos los datos
      Datos = $.parseJSON(Datos);

      // Verificamos el estado de la petición
      if(Datos['estado'] == 'error'){
        errorLoader(Datos['detalle']);
      }else if(Datos['estado'] == 'exitoso'){
          
        // Establecemos datos
        $("#SobreTi-Presentación").val(Datos['detalle']['Presentación']);
        $("#SobreTi-LibroFavorito").val(Datos['detalle']['LibroFavorito']);
        $("#SobreTi-ActorFavorito").val(Datos['detalle']['ActorFavorito']);
        $("#SobreTi-EscritorFavorito").val(Datos['detalle']['EscritorFavorito']);
        $("#SobreTi-Hobby").val(Datos['detalle']['Hobby']);
        $("#General-Telefono").val(Datos['detalle']['Telefono']);
        $("#General-Usuario").val(Datos['detalle']['Usuario']);
        var Ver = '#General-Ver option[value="' + Datos['detalle']['Privacidad'] + '"]';
        $(Ver).prop('selected', true);
        var Gen = '#General-Genero option:contains("' + Datos['detalle']['Genero'] + '")';
        $(Gen).prop('selected', true);

        // Quitamos loader
        quitarLoader();
          
      }else{
        errorLoader();
      }
    },
    error: function(){
      errorLoader();
    }
  })
}

function deshabilitarBoton(){
  $("#ConfiguracionesFormularios button").attr('disabled', true);
  $("#ConfiguracionesFormularios button").html('<i class="fa fa-spinner fa-spin"></i> Guardando');
}

function habilitarBoton(){
  $("#ConfiguracionesFormularios button").attr('disabled', false);
  $("#ConfiguracionesFormularios button").html("Guardar cambios");
}

$("#ConfiguracionesFormularios").submit(function(e){
  e.preventDefault();

  deshabilitarBoton();

  if($("#SobreTi-Presentación").val().length > 1000){
    $("#ErrorSobreTi-Presentación").text('* La presentación es demasiada larga.');
  }else if($("#SobreTi-LibroFavorito").val().length > 100){
    $("#ErrorSobreTi-LibroFavorito").text('* Tu libro favorito es demasiado largo.');
  }else if($("#SobreTi-ActorFavorito").val().length > 100){
    $("#ErrorSobreTi-ActorFavorito").text('* Tu actor favorito es demasiado largo.');
  }else if($("#SobreTi-EscritorFavorito").val().length > 100){
    $("#ErrorSobreTi-EscritorFavorito").text('* Tu escritor favorito es demasiado largo.');
  }else if($("#SobreTi-Hobby").val().length > 100){
    $("#ErrorSobreTi-Hobby").text('* Tu hobby es demasiado largo.');
  }

  $.ajax({
    type: "POST",
    url: Url + 'Api/Usuarios?Tipo=actualizarConfiguraciones',
    data: $("#ConfiguracionesFormularios").serialize(),
    success: function(Datos, textStatus, xhr){

      habilitarBoton();

      Datos = $.parseJSON(Datos);

      if(Datos['estado'] == 'exitoso'){
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })

        Toast.fire({
          icon: 'success',
          title: 'Configuraciones actualizadas con éxito. Cierre sesión para ver los cambios.'
        })
      }else if(Datos['estado'] == 'error'){
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })

        Toast.fire({
          icon: 'error',
          title: Datos['detalle']
        })
      }else{
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })

        Toast.fire({
          icon: 'error',
          title: "Hubo un error desconocido"
        })
      }
    },
    error: function(){
      const Toast = Swal.mixin({
        toast: true,
        position: 'top-end',
        showConfirmButton: false,
        timer: 3000,
        timerProgressBar: true,
        didOpen: (toast) => {
          toast.addEventListener('mouseenter', Swal.stopTimer)
          toast.addEventListener('mouseleave', Swal.resumeTimer)
        }
      })

      Toast.fire({
        icon: 'error',
        title: 'Hubo un error desconocido, inténtelo de nuevo mas tarde.'
      })

      $("input").attr("disabled", false); $("select").attr("disabled", false); $("textarea").attr("disabled", false);
    }
  })
})

  obtenerMisDatos();

  $("#actualizarImagenPerfil").click(function(){
    //$("#imagenDePerfil").modal("show");

    const Toast = Swal.mixin({
      toast: true,
      position: 'top-end',
      showConfirmButton: false,
      timer: 3000,
      timerProgressBar: true,
      didOpen: (toast) => {
        toast.addEventListener('mouseenter', Swal.stopTimer)
        toast.addEventListener('mouseleave', Swal.resumeTimer)
      }
    })
    
    Toast.fire({
      icon: 'info',
      title: 'Muy pronto habilitaremos esta función 😁'
    })
  })


  const articulosAdqueridos = [];

// Función: actualizar vista previa de la imagen de perfil.
function actualizarPersonaje(){

  var Pelo = $("#Pelo").val();

  var Bigote = $("#Bigote").val();

  var ColorPelo = $("#ColorPelo").val();

  var ColorPiel = $("#ColorPiel").val();

  var ColorBigote = $("#ColorBigote").val();

  var ColorRemera = $("#ColorRemera").val();

  var Url = "https://desarrollo.sibau.com.ar/Api/imagenDePerfil?ColorPelo=" + $("#ColorPelo").val().slice(1) + "&TipoPelo=" + $("#Pelo").val() + "&TipoBigote=" + $("#Bigote").val() + "&ColorBigote=" + $("#ColorBigote").val().slice(1) + "&ColorRemera=" + $("#ColorRemera").val().slice(1) + " &ColorPiel=" + $("#ColorPiel").val().slice(1);

  $("object").attr("data", Url);


}
  
// Verificamos si es una imagen de perfil por defecto y aplicamos la configuración por defecto.
if(imagenPerfilActual.length < 4){
  $('#personaje option[value="' + imagenPerfilActual[0] + '"]').prop('selected', true)
}else{
  $('#personaje option[value="' + imagenPerfilActual[0] + '"]').prop('selected', true)
  $("#pelo").val("#" + imagenPerfilActual[1].split("=")[1]);
  $("#piel").val("#" + imagenPerfilActual[2].split("=")[1]);
  $("#remera").val("#" + imagenPerfilActual[3].split("=")[1]);
  if(imagenPerfilActual[4] == 'Calvo'){$("#Calvo").prop("checked",true);}
}
actualizarPersonaje();

// Establecemos si el usuario cambio algun dato
$("input").change(actualizarPersonaje);
$("select").change(actualizarPersonaje);
$("select").change(actualizarPersonaje);

$("#Restablecer").click(function(){
  $("#pelo").val("#333333");
  $("#piel").val("#BE7C5E");
  $("#remera").val("#4E73DF");
  actualizarPersonaje();
})

// Función: Guardamos la nueva imagen de perfil
function guardarImagenDePerfil(){

  // Cambiamos el botón
  $("#Guardar button").attr("disabled", true);
  $("#Guardar button").text("Actualizando...");

  // Establecemos el aspecto
  /*var Aspecto = $("#personaje").val() + "&ColorPelo=" + $("#pelo").val().slice(1) + "&ColorPiel=" + $("#piel").val().slice(1) + "&ColorRemera=" + $("#remera").val().slice(1);
  if($("#Calvo").prop('checked') == true){
    Aspecto += "&Calvo";
  }
  $("#nuevaConfiguracion #DatosPerfil").val(Aspecto);*/

  // Quitamos errores previos
  $("#imagenDePerfil .error-form").text("");

  // Ejecutamos petición
  $.ajax({
    type: "POST",
    url: Url + 'Api/Usuarios?Tipo=actualizarImagenPerfil',
    data: {
      "Pelo": $("#Pelo").val().slice(1),
      "Bigote": $("#Bigote").val(),
      "ColorPelo": $("#ColorPelo").val().slice(1),
      "ColorPiel": $("#ColorPiel").val().slice(1),
      "ColorBigote": $("#ColorBigote").val().slice(1),
      "ColorRemera": $("#ColorRemera").val().slice(1),
    },
    success: function(Datos, textStatus, xhr){

      // Establecemos los datos
      Datos = $.parseJSON(Datos);

      // Verificamos el estado de la peticion
      if(Datos['estado'] == 'error'){
        $(".error-form").text("* Error: " + Datos['detalle'] + " [" + Datos['codigo'] + "]");
        $("#Guardar button").attr("disabled", false);
        $("#Guardar button").text("Guardar");
      }else if(Datos['estado'] == 'exitoso'){
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })

        Toast.fire({
          icon: 'success',
          title: 'Imagen de perfil guardada con éxito, cierre sesión e ingrese nuevamente para ver los cambios.'
        })
        $(".img-profile").attr("src", "https://sibau.com.ar/Recursos/Perfiles/" + Aspecto);
        $("#Guardar button").attr("disabled", false);
        $("#Guardar button").text("Guardar");
      }else{
        $(".error-form").text("* Lo sentimos, hubo un error desconocido. Inténtelo de nuevo mas tarde.");
        $("#Guardar button").attr("disabled", false);
        $("#Guardar button").text("Guardar");
      }
    },
    error: function(){
      $(".error-form").text("* Lo sentimos, hubo un error desconocido. Inténtelo de nuevo mas tarde.");
      $("#Guardar button").attr("disabled", false);
      $("#Guardar button").text("Guardar");
    }
  })
}