/*

  Idiomas aceptados:

  [ES] Español
  [EN] Ingles
  [PT] Portugués
  [DE] Alemán

*/

// Establecemos idiomas aceptados
const Idiomas = {"ES": "Español", "EN": "Ingles", "PT": "Portugués", "DE": "Alemán"};

// Función: Cambia el idioma establecido en el localStorage
function cambiarIdioma(NuevoIdioma){
  localStorage.setItem("Idioma", NuevoIdioma);
  Idioma = NuevoIdioma;
  console.log(`SIBAU MULTILINGÜE: El idioma a cambiado a ${Idiomas[NuevoIdioma]} [${NuevoIdioma}]`);
  window.location.reload();
}

// Obtenemos el idioma, en caso de que no haya seleccionamos uno dependiendo el navegador
var Idioma = "";
if(localStorage.getItem("Idioma") !== null && localStorage.getItem("Idioma") !== ""){
  Idioma = localStorage.getItem("Idioma");
  console.info(`SIBAU MULTILINGÜE: SIBAU ha detectado que ya usabas ${Idiomas[localStorage.getItem("Idioma")]} [${localStorage.getItem("Idioma")}], por lo que lo usaremos para mejorar tu experiencia en nuestro sistema.`);
}else{
  var lenguajeNavegador = navigator.language || navigator.userLanguage;
  if(Idiomas[lenguajeNavegador.substr(0,2).toUpperCase()] !== undefined){
    console.info(`SIBAU MULTILINGÜE: SIBAU no ha detectado un idioma anterior por lo que obtuvo el idioma del navegador ${Idiomas[lenguajeNavegador.substr(0,2).toUpperCase()]} [${lenguajeNavegador.substr(0,2).toUpperCase()}].`);
    Idioma = lenguajeNavegador.substr(0,2).toUpperCase();
    localStorage.setItem("Idioma", lenguajeNavegador.substr(0,2).toUpperCase());
  }else{
    console.info(`SIBAU MULTILINGÜE: SIBAU no ha detectado un idioma anterior por lo que obtuvo el idioma del navegador pero no es un idioma compatible. Por lo que usaremos el español.`);
    Idioma = "ES";
    localStorage.setItem("Idioma", "ES");
  }
}

// Incluimos el archivos JS del respectivo idioma
var Lenguaje;console.log("A");

async function obtenerJSON(url) {
  // Usamos await para esperar a que se resuelva la promesa de $.getJSON
  let json = await $.getJSON(url);
  // Devolvemos el resultado
  return json;
}

obtenerJSON(`${Url}Recursos/js/Idiomas/${Idioma}.json?t=${new Date}`).then(function(json) {
  Lenguaje = json;
}).then(function() {
  console.log("B");
  // Cambiamos los textos
  for (var i = 0; i < $("[SibauMulti]").length; i++) {
    $("[SibauMulti]").eq(i).html(Lenguaje[$("[SibauMulti]").eq(i).attr("SibauMulti")]);
  }

  if(typeof idiomasEspeciales === "function"){idiomasEspeciales();}
});

console.log("C");
// Función: Incrusta idioma en ATTR especifico
function idiomaATTR(Item, Selector, Attr){
  $(Selector).attr(Attr, Lenguaje[Item]);
}

// Función: Obtiene el item
function obtenerItemIdioma(Item){
  return Lenguaje[Item];
}