// Obtener regiones
$.ajax({
  type: "GET",
  url: Url + "Api/Mapoteca",
  data: {"Tipo": "obtenerRegion"},
  success: function(Datos, textStatus, xhr){

    // Establecemos los datos
    Datos = $.parseJSON(Datos);

    // Verificamos estado de la petición
    if(Datos['estado'] == 'exitoso'){
      
      for(var i = 0; i < Datos['detalle'].length; i++){
        $(".Regiones").append(`<div onclick="accederRegion(${Datos['detalle'][i]['Id']})" class="col region"><div class="fondo" style="background-image: url('${Url}Recursos/img/Mapoteca/${Datos['detalle'][i]['Nombre']}.webp')"></div><div class="nombre"><span>${Datos['detalle'][i]['Nombre']}</span></div></div>`)
      }

      quitarLoader();

    }else if(Datos['estado'] == 'error'){
      errorLoader(Datos['detalle'], Datos['codigo']);
    }else{
      errorLoader();
    }

  },
  error: function(){errorLoader();}
})

// Ver mapas
var cargaMapas = 0;
function accederRegion(Id){
  if(cargaMapas == 0){

    const Toast = Swal.mixin({
      toast: true,
      position: 'top-end',
      showConfirmButton: false,
      timerProgressBar: true,
      didOpen: (toast) => {
        toast.addEventListener('mouseenter', Swal.stopTimer)
        toast.addEventListener('mouseleave', Swal.resumeTimer)
      }
    })
    
    Toast.fire({
      icon: 'info',
      title: obtenerItemIdioma("mapoteca.obteniendo").replace("NOMBRE", General["nombreUsuario"])
    })

    cargaMapas = 1;
    $.ajax({
      type: "GET",
      url: Url + "Api/Mapoteca",
      data: {"Tipo": "obtenerMapas", "Region": Id},
      success: function(Datos, textStatus, xhr){
    
        // Establecemos los datos
        Datos = $.parseJSON(Datos);
    
        // Verificamos estado de la petición
        if(Datos['estado'] == 'exitoso'){

          if(Datos['detalle'].length > 0){
            
            $("#verMapas").modal("hide");
            $("#verMapas").remove();
            var Model = `<div class="modal fade" id="verMapas" tabindex="-1" aria-hidden="true">
            <div class="modal-dialog modal-lg">
              <div class="modal-content">
                <div class="modal-header">
                  <h1 class="modal-title fs-5">${obtenerItemIdioma("mapoteca.modal.titulo")} <region></region></h1>
                  <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                  
                </div>
              </div>
            </div>
            </div>`;
            $("body").append(Model);

            $("#verMapas region").html(Datos['detalle'][0]['Region']);

            for(var i = 0; i < Datos['detalle'].length; i++){
              if(i > 0){$("#verMapas .modal-body").append(`<hr>`);}
              $("#verMapas .modal-body").append(`<p>
                <a>${obtenerItemIdioma("mapoteca.modal.mapa")} ${Datos['detalle'][0]['Region']} ${Datos['detalle'][i]['Tipo']}</a>
                <a onclick="vizualizarMapa('${Datos['detalle'][i]['Archivo']}')" class="mt-2 visualizarMapa btn btn-success btn-icon-split"><span class="icon text-white-50"><i class="fa-solid fa-eye"></i></span> <span class="text">${obtenerItemIdioma("mapoteca.modal.ver")}</span></a>
                <a onclick="descargarMapa('${Datos['detalle'][i]['Archivo']}')" class="mt-2 btn btn-success btn-icon-split"><span class="icon text-white-50"><i class="fa-solid fa-file-pdf"></i></span> <span class="text">${obtenerItemIdioma("mapoteca.modal.descargar")}</span></a>
              </p>`);
            }

            Swal.close();

            $("#verMapas").modal("show")
            $('#verMapas').on('hidden.bs.modal', function(){
              $("#verMapas").remove();
            })

          }else{

            const Toast = Swal.mixin({
              toast: true,
              position: 'top-end',
              showConfirmButton: false,
              timer: 3000,
              timerProgressBar: true,
              didOpen: (toast) => {
                toast.addEventListener('mouseenter', Swal.stopTimer)
                toast.addEventListener('mouseleave', Swal.resumeTimer)
              }
            })
            
            Toast.fire({
              icon: 'error',
              title: obtenerItemIdioma("mapoteca.noHay")
            })

          }
    
        }else if(Datos['estado'] == 'error'){
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            showConfirmButton: false,
            timer: 3000,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })
          
          Toast.fire({
            icon: 'error',
            title: `${Datos['detalle']} [${Datos['codigo']}]`
          })
        }else{
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            showConfirmButton: false,
            timer: 3000,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })
          
          Toast.fire({
            icon: 'error',
            title: obtenerItemIdioma("mapoteca.error")
          })
        }

        cargaMapas = 0;
    
      },
      error: function(){
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
        
        Toast.fire({
          icon: 'error',
          title: 'Hubo un error desconocido'
        })

        cargaMapas = 0;
      }
    })
  }
}

function descargarMapa(Id){
  window.open(Url + "Recursos/Mapa?Id=" + Id, '_blank');
}
function vizualizarMapa(Id){
  window.open(Url + "Recursos/Mapa?Id=" + Id + "&Ver", '_blank');
}