// Detectamos si se pulso el boton para enviar el reporte.
$("#formularioReportes").submit(function(e){

  // Evitamos la accion por defecto
  e.preventDefault();

  // Quitamos los posibles errores previos
  $(".error-form").text("");

  // Deshabilitamos el boton
  desHabilitarBotón();
  
  // Verificamos que haya seleccionado una opcion valida.
  if($("#reportarRecuro input[name='Opcion']:checked").val() < 1 && $("#reportarRecuro input[name='Opcion']:checked").val() > 13 || $("#reportarRecuro input[name='Opcion']:checked").val() == undefined){
    $("#reportarRecuro #errorOpcion").text("* Debes seleccionar una opcion valida");
    habilitarBotón();

  // Verificamos que los detalles no tengan menos de 5 caracteres.
  }else if($("#reportarRecuro #Detalles").val().length < 5){
    $("#reportarRecuro #errorDetalle").text("* La descripcion es corta, ¿Crees que puedes extenderla?");
    habilitarBotón();

  // Verificamos que los detalles no tenga mas 1.000 caracteres.
  }else if($("#reportarRecuro #Detalles").val().length > 1000){
    $("#reportarRecuro #errorDetalle").text("* La descripcion es larga, ¿Crees que puedes resumirla?");
    habilitarBotón();

  // Verificamos que haya aceptado el entendimiento.
  }else if(!$("#Entiendo").is(":checked")){
    $("#reportarRecuro #errorEntendimiento").text("* Debes marcar el entendimiento.");
    habilitarBotón();

  // Ya validado enviamos la peticion
  }else{
    $.ajax({
      type: "GET",
      url: Url + "Api/RecursosOnline?Tipo=Reportar&Recurso=" + Recurso + "&Opcion=" + $("#reportarRecuro input[name='Opcion']:checked").val() + "&Detalles=" + $("#reportarRecuro #Detalles").val(),
      success: function(Datos, textStatus, xhr){

        // Establecemos los datos
        Datos = $.parseJSON(Datos);
      
        // Verificamos el estado de la peticion
        if(Datos['estado'] == "exitoso"){

          // Mostramos mensaje de exito
          var ContenidoExito = '<img src="https://desarrollo.sibau.com.ar/Recursos/img/reporteExitoso.svg" style="height: 50vh;"> <h2 class="mt-2" style="font-weight: bold;">¡Reporte enviado de forma exitosa!</h2><h6>Gracias por ayudar a la comunidad 🙌</h6><h6 style="font-style: italic; font-size: small;">Identificacion del reporte #' + Datos['detalle'] + '</h6>'
          $("#reportarRecuro .modal-body").html(ContenidoExito);
          $("#reportarRecuro .modal-body").css("text-align", "center");
          $("#reportarRecuro .modal-footer").hide();
          $("#reportarRecuro .modal-header").hide();

        }else if(Datos['estado'] == "error"){
          
          // Habilitamos boton y mostramos error
          habilitarBotón();
          $("#reportarRecuro #errorGeneral").text("* Error: " + Datos['detalle']);

        }else{
        
          // Habilitamos boton y mostramos error
          habilitarBotón();
          $("#reportarRecuro #errorGeneral").text("* Hubo un error desconocido, intentelo denuevo mas tarde.");

        }

      },
      error: function(){

        // Habilitamos boton y mostramos error
        habilitarBotón();
        $("#reportarRecuro #errorGeneral").text("* Hubo un error desconocido, intentelo denuevo mas tarde.");

      }
    })
  }

})

// Función: Habilita el boton para enviar reporte al recurso
function habilitarBotón(){
  $("#enviarReporte").attr("disabled", false);
  $("#enviarReporte").css('opacity','100%');
  $("#enviarReporte").html('Enviar reporte');
}

// Función: Deshabilita el boton para enviar reporte al recurso
function desHabilitarBotón(){
  $("#enviarReporte").attr("disabled", true);
  $("#enviarReporte").css('opacity','50%');
  $("#enviarReporte").html('<i class="fa fa-spinner fa-spin"></i> Enviando');
}

// Cargamos el recurso, establecemos las variables
var Datos = '';
var ComentariosPc = '';
var ComentariosMovil = '';

// Enviamos la peticion
$.ajax({
  type: "GET",
  contentType: 'application/json; charset=utf-8',
  url: Url + "Api/RecursosOnline?Tipo=ObtenerEspecifico&Recurso=" + Recurso,
  success: function(data, textStatus, xhr){

    // Establecemos los datos
    Datos = $.parseJSON(data);

    // Verificamos el estado de la peticion
    if(Datos['estado'] == 'exitoso'){

      // Establecemos el titulo
      $("title").text("Recurso: " + Datos['detalle']['Titulo']);
      $("datos[dato='Titulo']").text(Datos['detalle']['Titulo']);

      // Establecemos el contenido
      if(Datos['detalle']['Tipo'] == 6){
        $("iframe").attr("src","https://www.youtube.com/embed/" + Datos['detalle']['IdDrive']);
      }else if(Datos['detalle']['Tipo'] == 7){
        $("iframe").attr("src","https://desarrollo.sibau.com.ar/Api/recursoExterno.php?Url=" + Datos['detalle']['IdDrive']);
      }else{
        $("iframe").attr("src","https://drive.google.com/file/d/" + Datos['detalle']['IdDrive'] + "/preview")
      };

      // Establecemos imagen de perfil
      $("img[dato='ImagenPerfil']").attr('src', Url + 'Api/imagenDePerfil' + Datos['detalle']['ImagenPerfil']);

      // Establecemos el nombre del propietario
      $("datos[dato='Nombre']").text(Datos['detalle']['Nombre']);
      $("datos[dato='Insignia']").html(obtenerInsignia(Datos['detalle']['EstadoUsuario'], false));
      $(".insigniaUsuarios").tooltip();

      // Establecemos la institucion
      $("datos[dato='Institucion']").text(Datos['detalle']['NombreInstitucionAbreviado']);    
      $("datos[dato='Institucion']").attr("data-bs-title", Datos['detalle']['NombreInstitucion']);  
      $("datos[dato='Institucion']").tooltip();

      // Establecemos QR
      $(".compartirQRIMAGEN").attr("src", "https://chart.googleapis.com/chart?chs=500x500&cht=qr&chl=https://panel.sibau.com.ar/recurso/" + Datos['detalle']['Id']);

      // Establecemos fecha de creacion
      var Fecha = new Date(Datos['detalle']['Fecha']);

      if(Fecha.getDate().toString().length == 1){
        var Dia = "0" + Fecha.getDate();
      }else{
        var Dia = Fecha.getDate();
      }

      if(Fecha.getMonth().toString().length == 1){
        var Mes = "0" + (Fecha.getMonth()+1);
      }else{
        var Mes = (Fecha.getMonth()+1);
      }

      $("datos[dato='Fecha']").text("Subido el " + Dia + "/" + Mes + "/" + Fecha.getFullYear() + " " + Fecha.getHours() + ":" + Fecha.getMinutes());

      // Establecemos la visibilidad
      if(Datos['detalle']['Despliegue'] == '0'){$("datos[dato='Visiblidad']").text("Recurso exclusivo para " + Datos['detalle']['NombreInstitucionAbreviado'])}else{$("datos[dato='Visiblidad']").text("Recurso compartido por " + Datos['detalle']['NombreInstitucionAbreviado'])};
      $("datos[dato='Visiblidad']").attr("data-bs-title", Datos['detalle']['NombreInstitucion']);
      $("datos[dato='Visiblidad']").tooltip();

      // Establecemos las visitas
      if(Datos['detalle']['Visitas'] == 1){
        $("datos[dato='Visitas']").text(Datos['detalle']['Visitas'] + " visualizacion"); 
      }else{
        $("datos[dato='Visitas']").text(Datos['detalle']['Visitas'] + " visualizaciones");
      }

      // Establecemos la descripcion
      if(Datos['detalle']['Descripcion'] == ''){$("datos[dato='Descripcion']").text("El usuario no ha aportado una descripcion");}else{$("datos[dato='Descripcion']").text(Datos['detalle']['Descripcion']);}
    
      // Verificamos el estado de los comentarios
      if(Datos['detalle']['Comentarios'] !== '1'){

        // Mostramos mensaje en comentarios movil
        $("#comantarioRecurso .modal-body").html('<strong>Este recurso no admite comentarios.</strong>');
        $("#comantarCajaPc").html('<strong style="text-align:center">Este recurso no admite comentarios.</strong>');

      }else{

        // Cargamos los comentarios
        for(var i = 0; i < Datos['detalle']['ComentariosLista'].length; i++){

          // Verificamos si el comentario tiene palabras malsonantes
          if(Datos['detalle']['ComentariosLista'][i]['Comentario'] == "-||-MODERADO-||-"){ console.log("MOD");
            // Establecemos el HTML
            ComentariosPc += '<!-- Comentario --><div class="ComentarioPC"><div class="Superior"><img src="' + Url + 'Api/imagenDePerfil' + Datos['detalle']['ComentariosLista'][i]['Usuario']['ImagenPerfil'] + '"><div class="Usuario"><h5>' + Datos['detalle']['ComentariosLista'][i]['Usuario']['Nombre'] + ' ' + Datos['detalle']['ComentariosLista'][i]['Usuario']['Apellido'] + ' ' + obtenerInsignia(Datos['detalle']['ComentariosLista'][i]['Usuario']['Estado'], false) + '</h5><i><i class="fa-light fa-clock"></i> ' + Datos['detalle']['ComentariosLista'][i]['Hace'] + '</i></div></div><div class="Inferior"><p><i class="fa-duotone fa-shield-check"></i> <i>SIBAU ha detectado un comentario con palabras malsonantes, hasta que se verifique manualmente este comentario se quedara censurado.</i></p></div></div>';
            ComentariosMovil += '<!-- Comentario #' + Datos['detalle']['ComentariosLista'][i]['Id'] + ' --><div class="Comentario mb-2"><div class="row datosComentario"><div class="col-2"><img src="' + Url + 'Api/imagenDePerfil' + Datos['detalle']['ComentariosLista'][i]['Usuario']['ImagenPerfil'] + '.svg"></div><div class="col-10"><p>' + Datos['detalle']['ComentariosLista'][i]['Usuario']['Nombre'] + ' ' + Datos['detalle']['ComentariosLista'][i]['Usuario']['Apellido'] + ' ' + obtenerInsignia(Datos['detalle']['ComentariosLista'][i]['Usuario']['Estado']) + '<br><small><i>' + Datos['detalle']['ComentariosLista'][i]['Hace'] + '</i></small></p></div></div><div class="row mt-1"><div class="col-1"></div><div class="col-11"><p><i class="fa-duotone fa-shield-check"></i> <i>SIBAU ha detectado un comentario con palabras malsonantes, hasta que se verifique manualmente este comentario se quedara censurado.</i></p></div></div></div><!-- Fin de Comentario -->';
          }else{
            // Establecemos el HTML
            ComentariosPc += '<!-- Comentario --><div class="ComentarioPC"><div class="Superior"><img src="' + Url + 'Api/imagenDePerfil' + Datos['detalle']['ComentariosLista'][i]['Usuario']['ImagenPerfil'] + '"><div class="Usuario"><h5>' + Datos['detalle']['ComentariosLista'][i]['Usuario']['Nombre'] + ' ' + Datos['detalle']['ComentariosLista'][i]['Usuario']['Apellido'] + ' ' + obtenerInsignia(Datos['detalle']['ComentariosLista'][i]['Usuario']['Estado'], false) + '</h5><i><i class="fa-light fa-clock"></i> ' + Datos['detalle']['ComentariosLista'][i]['Hace'] + '</i></div></div><div class="Inferior"><p>' + Datos['detalle']['ComentariosLista'][i]['Comentario'] + '</p></div></div><!-- Fin de Comentario -->';
            ComentariosMovil += '<!-- Comentario #' + Datos['detalle']['ComentariosLista'][i]['Id'] + ' --><div class="Comentario mb-2"><div class="row datosComentario"><div class="col-2"><img src="' + Url + 'Api/imagenDePerfil' + Datos['detalle']['ComentariosLista'][i]['Usuario']['ImagenPerfil'] + '.svg"></div><div class="col-10"><p>' + Datos['detalle']['ComentariosLista'][i]['Usuario']['Nombre'] + ' ' + Datos['detalle']['ComentariosLista'][i]['Usuario']['Apellido'] + ' ' + obtenerInsignia(Datos['detalle']['ComentariosLista'][i]['Usuario']['Estado']) + '<br><small><i>' + Datos['detalle']['ComentariosLista'][i]['Hace'] + '</i></small></p></div></div><div class="row mt-1"><div class="col-1"></div><div class="col-11"><p>' + Datos['detalle']['ComentariosLista'][i]['Comentario'] + '</p></div></div></div><!-- Fin de Comentario -->';
          }
        }

        // Importamos comentarios
        if(Datos['detalle']['ComentariosLista'].length !== 0){$(".comantariosMovil").html(ComentariosMovil);}
        if(Datos['detalle']['ComentariosLista'].length !== 0){$(".comantariosPc").html(ComentariosPc);}

      }
       
      // Cargamos el tooltip de los comentarios
      $(".insigniaUsuarios").tooltip();
        
      // Vemos si el usuario es propietario
      if(IdUsuario !== Datos['detalle']['IdUsuario']){

        $(".editarRecursoIcono").hide();
        $("#editarRecuro").html("");

      }else{

        // Establecemos acciones de iconos
        $(".editarRecursoIcono").click(function(){
          $("#editarRecuro").modal("show");
        })

        // Establecemos titulo
        $("#editarRecursoFormulario #Titulo").val(Datos['detalle']['Titulo']);
        $("#editarRecursoFormulario #Titulo").attr("placeholder",Datos['detalle']['Titulo']);

        // Establecemos descripción
        $("#editarRecursoFormulario #Descripción").val(Datos['detalle']['Descripcion']);
        $("#editarRecursoFormulario #Descripción").attr("placeholder",Datos['detalle']['Descripcion']);

        // Establecemos ID Archivo
        $("#editarRecursoFormulario #Archivo").val(Datos['detalle']['Archivo']);
        $("#editarRecursoFormulario #Archivo").attr("placeholder",Datos['detalle']['Archivo']);

        // Establecemos Tipo de recurso
        $("#editarRecursoFormulario #Tipo").val(Datos['detalle']['Tipo']);
        
        // Establecemos Categoria
        $("#editarRecursoFormulario #Categoria").val(Datos['detalle']['Categoria']);

        // Establecemos ID Archivo
        $("#editarRecursoFormulario #Archivo").val(Datos['detalle']['IdDrive']);
        $("#editarRecursoFormulario #Archivo").attr("placeholder",Datos['detalle']['IdDrive']);

        // Establecemos etiquetas
        var Etiquetas = '';
        for(var z = 0; z < Datos['detalle']['Etiquetas'].length; z++){
          if(z > 0){
            Etiquetas += ',';
          }
          Etiquetas += Datos['detalle']['Etiquetas'][z];
        }
        $("#editarRecursoFormulario #Etiquetas").val(Etiquetas);

        // Establecemos despliegue
        if(Datos['detalle']['Despliegue'] == '1'){$("#Despliegue").attr("checked", true)}

        // Establecemos comentarios
        if(Datos['detalle']['Comentarios'] == '1'){$("#Comentarios").attr("checked", true)}

      }

      // Quitamos el loader
      quitarLoader();

    }else if(Datos['estado'] == 'error'){
      errorLoader(Datos['detalle']);
    }else{
      errorLoader();
    }
  },
  error: function(){
    errorLoader();
  }
})

// Establecemos funcionalidades a los botones de menu movil
$(".editarRecursoIcono").click(function(){$("#editarRecurso").modal('show');});
$(".reportarRecursoIcono").click(function(){$("#reportarRecuro").modal('show');});
$(".compartirRecursoIcono").click(function(){navigator.share({title: $("datos[dato='Titulo']").text(),text: $("datos[dato='Descripcion']").text(),url: window.location,})});
$(".comantarioRecursoIcono").click(function(){$("#comantarioRecurso").modal('show');});
$(".infoRecursoIcono").click(function(){$("#informacionRecurso").modal('show');});
$(".Iconos i").tooltip();

// Función: Enviar comentario
function enviarComentario(Caja){

  // Borramos errores previos
  $(".errorComentario").text("");

  // Verificamos si tiene contenido
  if($("#nuevoComentario" + Caja).val() !== 0){

    // Deshabilitamos el botón
    $("#enviarComentario button").attr("disabled", true);
    $("#enviarComentario button").html('<i class="fa fa-spinner fa-spin"></i>');

    // Establecemos variable
    var nuevoComentario = $("#nuevoComentario" + Caja).val();

    // Enviamos la peticion
    $.ajax({
      type: "GET",
      contentType: 'application/json; charset=utf-8',
      url: Url + "Api/RecursosOnline?Tipo=agregarComentario&Recurso=" + Recurso + "&Comentario=" + nuevoComentario,
      success: function(Datos, textStatus, xhr){

        // establecemos datos
        Datos = $.parseJSON(Datos);

        // Verificamos el estado
        if(Datos['estado'] == 'exitoso'){

          // Verificamos si fue moderado
          if(Datos['detalle'] == 'Moderado'){

            // Establecemos nuevos comentarios
            var NuevoComentariosPc = '<!-- Comentario --><div class="ComentarioPC"><div class="Superior"><img src="' + Url + 'Api/imagenDePerfil' + ImagenPerfil + '"><div class="Usuario"><h5>' + Nombre + ' ' + obtenerInsignia(Estado, false) + '</h5><i><i class="fa-light fa-clock"></i> Acabas de enviarlo</i></div></div><div class="Inferior"><p><i class="fa-duotone fa-shield-check"></i> <i>SIBAU ha detectado un comentario con palabras malsonantes, hasta que se verifique manualmente este comentario se quedara censurado.</i></p></div></div><!-- Fin de Comentario -->';
            var NuevoComentariosMovil = '<!-- Comentario nuevo --><div class="Comentario mb-2"><div class="row datosComentario"><div class="col-2"><img src="' + Url + 'Api/imagenDePerfil' + ImagenPerfil + '"></div><div class="col-10"><p>' + Nombre + ' ' + obtenerInsignia(Estado) + '<br><small><i>Lo acabas de comentar</i></small></p></div></div><div class="row mt-1"><div class="col-1"></div><div class="col-11"><p><i class="fa-duotone fa-shield-check"></i> <i>SIBAU ha detectado un comentario con palabras malsonantes, hasta que se verifique manualmente este comentario se quedara censurado.</i></p></div></div></div><!-- Fin de Comentario -->';
  
          }else{

            // Establecemos nuevos comentarios
            var NuevoComentariosPc = '<!-- Comentario --><div class="ComentarioPC"><div class="Superior"><img src="' + Url + 'Api/imagenDePerfil' + ImagenPerfil + '"><div class="Usuario"><h5>' + Nombre + ' ' + obtenerInsignia(Estado, false) + '</h5><i><i class="fa-light fa-clock"></i> Acabas de enviarlo</i></div></div><div class="Inferior"><p>' + nuevoComentario + '</p></div></div><!-- Fin de Comentario -->';
            var NuevoComentariosMovil = '<!-- Comentario nuevo --><div class="Comentario mb-2"><div class="row datosComentario"><div class="col-2"><img src="' + Url + 'Api/imagenDePerfil' + ImagenPerfil + '"></div><div class="col-10"><p>' + Nombre + ' ' + obtenerInsignia(Estado) + '<br><small><i>Lo acabas de comentar</i></small></p></div></div><div class="row mt-1"><div class="col-1"></div><div class="col-11"><p>' + nuevoComentario + '</p></div></div></div><!-- Fin de Comentario -->';
  
          }

          ComentariosMovil = NuevoComentariosMovil + ComentariosMovil;
          ComentariosPc = NuevoComentariosPc + ComentariosPc;
          $(".comantariosMovil").html(ComentariosMovil);
          $(".comantariosPc").html(ComentariosPc);


          // Restablecemos el input
          $("#nuevoComentario" + Caja).val("");

          // Cargamos el tooltip de los comentarios
          $(".insigniaUsuarios").tooltip();

          // Restablecemos el boton
          $("#enviarComentario button").html('<i class="fa-solid fa-paper-plane"></i></button>');
          $("#enviarComentario button").attr("disabled", false);

        }else if(Datos['estado'] == 'error'){

          // Mostramos mensaje de error
          $(".errorComentario").text("* Error: " + Datos['detalle'] + " [" +  Datos['codigo'] + "]");

          // Restablecemos el boton
          $("#enviarComentario button").html('<i class="fa-solid fa-paper-plane"></i></button>');
          $("#enviarComentario button").attr("disabled", false);

        }else{

          // Mostramos mensaje de error
          $(".errorComentario").text("* Hubo un error desconocido, intentelo denuevo.");

          // Restablecemos el boton
          $("#enviarComentario button").html('<i class="fa-solid fa-paper-plane"></i></button>');
          $("#enviarComentario button").attr("disabled", false);

        }

      },
      error: function(){

        // Mostramos mensaje de error
        $(".errorComentario").text("* Hubo un error desconocido, intentelo denuevo.");

        // Restablecemos el boton
        $("#enviarComentario button").html('<i class="fa-solid fa-paper-plane"></i></button>');
        $("#enviarComentario button").attr("disabled", false);
      }
    })

  }

}
            
// Detectamos si se hizo enter en el comentador
$("#comantarCajaMovil input").on('keyup', function (e) {
  var keycode = e.keyCode || e.which;
    if (keycode == 13) {
      enviarComentario("Movil");
    }
});
$("#comantarCajaPc input").on('keyup', function (e) {
  var keycode = e.keyCode || e.which;
    if (keycode == 13) {
      enviarComentario("Pc");
    }
});

$(".qrCodigo").click(function(){
  $("#compartirQR").modal("show");
})

$(".qrRecurso").click(function(){
  $("#compartirQR").modal("show");
})

function deshabilitarBotónEditar(){
  $("#añadirRecurso .btn-primary").html('<i class="fa fa-spinner fa-spin"></i> Cargando');
  $("#añadirRecurso .btn-primary").css('opacity','50%');
  $("#añadirRecurso .btn-primary").attr("disabled", true);
}

function habilitarBotónEditar(){
  $("#añadirRecurso .btn-primary").html('Agregar recurso');
  $("#añadirRecurso .btn-primary").css('opacity','100%');
  $("#añadirRecurso .btn-primary").attr("disabled", false);
}

$("#editarRecursoFormulario").submit(function(e){

  // Deshabilitar botón
  deshabilitarBotónEditar();
  $(".error-form").text("");

  // Verificamos si los campos cumplen con los requisitos
  if($("#editarRecursoFormulario #Titulo").val().length < 5){
    $("#editarRecursoFormulario #TituloError").text("Por favor, ingrese un nombre mas largo.");
    habilitarBotónEditar();
  }else if($("#editarRecursoFormulario #Titulo").val().length > 300){
    $("#editarRecursoFormulario #TituloError").text("Por favor, ingrese un nombre mas corto.");
    habilitarBotónEditar();
  }else if($("#editarRecursoFormulario #Descripción").val().length > 1000){
    $("#editarRecursoFormulario #DescripciónError").text("Por favor, ingrese una descripción mas corta.");
    habilitarBotónEditar();
  }else if($("#editarRecursoFormulario #Archivo").val().length < 1){
    $("#editarRecursoFormulario #ArchivoError").text("Debe completar este campo");
    habilitarBotónEditar();
  }else{

    $.ajax({
      type: "POST",
      url: Url + "Api/RecursosOnline?Tipo=editar&Recurso=" + Recurso,
      data: $("#editarRecursoFormulario").serialize(),
      success: function(data, textStatus, xhr) {

        Datos = $.parseJSON(data);
        habilitarBotónEditar();
      
        if(Datos['estado'] == 'exitoso'){
          window.location.reload();
        }else if(Datos['estado'] == 'error'){
          $("#editarRecursoFormulario #ErrorOtro").text(Datos['detalle'] + " [" + Datos['codigo'] + "]");
          habilitarBotónEditar();
        }else{
          $("#editarRecursoFormulario #ErrorOtro").text("Hubo un error desconocido.");
          habilitarBotónEditar();
        }
      } 
    });

  }
  
  e.preventDefault();

})