const RecursosPaginador = [];

var DatosBusqueda;

const Mimes = [
  {
    "Nombre": "Imagen",
    "Tipo": "0",
    "Mimes": ["image/avif","image/bmp","image/gif","image/vnd.microsoft.icon","image/jpeg","image/png","image/svg+xml","image/tiff","image/webp"],
  },
  {
    "Nombre": "PDF",
    "Tipo": "1",
    "Mimes": ["application/pdf"],
  },
  {
    "Nombre": "Documento",
    "Tipo": "2",
    "Mimes": ["application\/vnd.google-apps.document","application/x-abiword","application/msword","application/vnd.openxmlformats-officedocument.wordprocessingml.document"],
  },
  {
    "Nombre": "Hoja de calculo",
    "Tipo": "3",
    "Mimes": ["application/vnd.ms-excel","application/vnd.openxmlformats-officedocument.spreadsheetml.sheet","application\/vnd.google-apps.spreadsheet"],
  },
  {
    "Nombre": "Presentación",
    "Tipo": "4",
    "Mimes": ["application/vnd.ms-powerpoint","application/vnd.openxmlformats-officedocument.presentationml.presentation","application/vnd.google-apps.presentation"],
  },
  {
    "Nombre": "Video",
    "Tipo": "5",
    "Mimes": ["video/x-msvideo","video/mp4","video/mpeg","video/mp2t","video/webm","video/3gpp","video/3gpp2"],
  }
]

const Categorias = ["4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21"];


function paginador(maxPorPagina, Datos, Arriba = null){

  // Eliminamos paginas anteriores
  $("paginas").html("");
  $("pagina").remove();

  $("#Contenidos h5").remove();

  // Establecemos la cantidad de visitas
  $("cantidad-recursos").text(Datos.length);

  if(Datos.length !== 0){

    $(".paginador").show();

    // Creamos variable
    var Contenido = '';

    // Verificamos la cantidad de paginas y creamos las diferentes paginas
    var paginasTotales = Math.ceil(Datos.length/maxPorPagina);
    for(var i = 1; i < paginasTotales+1; i++){
      $("paginas").append("<pagina style='display: none; margin-top: 1.5rem' class='row' pagina='" + i + "'></pagina>");
    }
         
    paginadorPropio(paginasTotales, 1, "#Contenido");
            
    // Empezamos el proceso de adaptacion
    for(var i = 0; i < Datos.length; i++){

      var Pagina = Math.ceil((i+1)/maxPorPagina);

      var ContenidoIn = '';

      // Añadimos contenido a Contenido
      ContenidoIn += '<div class="col Contenido"><div onclick="abrirContenido(' + Datos[i]['Id'] + ')" class="Superior" style="background-image: url(';

      // Establecemos la minuatura del recurso
      ContenidoIn += Url + 'Api/RecursosOnline?Tipo=ObtenerMinuatura&Miniatura=' + Datos[i]['IdDrive'] + '&TipoRecurso=' + Datos[i]['Tipo'];
              
      // Añadimos contenido a Contenido
      ContenidoIn += ');"><span class="badge bg-light vizualizacion"><i class="fa-light fa-eye"></i> ';

      // Establecemos visualizaciones del recurso
      ContenidoIn += Datos[i]['Visitas'];

      // Añadimos contenido a Contenido
      ContenidoIn += '</span><span class="badge bg-primary tipo-archivo">';

      // Establecemos categoría en caso de tener
      ContenidoIn += obtenerCategoría(Datos[i]['Categoria']);
            
      // Establecemos tipo de recurso
      ContenidoIn += obtenerTipoDeRecurso(Datos[i]['Tipo'])

      // Añadimos contenido a Contenido
      ContenidoIn += '</span></div><div class="Cuerpo"><a onclick="abrirContenido(' + Datos[i]['Id'] + ')" class="Titulo TituloRecurso" data-bs-toggle="tooltip" data-bs-title="' + Datos[i]['Titulo'] + '">' + Datos[i]['Titulo'] + '</a><br> <div class="row" id="DatosPerfil"><div class="col-9"><a>' + Datos[i]['Nombre'] + ' ' + obtenerInsignia(Datos[i]['EstadoUsuario'], false) + '</a><br><small><i onclick="window.location.href = `/perfil/@' + Datos[i]['Usuario'] + '`">@' + Datos[i]['Usuario'] + '</i> - <institucion data-bs-toggle="tooltip" data-bs-title="' + Datos[i]['NombreInstitucion'] + '">' + Datos[i]['NombreInstitucionAbreviacion'] + '</institucion></small></div><div class="col-3"><img loading="lazy" src="' + Url + '/Api/imagenDePerfil' + Datos[i]['ImagenPerfil'] + '"></div></div><div style="margin: 1rem">';
              
      // Establecemos las etiquetas 
      for(var a = 0; a < Datos[i]['Etiquetas'].length; a++){
        ContenidoIn += '<span style="margin: 0.1rem; margin-bottom: 1rem;" class="badge bg-success">' + Datos[i]['Etiquetas'][a] + '</span>';
      }

      // Añadimos contenido a Contenido
      ContenidoIn += '</div></div></div>';

      $("pagina[pagina='" + Pagina + "']").append(ContenidoIn);

      // Habilitamos el Tooltip a las insignias y instituciones
      $(".insigniaUsuarios").tooltip();
      $("institucion").tooltip();

      setTimeout(function(){
        $('[data-bs-toggle="tooltip"]').tooltip();
      }, 1500);

      quitarLoader();

    }

  }else{
    ocularPaginador();
    $("paginas").html(`<h5 class='text-center mt-2'><b>${obtenerItemIdioma("recursosOnline.error.noHuboResultados")}</b></h5>`);
  }

}

// Establecemos que ejecute la acción al detectar cambio en el buscador.
$("#BuscadorRecursos button").click(function(){

  // Ponemos en minúscula lo buscado
  const terminoDeBúsqueda = $("#BuscadorRecursos input").val().toLowerCase();

  // Establecemos el resultado
  const resultadosDeBúsqueda = DatosBusqueda.filter(function(Resultado) {
    if(Number($("#Categoria").val()) !== 0){
      return Resultado.Titulo.toLowerCase().includes(terminoDeBúsqueda) && Resultado.Categoria == $("#Categoria").val();
    }else{
      return Resultado.Titulo.toLowerCase().includes(terminoDeBúsqueda) || Resultado.Etiquetas.some(function(keyword) {
        return keyword.toLowerCase().includes(terminoDeBúsqueda);
      });
    }
  });

  // Mostramos el resultado
  paginador(8, resultadosDeBúsqueda, 1);
  
});

function obtenerTipoDeRecurso(Id){
  return obtenerItemIdioma("recursosOnline.tipo." + Id);
}

function obtenerCategoría(Id){
  return obtenerItemIdioma("recursosOnline.categoria." + Id) + " - ";
}
// Función: Obtiene los recursos desde la base de datos (De a 10)
function obtenerRecursos(Busqueda = ''){

  // Quitar paginas
  $("pagina").remove();

  // Ponemos opacidad al contenido actual
  $("#Contenidos").css("opacity", "0.2");

  // Realizamos la peticion al servidor
  $.ajax({
    type: "GET",
    url: Url + "Api/RecursosOnline",
    data: {"Tipo": "Obtener"},
    success: function(Datos, textStatus, xhr){

      // Establecemos los datos
      Datos = $.parseJSON(Datos);
      DatosBusqueda = Datos['detalle']['Datos'];

      // Verificamos el estado de la peticion
      if(Datos['estado'] == 'exitoso'){

        // Verificamos si hay recursos disponibles
        if(Datos.Total == 0){

          // Mostramos el texto de error
          $("#Contenidos").html(`<h5 class="text-center">${obtenerItemIdioma("recursosOnline.error.noHayRecursos")}</h5>`);

          // Restablecemos la opacidad
          $("#Contenidos").css("opacity", "1");
          
        }else{

          paginador(8, Datos.detalle.Datos);

          if(Busqueda !== ''){$("#BuscadorRecursos input").val(Busqueda); $("#BuscadorRecursos input").val(Busqueda); $("#BuscadorRecursos .btn-primary").click();}
          
        }

      }else if(Datos['estado'] == 'error'){
        errorLoader(Datos['detalle']);
      }else{
        errorLoader();
      }

    },
    error: function(){
      errorLoader();
    }
  })
    
}

// Función: Abre el contenido al cual le haces click
function abrirContenido(Id){
  window.location = "./recurso/" + Id;
}

// Detecta al hacer click en el buscaodr y trae lo solicitado 
$("#BuscadorRecursos").submit(function(e){
  e.preventDefault();
  $("#BuscadorRecursos button").click();
})

// Detecta al cambiar la categoria y muestra la nueva categoria
$("#Categoria").change(function(){
  $("#BuscadorRecursos button").click();
})

function irPagina(Pagina, Arriba = null){
  if(Arriba == null){window.location.href = "#Contenido";}
  console.log(Arriba);
  $("pagina").hide();
  $("pagina[pagina='" + Pagina + "']").show();
}
            ////////////////
function añadirRecurso(){

  var CategoriasModal = "";
  for(var i = 0; i < Categorias.length; i++){
    CategoriasModal += `<option value="${Categorias[i]}">${obtenerItemIdioma("recursosOnline.categoria." + Categorias[i])}</option>`;
  } 
  $("body").append(`<div class="modal fade" data-bs-backdrop="static" data-bs-keyboard="false" id="añadirRecurso" tabindex="-1" aria-hidden="true">
    <div class="modal-dialog modal-lg">
      <div class="modal-content" style="height: 90vh;"><div class="modal-header"><h1 class="modal-title fs-5">${obtenerItemIdioma("recursosOnline.añadir.tituloModal")}</h1><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div>
        <div class="modal-body" style="overflow-y: scroll;">
          <form id="añadirRecursoFormulario">
            <div class="mb-3">
              <label for="Titulo" class="form-label">${obtenerItemIdioma("recursosOnline.añadir.titulo")} <sup style="color: red;">*</sup></label> <input type="text" class="form-control" required id="Titulo" name="Titulo" aria-describedby="TituloInfo" />
              <div id="TituloAyuda" class="form-text">${obtenerItemIdioma("recursosOnline.añadir.titulo.desc")}</div>
              <a id="TituloError" class="error-form"></a>
            </div>
            <div class="mb-3">
              <label for="Descripción" class="form-label">${obtenerItemIdioma("recursosOnline.añadir.descripcion")}</label> <textarea class="form-control" id="Descripción" name="Descripción"></textarea>
              <div id="DescripciónInfo" class="form-text">${obtenerItemIdioma("recursosOnline.añadir.descripcion.desc")}</div>
              <a id="DescripciónError" class="error-form"></a>
            </div>

            <div class="mb-3">
              <label for="Categoria" class="form-label">${obtenerItemIdioma("recursosOnline.añadir.categoria")} <sup style="color: red;">*</sup></label>
              <select required class="form-select" id="Categoria" name="Categoria">
                ${CategoriasModal}
              </select>
            </div>
            <div class="mb-3">
              <label for="Etiquetas" class="form-label">${obtenerItemIdioma("recursosOnline.añadir.etiquetas")}</label>
              <input type="text" placeholder="Literatura, Novelas..." class="form-control" id="Etiquetas" name="Etiquetas" />
            </div>

            <hr>
            <label><strong>Archivo:</strong></label>

            <div class="mb-3">
              <label for="Proveedor" class="form-label">${obtenerItemIdioma("recursosOnline.añadir.proveedor")} <sup style="color: red;">*</sup></label>
              <select required class="form-select" id="Proveedor" name="Proveedor">
                <option disabled selected>${obtenerItemIdioma("recursosOnline.añadir.proveedor.seleccione")}</option>
                <option value="0">Google Drive</option>
                <option value="1">Youtube</option>
                <option value="2">${obtenerItemIdioma("recursosOnline.añadir.proveedor.link")}</option>
                <option value="3" disabled>${obtenerItemIdioma("recursosOnline.añadir.proveedor.servidores")}</option>
              </select>
            </div>

            <div class="TipoDeProveedor"></div>

            <hr>
            <div class="mb-3 form-check">
              <input type="checkbox" class="form-check-input" id="Despliegue" name="Despliegue" />
              <label class="form-check-label" for="Despliegue">${obtenerItemIdioma("recursosOnline.añadir.Despliegue")}</label>
            </div>
            <div class="mb-3 form-check">
              <input type="checkbox" class="form-check-input" checked="1" id="Comentarios" name="Comentarios">
              <label class="form-check-label" for="Comentarios">${obtenerItemIdioma("recursosOnline.añadir.Comentarios")}</label></div>
              <a class="error-form" id="ErrorOtro"></a>
          </form>
          <p>${obtenerItemIdioma("recursosOnline.añadir.legal")}</p>
        </div>
        <div class="modal-footer"><button type="button" class="btn btn-secondary" data-bs-dismiss="modal">${obtenerItemIdioma("recursosOnline.añadir.cerrar")}</button> <button type="button" accion="agregarRecurso" class="btn btn-primary">${obtenerItemIdioma("recursosOnline.añadir.agregar")}</button></div>
      </div>
    </div>
  </div>`);

  $("#añadirRecurso").modal("show");
  $('#añadirRecurso').on('hidden.bs.modal', function(){
    $("#añadirRecurso").remove();
  })

  $("#Proveedor").on("change", function(){

    if($("#Proveedor").val() == "0"){
      $(".TipoDeProveedor").html(`<input type="hidden" value="" id="Tipo" name="Tipo">
      <div style="display: flex; align-items: center">
        <div class="mb-3" style="width: 100%">
          <label for="Archivo" class="form-label">${obtenerItemIdioma("recursosOnline.añadir.prove.drive")} <sup style="color: red;">*</sup></label>
          <input type="text" placeholder="xxxxxx_x_xxxxxxxxxxxxxxx_xxxxxxxxx o https://drive.google.com/file/d/xxxxxx_x_xxxxxxxxxxxxxxx_xxxxxxxxx/view" class="form-control" id="Archivo" name="Archivo" oninput="driveLinkId()">
          <span class="driveENCONTRADOContenedor" style="display: none"><strong>${obtenerItemIdioma("recursosOnline.añadir.prove.driveEncontrado")}:</strong> <i class="driveENCONTRADO"></i></span>
          <span class="driveNOENCONTRADOContenedor" style="display: none"><strong><i style="color: #dd2a2a;" class="fa-solid fa-triangle-exclamation fa-beat-fade"></i> ${obtenerItemIdioma("recursosOnline.añadir.prove.driveNoEncontrado")}</strong></span>
          <a id="ArchivoError" class="error-form"></a>
        </div>
        <div class="col-3"><button style="width: 100%" type="button" onclick="handleAuthClick()" class="btn btn-primary">${obtenerItemIdioma("recursosOnline.añadir.prove.driveSeleccionar")}</button></div>
      </div>
      <span><small>${obtenerItemIdioma("recursosOnline.driveLegal")}</small></span>`);
    }else if($("#Proveedor").val() == "1"){
      $(".TipoDeProveedor").html(`<input type="hidden" value="6" id="Tipo" name="Tipo">
      <div class="mb-3">
        <label for="Archivo" class="form-label">${obtenerItemIdioma("recursosOnline.añadir.prove.youtube")} <sup style="color: red;">*</sup></label>
        <input type="text" placeholder="xxxxxxxxxxx o https://www.youtube.com/watch?v=xxxxxxxxxxx" class="form-control" id="Archivo" name="Archivo" oninput="youtubeLinkId()">
        <span class="youtubeENCONTRADOContenedor" style="display: none"><strong>${obtenerItemIdioma("recursosOnline.añadir.prove.youtubeEncontrado")}:</strong> <i class="youtubeENCONTRADO"></i></span>
        <a id="ArchivoError" class="error-form"></a>
      </div>`);
    }else if($("#Proveedor").val() == "2"){
      $(".TipoDeProveedor").html(`<input type="hidden" value="7" id="Tipo" name="Tipo">
      <div class="mb-3">
        <label for="Archivo" class="form-label">${obtenerItemIdioma("recursosOnline.añadir.prove.link")} <sup style="color: red;">*</sup></label>
        <input type="text" placeholder="https://sibau.com.ar/" class="form-control" id="Archivo" name="Archivo"">
        <a id="ArchivoError" class="error-form"></a>
      </div>`);
    }
  })

  $("#añadirRecurso [accion='agregarRecurso']").click(function(){$("#añadirRecursoFormulario").submit()});
  $("#añadirRecurso #añadirRecursoFormulario").submit(function(e){

    quitarErrores();

    // Deshabilitar botón
    botónCargando("#añadirRecurso [accion='agregarRecurso']");
  
    // Verificamos si los campos cumplen con los requisitos
    if($("#añadirRecursoFormulario #Titulo").val().length < 5){
      $("#añadirRecurso .modal-content .modal-body").after(generarError(obtenerItemIdioma("recursosOnline.añadir.error.tituloCorto")));
      quitarbotónCargando("#añadirRecurso [accion='agregarRecurso']");
    }else if($("#añadirRecursoFormulario #Titulo").val().length > 300){
      $("#añadirRecurso .modal-content .modal-body").after(generarError(obtenerItemIdioma("recursosOnline.añadir.error.tituloLargo")));
      quitarbotónCargando("#añadirRecurso [accion='agregarRecurso']");
    }else if($("#añadirRecursoFormulario #Descripción").val().length > 1000){
      $("#añadirRecurso .modal-content .modal-body").after(generarError(obtenerItemIdioma("recursosOnline.añadir.error.desc")));
      quitarbotónCargando("#añadirRecurso [accion='agregarRecurso']");
    }else if($("#añadirRecursoFormulario #Archivo").val().length < 1){
      $("#añadirRecurso .modal-content .modal-body").after(generarError(obtenerItemIdioma("recursosOnline.añadir.error.id")));
      quitarbotónCargando("#añadirRecurso [accion='agregarRecurso']");
    }else{
  
      $.ajax({
        type: "POST",
        url: Url + "Api/RecursosOnline?Tipo=agregar",
        data: $("#añadirRecursoFormulario").serialize(),
        success: function(data, textStatus, xhr) {
  
          Datos = $.parseJSON(data);
          quitarbotónCargando("#añadirRecurso [accion='agregarRecurso']");
        
          if(Datos['estado'] == 'exitoso'){
            abrirContenido(Datos['detalle']);
          }else if(Datos['estado'] == 'error'){
            $("#añadirRecurso .modal-content .modal-body").after(generarError(Datos['detalle'], Datos['codigo']));
            quitarbotónCargando("#añadirRecurso [accion='agregarRecurso']");
          }else{
            $("#añadirRecurso .modal-content .modal-body").after(generarError());
          }
        },
        error: function(){
          $("#añadirRecurso .modal-content .modal-body").after(generarError());
        }
      });
    }
    e.preventDefault();
  })
}
var ANT;
function youtubeLinkId(){
  if((/^(ftp|http|https):\/\/[^ "]+$/).test($("#Archivo").val())){
    var video_id = $("#Archivo").val().split('v=')[1]
    var ampersandPosition;
    if($("#Archivo").val().includes("&")){
      ampersandPosition = video_id.indexOf('&');
      if(ampersandPosition != -1) {
        $("#Archivo").val(video_id.substring(0, ampersandPosition));
      }
    }else{
      $("#Archivo").val(video_id);
    }    
  }

  if(ANT !== $("#Archivo").val()){
    ANT = $("#Archivo").val();
    $.ajax({
      type: "GET",
      url: Url + "Api/RecursosOnline",
      data: {"Tipo": "ObtenerTitulo", "IdVideo": $("#Archivo").val()},
      success: function(data, textStatus, xhr){
        if(data !== ""){
          $(".youtubeENCONTRADOContenedor").show();
          $(".youtubeENCONTRADO").text(data);
        }else{
          $(".youtubeENCONTRADOContenedor").hide();
        }
      }
    })
  }
}

function driveLinkId(){
  if($("#Archivo").val() !== ""){
    if($("#Archivo").val().match(/[-\w]{25,}/)!==null){
      $("#Archivo").val(($("#Archivo").val().match(/[-\w]{25,}/))[0]);
    }

    if(ANT !== $("#Archivo").val()){
      ANT = $("#Archivo").val();
      $(".driveNOENCONTRADOContenedor").hide();
      $(".driveENCONTRADOContenedor").hide();
      $.ajax({
        type: "GET",
        url: Url + "Api/RecursosOnline",
        data: {"Tipo": "ObtenerTitulo", "IdDrive": $("#Archivo").val()},
        success: function(Datos, textStatus, xhr){

          // Establecemos los datos
          Datos = $.parseJSON(Datos);

          

          if(Datos == null){
            $(".driveNOENCONTRADOContenedor").show();
          }else{
            $(".driveENCONTRADOContenedor").show();
            $(".driveENCONTRADO").text(Datos['name'] + " (" + mimeTypeNombre(Datos['mimeType']) + ")");
            $("#Tipo").val(mimeType(Datos['mimeType']));
            
          }
        }
      })
    }
  }else{
    $(".driveNOENCONTRADOContenedor").hide();
    $(".driveENCONTRADOContenedor").hide();
  }
}


function mimeType(mime){
  return Mimes.find(e => e['Mimes'].includes(mime))['Tipo'];
}

function mimeTypeNombre(mime){
  return Mimes.find(e => e['Mimes'].includes(mime))['Nombre'];
}