var Instituciones;

// Obtenemos instituciones
$.ajax({
  type: "GET",
  contentType: 'application/json; charset=utf-8',
  url: Url + "Api/Instituciones",
  data: {"Tipo": "obtenerListado"},
  success: function(Datos, textStatus, xhr) {
  
    // Establecer datos
    Datos = $.parseJSON(Datos);

    // Verificar estado de petición
    if(Datos['estado'] == 'exitoso'){

      Instituciones = Datos['detalle'];

      for(var i = 0; i < Datos['detalle'].length; i++){
        console.log(Datos['detalle'][i]);
        $("#Institución").append(`<option value="${Datos['detalle'][i]["Id"]}" title="${Datos['detalle'][i]["Logo"]}">${Datos['detalle'][i]["Abreviado"]} (${Datos['detalle'][i]["Nombre"]})</option>`);
      }

      $("#Institución").select2({
        placeholder: "Seleccione las institución/es donde quieras buscar.",
        templateResult: function (Institución) {
          return $(`<span><img class='instituciónImagen' src='${Institución.title}'>${Institución.text}</span>`);
        }
      });

      quitarLoader();

    }else if(Datos['estado'] == 'error'){
      errorLoader(Datos['detalle'], Datos['codigo']);
    }else{
      errorLoader();
    }

  },
  error: function(){
    errorLoader();
  }
})

// Cambiar previzualización
function actualizarPrevizualicación(){
      
  var termino = "";
  if($("[name=InstitucionBuscar]:checked").val() == 0){
    termino += "Se buscara dentro de todas las instituciones"
  }else{
    termino += "Se buscara dentro de"
  }

  termino += " un recurso fisico donde"

  for(var i = 0; i < $(".terminoBusqueda").length; i++){
    if(i > 0 && i < $(".terminoBusqueda").length -1){termino += ","}else if(i == $(".terminoBusqueda").length-1){termino += " y"}
    termino += ` el campo ${$(".terminoBusqueda #CamposMarc").eq(i).val()} contenga `;
    if($(".terminoBusqueda #Valor").eq(i).val() == ""){
      termino += "nulo"
    }else{
      termino += `"${$(".terminoBusqueda #Valor").eq(i).val()}"`
    }
  }

  termino += ".";


  $("#previzualizaciónTerminos").text(termino);

};


$("[name='InstitucionBuscar']").on("click", function(){
  if($("[name='InstitucionBuscar']:checked").val() == 0){
    $("#listadoIntituciones").hide();
  }else{
    $("#listadoIntituciones").show();
  }
})

function eliminarTermino(){
  if($("#agregarTermino").attr("act") > 1){
    $("[ter='" + $("#agregarTermino").attr("act") + "']").remove();
    $("#agregarTermino").attr("act", Number($("#agregarTermino").attr("act"))-1);
    if($("#agregarTermino").attr("act") == 1){
      $("[onclick='eliminarTermino()']").attr("disabled", true);
    }
  }
}

var tiempoInicio;
var tiempoFinal;

function iniciarTiempo() {
  tiempoInicio = new Date();
}

function finalizarTiempo() {
  tiempoFinal = new Date();
  var tiempoTranscurrido = tiempoFinal.getTime() - tiempoInicio.getTime(); // Diferencia en milisegundos
  return tiempoTranscurrido;
}


var actualizarPrevizualicación;
function busquedaAvanzada(){

    // Verificamos si existe el modal. En caso de existir lo ocultamos y eliminamos.
    if($("#busquedaAvanzada").length !== 0){
  
      // Ocultamos el modal.
      $("#busquedaAvanzada").modal("hide");
  
      // Eliminamos modal.
      $("#busquedaAvanzada").remove();
  
    }

    // Establecemos campos
    var CamposMarc = [
      {
        "Marc": "020",
        "Titulo": obtenerItemIdioma("marc.020"),
      },
      {
        "Marc": "022",
        "Titulo": obtenerItemIdioma("marc.022"),
      },
      {
        "Marc": "100",
        "Titulo": obtenerItemIdioma("marc.100"),
      },
      {
        "Marc": "245",
        "Titulo": obtenerItemIdioma("marc.245"),
      },
      {
        "Marc": "250",
        "Titulo": obtenerItemIdioma("marc.250"),
      },
      {
        "Marc": "260",
        "Titulo": obtenerItemIdioma("marc.260"),
      },
      {
        "Marc": "300",
        "Titulo": obtenerItemIdioma("marc.300"),
      }
    ]; 

    // Creamos modal
    $("body").append(`<div class="modal fade" data-bs-backdrop="static" data-bs-keyboard="false" id="busquedaAvanzada" tabindex="-1" aria-hidden="true">
      <div class="modal-dialog modal-lg modal-dialog-scrollable">
        <div class="modal-content">
          <div class="modal-header">
            <h1 class="modal-title fs-5">Búsqueda interbibliotecaria <span class="badge bg-secondary">BETA</span></h1>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
          </div>
          <div class="modal-body">
          </div>
          <div class="modal-footer">
            <div class="row w-100">
              <div class="col-6"><button type="button" class="w-100 btn btn-danger" onclick="$('#busquedaAvanzada').modal('hide')">${obtenerItemIdioma("interBibliotecaria.modal.cancelar")}</button></div>
              <div class="col-6"><button type="button" class="w-100 btn btn-primary buscarBotón">${obtenerItemIdioma("interBibliotecaria.modal.buscar")}</button></div>
            </div>
          </div>
        </div>
      </div>
    </div>`);

    var opcionesCampos = "";
    for(var i = 0; i < CamposMarc.length; i++){
      opcionesCampos += `<option value="${CamposMarc[i]['Marc']}">${CamposMarc[i]['Titulo']} [${obtenerItemIdioma("interBibliotecaria.modal.campo")} ${CamposMarc[i]['Marc']}]</option>`;
    }


    // Termino 1
    $("#busquedaAvanzada .modal-body").append(`<div class="mb-4 mt-4">
      <label class="form-label terminoBusquedaLabel">${obtenerItemIdioma("interBibliotecaria.modal.termino")} 1:</label><br>
      <div class="row terminoBusqueda">
        <div class="mt-1 col-6">
          <label for="Institución" class="form-label InstituciónLabel">${obtenerItemIdioma("interBibliotecaria.modal.campo")}</label><br>
          <select style="width: 100%" oninput="actualizarPrevizualicación()" class="form-select CamposMarc" id="CamposMarc" name="CamposMarc">${opcionesCampos}</select>
        </div>
        <div class="mt-1 col-6">
          <label for="Institución" class="form-label InstituciónLabel">${obtenerItemIdioma("interBibliotecaria.modal.valor")}</label><br>
          <input style="width: 100%" oninput="actualizarPrevizualicación()" class="form-control" id="Valor" name="Valor"></input>
        </div>
      </div>
    </div>
    <div id="multiArriba" style="display: flex; justify-content: center"><button act="1" onclick="eliminarTermino()" class="btn btn-danger ml-1 mr-1">${obtenerItemIdioma("interBibliotecaria.modal.eliminarTermino")}</button> <button act="1" id="agregarTermino" type="button" class="ml-1 mr-1 btn btn-success">${obtenerItemIdioma("interBibliotecaria.modal.agregar")}</button></div>`);
    
    $("#busquedaAvanzada .modal-body").append(`<div class="mb-3 mt-3">
      <label class="form-label terminoBusquedaLabel">${obtenerItemIdioma("interBibliotecaria.modal.termino")}:</label><br>
      <textarea id="previzualizaciónTerminos" disabled style="padding: 0.5rem; resize: none" class="w-100" rows="3"></textarea>
    </div>`);

    // Agregar termino
    $("#agregarTermino").on("click", function(){
      var campActual = Number($("#agregarTermino").attr("act"))+1;
      $("#agregarTermino").attr("act", Number($("#agregarTermino").attr("act"))+1);
      if($("#agregarTermino").attr("act") > 1){
        $("[onclick='eliminarTermino()']").attr("disabled", false);
      }else{
        $("[onclick='eliminarTermino()']").attr("disabled", true);
      }
      $("#multiArriba").before(`<div ter="${campActual}" class="mb-4 mt-4"><hr>
      <label class="form-label terminoBusquedaLabel">${obtenerItemIdioma("interBibliotecaria.modal.termino")} ${campActual}:</label><br>
      <div class="row terminoBusqueda">
        <div class="mt-1 col-6">
          <label for="Institución" class="form-label InstituciónLabel">${obtenerItemIdioma("interBibliotecaria.modal.campo")}</label><br>
          <select style="width: 100%" oninput="actualizarPrevizualicación()" class="form-select CamposMarc" id="CamposMarc" name="CamposMarc">${opcionesCampos}</select>
        </div>
        <div class="mt-1 col-6">
          <label for="Institución" class="form-label InstituciónLabel">${obtenerItemIdioma("interBibliotecaria.modal.valor")}</label><br>
          <input style="width: 100%" class="form-control" oninput="actualizarPrevizualicación()" id="Valor" name="Valor"></input>
        </div>
      </div>
    </div>`);
    });
    
    // Establecemos acción al ocultar modal.
    $('#busquedaAvanzada').on('hidden.bs.modal', function(){
      $("#busquedaAvanzada").remove();
    })
  
    // Mostramos modal
    $("#busquedaAvanzada").modal("show");
  
    // Al hacer click en buscar
    $(".buscarBotón").click(function(){
  
      $("#busquedaAvanzada .modal-body").hide();
      $("#busquedaAvanzada .modal-footer").hide();
      $("#busquedaAvanzada .modal-body").before(`
      <div style="padding: 1rem">
        <h4 class="mt-3" id="Proc1" style="text-align:center"><i class="fa-regular fa-spinner-third fa-spin"></i> ${obtenerItemIdioma("interBibliotecaria.obteniendoRegistros")}</h4>
      </div>`);
      
      var campoABuscar = $("#campoABuscar").val();
      var terminoABuscar = $("#terminoABuscar").val();
  
      iniciarTiempo();
      $.ajax({
        type: "GET",
        url: Url + "Api/RecursosFisicos",
        data: {"Tipo": "busquedaInterBibliotecaria", "TipoInsti": $("[name='InstitucionBuscar']:checked").val(), "Institucion": $("#Institución").val()},
        success: function(Datos, textStatus, xhr){

          $("#Proc1 i").addClass
  
          // Establecemos los datos
          Datos = $.parseJSON(Datos);
  
          // Verificamos estado de la petición
          if(Datos['estado'] == 'exitoso'){
  
            $("#Proc1 i").removeClass("fa-spinner-third");
            $("#Proc1 i").removeClass("fa-spin");
            $("#Proc1 i").addClass("fa-check");
            $("#Proc1").css("color", "#11e51185");
            $("#Proc1").append(` [${Datos['detalle'].length}] `);
            $("#Proc1").append(` <small>[${finalizarTiempo()}ms]</small> `);
            $("#Proc1").after(`
            <div style="padding: 1rem">
              <h4 class="mt-3" id="Proc2" style="text-align:center"><i class="fa-regular fa-spinner-third fa-spin"></i> ${obtenerItemIdioma("interBibliotecaria.filtrando")}</h4>
            </div>`);

            aplicarFiltros(Datos['detalle']);
            
  
          }else if(Datos['estado'] == 'error'){
            $(".error-form").remove();
            $("#busquedaAvanzada").modal("hide");
            const Toast = Swal.mixin({
              toast: true,
              position: 'top-end',
              showConfirmButton: false,
              timer: 3000,
              timerProgressBar: true,
              didOpen: (toast) => {
                toast.addEventListener('mouseenter', Swal.stopTimer)
                toast.addEventListener('mouseleave', Swal.resumeTimer)
              }
            })
            
            Toast.fire({
              icon: 'error',
              title: `${Datos['detalle']} [${Datos['codigo']}]`
            })
          }else{
            $(".error-form").remove();
            $("#busquedaAvanzada").modal("hide");
            const Toast = Swal.mixin({
              toast: true,
              position: 'top-end',
              showConfirmButton: false,
              timer: 3000,
              timerProgressBar: true,
              didOpen: (toast) => {
                toast.addEventListener('mouseenter', Swal.stopTimer)
                toast.addEventListener('mouseleave', Swal.resumeTimer)
              }
            })
            
            Toast.fire({
              icon: 'error',
              title: obtenerItemIdioma("interBibliotecaria.errorDesconocido")
            })
          }
  
        },
        error: function(){
          $(".error-form").remove();
          $("#busquedaAvanzada").modal("hide");
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            showConfirmButton: false,
            timer: 3000,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })
          
          Toast.fire({
            icon: 'error',
            title: obtenerItemIdioma("interBibliotecaria.errorDesconocido")
          })
        }
      })
  
    })
  
  }

function aplicarFiltros(Datos){

  iniciarTiempo();

  console.info(`Obtuvimos ${Datos.length} registros`);

  const Terminos = [];
     
  for(var i = 0; i < $(".terminoBusqueda").length; i++){
    if($(".terminoBusqueda #Valor").eq(i).val() !== ""){
      Terminos.push({"Campo": $(".terminoBusqueda #CamposMarc").eq(i).val(), "Valor": $(".terminoBusqueda #Valor").eq(i).val()});
    }
  }

  var Registros = Datos;

  for(var i = 0; i < Terminos.length; i++){

      
    var campoABuscar = Terminos[i]['Campo'];
    var terminoABuscar = Terminos[i]['Valor'];

    if(campoABuscar == "020"){
      // 020
      Resultados = Registros.filter(e => e['Datos']['Datos']['020'] && e['Datos']['Datos']['020'].some(item => item["a"] && item["a"].replace(/-/g, '') === terminoABuscar));
    }else if(campoABuscar == "022"){
        // 022
        Resultados = Registros.filter(e => e['Datos']['Datos']['022'] && e['Datos']['Datos']['022'].some(item => item["a"] && item["a"].replace(/-/g, '') === terminoABuscar));
    }else if(campoABuscar == "100"){
        // 100
        Resultados = Registros.filter(function(Registro) {

          const terminosDeBusqueda = terminoABuscar.trim().toLowerCase().split(/\s+/);

          var Autor;
          var Numeración;
          var Títulos;
          var Fechas;

          if(Registro['Datos']['Datos']['100'] !== undefined){
            if(Registro['Datos']['Datos']['100']['a'] !== undefined){
              Autor = Registro['Datos']['Datos']['100']['a'];
            }else{
              Autor = "";
            }

            if(Registro['Datos']['Datos']['100']['b'] !== undefined){
              Numeración = Registro['Datos']['Datos']['100']['b'];
            }else{
              Numeración = "";
            }

            if(Registro['Datos']['Datos']['100']['c'] !== undefined){
              Títulos = Registro['Datos']['Datos']['100']['c'];
            }else{
              Títulos = "";
            }

            if(Registro['Datos']['Datos']['100']['d'] !== undefined){
              Fechas = Registro['Datos']['Datos']['100']['d'];
            }else{
              Fechas = "";
            }

          }

          const Termino = `${Autor} ${Numeración} ${Títulos} ${Fechas}`.toLowerCase();
      
          // Verificar si todos los términos de búsqueda están incluidos en el string
          return terminosDeBusqueda.every((búsqueda) =>
            Termino.includes(búsqueda)
          );
      
        });
    }else if(campoABuscar == "245"){
        // 245
        Resultados = Registros.filter(function(Registro) {

          const terminosDeBusqueda = terminoABuscar.trim().toLowerCase().split(/\s+/);

          var Titulo;
          var Número;
          var DGM;
          var Subtítulo;
          var Mención;

          if(Registro['Datos']['Datos']['245'] !== undefined){

            if(Registro['Datos']['Datos']['245']['a'] !== undefined){
              Titulo = Registro['Datos']['Datos']['245']['a'];
            }else{
              Titulo = "";
            }

            if(Registro['Datos']['Datos']['245']['n'] !== undefined){
              Número = Registro['Datos']['Datos']['245']['n'];
            }else{
              Número = "";
            }

            if(Registro['Datos']['Datos']['245']['h'] !== undefined){
              DGM = Registro['Datos']['Datos']['245']['h'];
            }else{
              DGM = "";
            }

            if(Registro['Datos']['Datos']['245']['b'] !== undefined){
              Subtítulo = Registro['Datos']['Datos']['245']['b'];
            }else{
              Subtítulo = "";
            }

            if(Registro['Datos']['Datos']['245']['c'] !== undefined){
              Mención = Registro['Datos']['Datos']['245']['c'];
            }else{
              Mención = "";
            }


          }

          const Termino = `${Titulo} ${Número} ${DGM} ${Subtítulo} ${Mención}`.toLowerCase();
      
          // Verificar si todos los términos de búsqueda están incluidos en el string
          return terminosDeBusqueda.every((búsqueda) =>
            Termino.includes(búsqueda)
          );
      
        });
    }else if(campoABuscar == "250"){
        // 250
        Resultados = Registros.filter(function(Registro) {

          const terminosDeBusqueda = terminoABuscar.trim().toLowerCase().split(/\s+/);

          var Termino;

          if(Registro['Datos']['Datos']['250'] !== undefined){
            if(Registro['Datos']['Datos']['250']['a'] !== undefined){
              Termino = Registro['Datos']['Datos']['250']['a'];
            }else{
              Termino = Registro['Datos']['Datos']['250'];
            }
          }else{
            Termino = "";
          }
      
          // Verificar si todos los términos de búsqueda están incluidos en el string
          return terminosDeBusqueda.every((búsqueda) =>
            Termino.toLowerCase().includes(búsqueda)
          );
      
        });
    }else if(campoABuscar == "260"){
        // 260
        Resultados = Registros.filter(function(Registro) {

          const terminosDeBusqueda = terminoABuscar.trim().toLowerCase().split(/\s+/);

          var Lugar;
          var Editor;
          var Fecha;

          if(Registro['Datos']['Datos']['260'] !== undefined){
            if(Registro['Datos']['Datos']['260']['a'] !== undefined){
              Lugar = Registro['Datos']['Datos']['260']['a'];
            }else{
              Lugar = "";
            }

            if(Registro['Datos']['Datos']['260']['b'] !== undefined){
              Editor = Registro['Datos']['Datos']['260']['b'];
            }else{
              Editor = "";
            }

            if(Registro['Datos']['Datos']['260']['c'] !== undefined){
              Fecha = Registro['Datos']['Datos']['260']['c'];
            }else{
              Fecha = "";
            }

          }

          const Termino = `${Lugar} ${Editor} ${Fecha}`.toLowerCase();
      
          // Verificar si todos los términos de búsqueda están incluidos en el string
          return terminosDeBusqueda.every((búsqueda) =>
            Termino.includes(búsqueda)
          );
      
        });
    }else if(campoABuscar == "300"){
        // 300
        Resultados = Registros.filter(function(Registro){

          const terminosDeBusqueda = terminoABuscar.trim().toLowerCase().split(/\s+/);
          
          if(Registro['Datos']['Datos']['300'] !== undefined){

            var Extensión = "";
            var Otros = "";
            var Dimensiones = "";
            var Material = "";

             for(var i = 0; i < Registro['Datos']['Datos']['300'].length; i++){

              if(Registro['Datos']['Datos']['300'][i]['a'] !== undefined && Registro['Datos']['Datos']['300'][i]['a'] !== ""){
                Extensión += ` ${Registro['Datos']['Datos']['300'][i]['a']} `;
              }

              if(Registro['Datos']['Datos']['300'][i]['b'] !== undefined && Registro['Datos']['Datos']['300'][i]['b'] !== ""){
                Otros += ` ${Registro['Datos']['Datos']['300'][i]['b']} `;
              }

              if(Registro['Datos']['Datos']['300'][i]['c'] !== undefined && Registro['Datos']['Datos']['300'][i]['c'] !== ""){
                Dimensiones += ` ${Registro['Datos']['Datos']['300'][i]['c']} `;
              }

              if(Registro['Datos']['Datos']['300'][i]['e'] !== undefined && Registro['Datos']['Datos']['300'][i]['d'] !== ""){
                Material += ` ${Registro['Datos']['Datos']['300'][i]['e']} `;
              }

             }

          }

          const Termino = `${Extensión} ${Otros} ${Dimensiones} ${Material}`.toLowerCase();
      
          // Verificar si todos los términos de búsqueda están incluidos en el string
          return terminosDeBusqueda.every((búsqueda) =>
            Termino.includes(búsqueda)
          );

        })
    }

    Registros = Resultados;


  }

  $("#Proc2 i").removeClass("fa-spinner-third");
  $("#Proc2 i").removeClass("fa-spin");
  $("#Proc2 i").addClass("fa-check");
  $("#Proc2").css("color", "#11e51185");
  $("#Proc2").append(` [${Registros.length}] `);
  $("#Proc2").append(` <small>[${finalizarTiempo()}ms]</small> `);
  $("#Proc2").after(`
  <div style="padding: 1rem">
    <h4 class="mt-3" id="Proc3" style="text-align:center"><i class="fa-regular fa-spinner-third fa-spin"></i> ${obtenerItemIdioma("interBibliotecaria.creandoTabla")}</h4>
  </div>`);

  iniciarTiempo();

  $("body").append(`<div class="modal fade" data-bs-backdrop="static" data-bs-keyboard="false" id="resultados" tabindex="-1" aria-hidden="true">
    <div class="modal-dialog modal-xl  modal-dialog-scrollable">
      <div class="modal-content">
        <div class="modal-header">
          <h1 class="modal-title fs-5">${obtenerItemIdioma("interBibliotecaria.resultados")} <span class="badge bg-secondary">BETA</span></h1>
          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <div class="modal-body">
          <table class="table table-fluid" id="resultadosTabla">
            <thead>
              <tr>
                <th>MFN</th>
                <th>Titulo</th>
                <th>Autor</th>
                <th>Editorial</th>
                <th>Propietario</th>
                <th>Cantidad</th>
            </thead>
            <tbody>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>`);

  $('#resultados').on('hidden.bs.modal', function(){
    $("#resultados").remove();
  })

  for(var i = 0; i < Registros.length; i++){

    var Titulo = "";

    if(Registros[i]['Datos']['Datos']['245'] !== undefined){
      if(Registros[i]['Datos']['Datos']['245']['a'] !== undefined && Registros[i]['Datos']['Datos']['245']['a'] !== ""){
        Titulo += Registros[i]['Datos']['Datos']['245']['a'];
      }

      if(Registros[i]['Datos']['Datos']['245']['n'] !== undefined && Registros[i]['Datos']['Datos']['245']['n'] !== ""){
        Titulo += " - " + Registros[i]['Datos']['Datos']['245']['n'];
      }

      if(Registros[i]['Datos']['Datos']['245']['b'] !== undefined && Registros[i]['Datos']['Datos']['245']['b'] !== ""){
        Titulo += " - " + Registros[i]['Datos']['Datos']['245']['b'];
      }

      if(Registros[i]['Datos']['Datos']['245']['c'] !== undefined && Registros[i]['Datos']['Datos']['245']['c'] !== ""){
        Titulo += " - " + Registros[i]['Datos']['Datos']['245']['c'];
      }

      if(Registros[i]['Datos']['Datos']['245']['h'] !== undefined && Registros[i]['Datos']['Datos']['245']['h'] !== ""){
        Titulo += " [" + Registros[i]['Datos']['Datos']['245']['h'] + "]";
      }

    }else{
      Titulo = "-"
    }

    var Autor = "";

    if(Registros[i]['Datos']['Datos']['100'] !== undefined){
      if(Registros[i]['Datos']['Datos']['100']['a'] !== undefined && Registros[i]['Datos']['Datos']['100']['a'] !== ""){
        Autor += Registros[i]['Datos']['Datos']['100']['a'];
      }
    }else{
      Autor = "-"
    }

    var Editorial = "";

    if(Registros[i]['Datos']['Datos']['260'] !== undefined){
      if(Registros[i]['Datos']['Datos']['260']['a'] !== undefined && Registros[i]['Datos']['Datos']['260']['a'] !== ""){
        Editorial += Registros[i]['Datos']['Datos']['260']['a'];
      }

      if(Registros[i]['Datos']['Datos']['260']['b'] !== undefined && Registros[i]['Datos']['Datos']['260']['b'] !== ""){
        Editorial += " - " + Registros[i]['Datos']['Datos']['260']['b'];
      }

      if(Registros[i]['Datos']['Datos']['260']['c'] !== undefined && Registros[i]['Datos']['Datos']['260']['c'] !== ""){
        Editorial += " - " + Registros[i]['Datos']['Datos']['260']['c'];
      }

    }else{
      Editorial = "-"
    }

    $("#resultados #resultadosTabla tbody").append(`<tr>
      <td>${Registros[i]["Id"]}</td>
      <td>${Titulo}</td>
      <td>${Autor}</td>
      <td>${Editorial}</td>
      <td data-bs-toggle="tooltip" data-bs-title="${Instituciones.find(e => e.Id = Registros[i]["Institucion"])['Nombre']}"><img src="${Instituciones.find(e => e.Id = Registros[i]["Institucion"])['Logo']}" style="width:2rem">${Instituciones.find(e => e.Id = Registros[i]["Institucion"])['Abreviado']}</td>
      <td>${Registros[i]["Cantidad"]}</td>
    </tr>`);
  }

  $("#Proc3 i").removeClass("fa-spinner-third");
  $("#Proc3 i").removeClass("fa-spin");
  $("#Proc3 i").addClass("fa-check");
  $("#Proc3").css("color", "#11e51185");
  $("#Proc3").append(` <small>[${finalizarTiempo()}ms]</small> `);
  $("#Proc3").after(`
  <div style="padding: 1rem; display: flex; justify-content: center">
  <button id="verTabla" "type="button" class="btn btn-primary">${obtenerItemIdioma("interBibliotecaria.verTabla")}</button>
  </div>`);

  $("#verTabla").on("click", function(){
    $("#busquedaAvanzada").modal("hide");
    $("#resultados").modal("show");
  })

  $("[data-bs-toggle='tooltip']").tooltip();

}