function idiomasEspeciales(){

  // Obtenemos los datos de la institución
  $.ajax({
    type: "GET",
    url: Url + 'Api/Instituciones',
    data: {"Tipo": "obtenerDatos"},
    success: function(Datos, textStatus, xhr){

      // Establecemos datos
      Datos = $.parseJSON(Datos);
            
      // Verificamos estado de la petición
      if(Datos['estado'] == 'exitoso'){

        // Establecemos el estado de la institución
        switch (Datos['detalle']['Estado']){
          case "0":
            $("#estadoInstitución").text(obtenerItemIdioma("estadoInstitucion.0"));
            break;
          case "1":
            $("#estadoInstitución").text(obtenerItemIdioma("estadoInstitucion.1"));
            break;
          case "2":
            $("#estadoInstitución").text(obtenerItemIdioma("estadoInstitucion.2"));
            break;
          case "3":
            $("#estadoInstitución").text(obtenerItemIdioma("estadoInstitucion.3"));
            break;
          case "4":
            $("#estadoInstitución").text(obtenerItemIdioma("estadoInstitucion.4"));
            break;
        }

        // Establecemos los datos al acordeón (Información)
        $("#accordionConfiguración #institucionCUE").val(Datos['detalle']['CUE']);
        $("#accordionConfiguración #institucionNombre").val(Datos['detalle']['Nombre']);
        $("#accordionConfiguración #institucionNombreCorto").val(Datos['detalle']['Abreviado']);
        $("#accordionConfiguración #institucionCorreo").val(Datos['detalle']['CorreoABC']);
        $("#accordionConfiguración #institucionUsuarioGestor").val(Datos['detalle']['Gestor']);
        $("#accordionConfiguración #institucionCorreoGestor").val(Datos['detalle']['GestorCorreo']);
        $("#accordionConfiguración #institucionFecha").val(Datos['detalle']['FechaDeInscripcion']);
        $("#accordionConfiguración #institucionLogo").attr("src", Datos['detalle']['Logo']);
        $("#accordionConfiguración correoGestor").text(Datos['detalle']['GestorCorreo']);
        $("#accordionConfiguración correoABC").text(Datos['detalle']['CorreoABC']);

        // Establecemos los datos al acordeón (Características y Funciones)
        const Funciones = [
          "Recursos Online",
          "Actividades",
          "Ludoteca",
          "Mapoteca",
          "Audioteca",
          "Aula Virtual",
          "Comunidad",
          "Películas",
          "Recursos Físicos"
        ]

        // Insertamos los checks de las funciones
        var Limitados = false;
        for(var i = 0; i < Funciones.length; i++){
          $("#configuracionCaracterísticas #Checkbox").append(`<div class="form-check">
            <input class="form-check-input" type="checkbox" value="" id="Función${i}">
            <label class="form-check-label" for="Función${i}">
              ${obtenerItemIdioma("gestion.configuraciones.acordion.caracteristica." + i + ".detalle")}
            </label>
          </div>`);

          Datos['detalle']['Configuracion']['Funciones'] !== undefined && Datos['detalle']['Configuracion']['Funciones']["" + i + ""] !== undefined && Datos['detalle']['Configuracion']['Funciones']["" + i + ""] == "true" ? document.querySelector(`#configuracionCaracterísticas #Checkbox #Función${i}`).checked = true : document.querySelector(`#configuracionCaracterísticas #Checkbox #Función${i}`).checked = false;
          
          if (Datos['detalle']['Configuracion']['Funciones'] !== undefined && Datos['detalle']['Configuracion']['Limitaciones']["" + i + ""] == true) {
            $(`#configuracionCaracterísticas #Checkbox #Función${i}`).attr("disabled", false);
          }else{
            $(`#configuracionCaracterísticas #Checkbox #Función${i}`).attr("disabled", true);
            $(`#configuracionCaracterísticas #Checkbox #Función${i}`).parent().attr({
              "data-bs-toggle": "tooltip",
              "data-bs-original-title": obtenerItemIdioma("gestion.configuraciones.acordion.carac.deshabilitado")
            }).tooltip();
            Limitados = true;
          }
        }

        // Verificamos si posee limitaciones
        console.log(Limitados);
        Limitados == true ? $("#configuracionCaracterísticas #Limitaciones").show() : $("#configuracionCaracterísticas #Limitaciones").hide();

        // Actualizar listado funciones
        $("#configuracionCaracterísticas #Checkbox .form-check-input").on("change", actualizarListadoFunciones);

        // Quitamos el loader
        quitarLoader();

      }else if(Datos['estado'] == 'error'){
        errorLoader(Datos['detalle'], Datos['codigo']);
      }else{
        errorLoader();
      }

    },
    error: function(){
      errorLoader();
    }
  })

}

// Actualizar listado funciones
function actualizarListadoFunciones(){

  for(var i = 0; i < $("#configuracionCaracterísticas #Checkbox .form-check-input").length; i++){
    $("#configuracionCaracterísticas #Checkbox .form-check-input").eq(i).attr("Id");
    $("#configuracionCaracterísticas #Checkbox .form-check-input")[i].checked == true ? $("#accordionConfiguraciónFunciones .Función" + i).show() : $("#accordionConfiguraciónFunciones .Función" + i).hide();
  }

  evitarCierre(true);

  const Toast = Swal.mixin({
    toast: true,
    position: 'bottom-end',
    showConfirmButton: false,
    timerProgressBar: true,
    didOpen: (toast) => {
      toast.addEventListener('mouseenter', Swal.stopTimer)
      toast.addEventListener('mouseleave', Swal.resumeTimer)
    }
  })
  
  Toast.fire({
    icon: 'warning',
    title: `<div style="display: flex">${obtenerItemIdioma("gestion.configuraciones.acordion.carac.guardar")} <button type="button" onclick="actualizarConfiguraciones()" class="btn btn-primary">${obtenerItemIdioma("gestion.configuraciones.acordion.carac.guardarBoton")}</button></div>`
  })

  $("[data-bs-target='#configuracionCaracterísticas'] .cambiosSinGuardar").remove();
  $("[data-bs-target='#configuracionCaracterísticas']").append(`<span class="badge bg-secondary cambiosSinGuardar" style="margin-left: 0.5rem;">${obtenerItemIdioma("gestion.configuraciones.acordion.carac.guardar")}</span>`);

}


// Actualizar
function actualizarConfiguraciones(){

  const Toast = Swal.mixin({
    toast: true,
    position: 'top-end',
    showConfirmButton: false,
    timerProgressBar: true,
    didOpen: (toast) => {
      toast.addEventListener('mouseenter', Swal.stopTimer)
      toast.addEventListener('mouseleave', Swal.resumeTimer)
    }
  })
  
  Toast.fire({
    icon: 'info',
    title: obtenerItemIdioma("gestion.configuraciones.acordion.carac.guardando")
  })

  $.ajax({
    type: "GET",
    url: Url + 'Api/Instituciones',
    data: {
      "Tipo": "actualizarDatos",
      "Funciones": {
        "0": document.querySelector("#Función0").checked,
        "1": document.querySelector("#Función1").checked,
        "2": document.querySelector("#Función2").checked,
        "3": document.querySelector("#Función3").checked,
        "4": document.querySelector("#Función4").checked,
        "5": document.querySelector("#Función5").checked,
        "6": document.querySelector("#Función6").checked,
        "7": document.querySelector("#Función7").checked,
        "8": document.querySelector("#Función8").checked,
      }
    },
    success: function(Datos, textStatus, xhr){

      // Establecemos datos
      Datos = $.parseJSON(Datos);
            
      // Verificamos estado de la petición
      if(Datos['estado'] == 'exitoso'){

        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
        
        Toast.fire({
          icon: 'success',
          title: obtenerItemIdioma("gestion.configuraciones.acordion.carac.guardado")
        })

        $("[data-bs-target='#configuracionCaracterísticas'] .cambiosSinGuardar").remove();

        evitarCierre(false);

      }else if(Datos['estado'] == 'error'){

        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
        
        Toast.fire({
          icon: 'error',
          title: `${Datos['detalle']} [${Datos['codigo']}]`
        })

        setTimeout(function(){
          const Toast = Swal.mixin({
            toast: true,
            position: 'bottom-end',
            showConfirmButton: false,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })
          
          Toast.fire({
            icon: 'warning',
            title: `<div style="display: flex">${obtenerItemIdioma("gestion.configuraciones.acordion.carac.guardar")} <button type="button" onclick="actualizarConfiguraciones()" class="btn btn-primary">${obtenerItemIdioma("gestion.configuraciones.acordion.carac.guardarBoton")}</button></div>`
          })
        }, 1000);

      }else{

        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
        
        Toast.fire({
          icon: 'error',
          title: obtenerItemIdioma("gestion.configuraciones.acordion.carac.errorGuardar")
        })

        setTimeout(function(){
          const Toast = Swal.mixin({
            toast: true,
            position: 'bottom-end',
            showConfirmButton: false,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })
          
          Toast.fire({
            icon: 'warning',
            title: `<div style="display: flex">${obtenerItemIdioma("gestion.configuraciones.acordion.carac.guardar")} <button type="button" onclick="actualizarConfiguraciones()" class="btn btn-primary">${obtenerItemIdioma("gestion.configuraciones.acordion.carac.guardarBoton")}</button></div>`
          })
        }, 1000);

      }
      
    },
    error: function(){
      const Toast = Swal.mixin({
        toast: true,
        position: 'top-end',
        showConfirmButton: false,
        timerProgressBar: true,
        didOpen: (toast) => {
          toast.addEventListener('mouseenter', Swal.stopTimer)
          toast.addEventListener('mouseleave', Swal.resumeTimer)
        }
      })
      
      Toast.fire({
        icon: 'error',
        title: obtenerItemIdioma("gestion.configuraciones.acordion.carac.errorGuardar")
      })
      
      setTimeout(function(){
        const Toast = Swal.mixin({
          toast: true,
          position: 'bottom-end',
          showConfirmButton: false,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
        
        Toast.fire({
          icon: 'warning',
          title: `<div style="display: flex">${obtenerItemIdioma("gestion.configuraciones.acordion.carac.guardar")} <button type="button" onclick="actualizarConfiguraciones()" class="btn btn-primary">${obtenerItemIdioma("gestion.configuraciones.acordion.carac.guardarBoton")}</button></div>`
        })
      }, 1000);
    }
  })
}