// Función: Redirige al usuario a la api para descargar el Backup.
function descargarBackup(){
  window.open(Url + 'Api/RecursosFisicos?Tipo=descargarBackup', '_blank');
}

// Ver Ejemplares
var enProcesoDeCambio = 0;
$("#verEjemplares").click(function(){
  $("#ContenedorRegistros").hide();
  $("#ContenedorEjemplares").show();
  $("#ContenedorResultadoBusqueda").hide();
  $("#ContenedorEjemplares").html(`<h5 class="text-center mt-3" style="font-weight: 800;"><i class="fa-regular fa-spin fa-spinner-third"></i> Obteniendo ejemplares.</h5><p class="text-center">${General["nombreUsuario"]}, te pedimos que esperes unos segundos.</p>`);
  $("#pagActual").text("Ejemplares");
  obtenerEjemplares();
})
function obtenerEjemplares(){

  // Verificamos si se esta cargando algo.
  if(enProcesoDeCambio == 0){

    // Cambiamos
    enProcesoDeCambio = 1;

    // Enviamos petición
    $.ajax({
      type: "GET",
      url: Url + 'Api/RecursosFisicos',
      data: {"Tipo": "obtenerListadoEjemplares"},
      success: function(Datos, textStatus, xhr){

        // Establecemos datos
        Datos = $.parseJSON(Datos);
          
        // Verificamos estado de la petición
        if(Datos['estado'] == 'exitoso'){

          if(Datos['detalle']['Cantidad'] > 0){

            // Creamos la tabla.
            $("#ContenedorEjemplares").html(`<table class="table table-fluid" id="Ejemplares">
              <thead>
                <tr>
                  <th>MFN</th>
                  <th>Inventario</th>
                  <th>Titulo</th>
                  <th>Autor</th>
                  <th>Estado</th>
                  <th>Préstamo</th>
                  <th>Ubicación</th>
                  <th>Clasificación</th>
                  <th>Librística</th>
                  <th>Estado</th>
                  <th class="text-center">Acciones</th></tr>
              </thead>
              <tbody>
              </tbody>
            </table>`);

            // Creamos una variable y agregamos todos los ejemplares en ella.
            var ejemplaresHTML = "";
            for(var i = 0; i < Datos['detalle']['Ejemplares'].length; i++){

              // Establecemos variable.
              var Ejemplar = Datos['detalle']['Ejemplares'][i];

              // Agregamos el Id.
              ejemplaresHTML += "<tr><td><a style='display:none'>REGISTRO[" + Ejemplar['RegistroId'] + "]</a>" + Ejemplar['Id'] + "</td>";
  
              // Agregamos el campo A.
              ejemplaresHTML += "<td>" + Ejemplar['CampoA'] + "</td>";
      
              // Agregamos el titulo en caso de que haya.
              ejemplaresHTML += "<td>";
                if(Ejemplar['Registro']['Titulo']['a'] !== undefined){
                  ejemplaresHTML += Ejemplar['Registro']['Titulo']['a'];
                  if(Ejemplar['Registro']['Titulo']['b'] !== undefined){
                    ejemplaresHTML += " - " + Ejemplar['Registro']['Titulo']['b'];
                  }
                }else{
                  ejemplaresHTML += "-";
                }
                
              ejemplaresHTML += "</td>";
              
      
              // Agregamos el autor en caso que haya.
              ejemplaresHTML += "<td>";
              if(Ejemplar['Registro']['Autor']['a'] !== undefined){
                ejemplaresHTML += Ejemplar['Registro']['Autor']['a'];
              }else{
                ejemplaresHTML += "-";
              }
              ejemplaresHTML += "</td>";
      
              // Agregamos el campo H.
              ejemplaresHTML += "<td>" + Ejemplar['CampoH'] + "</td>";
      
              // Agregamos el campo D.
              ejemplaresHTML += "<td>" + Ejemplar['CampoD'] + "</td>";
      
              // Agregamos el campo L.
              ejemplaresHTML += "<td>" + Ejemplar['CampoL'] + "</td>";
      
              // Agregamos el campo M.
              ejemplaresHTML += "<td>" + Ejemplar['CampoM'] + "</td>";
      
              // Agregamos el campo N.
              ejemplaresHTML += "<td>" + Ejemplar['CampoN'] + "</td>";
      
              // Agregamos la disponibilidad del recurso.
              if(Ejemplar['Estado'] == 0){
                ejemplaresHTML += "<td>Disponible</td>";
              }else{
                ejemplaresHTML += "<td>No disponible</td>";
              }
              
              // Agregamos las opciones.
              ejemplaresHTML += "<td class='text-center'><i onclick='modificarEjemplar(" + Ejemplar['Id'] + ")' data-bs-toggle='tooltip' title='Modificar' class='fa-solid fa-pen ml-1 mr-1'></i> <i onclick='eliminarEjemeplar(" + Ejemplar['Id'] + ")' data-bs-toggle='tooltip' title='Eliminar' class='fa-solid fa-trash ml-1 mr-1'></i></td>";

            }

            // Agregamos ejemplares a la tabla.
            $("#ContenedorEjemplares tbody").append(ejemplaresHTML);

            // Inicializamos tabla.
            $('#ContenedorEjemplares #Ejemplares').DataTable({
              "language": {
                "sProcessing":    "Procesando...",
                "sLengthMenu":    "Mostrar _MENU_ ejemplares",
                "sZeroRecords":   "No se encontraron resultados",
                "sEmptyTable":    "Ningún dato disponible en esta tabla",
                "sInfo":          "Mostrando ejemplares del _START_ al _END_ de un total de _TOTAL_ ejemplares",
                "sInfoEmpty":     "Mostrando ejemplares del 0 al 0 de un total de 0 ejemplares",
                "sInfoFiltered":  "(filtrado de un total de _MAX_ ejemplares)",
                "sInfoPostFix":   "",
                "sSearch":        "Buscar:",
                "sUrl":           "",
                "sInfoThousands":  ",",
                "sLoadingRecords": "Cargando...",
                "oPaginate": {
                  "sFirst":    "Primero",
                  "sLast":    "Último",
                  "sNext":    "Siguiente",
                  "sPrevious": "Anterior"
                },
                "oAria": {
                  "sSortAscending":  ": Activar para ordenar la columna de manera ascendente",
                  "sSortDescending": ": Activar para ordenar la columna de manera descendente"
                }
              }
            });

          }else{

            // Indicamos al usuario que no hay ejemplares
            $("#ContenedorEjemplares").html(`<h5 class="text-center mt-3" style="font-weight: 800;"><i class="fa-regular fa-circle-info"></i> ${General["nombreUsuario"]}, tu institución aun no cuenta con ejemplares cargados.</h5><p class="text-center">Puedes cargar ejemplares desde la pestaña "Ver registros" haciendo click en "Agregar ejemplar"</p>`);
          
          }
          
          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }else if(Datos['estado'] == 'error'){

          // Mostramos el error
          $("#ContenedorEjemplares").html(`<h5 class="text-center mt-3" style="font-weight: 800;"><i style="color: red" class="fa-regular fa-xmark"></i> ${Datos["detalle"]} [${Datos["codigo"]}].</h5><p class="text-center">Tranquil@ ${General["nombreUsuario"]}, intentalo denuevo en unos instantes o comunicate con nosotros a <code>${General["correoSoporte"]}</code>.</p>`);
          
          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }else{

          // Mostramos el error
          $("#ContenedorEjemplares").html(`<h5 class="text-center mt-3" style="font-weight: 800;"><i style="color: red" class="fa-regular fa-xmark"></i> Hubo un error desconocido.</h5><p class="text-center">Tranquil@ ${General["nombreUsuario"]}, intentalo denuevo en unos instantes o comunicate con nosotros a <code>${General["correoSoporte"]}</code>.</p>`);
          
          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }
          
      },
      error: function(){
        
        // Mostramos el error
        $("#ContenedorEjemplares").html(`<h5 class="text-center" style="font-weight: 800;"><i style="color: red" class="fa-regular fa-xmark"></i> Hubo un error desconocido.</h5><p class="text-center">Tranquil@ ${General["nombreUsuario"]}, intentalo denuevo en unos instantes o comunicate con nosotros a <code>${General["correoSoporte"]}</code>.</p>`);

        // Volvemos a cambiar el estado del proceso
        enProcesoDeCambio = 0;

      }
    })
  }
}

// Ver Registros
var enProcesoDeCambio = 0;
$("#verRegistros").click(function(){
  $("#ContenedorRegistros").show();
  $("#ContenedorEjemplares").hide();
  $("#ContenedorResultadoBusqueda").hide();
  $("#ContenedorRegistros").html(`<h5 class="text-center mt-3" style="font-weight: 800;"><i class="fa-regular fa-spin fa-spinner-third"></i> Obteniendo registros.</h5><p class="text-center">${General["nombreUsuario"]}, te pedimos que esperes unos segundos.</p>`);
  $("#pagActual").text("Registros");
  obtenerRegistros();
})
function obtenerRegistros(){

  // Verificamos si se esta cargando algo.
  if(enProcesoDeCambio == 0){

    // Cambiamos
    enProcesoDeCambio = 1;

    // Enviamos petición
    $.ajax({
      type: "GET",
      url: Url + 'Api/RecursosFisicos',
      data: {"Tipo": "obtenerListadoRegistro"},
      success: function(Datos, textStatus, xhr){

        // Establecemos datos
        Datos = $.parseJSON(Datos);
          
        // Verificamos estado de la petición
        if(Datos['estado'] == 'exitoso'){

          if(Datos['detalle']['Cantidad'] > 0){

            // Creamos la tabla.
            $("#ContenedorRegistros").html(`<table class="table table-fluid" id="Registros">
              <thead>
                <tr>
                  <th>MFN</th>
                  <th>Titulo</th>
                  <th>Autor</th>
                  <th>Editorial</th>
                  <th>Nota de contenido</th>
                  <th class="text-center">Acciones</th></tr>
              </thead>
              <tbody>
              </tbody>
            </table>`);

            // Creamos una variable y agregamos todos los registros en ella.
            var registrosHTML = "";
            for(var i = 0; i < Datos['detalle']['Registros'].length; i++){

              // Establecemos variable.
              var Registro = Datos['detalle']['Registros'][i];

              // Establecemos ISBNs
              var ISBN = "";
              if(Registro['Datos']['Datos']['020'] !== undefined){
                for(var a = 0; a < Registro['Datos']['Datos']['020'].length; a++){
                  ISBN += " - " + Registro['Datos']['Datos']['020'][a];
                }
              }

              // Agregamos el Id.
              registrosHTML += `<tr><td>${Registro['Id']}</td>`;
  
              // Agregamos el campo 245.
              if(Registro['245']['a'] !== undefined){
                registrosHTML += "<td>" + Registro['245']['a'];
                if(Registro['245']['b'] !== undefined){
                  registrosHTML += " - " + Registro['245']['b'];
                }
                registrosHTML += " <a style='display:none'>${ISBN}</a></td>";
              }else{
                registrosHTML += "<td>- <a style='display:none'>${ISBN}</a></td>"
              }
      
              // Agregamos el campo 100.
              if(Registro['100']['a'] !== undefined){
                registrosHTML += "<td>" + Registro['100']['a'] + "</td>";
              }else{
                registrosHTML += "<td>-</td>"
              }

              // Agregamos el campo 260.
              if(Registro['Datos']['Datos']['260'] !== undefined){
                if(Registro['Datos']['Datos']['260']['b'] !== undefined){
                  registrosHTML += "<td>" + Registro['Datos']['Datos']['260']['b'] + "</td>";
                }else{
                  registrosHTML += "<td>-</td>"
                }
              }else{
                registrosHTML += "<td>-</td>"
              }

              // Agregamos el campo 505.
              if(Registro['Datos']['Datos']['505'] !== undefined){
                if(Registro['Datos']['Datos']['505'].length !== 0){
                  registrosHTML += "<td class='text-center'><a style='display:none'>";
                  for(var z = 0; z < Registro['Datos']['Datos']['505'].length; z++){
      
                    if(z > 0){registrosHTML += "<br>";}
      
                    if(Registro['Datos']['Datos']['505'][z]['t'] !== undefined){
                      registrosHTML += Registro['Datos']['Datos']['505'][z]['t'];
                      if(Registro['Datos']['Datos']['505'][z]['r'] !== undefined){
                        registrosHTML += " ⁓ " + Registro['Datos']['Datos']['505'][z]['r'];
                      }
                    }
      
                  }
                  registrosHTML += "</a><i onclick='verNotaDeContenido(" + Registro['Id'] + ")' class='fa-solid fa-eye'></i></td>";
                }else{
                  registrosHTML += "<td class='text-center'>-</td>";
                }
              }else{
                registrosHTML += "<td class='text-center'>-</td>";
              }
      
              registrosHTML += "<td class='text-center'>";
          
              registrosHTML += "<i onclick='verFicha(" + Registro['Id'] + ")' class='mr-1 ml-1 fa-duotone fa-arrow-up-right-from-square'></i>";

              registrosHTML += "<i onclick='verEjemeplares(" + Registro['Id'] + ")' class='mr-1 ml-1 fa-duotone fa-books'></i>";

              registrosHTML += "<i onclick='añadirEjemeplar(" + Registro['Id'] + ")' class='mr-1 ml-1 fa-duotone fa-books-medical'></i>"

              registrosHTML += "<i onclick='eliminarRegistro(" + '"' + Registro['245']['a'] + '"' + ", " + Registro['Id'] + ")' class='mr-1 ml-1 fa-duotone fa-trash'></i>"
              
              registrosHTML += "<i onclick='ediciónRegistro(" + Registro['Id'] + ")' class='mr-1 ml-1 fa-duotone fa-pen'></i>"
              
              registrosHTML += "</td></tr>";
              
            }

            // Agregamos ejemplares a la tabla.
            $("#ContenedorRegistros tbody").append(registrosHTML);

            // Inicializamos tabla.
            $('#ContenedorRegistros #Registros').DataTable({
              "language": {
                "sProcessing":    "Procesando...",
                "sLengthMenu":    "Mostrar _MENU_ ejemplares",
                "sZeroRecords":   "No se encontraron resultados",
                "sEmptyTable":    "Ningún dato disponible en esta tabla",
                "sInfo":          "Mostrando ejemplares del _START_ al _END_ de un total de _TOTAL_ ejemplares",
                "sInfoEmpty":     "Mostrando ejemplares del 0 al 0 de un total de 0 ejemplares",
                "sInfoFiltered":  "(filtrado de un total de _MAX_ ejemplares)",
                "sInfoPostFix":   "",
                "sSearch":        "Buscar:",
                "sUrl":           "",
                "sInfoThousands":  ",",
                "sLoadingRecords": "Cargando...",
                "oPaginate": {
                  "sFirst":    "Primero",
                  "sLast":    "Último",
                  "sNext":    "Siguiente",
                  "sPrevious": "Anterior"
                },
                "oAria": {
                  "sSortAscending":  ": Activar para ordenar la columna de manera ascendente",
                  "sSortDescending": ": Activar para ordenar la columna de manera descendente"
                }
              }
            });

          }else{

            // Indicamos al usuario que no hay ejemplares
            $("#ContenedorRegistros").html(`<h5 class="text-center mt-3" style="font-weight: 800;"><i class="fa-regular fa-circle-info"></i> ${General["nombreUsuario"]}, tu institución aun no cuenta con registros cargados.</h5><p class="text-center">Puedes cargar ejemplares desde la pestaña "Ver registros" haciendo click en "Agregar ejemplar"</p>`);
          
          }
          
          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }else if(Datos['estado'] == 'error'){

          // Mostramos el error
          $("#ContenedorRegistros").html(`<h5 class="text-center mt-3" style="font-weight: 800;"><i style="color: red" class="fa-regular fa-xmark"></i> ${Datos["detalle"]} [${Datos["codigo"]}].</h5><p class="text-center">Tranquil@ ${General["nombreUsuario"]}, intentalo denuevo en unos instantes o comunicate con nosotros a <code>${General["correoSoporte"]}</code>.</p>`);
          
          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }else{

          // Mostramos el error
          $("#ContenedorRegistros").html(`<h5 class="text-center mt-3" style="font-weight: 800;"><i style="color: red" class="fa-regular fa-xmark"></i> Hubo un error desconocido.</h5><p class="text-center">Tranquil@ ${General["nombreUsuario"]}, intentalo denuevo en unos instantes o comunicate con nosotros a <code>${General["correoSoporte"]}</code>.</p>`);
          
          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }
          
      },
      error: function(){
        
        // Mostramos el error
        $("#ContenedorRegistros").html(`<h5 class="text-center" style="font-weight: 800;"><i style="color: red" class="fa-regular fa-xmark"></i> Hubo un error desconocido.</h5><p class="text-center">Tranquil@ ${General["nombreUsuario"]}, intentalo denuevo en unos instantes o comunicate con nosotros a <code>${General["correoSoporte"]}</code>.</p>`);

        // Volvemos a cambiar el estado del proceso
        enProcesoDeCambio = 0;

      }
    })
  }
}
var REGIS;
// Función: Vemos la información de un registro.
function verFicha(Id){

  // Verificamos si se esta cargando algo.
  if(enProcesoDeCambio == 0){

    // Medimos tiempo inicio
    var tiempoInicio = performance.now();

    // Cambiamos estado del proceso
    enProcesoDeCambio = 1;

    // Mostramos toast
    const Toast = Swal.mixin({
      toast: true,
      position: 'top-end',
      showConfirmButton: false,
      timerProgressBar: true,
      didOpen: (toast) => {
        toast.addEventListener('mouseenter', Swal.stopTimer)
        toast.addEventListener('mouseleave', Swal.resumeTimer)
      }
    })
    
    Toast.fire({
      icon: 'info',
      title: `${General["nombreUsuario"]}, estamos obteniendo la ficha...`
    })

    // Realizamos petición
    $.ajax({
      type: "GET",
      url: Url + 'Api/RecursosFisicos',
      data: {"Tipo": "obtenerRegistroEspecifico", "Registro": Id},
      success: function(Datos, textStatus, xhr){
        
        // Establecemos datos
        Datos = $.parseJSON(Datos);
          
        // Verificamos estado de la petición
        if(Datos['estado'] == 'exitoso'){

          // Quitamos Swal
          Swal.close();

          // Establecemos variable
          console.log(Registro);
          var Registro = Datos["detalle"]["Registro"];
          REGIS = Registro;
          // Verificamos si existe el modal. En caso de existir lo ocultamos y eliminamos.
          if($("#fichaRegistro").length !== 0){

            // Ocultamos el modal.
            $("#fichaRegistro").modal("hide");

            // Eliminamos modal.
            $("#fichaRegistro").remove();

          }

          // Creamos modal
          $("body").append(`<div class="modal fade" id="fichaRegistro" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"><div class="modal-dialog modal-dialog-scrollable"><div class="modal-content"><div class="modal-header"><h1 class="modal-title fs-5" id="exampleModalLabel">Ficha de registro seleccionado</h1><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body" id="Ficha"></div><div class="modal-footer" style="color: gainsboro;">Tiempo performance: <tiempoPerformance></tiempoPerformance>ms</div></div></div></div>`);
        
          // Establecemos acción al ocultar modal.
          $('#fichaRegistro').on('hidden.bs.modal', function(){
            $("#fichaRegistro").remove();
          })

          ///////////////////////////////////
          //                               //
          //      ESTABLECEMOS CAMPOS      //
          //                               //
          ///////////////////////////////////

          for(var i = 0; i < Campos.length; i++){

            // Creamos contenedor del campo
            $("#fichaRegistro .modal-body").append(`<div style="margin-bottom: 1rem; border: 2.5px solid rgb(0 0 0 / 32%); border-radius: 5px; padding: 1rem;" id="Campo${Campos[i]['Nombre']}">
              <p data-bs-toggle="popover" data-bs-title="${obtenerItemIdioma("marc.ayuda")}" data-bs-content="${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.ayuda`)}" style="margin-bottom: 0"><b>${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}`)} [${Campos[i]['Nombre']}]:</b></p><p class="Datos" style="margin-left: 0.5rem"></p>
            </div>`);

            // Verificamos si es repetible o normal
            if(Campos[i]['Repetible'] !== 1){

              // Verificamos si el campo esta definido
              if(Registro['Datos']['Datos'][Campos[i]['Nombre']] !== undefined){

                // Mostramos datos
                for(var b = 0; b < Campos[i]['Subcampos'].length; b++){
                  if(!verificarJson(Registro['Datos']['Datos'][Campos[i]['Nombre']])){
                    $(`#Ficha #Campo${Campos[i]['Nombre']} .Datos`).append(`<a data-bs-toggle="tooltip" data-bs-title="${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}.ayuda`)}" style="font-style: unset; font-weight: bold">${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}`)}:</a> <i>${Registro['Datos']['Datos'][Campos[i]['Nombre']][Campos[i]['Subcampos'][b]['Campo']] !== undefined ? Registro['Datos']['Datos'][Campos[i]['Nombre']][Campos[i]['Subcampos'][b]['Campo']] : '-'}</i><br>`);
                  }else{
                    $(`#Ficha #Campo${Campos[i]['Nombre']} .Datos`).append(`<a data-bs-toggle="tooltip" data-bs-title="${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}.ayuda`)}" style="font-style: unset; font-weight: bold">${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}`)}:</a> <i>${Registro['Datos']['Datos'][Campos[i]['Nombre']] !== undefined ? Registro['Datos']['Datos'][Campos[i]['Nombre']] : '-'}</i><br>`);
                  }
                }

              }else{
                
                // Mostramos datos
                for(var b = 0; b < Campos[i]['Subcampos'].length; b++){
                  $(`#Ficha #Campo${Campos[i]['Nombre']} .Datos`).append(`<a data-bs-toggle="tooltip" data-bs-title="${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}.ayuda`)}" style="font-style: unset; font-weight: bold">${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}`)}:</a> <i>-</i><br>`);
                }

              }

            }else{

              if(Registro['Datos']['Datos'][Campos[i]['Nombre']] !== undefined){

                for(var c = 0; c < Registro['Datos']['Datos'][Campos[i]['Nombre']].length; c++){

                  $(`#Ficha #Campo${Campos[i]['Nombre']} .Datos`).append("<hr>");

                  // Verificamos si el campo esta definido
                  if(Registro['Datos']['Datos'][Campos[i]['Nombre']][c] !== undefined){

                    // Mostramos datos
                    for(var b = 0; b < Campos[i]['Subcampos'].length; b++){
                      if(!verificarJson(Registro['Datos']['Datos'][Campos[i]['Nombre']][b])){
                        $(`#Ficha #Campo${Campos[i]['Nombre']} .Datos`).append(`
                        <a data-bs-toggle="tooltip" data-bs-title="${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}.ayuda`)}" style="font-style: unset; font-weight: bold"> ${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}`)}:</a>
                        <i>${Registro['Datos']['Datos'][Campos[i]['Nombre']][c][Campos[i]['Subcampos'][b]['Campo']] !== undefined ? Registro['Datos']['Datos'][Campos[i]['Nombre']][c][Campos[i]['Subcampos'][b]['Campo']] : '-'}
                        </i><br>`);
                      }else{
                        $(`#Ficha #Campo${Campos[i]['Nombre']} .Datos`).append(`
                        <a data-bs-toggle="tooltip" data-bs-title="${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}.ayuda`)}" style="font-style: unset; font-weight: bold"> ${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}`)}:</a>
                        <i>${Registro['Datos']['Datos'][Campos[i]['Nombre']][c] !== undefined ? Registro['Datos']['Datos'][Campos[i]['Nombre']][c] : '-'}
                        </i><br>`);
                      }
                    }

                  }else{
                    
                    // Mostramos datos
                    for(var b = 0; b < Campos[i]['Subcampos'].length; b++){
                      $(`#Ficha #Campo${Campos[i]['Nombre']} .Datos`).append(`<a data-bs-toggle="tooltip" data-bs-title="${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}.ayuda`)}" style="font-style: unset; font-weight: bold">${obtenerItemIdioma(`marc.${Campos[i]['Nombre']}.${Campos[i]['Subcampos'][b]['Campo']}`)}:</a> <i>-</i><br>`);
                    }

                  }

                }
              
              }

            }

          }

          // Mostramos modal
          $("#fichaRegistro").modal("show");

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

          $("#fichaRegistro tiempoPerformance").text(Math.round(performance.now() - tiempoInicio));

          $("[data-bs-toggle='popover']").popover();
          $("[data-bs-toggle='tooltip']").tooltip();

    

        }else if(Datos['estado'] == 'error'){

          // Mostramos error
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            timer: 3000,
            showConfirmButton: false,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })
          
          Toast.fire({
            icon: 'error',
            title: `${General["nombreUsuario"]}, hubo un error. ${Datos["detalle"]} [${Datos["codigo"]}]`
          })

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;
        }else{

          // Mostramos error
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            timer: 3000,
            showConfirmButton: false,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })
          
          Toast.fire({
            icon: 'error',
            title: `${General["nombreUsuario"]}, hubo un error. Reintentalo o comuníquese con soporte.`
          })

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;
        }

      },
      error: function(){

        // Mostramos error
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          timer: 3000,
          showConfirmButton: false,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
        
        Toast.fire({
          icon: 'error',
          title: `${General["nombreUsuario"]}, hubo un error. Reintentalo o comuníquese con soporte.`
        })

        // Volvemos a cambiar el estado del proceso
        enProcesoDeCambio = 0;

      }
    })

  }else{
    const Toast = Swal.mixin({
      toast: true,
      position: 'top-end',
      timer: 3000,
      showConfirmButton: false,
      timerProgressBar: true,
      didOpen: (toast) => {
        toast.addEventListener('mouseenter', Swal.stopTimer)
        toast.addEventListener('mouseleave', Swal.resumeTimer)
      }
    })
    
    Toast.fire({
      icon: 'info',
      title: 'Ya se esta cargando una ficha, aguarde a que termine de cargar antes de abrir otra.'
    })
  }
    
}

// Función: Vemos notas de contenido.
function verNotaDeContenido(Id){

  // Verificamos si se esta cargando algo.
  if(enProcesoDeCambio == 0){

    // Medimos tiempo inicio
    var tiempoInicio = performance.now();

    // Cambiamos estado del proceso
    enProcesoDeCambio = 1;

    // Mostramos toast
    const Toast = Swal.mixin({
      toast: true,
      position: 'top-end',
      showConfirmButton: false,
      timerProgressBar: true,
      didOpen: (toast) => {
        toast.addEventListener('mouseenter', Swal.stopTimer)
        toast.addEventListener('mouseleave', Swal.resumeTimer)
      }
    })
    
    Toast.fire({
      icon: 'info',
      title: `${General["nombreUsuario"]}, estamos obteniendo las notas de contenido...`
    })

    // Realizamos petición
    $.ajax({
      type: "GET",
      url: Url + 'Api/RecursosFisicos',
      data: {"Tipo": "obtenerNotasDeContenido", "Registro": Id},
      success: function(Datos, textStatus, xhr){
        
        // Establecemos datos
        Datos = $.parseJSON(Datos);
          
        // Verificamos estado de la petición
        if(Datos['estado'] == 'exitoso'){

          // Verificamos si existe el modal. En caso de existir lo ocultamos y eliminamos.
          if($("#notaDeContenido").length !== 0){

            // Ocultamos el modal.
            $("#notaDeContenido").modal("hide");

            // Eliminamos modal.
            $("#notaDeContenido").remove();

          }

          // Creamos modal
          $("body").append(`<div class="modal fade" id="notaDeContenido" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"><div class="modal-dialog"><div class="modal-content"><div class="modal-header"><h1 class="modal-title fs-5" id="exampleModalLabel">Nota de contenido</h1><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body" id="Nota"></div><div class="modal-footer" style="color: gainsboro;">Tiempo performance: <tiempoPerformance></tiempoPerformance>ms</div></div></div></div>`);;
        
          // Establecemos acción al ocultar modal.
          $('#notaDeContenido').on('hidden.bs.modal', function(){
            $("#notaDeContenido").remove();
          })

          var Campo505 = '';
          for(var i = 0; i < Datos["detalle"].length; i++){
            if(Datos["detalle"][i]["t"] !== undefined && Datos["detalle"][i]["t"] !== ""){
              if(i > 0){Campo505 += "<br>";}
              Campo505 += Datos["detalle"][i]["t"];
              if(Datos["detalle"][i]["r"] !== undefined && Datos["detalle"][i]["r"] !== ""){
                Campo505 += " ⁓ " + Datos["detalle"][i]["r"];
              }
            }
            
          }
          if(Datos["detalle"].length == 0){Campo505 = "-"}

          // Insertamos notas de contenido
          $("#notaDeContenido #Nota").html('<div><p style="margin-bottom: 0"><b>Nota de contenido [505]:</b></p><p style="margin-left: 0.5rem"><a style="font-style: italic">' + Campo505 + '</a></p></div>');

          // Mostramos el modal.
          $("#notaDeContenido").modal("show");

          // Quitamos mensaje
          Swal.close();

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

          $("#notaDeContenido tiempoPerformance").text(Math.round(performance.now() - tiempoInicio));


        }else if(Datos['estado'] == 'error'){

          // Mostramos error
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            timer: 3000,
            showConfirmButton: false,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })

          Toast.fire({
            icon: 'error',
            title: `${General["nombreUsuario"]}, hubo un error. ${Datos['detalle']} [${Datos['codigo']}]`
          })

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }else{

          // Mostramos error
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            timer: 3000,
            showConfirmButton: false,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })

          Toast.fire({
            icon: 'error',
            title: `${General["nombreUsuario"]}, hubo un error. Reintentalo o comuníquese con soporte.`
          })

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }

      },
      error: function(){

        // Mostramos error
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          timer: 3000,
          showConfirmButton: false,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })

        Toast.fire({
          icon: 'error',
          title: `${General["nombreUsuario"]}, hubo un error. Reintentalo o comuníquese con soporte.`
        })

        // Volvemos a cambiar el estado del proceso
        enProcesoDeCambio = 0;

      }

    })

  }
  
}
  
// Función: Vemos los ejemplares de un registro.
function verEjemeplares(Id){

  // Verificamos si se esta cargando algo.
  if(enProcesoDeCambio == 0){

    // Medimos tiempo inicio
    var tiempoInicio = performance.now();

    // Cambiamos estado del proceso
    enProcesoDeCambio = 1;

    // Mostramos toast
    const Toast = Swal.mixin({
      toast: true,
      position: 'top-end',
      showConfirmButton: false,
      timerProgressBar: true,
      didOpen: (toast) => {
        toast.addEventListener('mouseenter', Swal.stopTimer)
        toast.addEventListener('mouseleave', Swal.resumeTimer)
      }
    })
    
    Toast.fire({
      icon: 'info',
      title: `${General["nombreUsuario"]}, estamos obteniendo los ejemplares...`
    })

    // Realizamos petición
    $.ajax({
      type: "GET",
      url: Url + 'Api/RecursosFisicos',
      data: {"Tipo": "obtenerListadoEjemplaresEspecifico", "Registro": Id},
      success: function(Datos, textStatus, xhr){
        
        // Establecemos datos
        Datos = $.parseJSON(Datos);
          
        // Verificamos estado de la petición
        if(Datos['estado'] == 'exitoso'){

          // Verificamos si existe el modal. En caso de existir lo ocultamos y eliminamos.
          if($("#gestionarEjemplares").length !== 0){

            // Ocultamos el modal.
            $("#gestionarEjemplares").modal("hide");

            // Eliminamos modal.
            $("#gestionarEjemplares").remove();

          }

          // Creamos modal
          $("body").append(`<div class="modal fade" id="gestionarEjemplares" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-hidden="true"><div class="modal-dialog modal-xl"><div class="modal-content"><div class="modal-header"><h1 class="modal-title fs-5">Gestión de ejemplares</h1><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body"><table class="table table-fluid" id="EjemplaresEspecifico"><thead><tr><th>MFN</th><th>Inventario</th><th>Estado</th><th>Préstamo</th><th>Ubicación</th><th>Clasificación</th><th>Librística</th><th>Estado</th><th class="text-center">Acciones</th></tr></thead><tbody></tbody></table></div><div class="modal-footer" style="color: gainsboro;">Tiempo performance: <tiempoPerformance></tiempoPerformance>ms</div></div></div></div>`);
        
          // Establecemos acción al ocultar modal.
          $('#gestionarEjemplares').on('hidden.bs.modal', function(){
            $("#gestionarEjemplares").remove();
          })

          // Establecemos datos de la tabla.
          var Tabla = '';
          for(var i = 0; i < Datos["detalle"].length; i++){
              
            Tabla += "<tr><td>" + Datos["detalle"][i]['Id'] + "</td>";
        
            Tabla += "<td>" + Datos["detalle"][i]['CampoA'] + "</td>";
        
            Tabla += "<td>" + Datos["detalle"][i]['CampoH'] + "</td>";
        
            Tabla += "<td>" + Datos["detalle"][i]['CampoD'] + "</td>";
        
            Tabla += "<td>" + Datos["detalle"][i]['CampoL'] + "</td>";
        
            Tabla += "<td>" + Datos["detalle"][i]['CampoM'] + "</td>";
        
            Tabla += "<td>" + Datos["detalle"][i]['CampoN'] + "</td>";
        
            if(Datos["detalle"][i]['Estado'] == 0){
              Tabla += "<td>Disponible</td>";
            }else{
              Tabla += "<td>No disponible</td>";
            }
              
            Tabla += `<td class='text-center'><i onclick='modificarEjemplar(${Datos["detalle"][i]['Id']})' data-bs-toggle='tooltip' title='Modificar' class='fa-solid fa-pen ml-1 mr-1'></i> <i onclick='eliminarEjemeplar(${Datos["detalle"][i]['Id']})' data-bs-toggle='tooltip' title='Eliminar' class='fa-solid fa-trash ml-1 mr-1'></i></td>`;
        
          }   

          // Insertamos datos de la tabla.
          $("#EjemplaresEspecifico tbody").html(Tabla);
        
          // Establecemos table
          $('#EjemplaresEspecifico').DataTable({
            "language": {
              "sProcessing":    "Procesando...",
              "sLengthMenu":    "Mostrar _MENU_ ejemplares",
              "sZeroRecords":   "No se encontraron resultados",
              "sEmptyTable":    "Ningún dato disponible en esta tabla",
              "sInfo":          "Mostrando ejemplares del _START_ al _END_ de un total de _TOTAL_ ejemplares",
              "sInfoEmpty":     "Mostrando ejemplares del 0 al 0 de un total de 0 ejemplares",
              "sInfoFiltered":  "(filtrado de un total de _MAX_ ejemplares)",
              "sInfoPostFix":   "",
              "sSearch":        "Buscar:",
              "sUrl":           "",
              "sInfoThousands": ",",
              "sLoadingRecords":"Cargando...",
              "oPaginate": {
                "sFirst":    "Primero",
                "sLast":     "Último",
                "sNext":     "Siguiente",
                "sPrevious": "Anterior"
              },
              "oAria": {
                "sSortAscending":  ": Activar para ordenar la columna de manera ascendente",
                "sSortDescending": ": Activar para ordenar la columna de manera descendente"
              }
            }
          });

          // Mostramos el modal.
          $("#gestionarEjemplares").modal("show");

          // Quitamos mensaje
          Swal.close();

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

          $("#gestionarEjemplares tiempoPerformance").text(Math.round(performance.now() - tiempoInicio));

        }else if(Datos['estado'] == 'error'){

          // Mostramos error
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            timer: 3000,
            showConfirmButton: false,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })

          Toast.fire({
            icon: 'error',
            title: `${General["nombreUsuario"]}, hubo un error. ${Datos['detalle']} [${Datos['codigo']}]`
          })

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }else{

          // Mostramos error
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            timer: 3000,
            showConfirmButton: false,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })

          Toast.fire({
            icon: 'error',
            title: `${General["nombreUsuario"]}, hubo un error. Reintentalo o comuníquese con soporte.`
          })

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }

      },
      error: function(){

        // Mostramos error
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          timer: 3000,
          showConfirmButton: false,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })

        Toast.fire({
          icon: 'error',
          title: `${General["nombreUsuario"]}, hubo un error. Reintentalo o comuníquese con soporte.`
        })

        // Volvemos a cambiar el estado del proceso
        enProcesoDeCambio = 0;

      }

    })

  }

}

// Función: Modificar ejemplar.
function modificarEjemplar(Id){

  // Verificamos si se esta cargando algo.
  if(enProcesoDeCambio == 0){

    // Cambiamos estado del proceso
    enProcesoDeCambio = 1;

    // Quitamos modal de gestion ejemplares
    $("#gestionarEjemplares").modal("hide");

    // Mostramos toast
    const Toast = Swal.mixin({
      toast: true,
      position: 'top-end',
      showConfirmButton: false,
      timerProgressBar: true,
      didOpen: (toast) => {
        toast.addEventListener('mouseenter', Swal.stopTimer)
        toast.addEventListener('mouseleave', Swal.resumeTimer)
      }
    })
    
    Toast.fire({
      icon: 'info',
      title: `${General["nombreUsuario"]}, estamos obteniendo los datos del ejemplar ...`
    })

    // Realizamos petición
    $.ajax({
      type: "GET",
      url: Url + 'Api/RecursosFisicos',
      data: {"Tipo": "obtenerEjemplar", "Ejemplar": Id},
      success: function(Datos, textStatus, xhr){
        
        // Establecemos datos
        Datos = $.parseJSON(Datos);
          
        // Verificamos estado de la petición
        if(Datos['estado'] == 'exitoso'){

          // Verificamos si existe el modal. En caso de existir lo ocultamos y eliminamos.
          if($("#editarEjemplar").length !== 0){

            // Ocultamos el modal.
            $("#editarEjemplar").modal("hide");

            // Eliminamos modal.
            $("#editarEjemplar").remove();

          }

          var Ejemplar = Datos['detalle'];

          // Creamos modal
          $("body").append(`<div class="modal fade" id="editarEjemplar" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-hidden="true"><div class="modal-dialog"><div class="modal-content"><div class="modal-header"><h1 class="modal-title fs-5">Editar ejemplar a el MFN ${Id}</h1><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body"><form id="editarEjemplarFormulario"><input type="hidden" id="EjemplarId" value="${Id}" name="EjemplarId"><input type="text" placeholder="Inventario" class="mt-1 form-control" id="Inventario" name="CampoA" value="${Ejemplar['CampoA']}"><input type="text" placeholder="Parte" class="mt-1 form-control" id="Parte" name="CampoB" value="${Ejemplar['CampoB']}"><input type="text" placeholder="Volumen" class="mt-1 form-control" id="Volumen" name="CampoC" value="${Ejemplar['CampoC']}"><input type="text" placeholder="Préstamo" class="mt-1 form-control" id="Préstamo" name="CampoD" value="${Ejemplar['CampoD']}"><input type="text" placeholder="Procedencia" class="mt-1 form-control" id="Procedencia" name="CampoE" value="${Ejemplar['CampoE']}"><input type="text" placeholder="Proveedor" class="mt-1 form-control" id="Proveedor" name="CampoF" value="${Ejemplar['CampoF']}"><input type="text" placeholder="Notas locales" class="mt-1 form-control" id="Notas" name="CampoG" value="${Ejemplar['CampoG']}"><input type="text" placeholder="Estado" class="mt-1 form-control" id="Estado" name="CampoH" value="${Ejemplar['CampoH']}"><input type="text" placeholder="Ubicación" class="mt-1 form-control" id="Ubicación" name="CampoL" value="${Ejemplar['CampoL']}"><input type="text" placeholder="Clasificación" class="mt-1 form-control" id="Clasificación" name="CampoM" value="${Ejemplar['CampoM']}"><input type="text" placeholder="Librística" class="mt-1 form-control" id="Librística" name="CampoN" value="${Ejemplar['CampoN']}"></form></div><a style="margin: 1rem" id="ErrorAlEditarEjemplar" class="error-form"></a><div class="modal-footer"><button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancelar</button><button type="button" class="btn btn-primary">Agregar</button></div></div></div></div>`);
        
          // Establecemos acción al ocultar modal.
          $('#editarEjemplar').on('hidden.bs.modal', function(){
            $("#editarEjemplar").remove();
          })

          $("#editarEjemplar .btn-primary").click(function(){
            $.ajax({
              type: "POST",
              url: Url + 'Api/RecursosFisicos?Tipo=editarEjemplar',
              data: {
                "Ejemplar": $("#editarEjemplar #EjemplarId").val(),
                "CampoA": $("#editarEjemplar #Inventario").val(),
                "CampoB": $("#editarEjemplar #Parte").val(),
                "CampoC": $("#editarEjemplar #Volumen").val(),
                "CampoD": $("#editarEjemplar #Préstamo").val(),
                "CampoE": $("#editarEjemplar #Procedencia").val(),
                "CampoF": $("#editarEjemplar #Proveedor").val(),
                "CampoG": $("#editarEjemplar #Notas").val(),
                "CampoH": $("#editarEjemplar #Estado").val(),
                "CampoL": $("#editarEjemplar #Ubicación").val(),
                "CampoM": $("#editarEjemplar #Clasificación").val(),
                "CampoN": $("#editarEjemplar #Librística").val(),
              },
              success: function(Datos, textStatus, xhr){
          
                Datos = $.parseJSON(Datos);
          
                if(Datos['estado'] == 'exitoso'){
                  $("#editarEjemplar").modal("hide");
                  const Toast=Swal.mixin({toast:!0,position:"top-end",showConfirmButton:!1,timer:3e3,timerProgressBar:!0,didOpen:e=>{e.addEventListener("mouseenter",Swal.stopTimer),e.addEventListener("mouseleave",Swal.resumeTimer)}});Toast.fire({icon:"success",title:"Ejemplar editado con éxito"});
                  $("#verRegistros").click();
                }else if(Datos['estado'] == 'error'){
                  $("#editarEjemplar #ErrorAlEditarEjemplar").text(`* ${Datos['detalle']} [${Datos['codigo']}]`);
                }else{
                  $("#editarEjemplar #ErrorAlEditarEjemplar").text("* Hubo un error desconocido");
                }           
          
              },
              error: function(){
                $("#editarEjemplar #ErrorAlEditarEjemplar").text("* Hubo un error desconocido");
              }
            })
          })

          // Mostramos el modal.
          $("#editarEjemplar").modal("show");

          // Quitamos mensaje
          Swal.close();

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }else if(Datos['estado'] == 'error'){

          // Mostramos error
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            timer: 3000,
            showConfirmButton: false,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })

          Toast.fire({
            icon: 'error',
            title: `${General["nombreUsuario"]}, hubo un error. ${Datos['detalle']} [${Datos['codigo']}]`
          })

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }else{

          // Mostramos error
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            timer: 3000,
            showConfirmButton: false,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })

          Toast.fire({
            icon: 'error',
            title: `${General["nombreUsuario"]}, hubo un error. Reintentalo o comuníquese con soporte.`
          })

          // Volvemos a cambiar el estado del proceso
          enProcesoDeCambio = 0;

        }

      },
      error: function(){

        // Mostramos error
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          timer: 3000,
          showConfirmButton: false,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })

        Toast.fire({
          icon: 'error',
          title: `${General["nombreUsuario"]}, hubo un error. Reintentalo o comuníquese con soporte.`
        })

        // Volvemos a cambiar el estado del proceso
        enProcesoDeCambio = 0;

      }

    })

  }

}

// Función: Añade nuevo ejemplar a un registo.
function añadirEjemeplar(Id){
  
  // Verificamos si existe el modal. En caso de existir lo ocultamos y eliminamos.
  if($("#añadirEjemplar").length !== 0){

    // Ocultamos el modal.
    $("#añadirEjemplar").modal("hide");

    // Eliminamos modal.
    $("#añadirEjemplar").remove();

  }

  // Creamos modal
  $("body").append(`<div class="modal fade" id="añadirEjemplar" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-hidden="true"><div class="modal-dialog"><div class="modal-content"><div class="modal-header"><h1 class="modal-title fs-5">Añadir ejemplar a el MFN "${Id}"</h1><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body"><form id="añadirEjemplarFormulario"><input type="hidden" id="RecursoId" name="RecursoId" value="${Id}"><input type="text" placeholder="Inventario" class="mt-1 form-control" id="Inventario" name="CampoA"><input type="text" placeholder="Parte" class="mt-1 form-control" id="Parte" name="CampoB"><input type="text" placeholder="Volumen" class="mt-1 form-control" id="Volumen" name="CampoC"><input type="text" placeholder="Préstamo" class="mt-1 form-control" id="Préstamo" name="CampoD"><input type="text" placeholder="Procedencia" class="mt-1 form-control" id="Procedencia" name="CampoE"><input type="text" placeholder="Proveedor" class="mt-1 form-control" id="Proveedor" name="CampoF"><input type="text" placeholder="Notas locales" class="mt-1 form-control" id="Notas" name="CampoG"><input type="text" placeholder="Estado" class="mt-1 form-control" id="Estado" name="CampoH"><input type="text" placeholder="Ubicación" class="mt-1 form-control" id="Ubicación" name="CampoL"><input type="text" placeholder="Clasificación" class="mt-1 form-control" id="Clasificación" name="CampoM"><input type="text" placeholder="Librística" class="mt-1 form-control" id="Librística" name="CampoN"></form></div><a style="margin: 1rem" id="ErrorAlAñadirEjemplar" class="error-form"></a><div class="modal-footer"><button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancelar</button><button type="button" class="btn btn-primary">Agregar</button></div></div></div></div>`);

  // Establecemos acción al ocultar modal.
  $('#añadirEjemplar').on('hidden.bs.modal', function(){
    $("#añadirEjemplar").remove();
  })

  // Al precionar agregar
  $("#añadirEjemplar .btn-primary").click(function(){
    $.ajax({
      type: "POST",
      url: Url + 'Api/RecursosFisicos?Tipo=agregarEjemplar',
      data: {
        "Registro": $("#añadirEjemplar #RecursoId").val(),
        "CampoA": $("#añadirEjemplar #Inventario").val(),
        "CampoB": $("#añadirEjemplar #Parte").val(),
        "CampoC": $("#añadirEjemplar #Volumen").val(),
        "CampoD": $("#añadirEjemplar #Préstamo").val(),
        "CampoE": $("#añadirEjemplar #Procedencia").val(),
        "CampoF": $("#añadirEjemplar #Proveedor").val(),
        "CampoG": $("#añadirEjemplar #Notas").val(),
        "CampoH": $("#añadirEjemplar #Estado").val(),
        "CampoL": $("#añadirEjemplar #Ubicación").val(),
        "CampoM": $("#añadirEjemplar #Clasificación").val(),
        "CampoN": $("#añadirEjemplar #Librística").val(),
      },
      success: function(Datos, textStatus, xhr){
  
        Datos = $.parseJSON(Datos);
  
        if(Datos['estado'] == 'exitoso'){
          $("#añadirEjemplar").modal("hide");
          const Toast=Swal.mixin({toast:!0,position:"top-end",showConfirmButton:!1,timer:3e3,timerProgressBar:!0,didOpen:e=>{e.addEventListener("mouseenter",Swal.stopTimer),e.addEventListener("mouseleave",Swal.resumeTimer)}});Toast.fire({icon:"success",title:"Ejemplar agregado con éxito"});
          verEjemeplares(Id);
        }else if(Datos['estado'] == 'error'){
          $("#añadirEjemplar #ErrorAlAñadirEjemplar").text("* " + Datos['detalle'] + " [" + Datos['codigo'] + "]");
        }else{
          $("#añadirEjemplar #ErrorAlAñadirEjemplar").text("* Hubo un error desconocido");
        }           
  
      },
      error: function(){
        $("#añadirEjemplar #ErrorAlAñadirEjemplar").text("* Hubo un error desconocido");
      }
    })
  })

  // Mostramos modal.
  $('#añadirEjemplar').modal("show");

}

// Función: Elimina registo.
function eliminarRegistro(Titulo, Id){
  Swal.fire({
    title: 'Esta seguro que desea eliminar el registro <code>' + Titulo + '</code> [MFN: #' + Id + ']',
    footer: "<b>No habrá forma de recuperarlo.</b>",
    showCancelButton: true,
    confirmButtonText: 'Si, eliminar',
    cancelButtonText: 'Cancelar',
    showLoaderOnConfirm: true,
    preConfirm: () => {

      $.ajax({
        type: "GET",
        url: Url + 'Api/RecursosFisicos?Tipo=eliminarRegistro&MFN=' + Id,
        success: function(Datos, textStatus, xhr){

          // Establecemos datos
          Datos = $.parseJSON(Datos);

          if(Datos['estado'] == 'exitoso'){
            Swal.fire({
              title: `Registro eliminado con éxito`,
            })
            Tabla.destroy();
            cargarUsuarios();
          }else if(Datos['estado'] == 'error'){
            Swal.fire({
              title: `Hubo un error`,
            })
            Swal.showValidationMessage(Datos['detalle'] + " [" + Datos['codigo'] + "]")
          }else{
            Swal.fire({
              title: `Hubo un error`,
            })
            Swal.showValidationMessage(`Hubo un error desconocido`)
          }

        },
        error: function(){
          Swal.showValidationMessage(`Hubo un error desconocido`)
        }
      })

    },
    allowOutsideClick: () => !Swal.isLoading()
  })
}

// Función: Elimina ejemplar.
function eliminarEjemeplar(Id){
  Swal.fire({
    title: 'Esta seguro que desea eliminar el ejemplar #' + Id,
    footer: "<b>No habra forma de recuperarlo.</b>",
    showCancelButton: true,
    confirmButtonText: 'Si, eliminar',
    cancelButtonText: 'Cancelar',
    showLoaderOnConfirm: true,
    preConfirm: () => {

      $.ajax({
        type: "GET",
        url: Url + 'Api/RecursosFisicos?Tipo=eliminarEjemplar&MFN=' + Id,
        success: function(Datos, textStatus, xhr){

          // Establecemos datos
          Datos = $.parseJSON(Datos);

          if(Datos['estado'] == 'exitoso'){
            Swal.fire({
              title: `Ejemplar eliminado con éxito`,
            })
            Tabla.destroy();
            cargarUsuarios();
          }else if(Datos['estado'] == 'error'){
            Swal.fire({
              title: `Hubo un error`,
            })
            Swal.showValidationMessage(Datos['detalle'] + " [" + Datos['codigo'] + "]")
          }else{
            Swal.fire({
              title: `Hubo un error`,
            })
            Swal.showValidationMessage(`Hubo un error desconocido`)
          }

        },
        error: function(){
          Swal.showValidationMessage(`Hubo un error desconocido`)
        }
      })

    },
    allowOutsideClick: () => !Swal.isLoading()
  })
}

// Función: Obtiene la circulación
$("#circulación").click(function(){

  // Verificamos si se esta cargando algo.
  if(enProcesoDeCambio == 0){

    // Cambiamos estado del proceso
    enProcesoDeCambio = 1;

    // Quitamos modal de gestion ejemplares
    $("#gestionarEjemplares").modal("hide");

    // Mostramos toast
    const Toast = Swal.mixin({
      toast: true,
      position: 'top-end',
      showConfirmButton: false,
      timerProgressBar: true,
      didOpen: (toast) => {
        toast.addEventListener('mouseenter', Swal.stopTimer)
        toast.addEventListener('mouseleave', Swal.resumeTimer)
      }
    })
    
    Toast.fire({
      icon: 'info',
      title: `${General["nombreUsuario"]}, estamos obteniendo la circulación...`
    })

    $.ajax({
      type: "GET",
      contentType: 'application/json; charset=utf-8',
      url: Url + "Api/RecursosFisicos?Tipo=obtenerCirculación",
      success: function(Datos, textStatus, xhr){
  
        // Establecemos datos
        Datos = $.parseJSON(Datos);
          
        // Verificamos estado de la petición
        if(Datos['estado'] == 'exitoso'){

          // Verificamos si existe el modal. En caso de existir lo ocultamos y eliminamos.
          if($("#circulaciónModal").length !== 0){

            // Ocultamos el modal.
            $("#circulaciónModal").modal("hide");

            // Eliminamos modal.
            $("#circulaciónModal").remove();

          }

          // Creamos modal
          $("body").append(`<div class="modal fade" id="circulaciónModal" tabindex="-1" aria-hidden="true"><div class="modal-dialog modal-xl"><div class="modal-content"><div class="modal-header"><h1 class="modal-title fs-5">Circulación de recursos físicos</h1><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body"></div></div></div></div>`);;
          $("#circulaciónModal .modal-body").append('<div style="display: flex;flex-direction: row-reverse;"><button onclick="agregarRetiro()" type="button" class="btn btn-primary">Agregar Retiro</button></div>');
          $("#circulaciónModal .modal-body").append('<table class="table table-fluid" id="Ejemplares"><thead><tr><th class="text-center">Id</th><th>Usuario</th><th>Fecha de retiro</th><th>Fecha de devolución</th><th>Tipo</th><th class="text-center">Cantidad</th><th>Estado</th><th class="text-center">Acciones</th></tr></thead><tbody></tbody></table>');
  
          // Establecemos acción al ocultar modal.
          $('#circulaciónModal').on('hidden.bs.modal', function(){
            $("#circulaciónModal").remove();
          })
          
          // Agrupamos datos para luego insertarla en la tabla.
          for(var i = 0; i < Datos['detalle'].length; i++){
  
            var Tabla = '';
  
            FechaDeRetiro = new Date(Datos['detalle'][i]['FechaDeRetiro']).toLocaleDateString('es-ES', { weekday: 'long', month: 'long', day: 'numeric', hour: '2-digit', year:'numeric', minute:'2-digit'}) + 'hs'
            FechaDeDevolucion = new Date(Datos['detalle'][i]['FechaDeDevolucion']).toLocaleDateString('es-ES', { weekday: 'long', month: 'long', day: 'numeric', year:'numeric', hour: '2-digit', minute:'2-digit'}) + 'hs'
          
            if(Datos['detalle'][i]['Estado'] == 0){
              Tabla += '<tr class="noDevuelto" style="background-color:rgb(255 211 211 / 30%)">';
            }else{
              Tabla += '<tr>';
            }
  
            Tabla += '<td class="text-center">' + Datos['detalle'][i]['Id'] + '</td>';
  
            Tabla += '<td>' + Datos['detalle'][i]['Usuario'] + '</td>';
            
            Tabla += '<td>' + FechaDeRetiro[0].toUpperCase() + FechaDeRetiro.substring(1) + '</td>';
  
            if(Datos['detalle'][i]['TipoDeRetiro'] == 0 && Datos['detalle'][i]['Estado'] == 0){
              Tabla += '<td>-</td>';
            }else if(Datos['detalle'][i]['TipoDeRetiro'] == 1 && Datos['detalle'][i]['Estado'] == 0){
              Tabla += '<td data-bs-toggle="tooltip" data-bs-title="Advertencia, esta fecha esta indicada por el usuario, no hay garantía que sea devuelto en la hora indicada."> <i class="fa-light fa-circle-info"></i> ' + FechaDeDevolucion[0].toUpperCase() + FechaDeDevolucion.substring(1) + '</td>';
            }else{
              Tabla += '<td>' + FechaDeDevolucion[0].toUpperCase() + FechaDeDevolucion.substring(1) + '</td>';
            }
  
            if(Datos['detalle'][i]['TipoDeRetiro'] == 0){
              Tabla += '<td>Salón</td>';
            }else{
              Tabla += '<td>Domicilio</td>';
            }
  
            Tabla += '<td class="text-center">' + Datos['detalle'][i]['RecursosRetirados'].length + '</td>';
  
            if(Datos['detalle'][i]['Estado'] == 0){
              Tabla += '<td>No devuelto</td>';
            }else{
              Tabla += '<td>Devuelto</td>';
            }
  
            var RecursosRetirados = '';
            for(var a = 0; a < Datos['detalle'][i]['RecursosRetirados'].length; a++){
              if(a > 0){RecursosRetirados += "<br>"}
              RecursosRetirados += Datos['detalle'][i]['RecursosRetirados'][a];
            }
            
  
            Tabla += '<td class="text-center">';
            
            if(Datos['detalle'][i]['Estado'] == 1){
              Tabla += '<i data-bs-toggle="popover" data-bs-html="true" data-bs-title="Informacion adicional" data-bs-html="true"  data-bs-content="<b>Reseña:</b><p style=' + "'margin-left:1rem'" + '>' + Datos['detalle'][i]['Reseña'] + '</p><b>Observación:</b><br><p style=' + "'margin-left:1rem'" + '>' + Datos['detalle'][i]['Observacion'] + '</p>" class="mr-1 ml-1 fa-duotone fa-circle-info"></i>';
            }
  
            Tabla += '<i data-bs-toggle="popover" data-bs-title="Recursos retirados" data-bs-html="true"  data-bs-content="' + RecursosRetirados + '" class="mr-1 ml-1 fa-duotone fa-books"></i>'; 
            
            if(Datos['detalle'][i]['Estado'] == 0){
              Tabla += `<i data-bs-toggle="tooltip" onclick="marcarComoDevuelto(${Datos['detalle'][i]['Id']})" data-bs-title="Marcar como devuelto" class="mr-1 ml-1 fa-duotone fa-file-import"></i></td>`;
            }
  
            Tabla += '</tr>';
  
            $("#circulaciónModal .modal-body tbody").append(Tabla);
  
          }
  
          // Habilitamos Tooltip y Popover
          $("[data-bs-toggle='tooltip']").tooltip();
          $("[data-bs-toggle='popover']").popover();

          // Establecemos tabla
          $('#circulaciónModal table').DataTable({
            "order": [[0, "desc"]],
            "language": {
              "sProcessing":    "Procesando...",
              "sLengthMenu":    "Mostrar _MENU_ retiros",
              "sZeroRecords":   "No se encontraron resultados",
              "sEmptyTable":    "Ningún dato disponible en esta tabla",
              "sInfo":          "Mostrando retiros del _START_ al _END_ de un total de _TOTAL_ retiros",
              "sInfoEmpty":     "Mostrando retiros del 0 al 0 de un total de 0 retiros",
              "sInfoFiltered":  "(filtrado de un total de _MAX_ retiros)",
              "sInfoPostFix":   "",
              "sSearch":        "Buscar:",
              "sUrl":           "",
              "sInfoThousands":  ",",
              "sLoadingRecords": "Cargando...",
              "oPaginate": {
                "sFirst":    "Primero",
                "sLast":    "Último",
                "sNext":    "Siguiente",
                "sPrevious": "Anterior"
              },
              "oAria": {
                "sSortAscending":  ": Activar para ordenar la columna de manera ascendente",
                "sSortDescending": ": Activar para ordenar la columna de manera descendente"
              }
            }
          });

          // Abrimos modal
          $("#circulaciónModal").modal("show");

          // Quitamos alerta
          Swal.close();

          // Cambiamos estado del proceso
          enProcesoDeCambio = 0;
  
  
        }else if(Datos['estado'] == 'error'){
  
          Swal.fire({
            icon: 'error',
            title: 'Hubo un error',
            text: Datos['detalle'] + ' [' + Datos['codigo'] + ']',
            footer: '<a>Para mas información comuníquese con</a><a class="ml-1" href="mailto:hola@sibau.com.ar"> hola@sibau.com.ar</a>'
          })

          // Cambiamos estado del proceso
          enProcesoDeCambio = 0;
  
        }else{
          Swal.fire({
            icon: 'error',
            title: 'Hubo un error',
            text: 'Hubo un error desconocido.',
            footer: '<a>Para mas información comuníquese con</a><a class="ml-1" href="mailto:hola@sibau.com.ar"> hola@sibau.com.ar</a>'
          })

          // Cambiamos estado del proceso
          enProcesoDeCambio = 0;
        }
  
      },
      error: function(){
        Swal.fire({
          icon: 'error',
          title: 'Hubo un error',
          text: 'Hubo un error desconocido.',
          footer: '<a>Para mas información comuníquese con</a><a class="ml-1" href="mailto:hola@sibau.com.ar"> hola@sibau.com.ar</a>'
        })

        // Cambiamos estado del proceso
        enProcesoDeCambio = 0;
      }
    })

  }

})

// Función: Marca como devuelto un retiro
function marcarComoDevuelto(Operación){
            
  $.ajax({
    type: "GET",
    url: Url + 'Api/RecursosFisicos',
    data: {"Tipo": "marcarRetiroDevuelto", "Operación": Operación},
    success: function(Datos, textStatus, xhr){

      // Establecemos los datos
      Datos = $.parseJSON(Datos);

      // Verificamos estado de la petición
      if(Datos['estado'] == 'exitoso'){
        $("#circulaciónModal").modal("hide");
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
        
        Toast.fire({
          icon: 'success',
          title: 'Haz marcado como duevuelto la operación.'
        })
      }else if(Datos['estado'] == 'error'){
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
        
        Toast.fire({
          icon: 'error',
          title: Datos['detalle'] + ' [' + Datos['codigo'] + ']'
        })
      }else{
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
        
        Toast.fire({
          icon: 'error',
          title: 'Hubo un error desconocido.'
        })
      }

    },
    error: function(){
      const Toast = Swal.mixin({
        toast: true,
        position: 'top-end',
        showConfirmButton: false,
        timer: 3000,
        timerProgressBar: true,
        didOpen: (toast) => {
          toast.addEventListener('mouseenter', Swal.stopTimer)
          toast.addEventListener('mouseleave', Swal.resumeTimer)
        }
      })
      
      Toast.fire({
        icon: 'error',
        title: 'Hubo un error desconocido.'
      })
    }
  })

}

function agregarRetiro(){

  // Cerramos modal
  $("#circulaciónModal").modal("hide");

  // Verificamos si existe el modal. En caso de existir lo ocultamos y eliminamos.
  if($("#agregarRetiroModal").length !== 0){

    // Ocultamos el modal.
    $("#agregarRetiroModal").modal("hide");

    // Eliminamos modal.
    $("#agregarRetiroModal").remove();

  }

  // Creamos modal
  $("body").append(`<div class="modal fade" data-bs-backdrop="static" data-bs-keyboard="false" id="agregarRetiroModal" tabindex="-1" aria-hidden="true"><div class="modal-dialog modal-dialog-centered modal-dialog-scrollable"><div class="modal-content"><div class="modal-header"><h1 class="modal-title fs-5">Agregar retiro</h1><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body"></div></div></div></div>`);;
  $("#agregarRetiroModal .modal-body").append("<form><div class='mb-3'><label class='form-label'>Usuario</label><select id='Usuario' name='Usuario' class='form-select'><option disabled selected>Obteniendo lista de usuarios...</option></select></div></form>");

  // Establecemos acción al ocultar modal.
  $('#agregarRetiroModal').on('hidden.bs.modal', function(){
    $("#agregarRetiroModal").remove();
  })

  // Mostramos modal
  $("#agregarRetiroModal").modal("show");
  
  // Realiamos petición
  $.ajax({
    type: "GET",
    url: Url + 'Api/Usuarios',
    data: {"Tipo": "ObtenerListado"},
    success: function(Datos, textStatus, xhr){
  
      // Establecemos los datos
      Datos = $.parseJSON(Datos);

      // Verificamos estado de la petición
      if(Datos['estado'] == 'exitoso'){

        $("#agregarRetiroModal .modal-body #Usuario option").remove();

        for(var i = 0; i < Datos['detalle'].length; i++){
          $("#agregarRetiroModal .modal-body #Usuario").append("<option value='" + Datos['detalle'][i]["Id"] + "'>" + Datos['detalle'][i]["Nombre"] + " " + Datos['detalle'][i]["Apellido"] + " [" + Datos['detalle'][i]["DNI"]  + "]</option>")
        }

        $("#Usuario").select2({
          placeholder: 'Seleccione un usuario',
          dropdownParent: $('#agregarRetiroModal')
        });

        $("#Retirar").attr("Disabled", false);
        $("#Retirar").text("Retirar");

      }else if(Datos['estado'] == 'error'){
        $("#agregarRetiroModal .modal-body #Usuario option").text(Datos['detalle'] + " [" + Datos['codigo'] + "]");
        $("#Retirar").attr("Disabled", false);
        $("#Retirar").text("Retirar");
      }else{
        $("#agregarRetiroModal .modal-body #Usuario option").text("Hubo un error desconocido");
        $("#Retirar").attr("Disabled", false);
        $("#Retirar").text("Retirar");
      }

    },
    error: function(){
      $("#agregarRetiroModal .modal-body select option").text("Hubo un error desconocido");
    }
  })

  $("#agregarRetiroModal .modal-body").append('<div class="mb-3"><label for="Lista" class="form-label">Recursos a retirar</label><select aria-describedby="ListaAyuda" class="js-example-basic-single" id="Lista" name="Lista[]" multiple="multiple" id="Lista"><option disabled selected>Cargando registros</option></select><div id="ListaAyuda" class="form-text">En caso de ser mas de un recurso, seleccione todos los que se lleva.</div></div>');

  $.ajax({
    type: "GET",
    url: Url + 'Api/RecursosFisicos',
    data: {"Tipo": "ObtenerListadoRetiro"},
    success: function(Datos, textStatus, xhr){
        
      // Establecemos datos
      Datos = $.parseJSON(Datos);
        
      // Verificamos estado de la petición
      if(Datos['estado'] == 'exitoso'){
        
        var Lista = '<option disabled>Seleccione al menos un recurso</option>';
        
        for(var i = 0; i < Datos['detalle'].length; i++){

          if(Datos['detalle'][i]['Estado'] == 0){
            Lista += "<option value='" + Datos['detalle'][i]['Id'] + "'>#" + Datos['detalle'][i]['Inventario']+ " - " + Datos['detalle'][i]['Titulo']['a'] + "</option>";
          }else if(Datos['detalle'][i]['Estado'] == 1){
            Lista += "<option disabled value='" + Datos['detalle'][i]['Id'] + "'>#" + Datos['detalle'][i]['Inventario'] + " - " + Datos['detalle'][i]['Titulo']['a'] + " [EN USO]</option>";
          }else{
            Lista += "<option disabled value='" + Datos['detalle'][i]['Id'] + "'>#" + Datos['detalle'][i]['Inventario'] + " - " + Datos['detalle'][i]['Titulo']['a'] + " [NO DISPONIBLE]</option>";
          }
       
        }
        
        $('#Lista').html(Lista);
        $('#Lista').select2({
          language: "es",
          width: "100%"
        });
                  
      }else if(Datos['estado'] == 'error'){
        $("#agregarRetiroModal .modal-body #Lista option").text(Datos['detalle'] + " [" + Datos['codigo'] + "]");
      }else{
        $("#agregarRetiroModal .modal-body #Lista option").text("Hubo un error desconocido");
      }
        
    },
    error: function(){
      $("#agregarRetiroModal .modal-body #Lista option").text("Hubo un error desconocido");
    }
  })

  $("#agregarRetiroModal .modal-body").append('<div class="mb-3"><label for="Lista" class="form-label">Seleccione el tipo de retiro</label><div class="form-check"><input value="0" class="form-check-input" type="radio" name="tipoDeRetiro" id="retiroSalon"><label class="form-check-label" for="retiroSalon">Al Salón</label></div><div class="form-check"><input value="1" class="form-check-input" type="radio" name="tipoDeRetiro" id="retiroDomicilio"><label class="form-check-label" for="retiroDomicilio">A Domicilio</label></div></div>');
        
  $("#agregarRetiroModal .modal-body").append('<div class="mb-3 Fecha"><label for="FechaRetiro" class="form-label">Fecha de retiro</label><input class="form-control" type="datetime-local" id="FechaRetiro" name="FechaRetiro"></div><div class="mb-3 Fecha"><label for="FechaDevolición" class="form-label">Fecha de devolución</label><input class="form-control" type="datetime-local" id="FechaDevolición" name="FechaDevolición"></div>')

  const now = new Date();
  const year = now.getFullYear();
  const month = String(now.getMonth() + 1).padStart(2, '0');
  const day = String(now.getDate()).padStart(2, '0');
  const hours = String(now.getHours()).padStart(2, '0');
  const minutes = String(now.getMinutes()).padStart(2, '0');

  $("#FechaRetiro").attr("value", `${year}-${month}-${day}T${hours}:${minutes}`);
  $("#FechaRetiro").attr("min", `${year}-${month}-${day}T${hours}:${minutes}`);

  $("#FechaDevolición").attr("value", `${year}-${month}-${day}T${hours}:${minutes}`);
  $("#FechaDevolición").attr("min", `${year}-${month}-${day}T${hours}:${minutes}`);

  $("#agregarRetiroModal .modal-body").append('<div class="row mt-2 botones"><div class="col-6"><button onclick="' + "$('#agregarRetiroModal').modal('hide')" + '" type="button" class="w-100 btn btn-danger">Cancelar</button></div><div class="col-6"><button id="Retirar" type="button" class="w-100 btn btn-primary">Retirar</button></div></div>');

  $("#agregarRetiroModal #Retirar").on("click", function(){

    $(this).attr("Disabled", true);
    $(this).html('<i class="fa-light fa-spinner-third fa-spin"></i> Cargando');
    $("errores").remove();

    $.ajax({
      type: "GET",
      url: Url + 'Api/RecursosFisicos',
      data: {"Tipo": "generarRetiro", "Usuario": $("#agregarRetiroModal #Usuario").val(), "Ejemplares": $("#agregarRetiroModal #Lista").val(), "TipoRetiro": $("#agregarRetiroModal [name='tipoDeRetiro']:checked").val(), "FechaRetiro": $("#agregarRetiroModal #FechaRetiro").val(), "FechaDevolición": $("#agregarRetiroModal #FechaDevolición").val()},
      success: function(Datos, textStatus, xhr){
                      
        // Establecemos datos
        Datos = $.parseJSON(Datos);
        
        // Verificamos estado de la petición
        if(Datos['estado'] == 'exitoso'){
          $("#agregarRetiroModal").modal("hide");
        }else if(Datos['estado'] == 'error'){
          $("#agregarRetiroModal .botones").before('<errores style="margin: 1rem;"><i class="fa-solid fa-circle-exclamation" style="color: red;"></i> ' + Datos['detalle'] + ' [' + Datos['codigo'] + ']</errores>');
          $(this).attr("Disabled", false);
          $(this).text('Retirar');
        }else{
          $("#agregarRetiroModal .botones").before('<errores style="margin: 1rem;"><i class="fa-solid fa-circle-exclamation" style="color: red;"></i> Hubo un error desconocido.</errores>');
          $(this).attr("Disabled", false);
          $(this).text('Retirar');
        }

      },
      error: function(){
        $("#agregarRetiroModal .botones").before('<errores style="margin: 1rem;"><i class="fa-solid fa-circle-exclamation" style="color: red;"></i> Hubo un error desconocido.</errores>');
        $(this).attr("Disabled", false);
        $(this).text('Retirar');
      }
    })
  })

}

var Campos = [
  {
    "Nombre": "020",
    "Descripción": "ISBN",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "ISBN",
        "Descripción": "Número Internacional Normalizado para Libros.",
      }
    ],
    "Repetible": 1,     
  },
  {
    "Nombre": "022",
    "Descripción": "ISSN",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "ISSN",
        "Descripción": "Número Internacional Normalizado para Publicaciones Periódicas.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "100",
    "Descripción": "Autor personal – asiento principal",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Autor",
        "Descripción": "Nombre del autor personal.",
      },
      {
        "Campo": "b",
        "Nombre": "Numeración",
        "Descripción": "Número romano asociado al nombre.",
      },
      {
        "Campo": "c",
        "Nombre": "Títulos",
        "Descripción": "Títulos y otras palabras asociadas al nombre.",
      },
      {
        "Campo": "d",
        "Nombre": "Fechas",
        "Descripción": "Fechas de nacimiento y muerte del autor.",
      }
    ],
    "Repetible": 0, 
  },
  {
    "Nombre": "110",
    "Descripción": "Autor institucional – asiento principal",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Entidad o lugar",
        "Descripción": "Nombre de la entidad o lugar como elemento inicial.",
      },
      {
        "Campo": "b",
        "Nombre": "Entidad subordinada",
        "Descripción": "Entidad subordinada a la registrada en el subcampo precedente.",
      },
      {
        "Campo": "c",
        "Nombre": "Sigla",
        "Descripción": "Sigla de la entidad",
      }
    ],
    "Repetible": 0, 
  },
  {
    "Nombre": "111",
    "Descripción": "Conferencia",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Conferencia",
        "Descripción": "Nombre de la conferencia.",
      },
      {
        "Campo": "n",
        "Nombre": "Número",
        "Descripción": "Número de la conferencia.",
      },
      {
        "Campo": "d",
        "Nombre": "Fecha",
        "Descripción": "Año de la conferencia.",
      },
      {
        "Campo": "c",
        "Nombre": "Lugar",
        "Descripción": "Ciudad y país.",
      }
    ],
    "Repetible": 0, 
  },
  {
    "Nombre": "245",
    "Descripción": "Título",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Título",
        "Descripción": "Título propiamente dicho.",
      },
      {
        "Campo": "n",
        "Nombre": "Número",
        "Descripción": "Número de la parte o sección de la obra.",
      },
      {
        "Campo": "h",
        "Nombre": "DGM",
        "Descripción": "Designación General del Material.",
      },
      {
        "Campo": "b",
        "Nombre": "Subtítulo",
        "Descripción": "Subtítulo, información complementaria y títulos paralelos.",
      },
      {
        "Campo": "c",
        "Nombre": "Mención",
        "Descripción": "Mención de responsabilidad y resto de transcripción de la portada.",
      }
    ],
    "Repetible": 0, 
  },
  {
    "Nombre": "246",
    "Descripción": "Variantes del título",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Título",
        "Descripción": "Título de la variante.",
      },
      {
        "Campo": "b",
        "Nombre": "Subtítulo",
        "Descripción": "Subtítulo de la variante del título.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "250",
    "Descripción": "Edición",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Edición",
        "Descripción": "Número de la edición.",
      }
    ],
    "Repetible": 0, 
  },
  {
    "Nombre": "255",
    "Descripción": "Escala y proyección",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Escala",
        "Descripción": "Escala en la que está representada el área geográfica.",
      },
      {
        "Campo": "b",
        "Nombre": "Proyección",
        "Descripción": "Técnica de proyección con la que se representó un área geográfica.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "260",
    "Descripción": "Publicación",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Lugar",
        "Descripción": "Lugar de publicación, distribución, etc.",
      },
      {
        "Campo": "b",
        "Nombre": "Editor",
        "Descripción": "Nombre del editor, distribuidor, etc.",
      },
      {
        "Campo": "c",
        "Nombre": "Fecha",
        "Descripción": "Fecha de publicación, distribución, etc.",
      }
    ],
    "Repetible": 0, 
  },
  {
    "Nombre": "300",
    "Descripción": "Descripción física",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Extensión, DEM y Duración",
        "Descripción": "Extensión, Designación Específica del Material y minutos.",
      },
      {
        "Campo": "b",
        "Nombre": "Otras detalles físicos",
        "Descripción": "Características físicas.",
      },
      {
        "Campo": "c",
        "Nombre": "Dimensiones",
        "Descripción": "Alto por ancho.",
      },
      {
        "Campo": "e",
        "Nombre": "Material complementario",
        "Descripción": "Material que acompaña al ítem.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "309",
    "Descripción": "Soporte",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Soporte",
        "Descripción": "Soporte específico del documento.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "310",
    "Descripción": "Frecuencia",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Frecuencia",
        "Descripción": "Periodicidad de publicación.",
      }
    ],
    "Repetible": 0, 
  },
  {
    "Nombre": "362",
    "Descripción": "Inicio y cese",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Inicio-cese",
        "Descripción": "Designación alfabética, numérica y/o cronológica.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "440",
    "Descripción": "Colección",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Título",
        "Descripción": "Nombre de la colección o serie.",
      },
      {
        "Campo": "p",
        "Nombre": "Subserie",
        "Descripción": "Nombre de la parte o sección.",
      },
      {
        "Campo": "v",
        "Nombre": "Volumen",
        "Descripción": "Número de volumen.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "500",
    "Descripción": "Nota general",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Nota",
        "Descripción": "Nota general.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "505",
    "Descripción": "Nota de contenido",
    "Subcampos": [
      {
        "Campo": "t",
        "Nombre": "Título",
        "Descripción": "Título.",
      },
      {
        "Campo": "r",
        "Nombre": "Autor",
        "Descripción": "Autor asociado al título.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "520",
    "Descripción": "Resumen",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Resumen",
        "Descripción": "Nota de sumario, resumen, etc.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "521",
    "Descripción": "Nivel",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Nivel",
        "Descripción": "Ciclo del sistema educativo al que se dirige.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "600",
    "Descripción": "Término de materia – nombre de persona",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Nombre",
        "Descripción": "Nombre de la persona que se quiere destacar.",
      },
      {
        "Campo": "b",
        "Nombre": "Numeración",
        "Descripción": "Número romano asociado al nombre.",
      },
      {
        "Campo": "c",
        "Nombre": "Títulos",
        "Descripción": "Títulos y otras palabras asociadas al nombre.",
      },
      {
        "Campo": "d",
        "Nombre": "Fechas",
        "Descripción": "Fechas de nacimiento y muerte de la persona.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "650",
    "Descripción": "Término de materia - controlado",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Término controlado",
        "Descripción": "Término de materia controlado.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "651",
    "Descripción": "Término de materia - geográfico",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Término geográfico",
        "Descripción": "Término de materia geográfico.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "653",
    "Descripción": "Término de materia - propuesto",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Término propuesto",
        "Descripción": "Término de materia propuesto.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "659",
    "Descripción": "Tema",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Tema",
        "Descripción": "Disciplina.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "700",
    "Descripción": "Autor personal – asiento secundario",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Autor",
        "Descripción": "Nombre del autor personal secundario.",
      },
      {
        "Campo": "b",
        "Nombre": "Numeración",
        "Descripción": "Número romano asociado al nombre.",
      },
      {
        "Campo": "c",
        "Nombre": "Títulos",
        "Descripción": "Títulos y otras palabras asociadas al nombre.",
      },
      {
        "Campo": "d",
        "Nombre": "Fechas",
        "Descripción": "Fechas de nacimiento y muerte del autor.",
      },
      {
        "Campo": "e",
        "Nombre": "Función",
        "Descripción": "Función que desempeña el autor en función a la obra.",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "710",
    "Descripción": "Autor institucional – asiento secundario",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Entidad o lugar",
        "Descripción": "Nombre de la entidad o lugar como elemento inicial.",
      },
      {
        "Campo": "b",
        "Nombre": "Entidad subordinada",
        "Descripción": "Entidad subordinada a la registrada en el subcampo precedente.",
      },
      {
        "Campo": "c",
        "Nombre": "Sigla",
        "Descripción": "Sigla de la entidad",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "740",
    "Descripción": "Otros títulos",
    "Subcampos": [
      {
        "Campo": "a",
        "Nombre": "Título",
        "Descripción": "Título y subtítulo",
      }
    ],
    "Repetible": 1, 
  },
  {
    "Nombre": "773",
    "Descripción": "Documento fuente",
    "Subcampos": [
      {
        "Campo": "t",
        "Nombre": "Título y mención",
        "Descripción": "Título y mención de la parte mayor.",
      },
      {
        "Campo": "d",
        "Nombre": "Lugar, editor y fecha",
        "Descripción": "Datos de publicación de la parte mayor.",
      },
      {
        "Campo": "g",
        "Nombre": "Parte relacionada",
        "Descripción": "Parte en la que está comprendida la analítica",
      }
    ],
    "Repetible": 1, 
  }
];

var Camp2 = Campos;
function añadirRecurso(){
  var Modal = '';

  var Modal = '<div class="modal fade" id="agregarRecurso" tabindex="-1" aria-hidden="true"><div class="modal-dialog modal-xl"><div class="modal-content"><div class="modal-header"><h1 class="modal-title fs-5">Agregar recurso físico</h1><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body"><form id="añadirRecursoFisico"></form></div><div class="modal-footer"><button type="button" onclick="revisarAgregación()" class="btn btn-primary">Agregar</button></div></div></div></div>';
  $("body").append(Modal);
  $("#agregarRecurso").modal("show");
  $('#agregarRecurso').on('hidden.bs.modal', function(){
    $("#agregarRecurso").remove();
  })

  for(i = 0; i < Campos.length; i++){
    $("#agregarRecurso .modal-body form").append("<div class='Campo mt-3' campoint=" + i + " campo='" + Campos[i]['Nombre'] + "'><h6>" + Campos[i]['Descripción'] + " [" + Campos[i]['Nombre'] + "]</h6><div rep='0' class='row ml-4 mt-4'></div>");
    if(Campos[i]['Repetible'] == 1){
      $("#agregarRecurso .modal-body form").append("<div class='agregarCampo' campoAgregar='" + Campos[i]['Nombre'] + "' style='text-align: center; margin: 1rem; font-weight: 600; color: #ff3939;'><a>Agregar campo nuevo</a></div>");
    }

    for(a = 0; a < Campos[i]['Subcampos'].length; a++){
      $("#agregarRecurso .modal-body .Campo[campo='" + Campos[i]['Nombre'] + "'] .row").append('<div class="col-6 mb-2"><label style="font-weight: 600" class="form-label">' + Campos[i]['Subcampos'][a]['Nombre'] + '</label><input campoIDENT="' + Campos[i]['Subcampos'][a]['Campo'] + '" type="text" class="form-control" name="' + Campos[i]['Nombre'] + '[' + Campos[i]['Subcampos'][a]['Campo'] + ']"><div class="form-text">' + Campos[i]['Subcampos'][a]['Descripción'] + '</div></div>');
    }
  }

  var Rep = 0;

  $(".agregarCampo").click(function(){
    Rep++;
    var Campo = $(this).attr("campoAgregar");
    var CampoINT = Campos.find(e => e['Nombre'] == $(this).attr("campoAgregar"));
    $("#agregarRecurso .modal-body .Campo[campo=" + Campo + "]").append("<div rep='" + Rep + "' class='row ml-4 mt-4'><hr style='border: 1.5px solid; width: 90%;'></div>");
    for(b = 0; b < CampoINT['Subcampos'].length; b++){
      $("#agregarRecurso .modal-body [rep='" + Rep + "']").append('<div class="col-6 mb-2"><label style="font-weight: 600" class="form-label">' + CampoINT['Subcampos'][b]['Nombre'] + '</label><input  campoIDENT="' + CampoINT['Subcampos'][b]['Campo'] + '"type="text"  name="' + Campo + '[' + CampoINT['Subcampos'][b]['Campo'] + ']" class="form-control" id=""><div class="form-text">' + CampoINT['Subcampos'][b]['Descripción'] + '</div></div>');
    }
  })

}

// Se realizo hasta repetibles con un solo subcampo
function revisarAgregación() {

  $(".error-form").remove();

  const DatosAInsertar = {};

  for(a = 0; a < Camp2.length; a++){
    if(Camp2[a]['Repetible'] == 1){
      DatosAInsertar[Camp2[a]['Nombre']] = [];
    }else{

      DatosAInsertar[Camp2[a]['Nombre']] = {};
    }
  }

  // CAMPO 020
  var ContenidoCampo020 = [];
  for(b = 0; b < Number($("[campo='020']").children().length)-1; b++){
    ContenidoCampo020.push({"a":$("[campo='020'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["020"] = ContenidoCampo020;

  // CAMPO 022
  var ContenidoCampo022 = [];
  for(b = 0; b < Number($("[campo='022']").children().length)-1; b++){
    ContenidoCampo022.push({"a":$("[campo='022'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["022"] = ContenidoCampo022;

  // CAMPO 100
  DatosAInsertar["100"] = {
    "a": $("[name='100[a]']").val(),
    "b": $("[name='100[b]']").val(),
    "c": $("[name='100[c]']").val(),
    "d": $("[name='100[d]']").val(),
  }

  // CAMPO 110
  DatosAInsertar["110"] = {
    "a": $("[name='110[a]']").val(),
    "b": $("[name='110[b]']").val(),
    "c": $("[name='110[c]']").val(),
  }

  // CAMPO 111
  DatosAInsertar["111"] = {
    "a": $("[name='111[a]']").val(),
    "n": $("[name='111[n]']").val(),
    "d": $("[name='111[d]']").val(),
    "c": $("[name='111[c]']").val(),
  }

  // CAMPO 245
  DatosAInsertar["245"] = {
    "a": $("[name='245[a]']").val(),
    "n": $("[name='245[n]']").val(),
    "h": $("[name='245[h]']").val(),
    "b": $("[name='245[b]']").val(),
    "c": $("[name='245[c]']").val(),
  }

  // CAMPO 246
  var ContenidoCampo246 = [];
  for(b = 0; b < $("[campo='246'] [rep]").length; b++){

    const contenidoInterno = {"a":"","b":""};
    for(c = 0; c < $("[campo='246'] [rep]").eq(b).children().length; c++){  
      contenidoInterno[$("[campo='246'] [rep]").eq(b).children().eq(c).children().eq(1).attr("campoIDENT")] = $("[campo='246'] [rep]").eq(b).children().eq(c).children().eq(1).val();
    }
    ContenidoCampo246.push(contenidoInterno);

  }
  DatosAInsertar["246"] = ContenidoCampo246;

  // CAMPO 250
  DatosAInsertar["250"] = {"a": $("[name='250[a]']").val()}

  // CAMPO 255
  var ContenidoCampo255 = [];
  for(b = 0; b < $("[campo='255'] [rep]").length; b++){

    const contenidoInterno = {"a":"","b":""};
    for(c = 0; c < $("[campo='255'] [rep]").eq(b).children().length; c++){  
      contenidoInterno[$("[campo='255'] [rep]").eq(b).children().eq(c).children().eq(1).attr("campoIDENT")] = $("[campo='255'] [rep]").eq(b).children().eq(c).children().eq(1).val();
    }
    ContenidoCampo255.push(contenidoInterno);

  }
  DatosAInsertar["255"] = ContenidoCampo255;

  // CAMPO 260
  DatosAInsertar["260"] = {
    "a": $("[name='260[a]']").val(),
    "b": $("[name='260[b]']").val(),
    "c": $("[name='260[c]']").val(),
  }

  // CAMPO 300
  var ContenidoCampo300 = [];
  for(b = 0; b < $("[campo='300'] [rep]").length; b++){

    const contenidoInterno = {"a":"","b":"","c":"","e":""};
    for(c = 0; c < $("[campo='300'] [rep]").eq(b).children().length; c++){  
      contenidoInterno[$("[campo='300'] [rep]").eq(b).children().eq(c).children().eq(1).attr("campoIDENT")] = $("[campo='300'] [rep]").eq(b).children().eq(c).children().eq(1).val();
    }
    ContenidoCampo300.push(contenidoInterno);

  }
  DatosAInsertar["300"] = ContenidoCampo300;

  // CAMPO 309
  var ContenidoCampo309 = [];
  for(b = 0; b < Number($("[campo='309']").children().length)-1; b++){
    ContenidoCampo309.push({"a": $("[campo='309'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["309"] = ContenidoCampo309;

  // CAMPO 310
  DatosAInsertar["310"] = {
    "a": $("[name='310[a]']").val(),
  }

  // CAMPO 362
  var ContenidoCampo362 = [];
  for(b = 0; b < Number($("[campo='362']").children().length)-1; b++){
    ContenidoCampo362.push({"a":$("[campo='362'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["362"] = ContenidoCampo362;

  // CAMPO 440
  var ContenidoCampo440 = [];
  for(b = 0; b < $("[campo='440'] [rep]").length; b++){

    const contenidoInterno = {"a":"","p":"","v":""};
    for(c = 0; c < $("[campo='440'] [rep]").eq(b).children().length; c++){  
      contenidoInterno[$("[campo='440'] [rep]").eq(b).children().eq(c).children().eq(1).attr("campoIDENT")] = $("[campo='440'] [rep]").eq(b).children().eq(c).children().eq(1).val();
    }
    ContenidoCampo440.push(contenidoInterno);

  }
  DatosAInsertar["440"] = ContenidoCampo440;

  // CAMPO 500
  var ContenidoCampo500 = [];
  for(b = 0; b < Number($("[campo='500']").children().length)-1; b++){
    ContenidoCampo500.push({"a": $("[campo='500'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["500"] = ContenidoCampo500;

  // CAMPO 505
  var ContenidoCampo505 = [];
  for(b = 0; b < $("[campo='505'] [rep]").length; b++){

    const contenidoInterno = {"a":"","p":"","v":""};
    for(c = 0; c < $("[campo='505'] [rep]").eq(b).children().length; c++){  
      contenidoInterno[$("[campo='505'] [rep]").eq(b).children().eq(c).children().eq(1).attr("campoIDENT")] = $("[campo='505'] [rep]").eq(b).children().eq(c).children().eq(1).val();
    }
    ContenidoCampo505.push(contenidoInterno);

  }
  DatosAInsertar["505"] = ContenidoCampo505;

  // CAMPO 520
  var ContenidoCampo520 = [];
  for(b = 0; b < Number($("[campo='520']").children().length)-1; b++){
    ContenidoCampo520.push({"a": $("[campo='520'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["520"] = ContenidoCampo520;

  // CAMPO 521
  var ContenidoCampo521 = [];
  for(b = 0; b < Number($("[campo='521']").children().length)-1; b++){
    ContenidoCampo521.push({"a": $("[campo='521'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["521"] = ContenidoCampo521;

  // CAMPO 600
  var ContenidoCampo600 = [];
  for(b = 0; b < $("[campo='600'] [rep]").length; b++){

    const contenidoInterno = {"a":"","b":"","c":"","d":""};
    for(c = 0; c < $("[campo='600'] [rep]").eq(b).children().length; c++){  
      contenidoInterno[$("[campo='600'] [rep]").eq(b).children().eq(c).children().eq(1).attr("campoIDENT")] = $("[campo='600'] [rep]").eq(b).children().eq(c).children().eq(1).val();
    }
    ContenidoCampo600.push(contenidoInterno);

  }
  DatosAInsertar["600"] = ContenidoCampo600;

  // CAMPO 650
  var ContenidoCampo650 = [];
  for(b = 0; b < Number($("[campo='650']").children().length)-1; b++){
    ContenidoCampo650.push({"a": $("[campo='650'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["650"] = ContenidoCampo650;

  // CAMPO 651
  var ContenidoCampo651 = [];
  for(b = 0; b < Number($("[campo='651']").children().length)-1; b++){
    ContenidoCampo651.push({"a": $("[campo='651'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["651"] = ContenidoCampo651;

  // CAMPO 653
  var ContenidoCampo653 = [];
  for(b = 0; b < Number($("[campo='653']").children().length)-1; b++){
    ContenidoCampo653.push({"a":$("[campo='653'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["653"] = ContenidoCampo653;

  // CAMPO 659
  var ContenidoCampo659 = [];
  for(b = 0; b < Number($("[campo='659']").children().length)-1; b++){
    ContenidoCampo659.push({"a":$("[campo='659'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["659"] = ContenidoCampo659;

  // CAMPO 700
  var ContenidoCampo700 = [];
  for(b = 0; b < $("[campo='700'] [rep]").length; b++){

    const contenidoInterno = {"a":"","b":"","c":"","d":"","e":""};
    for(c = 0; c < $("[campo='700'] [rep]").eq(b).children().length; c++){  
      contenidoInterno[$("[campo='700'] [rep]").eq(b).children().eq(c).children().eq(1).attr("campoIDENT")] = $("[campo='700'] [rep]").eq(b).children().eq(c).children().eq(1).val();
    }
    ContenidoCampo700.push(contenidoInterno);

  }
  DatosAInsertar["700"] = ContenidoCampo700;

  // CAMPO 710
  var ContenidoCampo710 = [];
  for(b = 0; b < $("[campo='710'] [rep]").length; b++){

    const contenidoInterno = {"a":"","b":"","9":""};
    for(c = 0; c < $("[campo='710'] [rep]").eq(b).children().length; c++){  
      contenidoInterno[$("[campo='710'] [rep]").eq(b).children().eq(c).children().eq(1).attr("campoIDENT")] = $("[campo='710'] [rep]").eq(b).children().eq(c).children().eq(1).val();
    }
    ContenidoCampo710.push(contenidoInterno);

  }
  DatosAInsertar["710"] = ContenidoCampo710;

  // CAMPO 740
  var ContenidoCampo740 = [];
  for(b = 0; b < Number($("[campo='740']").children().length)-1; b++){
    ContenidoCampo740.push({"a": $("[campo='740'] [rep] input").eq(b).val()});
  }
  DatosAInsertar["740"] = ContenidoCampo740;

  DatosAInsertar2 = DatosAInsertar;

  // CAMPO 773
  var ContenidoCampo773 = [];
  for(b = 0; b < $("[campo='773'] [rep]").length; b++){

    const contenidoInterno = {"t":"","d":"","g":""};
    for(c = 0; c < $("[campo='773'] [rep]").eq(b).children().length; c++){  
      contenidoInterno[$("[campo='773'] [rep]").eq(b).children().eq(c).children().eq(1).attr("campoIDENT")] = $("[campo='773'] [rep]").eq(b).children().eq(c).children().eq(1).val();
    }
    ContenidoCampo773.push(contenidoInterno);

  }
  DatosAInsertar["773"] = ContenidoCampo773;

  $.ajax({
    type: "GET",
    url: Url + 'Api/RecursosFisicos',
    data: {"Tipo": "agregarRegistro", "Datos": DatosAInsertar, "DatosAdicionales": {"245": DatosAInsertar["245"], "100": DatosAInsertar["100"], "659": DatosAInsertar["659"], "650": DatosAInsertar["650"], "653": DatosAInsertar["653"]}},
    success: function(Datos, textStatus, xhr){
      // Establecemos datos
      Datos = $.parseJSON(Datos);
        
      // Verificamos estado de la petición
      if(Datos['estado'] == 'exitoso'){
        $("#agregarRecurso").modal("hide");
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 10000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
        
        Toast.fire({
          icon: 'success',
          title: 'Registro agregado con exito. Recarge la pagina para ver los cambios.'
        })
      }else if(Datos['estado'] == 'error'){
        $("#agregarRecurso .modal-footer .btn ").before(`<p class="error-form"><i class="fa-regular fa-circle-exclamation"></i> ${Datos['detalle']} [${Datos['codigo']}]</p>`);
      }else{
        $("#agregarRecurso .modal-footer .btn ").before(`<p class="error-form"><i class="fa-regular fa-circle-exclamation"></i> Hubo un error desconocido.</p>`);
      }
        
    },
    error: function(){
      $("#agregarRecurso .modal-footer .btn ").before(`<p class="error-form"><i class="fa-regular fa-circle-exclamation"></i> Hubo un error desconocido.</p>`);
    }
  })

  console.log(DatosAInsertar);
}
var DatosAInsertar2;
var TEST = "";
// Función: Busqueda avanzada
function busquedaAvanzada(){

  // Verificamos si existe el modal. En caso de existir lo ocultamos y eliminamos.
  if($("#busquedaAvanzada").length !== 0){

    // Ocultamos el modal.
    $("#busquedaAvanzada").modal("hide");

    // Eliminamos modal.
    $("#busquedaAvanzada").remove();

  }

  // Creamos modal
  $("body").append(`<div class="modal fade" data-bs-backdrop="static" data-bs-keyboard="false" id="busquedaAvanzada" tabindex="-1" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h1 class="modal-title fs-5">Búsqueda avanzada</h1>
          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <div class="modal-body">

          <div class="mb-3">
            <label for="campoABuscar" class="form-label">Campo a buscar</label>
            <select class="form-select" id="campoABuscar" aria-describedby="campoABuscarAyuda">
              <option selected disabled>Seleccione una campo</option>
              <option value="1">ISBN [Campo 020]</option>
              <option value="2">ISSN [Campo 022]</option>
              <option value="3">Autor personal – asiento principal [Campo 100]</option>
              <option value="4">Título [Campo 245]</option>
              <option value="5">Edición [Campo 250]</option>
              <option value="6">Publicación [Campo 260]</option>
              <option value="7">Descripción física [Campo 300]</option>
              <option disabled value="8">Soporte [Campo 309]</option>
              <option disabled value="9">Colección [Campo 440]</option>
              <option disabled value="10">Nota general [Campo 500]</option>
              <option disabled value="11">Nota de contenido [Campo 505]</option>
              <option disabled value="12">Resumen [Campo 520]</option>
              <option disabled value="13">Nivel [Campo 521]</option>
              <option disabled value="14">Término de materia – nombre de persona [Campo 600]</option>
              <option disabled value="15">Término de materia - controlado [Campo 650]</option>
              <option disabled value="16">Término de materia - geográfico [Campo 651]</option>
              <option disabled value="17">Término de materia - propuesto [Campo 653]</option>
              <option disabled value="18">Tema [Campo 659]</option>
              <option disabled value="19">Autor personal – asiento secundario [Campo 700]</option>
              <option disabled value="20">Autor institucional – asiento secundario [Campo 710]</option>
              <option disabled value="21">Otros títulos [Campo 740]</option>
            </select>
            <div id="campoABuscarAyuda" class="form-text">Seleccione el campo donde quiera realizar la busqueda.</div>
          </div>

          <div class="mb-3">
            <label for="terminoABuscar" class="form-label">Termino a buscar</label>
            <input type="text" class="form-control" id="terminoABuscar" aria-describedby="terminoABuscarAyuda">
            <div id="terminoABuscarAyuda" class="form-text">Escriba el termino el que desea buscar.</div>
          </div>

          <div class="mb-3">
            <button id="buscar" style="width: 100%" type="button" class="btn btn-primary">Buscar</button>
          </div>

        </div>
      </div>
    </div>
  </div>`);

  // Establecemos acción al ocultar modal.
  $('#busquedaAvanzada').on('hidden.bs.modal', function(){
    $("#busquedaAvanzada").remove();
  })

  // Mostramos modal
  $("#busquedaAvanzada").modal("show");

  // Al hacer click en buscar
  $("#buscar").click(function(){

    $("#buscar").attr("disabled", true);
    
    var campoABuscar = $("#campoABuscar").val();
    var terminoABuscar = $("#terminoABuscar").val();

    $.ajax({
      type: "GET",
      url: Url + "Api/RecursosFisicos",
      data: {"Tipo": "obtenerListadoRegistro"},
      success: function(Datos, textStatus, xhr){

        // Establecemos los datos
        Datos = $.parseJSON(Datos);

        // Verificamos estado de la petición
        if(Datos['estado'] == 'exitoso'){

          var Registros = Datos['detalle']["Registros"];
          var Resultados;
          TEST = Registros;

          if(campoABuscar == "1"){
            // 020
            Resultados = Registros.filter(e => e['Datos']['Datos']['020'] && e['Datos']['Datos']['020'].some(item => item["a"] && item["a"].replace(/-/g, '') === terminoABuscar));
          }else if(campoABuscar == "2"){
            // 022
            Resultados = Registros.filter(e => e['Datos']['Datos']['022'] && e['Datos']['Datos']['022'].some(item => item["a"] && item["a"].replace(/-/g, '') === terminoABuscar));
          }else if(campoABuscar == "3"){
            // 100
            Resultados = Registros.filter(function(Registro) {

              const terminosDeBusqueda = terminoABuscar.trim().toLowerCase().split(/\s+/);

              var Autor;
              var Numeración;
              var Títulos;
              var Fechas;

              if(Registro['Datos']['Datos']['100'] !== undefined){
                if(Registro['Datos']['Datos']['100']['a'] !== undefined){
                  Autor = Registro['Datos']['Datos']['100']['a'];
                }else{
                  Autor = "";
                }

                if(Registro['Datos']['Datos']['100']['b'] !== undefined){
                  Numeración = Registro['Datos']['Datos']['100']['b'];
                }else{
                  Numeración = "";
                }

                if(Registro['Datos']['Datos']['100']['c'] !== undefined){
                  Títulos = Registro['Datos']['Datos']['100']['c'];
                }else{
                  Títulos = "";
                }

                if(Registro['Datos']['Datos']['100']['d'] !== undefined){
                  Fechas = Registro['Datos']['Datos']['100']['d'];
                }else{
                  Fechas = "";
                }

              }

              const Termino = `${Autor} ${Numeración} ${Títulos} ${Fechas}`.toLowerCase();
          
              // Verificar si todos los términos de búsqueda están incluidos en el string
              return terminosDeBusqueda.every((búsqueda) =>
                Termino.includes(búsqueda)
              );
          
            });
          }else if(campoABuscar == "4"){
            // 245
            Resultados = Registros.filter(function(Registro) {

              const terminosDeBusqueda = terminoABuscar.trim().toLowerCase().split(/\s+/);

              var Titulo;
              var Número;
              var DGM;
              var Subtítulo;
              var Mención;

              if(Registro['Datos']['Datos']['245'] !== undefined){

                if(Registro['Datos']['Datos']['245']['a'] !== undefined){
                  Titulo = Registro['Datos']['Datos']['245']['a'];
                }else{
                  Titulo = "";
                }

                if(Registro['Datos']['Datos']['245']['n'] !== undefined){
                  Número = Registro['Datos']['Datos']['245']['n'];
                }else{
                  Número = "";
                }

                if(Registro['Datos']['Datos']['245']['h'] !== undefined){
                  DGM = Registro['Datos']['Datos']['245']['h'];
                }else{
                  DGM = "";
                }

                if(Registro['Datos']['Datos']['245']['b'] !== undefined){
                  Subtítulo = Registro['Datos']['Datos']['245']['b'];
                }else{
                  Subtítulo = "";
                }

                if(Registro['Datos']['Datos']['245']['c'] !== undefined){
                  Mención = Registro['Datos']['Datos']['245']['c'];
                }else{
                  Mención = "";
                }


              }

              const Termino = `${Titulo} ${Número} ${DGM} ${Subtítulo} ${Mención}`.toLowerCase();
          
              // Verificar si todos los términos de búsqueda están incluidos en el string
              return terminosDeBusqueda.every((búsqueda) =>
                Termino.includes(búsqueda)
              );
          
            });
          }else if(campoABuscar == "5"){
            // 250
            Resultados = Registros.filter(function(Registro) {

              const terminosDeBusqueda = terminoABuscar.trim().toLowerCase().split(/\s+/);

              var Termino;

              if(Registro['Datos']['Datos']['250'] !== undefined){
                if(Registro['Datos']['Datos']['250']['a'] !== undefined){
                  Termino = Registro['Datos']['Datos']['250']['a'];
                }else{
                  Termino = Registro['Datos']['Datos']['250'];
                }
              }else{
                Termino = "";
              }
          
              // Verificar si todos los términos de búsqueda están incluidos en el string
              return terminosDeBusqueda.every((búsqueda) =>
                Termino.toLowerCase().includes(búsqueda)
              );
          
            });
          }else if(campoABuscar == "6"){
            // 260
            Resultados = Registros.filter(function(Registro) {

              const terminosDeBusqueda = terminoABuscar.trim().toLowerCase().split(/\s+/);

              var Lugar;
              var Editor;
              var Fecha;

              if(Registro['Datos']['Datos']['260'] !== undefined){
                if(Registro['Datos']['Datos']['260']['a'] !== undefined){
                  Lugar = Registro['Datos']['Datos']['260']['a'];
                }else{
                  Lugar = "";
                }

                if(Registro['Datos']['Datos']['260']['b'] !== undefined){
                  Editor = Registro['Datos']['Datos']['260']['b'];
                }else{
                  Editor = "";
                }

                if(Registro['Datos']['Datos']['260']['c'] !== undefined){
                  Fecha = Registro['Datos']['Datos']['260']['c'];
                }else{
                  Fecha = "";
                }

              }

              const Termino = `${Lugar} ${Editor} ${Fecha}`.toLowerCase();
          
              // Verificar si todos los términos de búsqueda están incluidos en el string
              return terminosDeBusqueda.every((búsqueda) =>
                Termino.includes(búsqueda)
              );
          
            });
          }else if(campoABuscar == "7"){
            // 300
            Resultados = Registros.filter(function(Registro){

              const terminosDeBusqueda = terminoABuscar.trim().toLowerCase().split(/\s+/);
              
              if(Registro['Datos']['Datos']['300'] !== undefined){

                var Extensión = "";
                var Otros = "";
                var Dimensiones = "";
                var Material = "";

                 for(var i = 0; i < Registro['Datos']['Datos']['300'].length; i++){

                  if(Registro['Datos']['Datos']['300'][i]['a'] !== undefined && Registro['Datos']['Datos']['300'][i]['a'] !== ""){
                    Extensión += ` ${Registro['Datos']['Datos']['300'][i]['a']} `;
                  }

                  if(Registro['Datos']['Datos']['300'][i]['b'] !== undefined && Registro['Datos']['Datos']['300'][i]['b'] !== ""){
                    Otros += ` ${Registro['Datos']['Datos']['300'][i]['b']} `;
                  }

                  if(Registro['Datos']['Datos']['300'][i]['c'] !== undefined && Registro['Datos']['Datos']['300'][i]['c'] !== ""){
                    Dimensiones += ` ${Registro['Datos']['Datos']['300'][i]['c']} `;
                  }

                  if(Registro['Datos']['Datos']['300'][i]['e'] !== undefined && Registro['Datos']['Datos']['300'][i]['d'] !== ""){
                    Material += ` ${Registro['Datos']['Datos']['300'][i]['e']} `;
                  }

                 }

              }

              const Termino = `${Extensión} ${Otros} ${Dimensiones} ${Material}`.toLowerCase();
          
              // Verificar si todos los términos de búsqueda están incluidos en el string
              return terminosDeBusqueda.every((búsqueda) =>
                Termino.includes(búsqueda)
              );

            })
          }

          if(Resultados.length > 0){

            $("#busquedaAvanzada").modal("hide");

            $("#ContenedorRegistros").hide();
            $("#ContenedorResultadoBusqueda").hide();
            $("#ContenedorEjemplares").hide();
            $("#pagActual").text("Búsqueda Avanzada");

            $("#ContenedorResultadoBusqueda").html(`<table class="table table-fluid" id="RegistrosBusqueda">
              <thead>
                <tr>
                  <th>MFN</th>
                  <th>Titulo</th>
                  <th>Autor</th>
                  <th>Editorial</th>
                  <th>Nota de contenido</th>
                  <th class="text-center">Acciones</th></tr>
              </thead>
              <tbody>
              </tbody>
            </table>`);

            var registrosHTML = "";
            for(var i = 0; i < Resultados.length; i++){

              // Establecemos variable.
              var Registro = Resultados[i];

              // Establecemos ISBNs
              var ISBN = "";
              if(Registro['Datos']['Datos']['020'] !== undefined){
                for(var a = 0; a < Registro['Datos']['Datos']['020'].length; a++){
                  ISBN += " - " + Registro['Datos']['Datos']['020'][a];
                }
              }

              // Agregamos el Id.
              registrosHTML += `<tr><td>${Registro['Id']}</td>`;
  
              // Agregamos el campo 245.
              if(Registro['245']['a'] !== undefined){
                registrosHTML += "<td>" + Registro['245']['a'];
                if(Registro['245']['b'] !== undefined){
                  registrosHTML += " - " + Registro['245']['b'];
                }
                registrosHTML += " <a style='display:none'>${ISBN}</a></td>";
              }else{
                registrosHTML += "<td>- <a style='display:none'>${ISBN}</a></td>"
              }
      
              // Agregamos el campo 100.
              if(Registro['100']['a'] !== undefined){
                registrosHTML += "<td>" + Registro['100']['a'] + "</td>";
              }else{
                registrosHTML += "<td>-</td>"
              }

              // Agregamos el campo 260.
              if(Registro['Datos']['Datos']['260'] !== undefined){
                if(Registro['Datos']['Datos']['260']['b'] !== undefined){
                  registrosHTML += "<td>" + Registro['Datos']['Datos']['260']['b'] + "</td>";
                }else{
                  registrosHTML += "<td>-</td>"
                }
              }else{
                registrosHTML += "<td>-</td>"
              }

              // Agregamos el campo 505.
              if(Registro['Datos']['Datos']['505'] !== undefined){
                if(Registro['Datos']['Datos']['505'].length !== 0){
                  registrosHTML += "<td class='text-center'><a style='display:none'>";
                  for(var z = 0; z < Registro['Datos']['Datos']['505'].length; z++){
      
                    if(z > 0){registrosHTML += "<br>";}
      
                    if(Registro['Datos']['Datos']['505'][z]['t'] !== undefined){
                      registrosHTML += Registro['Datos']['Datos']['505'][z]['t'];
                      if(Registro['Datos']['Datos']['505'][z]['r'] !== undefined){
                        registrosHTML += " ⁓ " + Registro['Datos']['Datos']['505'][z]['r'];
                      }
                    }
      
                  }
                  registrosHTML += "</a><i onclick='verNotaDeContenido(" + Registro['Id'] + ")' class='fa-solid fa-eye'></i></td>";
                }else{
                  registrosHTML += "<td class='text-center'>-</td>";
                }
              }else{
                registrosHTML += "<td class='text-center'>-</td>";
              }
      
              registrosHTML += "<td class='text-center'>";
          
              registrosHTML += "<i onclick='verFicha(" + Registro['Id'] + ")' class='mr-1 ml-1 fa-duotone fa-arrow-up-right-from-square'></i>";

              registrosHTML += "<i onclick='verEjemeplares(" + Registro['Id'] + ")' class='mr-1 ml-1 fa-duotone fa-books'></i>";

              registrosHTML += "<i onclick='añadirEjemeplar(" + Registro['Id'] + ")' class='mr-1 ml-1 fa-duotone fa-books-medical'></i>"

              registrosHTML += "<i onclick='eliminarRegistro(" + '"' + Registro['245']['a'] + '"' + ", " + Registro['Id'] + ")' class='mr-1 ml-1 fa-duotone fa-trash'></i>"

              registrosHTML += "</td></tr>";
              
            }

            // Agregamos ejemplares a la tabla.
            $("#ContenedorResultadoBusqueda tbody").append(registrosHTML);

            // Inicializamos tabla.
            $('#ContenedorResultadoBusqueda #RegistrosBusqueda').DataTable({
              "language": {
                "sProcessing":    "Procesando...",
                "sLengthMenu":    "Mostrar _MENU_ resultados",
                "sZeroRecords":   "No se encontraron resultados",
                "sEmptyTable":    "Ningún dato disponible en esta tabla",
                "sInfo":          "Mostrando resultados de la busqueda del _START_ al _END_ de un total de _TOTAL_ resultados",
                "sInfoEmpty":     "No hubo resultados a tu búsqueda",
                "sInfoFiltered":  "(filtrado de un total de _MAX_ resultados)",
                "sInfoPostFix":   "",
                "sSearch":        "Buscar:",
                "sUrl":           "",
                "sInfoThousands":  ",",
                "sLoadingRecords": "Cargando...",
                "oPaginate": {
                  "sFirst":    "Primero",
                  "sLast":    "Último",
                  "sNext":    "Siguiente",
                  "sPrevious": "Anterior"
                },
                "oAria": {
                  "sSortAscending":  ": Activar para ordenar la columna de manera ascendente",
                  "sSortDescending": ": Activar para ordenar la columna de manera descendente"
                }
              }
            });

            $("#ContenedorResultadoBusqueda").show();

          }else{
            $(".error-form").remove();
            $("#busquedaAvanzada .modal-body").append("<p class='error-form'>* No hubo resultados a tu búsqueda</p>");
            $("#busquedaAvanzada button").attr("disabled", false);
          }

        }else if(Datos['estado'] == 'error'){
          $(".error-form").remove();
          $("#busquedaAvanzada .modal-body").append(`<p class='error-form'>* ${Datos['detalle']} [${Datos['codigo']}]</p>`);
          $("#busquedaAvanzada button").attr("disabled", false);
        }else{
          $(".error-form").remove();
          $("#busquedaAvanzada .modal-body").append("<p class='error-form'>* Hubo un error desconocido</p>");
          $("#busquedaAvanzada button").attr("disabled", false);
        }

      },
      error: function(){
        $(".error-form").remove();
        $("#busquedaAvanzada .modal-body").append("<p class='error-form'>* Hubo un error desconocido</p>");
        $("#busquedaAvanzada button").attr("disabled", false);
      }
    })

  })

}