<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('actividades');

  // Verificamos si la función actual esta habilitada.
  verificarFunciónActual(1);

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title SibauMulti="actividades.tiutloNavegador">SIBAU - Actividades</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="./Recursos/css/Estilos.css" rel="stylesheet">
  <link href="https://pagination.js.org/dist/2.6.0/pagination.css" rel="stylesheet">
  <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->
 
        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

          <!-- Contenido -->
          <div style="display:none" id="Contenido">

            <!-- Contenedor superior -->
            <div class="row text-center">

              <!-- Titulo -->
              <h2 class="col h4 mb-2 text-gray-800"><strong SibauMulti="actividades.tiutlo">Actividades</strong><br></h2>
              <p class="mb-2" SibauMulti="actividades.subtiutlo">Este sitio te ofrece ejercicios de varias asignaturas que se corrigen solos. Son mayormente de opción múltiple y te dan una retroalimentación según tu respuesta. Los ejercicios se basan en contenidos de la biblioteca virtual.</p>

              <!-- Contenedor -->
              <div id="Contenedor">

                <!-- Listado de actividades -->
                <div class="row row-cols-1 row-cols-xxl-3 row-cols-xl-3 row-cols-lg-2 row-cols-md-2 row-cols-sm-2 row-cols-xs-1 g-4" id="Actividades"></div>
                <!-- Fin de Listado de actividades -->
                
              </div>
              <!-- Fin de Contenedor -->

            </div>
            <!-- Fin de Contenedor superior -->

          </div>
          <!-- Fin de Contenido -->

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

  <!-- Jquery -->
  <script src="./Recursos/vendor/jquery/jquery.min.js"></script>
  <script src="./Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>

  <!-- Bootstrap -->
  <script src="./Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    
  <!-- Generales -->
  <script src="./Recursos/js/Carga.js"></script>
  <script src="./Recursos/js/General.js?t=<?php echo time(); ?>"></script>
  
  <!-- Sweet2Alert -->
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.16/dist/sweetalert2.all.min.js"></script>

  <!-- Propios del archivo -->
  <script src="./Recursos/js/Actividades.js?t=<?php echo time(); ?>"></script>

</body>
</html>