<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('audioteca');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Audioteca</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="./Recursos/css/Estilos.css" rel="stylesheet">

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->
 
        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

          <!-- Contenido -->
          <div style="display:none" id="Contenido">

            <!-- Contenedor superior -->
            <div class="row text-center">

              <!-- Titulo -->
              <h2 class="col h4 mb-0 text-gray-800"><strong>Audioteca</strong></h2>
            
              <!-- Audiolibros -->
              <div class="row row-cols-1 row-cols-md-2 g-4" id="Audiolibros"></div>
              <!-- Fin de Audiolibros -->

            </div>
            <!-- Fin de Contenedor superior -->

          </div>
          <!-- Fin de Contenido -->

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>";</script>
    <script src="./Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="./Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="./Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="./Recursos/js/General.js"></script>
    <script src="./Recursos/js/Carga.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    <script>

      // Obtenemos archivo
      var Datos2 = '';
      var Contenido = "";
      $.ajax({
        type: "GET",
        contentType: 'application/json; charset=utf-8',
        url: Url + "Api/Audioteca?Tipo=Obtener",
        success: function(Datos, textStatus, xhr){

          Datos = $.parseJSON(Datos);

          Datos2 = Datos;
          
          if(Datos['estado'] == 'exitoso'){
            console.log(Datos);

            for(var i = 0; i < Datos['detalle'].length; i++){
              var Detalles = $.parseJSON(Datos2['detalle'][i]['Datos']);
              Contenido += '<div class="col"><div class="card mb-3"><div class="row g-0"><div class="col-md-4" style="background-image: url(' + Datos['detalle'][i]['Portada'] + '); background-position: center; background-size: cover;"></div><div class="col-md-8"><div class="card-body text-left"><h5 class="card-title">' + Datos['detalle'][i]['Titulo'] + '</h5><p class="card-text">';
              
              if(Detalles['Autor'] !== undefined){
                Contenido += '<strong>Autor:</strong> <i>' + Detalles['Autor'] + '</i>';
              }else{
                Contenido += '<strong>Compilador:</strong> <i>' + Detalles['Compilador'] + '</i>';
              }
              
              Contenido += '<br><strong>Narrador:</strong> <i>' + Detalles['Narrador'] + '</i><br><strong>Descripción:</strong> <i>' + Detalles['Descripcion'] + '</i></p><audio controls style="width: 100%" src="' + Url + 'Recursos/Audioteca/Audiolibro' + Datos['detalle'][i]['Id'] + '.mp3"></audio></div></div></div></div></div>';
            }

            $("#Audiolibros").html(Contenido);

            quitarLoader();

          }else if(Datos['estado'] == 'error'){
            errorLoader(Datos['detalle'] + " [" + Datos['codigo'] + "]");
          }else{
            errorLoader();
          }

        },
        error: function(){
          errorLoader();
        }
      })

    </script>
</body>
</html>