<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('canjeCreditos');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Canjear creditos</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="./Recursos/css/Estilos.css" rel="stylesheet">

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

  <style>
    @media (max-width: 900px) {
      #Catalogo .col {
        flex: 0 0 33.33333%;
        max-width: 33.33333%;
      }
    }

    @media (max-width: 650px) {
      #Catalogo .col {
        flex: 0 0 50%;
        max-width: 50%;
      }
    }

    @media (max-width: 450px) {
      #Catalogo .col {
        flex: 0 0 100%;
        max-width: 100%;
      }
    }
  </style>

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->
 
        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

          <!-- Contenedor Final -->
          <div class="row text-center" style="display: none" id="Contenido">

            <!-- Titulo -->
            <h2 class="col h4 mb-0 text-gray-800"><strong>Canjea tus créditos</strong></h2>
            <p>(Los créditos son intransferibles y no se efectúan rembolso)</p>

            <!-- Canjes -->
            <div class="row row-cols-1 row-cols-md-4 g-4" id="Catalogo"></div>
            <!-- Fin de Canjes -->

          </div>
          <!-- Fin de Contenedor Final -->

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>";</script>
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.16/dist/sweetalert2.all.min.js"></script>
    <script src="./Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="./Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="./Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="./Recursos/js/Carga.js"></script>
    <script src="./Recursos/js/General.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    <script>

$.ajax({
  type: "GET",
  url: Url + "Api/creditos?Tipo=obtenerCatalogo",
  success: function(Datos, textStatus, xhr){

    // Establecemos datos
    Datos = $.parseJSON(Datos);

    if(Datos['estado'] == 'exitoso'){

      const Canjeados = [];

      
      for(var i = 0; i < Datos['detalle']['Canjeados'].length; i++){
        Canjeados.push(Datos['detalle']['Canjeados'][i]['Canje']);
      }

      // Quitar loader
      quitarLoader();

      var Catalogo = '';

      for(var i = 0; i < Datos['detalle']['Catalogo'].length; i++){
        
        Catalogo += '<div class="col" id="Catalogo' + Datos['detalle']['Catalogo'][i]['Id'] + '"><div class="card"><img src="' + Datos['detalle']['Catalogo'][i]['Imagen'] + '" style="padding: 1rem" class="card-img-top"><div class="card-body"><h5 class="card-title"><b>' + Datos['detalle']['Catalogo'][i]['Titulo'] + '</b></h5><p class="card-text">' + Datos['detalle']['Catalogo'][i]['Descripcion'] + '</p><button onclick="confirmarCanje(' + "'" +  Datos['detalle']['Catalogo'][i]['Id'] + "', '" + Datos['detalle']['Catalogo'][i]['Titulo'] + "', '" + Datos['detalle']['Catalogo'][i]['Costo'] + "'" + ')" class="btn btn-primary" costo="' + Datos['detalle']['Catalogo'][i]['Costo'] + '"';
        
        if(Canjeados.indexOf(Datos['detalle']['Catalogo'][i]['Id']) == '-1'){
          Catalogo += '>Canjear por ' + Datos['detalle']['Catalogo'][i]['Costo'] + ' créditos.';
        }else{
          Catalogo += 'disabled>Ya canjeado';
        }
        
        Catalogo += '</button></div></div></div>';
      }

      $("#Catalogo").html(Catalogo);
      
    }else if(Datos['estado'] == 'error'){
      errorLoader(Datos['detalle'] + " [" + Datos['codigo'] + "]");
    }else{
      errorLoader();
    }
  
  },
  error: function(){
    errorLoader();
  }
})

function confirmarCanje(Id, Titulo, Precio){

  var creditosActuales = $("contador").attr("data-count");
  var creditosLuego = creditosActuales - 50;
  creditosLuego = new Intl.NumberFormat(['ban', 'id']).format(creditosLuego);

  if($("contador").attr("data-count") < 50){
    $("button[costo='50']").attr("onclick", "");
    $("button[costo='50']").attr("data-bs-toggle", "tooltip");
    $("button[costo='50']").attr("data-bs-original-title", "No tienes créditos suficientes.");
    $("button[costo='50']").css("opacity", "0.5");
    $("button[costo='50']").tooltip();
  }else{
    var modal = document.createElement("modalconfirmacion");
    modal.innerHTML = '<div class="modal fade" id="confirmarCanje" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true"><div class="modal-dialog"><div class="modal-content"><div class="modal-header"><h1 class="modal-title fs-5" id="exampleModalLabel">Confirmar canje</h1><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body text-center"><a>¡Estas seguro que desea canjear "' + Titulo + '" por <code>' + Precio + '</code> créditos?<br><small>[Luego de realizar esta operación te quedaran ' + creditosLuego + ' créditos]</small></a></div><div class="modal-footer" style="display: flex; justify-content: center;"><button type="button" class="btn btn-danger" data-bs-dismiss="modal">Cancelar operación</button><button type="button" class="btn btn-success" onclick="canjear(' + Id + ',' + "'" +  Titulo + "'" + ')">Confirmar operación</button></div></div></div></div>';
    document.body.appendChild(modal);

    $("#confirmarCanje").modal("show");
 
    $("#confirmarCanje").on('hide.bs.modal', function(){
      $("modalconfirmacion").remove();
    });
  }

}

function canjear(Id, Titulo){
  $.ajax({
    type: "GET",
    url: Url + "Api/creditos?Tipo=canjear&Articulo=" + Id,
    success: function(Datos, textStatus, xhr){

      // Establecemos datos
      Datos = $.parseJSON(Datos);

      // Verificamos estado de la petición
      if(Datos['estado'] == 'exitoso'){
        var idCat = "Catalogo" + Id;
        $("#" + idCat + " button").attr("disabled", true);
        $("#" + idCat + " button").text("Ya canjeado");
        $("#confirmarCanje").modal("hide");
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 10000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
  
        Toast.fire({
          icon: 'success',
          title: 'Canjeaste ' + Titulo + ' de forma exitosa!'
        })

        $(".contador").attr('data-count',$(".contador").attr('data-count')-50);

        $(".contador").each(function () {
          var count = $(this);
          var countTo = count.attr('data-count');
        $({countNum:count.text()}).animate({
          countNum:countTo,
        },
        {
          duration:3000,
          easing:'linear',
          step:function(){
            count.text(new Intl.NumberFormat(['ban', 'id']).format(Math.floor(this.countNum)));
          },
          complete:function(){
            count.text(new Intl.NumberFormat(['ban', 'id']).format(this.countNum));
          }
        });
      });
      }else if(Datos['estado'] == 'error'){
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 10000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
  
        Toast.fire({
          icon: 'error',
          title: 'Error: ' + Datos['detalle'] + " [" + Datos['codigo']  +"]"
        })
      }else{
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })
  
        Toast.fire({
          icon: 'error',
          title: 'Hubo un error desconocido a la hora de canjear un articulo.'
        })
      }
    
    },
    error: function(){
      const Toast = Swal.mixin({
        toast: true,
        position: 'top-end',
        showConfirmButton: false,
        timer: 3000,
        timerProgressBar: true,
        didOpen: (toast) => {
          toast.addEventListener('mouseenter', Swal.stopTimer)
          toast.addEventListener('mouseleave', Swal.resumeTimer)
        }
      })
  
      Toast.fire({
        icon: 'error',
        title: 'Hubo un error desconocido a la hora de canjear un articulo.'
      })
    }
  })
}
    </script>

</body>
</html>