<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('configuraciones');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title SibauMulti="perfil.configuraciones.tituloNavegador">SIBAU - Configuraciones</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="./Recursos/css/Estilos.css" rel="stylesheet">
  <link href="./Recursos/css/Configuraciones.css?v" rel="stylesheet">

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->

        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

          <!-- Contenedor superior -->
          <div id="Contenido" class="row" style="display:none">

            <!-- Titulo -->
            <h2 class="col h4 mb-0 text-gray-800 mb-3"><strong SibauMulti="perfil.configuraciones.titulo">Configuraciones</strong></h2>

            <!-- Configuraciones -->
            <form id="ConfiguracionesFormularios"><div class="row">

              <!-- Sobre Ti -->
              <div id="sobreTi" class="col-6">
                <div style="border: 2px solid #e2e4eb; background-color:white; border-radius:15px; padding: 1rem">

                <!-- Subtitulo -->
                <h2 class="text-center mt-3 h4 mb-0 text-gray-800"><strong>Sobre Ti</strong></h2>

                  <div class="mb-3">
                    <label for="SobreTi-Presentación" class="form-label"><i class="fa-duotone fa-address-card"></i> Breve presentación</label>
                    <textarea class="form-control" id="SobreTi-Presentación" name="SobreTi-Presentación" placeholder="Breve presentación" rows="5"></textarea>
                    <a id="ErrorSobreTi-Presentación" class="error-form"></a>
                  </div>

                  <div class="mb-3">
                    <label for="SobreTi-LibroFavorito" class="form-label"><i class="fa-duotone fa-book"></i> Libro favorito</label>
                    <input type="text" class="form-control" id="SobreTi-LibroFavorito" name="SobreTi-LibroFavorito" placeholder="Libro favorito">
                    <a id="ErrorSobreTi-LibroFavorito" class="error-form"></a>
                  </div>

                  <div class="mb-3">
                    <label for="SobreTi-ActorFavorito" class="form-label"><i class="fa-duotone fa-film"></i> Actor favorito</label>
                    <input type="text" class="form-control" id="SobreTi-ActorFavorito" name="SobreTi-ActorFavorito" placeholder="Actor favorito">
                    <a id="ErrorSobreTi-ActorFavorito" class="error-form"></a>
                  </div>

                  <div class="mb-3">
                    <label for="SobreTi-EscritorFavorito" class="form-label"><i class="fa-duotone fa-typewriter"></i> Escritor favorito</label>
                    <input type="text" class="form-control" id="SobreTi-EscritorFavorito" name="SobreTi-EscritorFavorito" placeholder="Escritor favorito">
                    <a id="ErrorSobreTi-EscritorFavorito" class="error-form"></a>
                  </div>

                  <div class="mb-3">
                    <label for="SobreTi-Hobby" class="form-label"><i class="fa-duotone fa-people-robbery"></i> Hobby</label>
                    <input type="text" class="form-control" id="SobreTi-Hobby" name="SobreTi-Hobby" placeholder="Hobby">
                    <a id="ErrorSobreTi-Hobby" class="error-form"></a>
                  </div>

                </div>
              </div>
              <!-- Fin de Sobre Ti -->

              <!-- General -->
              <div id="general" class="col-6">
                <div style="border: 2px solid #e2e4eb; background-color:white; border-radius:15px; padding: 1rem">

                <!-- Subtitulo -->
                <h2 class="text-center mt-3 h4 mb-0 text-gray-800"><strong>General</strong></h2>

                  <div class="mb-3">
                    <label for="General-Ver" class="form-label"><i class="fa-duotone fa-eyes"></i> ¿Quien puede ver mi perfil?</label>
                    <select class="form-select" id="General-Ver" name="General-Ver" placeholder="Ver">
                      <option value="1">Personas de mi institución</option>
                      <option value="2">Amigos</option>
                      <option value="3">Todos</option>
                    </select>
                  </div>

                  <div class="mb-3">
                    <label for="General-Imagen" class="form-label"><i class="fa-duotone fa-camera"></i> Imagen de perfil</label><br>
                    <a id="actualizarImagenPerfil"><strong>Personalize su imagen de perfil haciendo click aquí.</strong></a>
                  </div>

                  <div class="mb-3">
                    <label for="General-Genero" class="form-label"><i class="fa-duotone fa-venus-mars"></i> Genero</label>
                    <select class="form-select" id="General-Genero" name="General-Genero" placeholder="Genero">
                      <option>Sin especificar</option>
                      <option>Masculino</option>
                      <option>Femenino</option>
                      <option>Otro</option>
                    </select>
                  </div>

                  <div class="mb-3">
                    <label for="General-Telefono" class="form-label"><i class="fa-duotone fa-phone"></i> Teléfono</label>
                    <input type="tel" class="form-control" id="General-Telefono" name="General-Telefono" placeholder="Telefono">
                  </div>

                  <div class="mb-3">
                    <label for="General-Usuario" class="form-label"><i class="fa-duotone fa-user"></i> Nombre de usuario</label>
                    <div class="input-group mb-3">
                      <span class="input-group-text" id="Arroba">@</span>
                      <input type="text" class="form-control" id="General-Usuario" name="General-Usuario" aria-label="Nombre de usuario" placeholder="Nombre de usuario" aria-describedby="Arroba">
                    </div>
                  </div>

                </div>
              </div>
              <!-- Fin de General -->

              <div class="row" style="justify-content: center;"><button onclick='$("#ConfiguracionesFormularios").submit()' style="width: 25%; margin: 1rem" type="button" class="btn btn-primary">Guardar cambios</button></div>
              

            </div></form>
            <!-- Fin de Configuraciones -->

            <!-- Configuración de Perfil -->
            <div class="modal fade" id="imagenDePerfil" tabindex="-1" data-bs-backdrop="static" data-bs-keyboard="false" aria-hidden="true">
              <div class="modal-dialog modal-xl">
                <div class="modal-content">
                  <div class="modal-body">
                    
                    <!-- Paneles -->
                    <div class="row" style="align-items: center">

                      <!-- Izquierdo -->
                      <div id="Izquierdo" class="col text-center">
                        <object style="width: 25vw" data="https://sibau.com.ar/Recursos/Perfiles/1.svg" type="image/svg+xml"></object>
                      </div>

                      <!-- Derecho -->
                      <div id="Derecho" class="col">
                        <div id="Configuraciones" style="width: 30vw; background-color: white; margin: auto; padding: 1.5rem; border-radius: 10px">
                          <form id="nuevaImagenDePerfil">
                            
                            <div class="mb-3">
                              <label for="Pelo" class="form-label">Elije un pelo</label>
                              <select class="form-select" id="Pelo" name="Pelo">
                                <option value="0">Sin Pelo</option>
                                <option value="1" estado="0" precio="50">Pelo #1 [🪙 50]</option>
                                <option value="2" estado="1" precio="50">Pelo #2 [ Ya lo tienes ]</option>
                                <option value="3" estado="0" precio="50">Pelo #3 [🪙 50]</option>
                                <option value="4" estado="0" precio="50">Pelo #4 [🪙 50]</option>
                                <option value="5" estado="0" precio="50">Pelo #5 [🪙 50]</option>
                                <option value="6" estado="0" precio="50">Pelo #6 [🪙 50]</option>
                                <option value="7" estado="0" precio="50">Pelo #7 [🪙 50]</option>
                                <option value="8" estado="0" precio="50">Pelo #8 [🪙 50]</option>
                              </select>
                            </div>

                            <div class="mb-3">
                              <label for="Bigote" class="form-label">Elije un Bigote</label>
                              <select class="form-select" id="Bigote" name="Bigote" onchange="actualizarSaldo(this)">
                                <option value="0">Sin Bigote</option>
                                <option value="1" estado="0" precio="50">Bigote #1 [🪙 50]</option>
                                <option value="2" estado="0" precio="50">Bigote #2 [🪙 50]</option>
                                <option value="3" estado="0" precio="50">Bigote #3 [🪙 50]</option>
                                <option value="4" estado="0" precio="50">Bigote #4 [🪙 50]</option>
                                <option value="5" estado="0" precio="50">Bigote #5 [🪙 50]</option>
                                <option value="6" estado="0" precio="50">Bigote #6 [🪙 50]</option>
                                <option value="7" estado="0" precio="50">Bigote #7 [🪙 50]</option>
                                <option value="8" estado="0" precio="50">Bigote #8 [🪙 50]</option>
                              </select>
                            </div>

                            <div class="mb-3">
                              <label for="Pelo" class="form-label">Color de pelo</label>
                              <input type="color" class="form-control form-control-color" id="ColorPelo" name="ColorPelo" value="Pelo" title="Color de pelo">
                            </div>

                            <div class="mb-3">
                              <label for="ColorBigote" class="form-label">Color de Bigote</label>
                              <input type="color" class="form-control form-control-color" id="ColorBigote" name="ColorBigote" value="Pelo" title="Color de Bigote">
                            </div>
                            
                            <div class="mb-3">
                              <label for="piel" class="form-label">Color de piel</label>
                              <input type="color" class="form-control form-control-color" id="ColorPiel" name="ColorPiel" value="#BE7C5E" title="Color de piel">
                            </div>

                            <div class="mb-3">
                              <label for="piel" class="form-label">Color de remera</label>
                              <input type="color" class="form-control form-control-color" id="ColorRemera" name="ColorRemera" value="#4E73DF" title="Color de remera">
                            </div>

                            <a class="error-form"></a>

                          </form>
                        </div>
                      </div>

                    </div>
                    <!-- Fin de Paneles -->
                    <form id="nuevaConfiguracion"><input type="hidden" name="DatosPerfil" id="DatosPerfil"></form>

                  </div>
                  <div class="modal-footer text-center" style="display: flex; justify-content: center">
                    <button type="button" class="btn btn-light" id="Restablecer">Restablecer</button>
                    <button type="button" class="btn btn-success" id="Guardar" onclick="guardarImagenDePerfil()">Guardar</button>
                    <button type="button" class="btn btn-danger" data-bs-dismiss="modal">Cancelar</button>
                  </div>
                </div>
              </div>
            </div>
            <!-- Fin de Configuración de Perfil -->

          </div>
          <!-- Fin de Contenedor superior -->

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>"; var imagenPerfilActual = "<?php echo $_SESSION['ImagenPerfil'] ?>".split("&");</script>
    <script src="./Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="./Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="./Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="./Recursos/js/General.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.16/dist/sweetalert2.all.min.js"></script>
    <script src="./Recursos/js/Carga.js"></script>
    <script src="./Recursos/js/Configuraciones.js?88"></script>
    <script src="https://cdn.jsdelivr.net/npm/intl-tel-input@18.1.1/build/js/intlTelInput.min.js"></script>

</body>
</html>