<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('gestion*configuraciones');

  // Establecemos el permiso necesario
  seRequirePermiso('gestion_configuraciones');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title SibauMulti="gestion.configuraciones.tituloWeb">SIBAU - Configuración de la institución</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="../Recursos/css/Estilos.css" rel="stylesheet">
  <link href="../Recursos/css/gestionConfiguraciones.css" rel="stylesheet">

  <!-- Sweet2Alert -->
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.15/dist/sweetalert2.all.min.js"></script>

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->
 
        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

          <!-- Contenido -->
          <div id="Contenido">

            <!-- Titulo -->
            <div class="row text-center"><h2 class="col h4 mb-2 text-gray-800"><strong SibauMulti="gestion.configuraciones.titulo">Configuraciones<br></strong></h2></div>

            <!-- Estado -->
            <div><h2 class="h4 mb-2 mt-2 text-gray-800"><strong SibauMulti="gestion.configuraciones.estado"></strong></h2></div>

            <!-- Configuraciones y funciones -->
            <div class="accordion mt-5" id="accordionConfiguración">
              
              <!-- Información -->
              <div class="accordion-item">
                <h2 class="accordion-header">
                 <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#configuracionInfo" aria-expanded="true" aria-controls="collapseOne" SibauMulti="gestion.configuraciones.acordion.info.titulo"></button>
                </h2>
                <div id="configuracionInfo" class="accordion-collapse collapse">
                  <div class="accordion-body">

                    <!-- Subtitulo e info -->
                    <p SibauMulti="gestion.configuraciones.acordion.info.aqui1"></p><ul SibauMulti="gestion.configuraciones.acordion.info.aqui2"></ul>
                  
                    <!-- Datos -->
                    <div>

                      <!-- CUE -->
                      <div class="mb-3">
                        <label for="institucionCUE" SibauMulti="gestion.configuraciones.acordion.info.CUE" class="form-label">CUE</label>
                        <input type="text" disabled class="form-control" id="institucionCUE">
                      </div>
                      <!-- Fin de CUE -->

                      <!-- Nombre -->
                      <div class="mb-3">
                        <label for="institucionNombre" SibauMulti="gestion.configuraciones.acordion.info.nombre" class="form-label">Nombre de la institución</label>
                        <input type="text" disabled class="form-control" id="institucionNombre">
                      </div>
                      <!-- Fin de Nombre -->

                      <!-- Nombre corto -->
                      <div class="mb-3">
                        <label for="institucionNombreCorto" SibauMulti="gestion.configuraciones.acordion.info.nombreCorto" class="form-label">Nombre abreviado de la institución</label>
                        <input type="text" disabled class="form-control" id="institucionNombreCorto">
                      </div>
                      <!-- Fin de Nombre corto -->

                      <!-- Correo -->
                      <div class="mb-3">
                        <label for="institucionCorreo" SibauMulti="gestion.configuraciones.acordion.info.correo" class="form-label">Correo</label>
                        <input type="text" disabled class="form-control" id="institucionCorreo">
                      </div>
                      <!-- Fin de Correo -->

                      <!-- Usuario gestor -->
                      <div class="mb-3">
                        <label for="institucionUsuarioGestor" SibauMulti="gestion.configuraciones.acordion.info.gestor" class="form-label">Usuario gestor de la institución</label>
                        <input type="text" disabled class="form-control" id="institucionUsuarioGestor">
                      </div>
                      <!-- Fin de Usuario gestor -->

                      <!-- Correo ABC -->
                      <div class="mb-3">
                        <label for="institucionCorreoGestor" SibauMulti="gestion.configuraciones.acordion.info.correoGestor" class="form-label">Correo</label>
                        <input type="text" disabled class="form-control" id="institucionCorreoGestor">
                      </div>
                      <!-- Fin de Correo ABC -->

                      <!-- Fecha de inscripción -->
                      <div class="mb-3">
                        <label for="institucionFecha" SibauMulti="gestion.configuraciones.acordion.info.fecha" class="form-label">Fecha de inscripción al SIBAU</label>
                        <input type="date" disabled class="form-control" id="institucionFecha">
                      </div>
                      <!-- Fin de Fecha de inscripción -->

                      <!-- Fecha de inscripción -->
                      <div class="mb-3">
                        <label for="institucionLogo" SibauMulti="gestion.configuraciones.acordion.info.logo" class="form-label">Logo de la institución</label><br>
                        <img alt="Logo de la institución" id="institucionLogo">
                      </div>
                      <!-- Fin de Fecha de inscripción -->

                    </div>
                    <!-- Fin de Datos -->

                  </div>
                </div>
              </div>

              <!-- Características -->
              <div class="accordion-item">
                <h2 class="accordion-header">
                 <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#configuracionCaracterísticas" aria-expanded="true" aria-controls="collapseOne" SibauMulti="gestion.configuraciones.acordion.carac.titulo"></button>
                </h2>
                <div id="configuracionCaracterísticas" class="accordion-collapse collapse">
                  <div class="accordion-body">

                    <!-- Subtitulo e info -->
                    <p SibauMulti="gestion.configuraciones.acordion.carac.aqui"></p><p id="Limitaciones" SibauMulti="gestion.configuraciones.acordion.carac.limitaciones"></p>

                    <!-- Checkbox -->
                    <div id="Checkbox"></div>
                    <!-- Fin de Checkbox -->

                    <!-- Configuraciones -->
                    <div class="accordion mt-5" id="accordionConfiguraciónFunciones"></div>

                  </div>
                </div>
              </div>
   
            </div>
            <!-- Fin de Configuraciones y funciones -->

          </div>
          <!-- Fin de Contenido --> 

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Jquery -->
    <script src="../Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="../Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>

    <!-- Bootstrap -->
    <script src="../Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    
    <!-- Generales -->
    <script src="../Recursos/js/Carga.js"></script>
    <script src="../Recursos/js/General.js?t=<?php echo time(); ?>"></script>

    <!-- Propios del archivo -->
    <script src="../Recursos/js/gestionConfiguraciones.js?t=<?php echo time(); ?>"></script>

</body>
</html>