<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('dispositivos');

  // Establecemos el permiso necesario
  seRequirePermiso('obtenerDispositivos');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Dispositivos</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/css/Estilos.css" rel="stylesheet">

  <!-- Sweet2Alert -->
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.15/dist/sweetalert2.all.min.js"></script>

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper"> 

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->
 
        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Contenido -->
          <div id="Contenido">

            <!-- Contenedor superior -->
            <div class="row">

              <!-- Titulo -->
              <h2 class="col h4 mb-0 text-gray-800"><strong>Dispositivos vinculados</strong> <button data-bs-toggle="modal" data-bs-target="#añadirDispositivo" type="button" class="ml-2 btn btn-primary">Añadir dispositivo</button></h2>

            </div>
            <!-- Fin de Contenedor superior -->

            <!-- Tabla -->
            <table class="table mt-5">
              <thead>
                <tr>
                  <th class="text-center" scope="col">Tipo</th>
                  <th scope="col">Nombre</th>
                  <th scope="col">Fecha de creación</th>
                  <th scope="col">Versión del software</th>
                  <th class="text-center" scope="col">Acciones</th>
                </tr>
              </thead>
              <tbody>
              </tbody>
            </table>
            <h5 id="CargandoDispositivos" class="text-center"><strong>Cargando dispositivos...</strong></h5>
            <!-- Fin de Tabla -->


          </div>
          <!-- Fin de Contenido --> 

          <!-- Confirmar eliminado -->
          <div class="modal fade" id="confirmarEliminación" tabindex="-1" aria-hidden="true">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h1 class="modal-title fs-5">Confirmar eliminado</h1>
                  <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                  <input type="hidden" id="Eliminado" name="Eliminado">
                  <p>Al eliminarlo el dispositivo no tendrá acceso a la red de SIBAU por lo que no se podrá realizar operaciones como retiros, devoluciones ni búsquedas.</p>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cerrar</button>
                  <button type="button" onclick="confirmarEliminación()" class="btn btn-danger">Confirmar</button>
                </div>
              </div>
            </div>
          </div>
          <!-- Fin de Confirmar eliminado -->

          <!-- Añadir dispositivo -->
          <div class="modal fade" id="añadirDispositivo" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h1 class="modal-title fs-5" id="staticBackdropLabel">Añadir un nuevo dispositivo</h1>
                  <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                  <form id="añadirDispositivoFormulario">
                    <div class="mb-3">
                      <label for="Nombre" class="form-label">Nombre del dispositivo</label>
                      <input type="text" class="form-control" id="Nombre" name="Nombre">
                      <a class="error-form" id="NombreError"></a>
                    </div>

                    <div class="mb-3">
                      <label for="Tipo" class="form-label">Tipo</label>
                      <select class="form-select" id="Tipo" name="Tipo">
                        <option selected>APP SIBAU</option>
                      </select>
                      <a class="error-form" id="TipoError"></a>
                    </div>

                    <div class="mb-3">
                      <label for="Seguridad" class="form-label">Código de vinculación</label>
                      <input type="text" class="form-control" id="Token" name="Token">
                      <a class="error-form" id="TokenError"></a>
                    </div>
                    <a class="error-form text-center" id="AñadirError"></a>
                  </form>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancelar</button>
                  <button type="button" class="btn btn-success" onclick='$("#añadirDispositivoFormulario").submit()'>Añadir</button>
                </div>
              </div>
            </div>
          </div>
          <!-- Fin de Añadir dispositivo -->

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>";</script>
    <script src="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/js/General.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    <?php if(isset($_GET['agregar'])){ ?>
    <script>
      $("#CodigoVinculacion").attr("disabled", true);
      $("#CodigoVinculacion").val("<?php echo substr($_GET['agregar'], -5) ?>");
      $("#añadirDispositivo").modal('show');
    </script>
    <?php } ?>
    <script>

// Cargar dispositivos
function cargarDispositivos(){
  $.ajax({
    type: "POST",
    url: Url + 'Api/Aplicacion?Tipo=obtenerDispositivos',
    data: $("#AgregarRecursoFormulario").serialize(),
    success: function(Datos, textStatus, xhr){

      Datos = $.parseJSON(Datos);
      var Contenido = '';

      if(Datos['estado'] == 'exitoso'){

        for(var i = 0; i < Datos['detalle'].length; i++){
          Contenido  += '<tr id="Fila' + Datos['detalle'][i]['Id'] + '"><th class="text-center" scope="row"><abbr title="' + Datos['detalle'][i]['Tipo'] + '"><i style="color: #0000ff8a;" class="fa-duotone fa-desktop"></i></abbr></th><td>' + Datos['detalle'][i]['Nombre'] + '</td><td>' + Datos['detalle'][i]['FechaDeCreacion'] + '</td><td>' + Datos['detalle'][i]['Version'] + '</td><td class="text-center"><i onclick="Eliminar(' + Datos['detalle'][i]['Id'] + ')" style="color: red" class="fa-duotone fa-trash"></i></td></tr>';
        }
              
        $("tbody").html(Contenido);

        if(Datos['detalle'].length == 0){
          $("#CargandoDispositivos strong").html("Aun no hay dispositivos, agrega uno.");
        }else{
          $("#CargandoDispositivos strong").html("");
        }
            
      }else if(Datos['estado'] == 'error'){

        $("#CargandoDispositivos strong").html(Datos['detalle'] + " [" + Datos['codigo'] + "]");

      }else{
        $("#CargandoDispositivos strong").html("Ups.. Hubo un error al intentar cargar los dispositivos. Inténtelo de nuevo mas tarde, si aun no funciona comuníquese con soporte.")
      }
          
    },
    error: function(){
      $("#CargandoDispositivos strong").html("Ups.. Hubo un error al intentar cargar los dispositivos. Inténtelo de nuevo mas tarde, si aun no funciona comuníquese con soporte.")
    }
  })
}

function Eliminar(Id){
  $("#Eliminado").val(Id);
  $("#confirmarEliminación").modal('show');
}

function confirmarEliminación(){
  $.ajax({
    type: "GET",
    url: Url + 'Api/Aplicacion?Tipo=eliminarDispositivo&Dispositivo=' + $("#Eliminado").val(),
    success: function(Datos, textStatus, xhr){
      Datos = $.parseJSON(Datos);
      
      if(Datos['estado'] == 'exitoso'){
        $("#confirmarEliminación").modal('hide');
        document.getElementById("Fila" +$("#Eliminado").val()).style.display = 'none';
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })

        Toast.fire({
          icon: 'success',
          title: 'Dispositivo eliminado de forma exitosa'
        })
      }else if(Datos['estado'] == 'error'){
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })

        Toast.fire({
          icon: 'error',
          title: Datos['detalle'] + " [" + Datos['codigo'] + "]"
        })
      }else{
        const Toast = Swal.mixin({
          toast: true,
          position: 'top-end',
          showConfirmButton: false,
          timer: 3000,
          timerProgressBar: true,
          didOpen: (toast) => {
            toast.addEventListener('mouseenter', Swal.stopTimer)
            toast.addEventListener('mouseleave', Swal.resumeTimer)
          }
        })

        Toast.fire({
          icon: 'error',
          title: 'Hubo un error desconocido'
        })
      }
    },
    error: function(){
      const Toast = Swal.mixin({
        toast: true,
        position: 'top-end',
        showConfirmButton: false,
        timer: 3000,
        timerProgressBar: true,
        didOpen: (toast) => {
          toast.addEventListener('mouseenter', Swal.stopTimer)
          toast.addEventListener('mouseleave', Swal.resumeTimer)
        }
      })

      Toast.fire({
        icon: 'error',
        title: 'Hubo un error desconocido'
      })
    }
  })
}

$("#añadirDispositivoFormulario").submit(function(e){
        
  e.preventDefault();

  $("#añadirDispositivo .btn-success").attr('disabled', true);
  $("#añadirDispositivo .btn-success").html('<i class="fa fa-spinner fa-spin"></i> Cargando');

  // Validamos los campos
  if($("#Nombre").val().length < 3){
    $("#NombreError").html("* El nombre es demasiado corto");
    $("#añadirDispositivo .btn-success").html("Añadir");
    $("#añadirDispositivo .btn-success").attr('disabled', false);
  }else if($("#Nombre").val().length > 30){
    $("#NombreError").html("* El nombre es demasiado largo");
    $("#añadirDispositivo .btn-success").html("Añadir");
    $("#añadirDispositivo .btn-success").attr('disabled', false);
  }else{
    $.ajax({
      type: "POST",
      url: Url + 'Api/Aplicacion?Tipo=añadirDispositivos',
      data: $("#añadirDispositivoFormulario").serialize(),
      success: function(Datos, textStatus, xhr){

        Datos = $.parseJSON(Datos);

        if(Datos['estado'] == 'exitoso'){
          cargarDispositivos();
          $("#añadirDispositivo").modal('hide');
          const Toast = Swal.mixin({
            toast: true,
            position: 'top-end',
            showConfirmButton: false,
            timer: 3000,
            timerProgressBar: true,
            didOpen: (toast) => {
              toast.addEventListener('mouseenter', Swal.stopTimer)
              toast.addEventListener('mouseleave', Swal.resumeTimer)
            }
          })

          Toast.fire({
            icon: 'success',
            title: 'Dispositivo eliminado de forma exitosa'
          })
          $("#añadirDispositivo .btn-success").html("Añadir");
          $("#añadirDispositivo .btn-success").attr('disabled', false);
        }else if(Datos['estado'] == 'error'){
          $("#AñadirError").html("Error: " + Datos['detalle'] + " [" + Datos['codigo'] + "]");
          $("#añadirDispositivo .btn-success").html("Añadir");
          $("#añadirDispositivo .btn-success").attr('disabled', false);
        }else{
          $("#AñadirError").html("Hubo un error desconocido, inténtelo de nuevo mas tarde o comuníquese con soporte.");
          $("#añadirDispositivo .btn-success").html("Añadir");
          $("#añadirDispositivo .btn-success").attr('disabled', false);
        }
 
      },
      error: function(){
        $("#AñadirError").html("Hubo un error desconocido, inténtelo de nuevo mas tarde o comuníquese con soporte.");
        $("#añadirDispositivo .btn-success").html("Añadir");
        $("#añadirDispositivo .btn-success").attr('disabled', false);
      }
    })
  }
})

cargarDispositivos();

    </script>

</body>
</html>