<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('gestion-general*bases-de-datos');

  // Establecemos el permiso necesario
  seRequirePermiso('gestion_general_basesdedatos');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Gestión General ~ Bases de datos</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="../Recursos/css/Estilos.css" rel="stylesheet">
  <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/dt/dt-1.13.1/datatables.min.css"/>

  <!-- Sweet2Alert -->
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.15/dist/sweetalert2.all.min.js"></script>

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->
 
        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

          <!-- Contenido -->
          <div id="Contenido" style="display: none">

            <!-- Titulo -->
            <div class="d-sm-flex align-items-center justify-content-between mb-4">
              <h1 class="h4 mb-0 text-gray-800">Gestión general - Bases de datos</h1> 

              <div>
                <a onclick="descargarBackup()"><button type="button" class="ml-2 btn btn-primary">Descargar Backup</button></a>
              </div>
            </div>
            <!-- Fin de Titulo -->

          </div>
          <!-- Fin de Contenido --> 

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>";</script>
    <script src="../Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="../Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="../Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="../Recursos/js/Carga.js"></script>
    <script src="https://unpkg.com/jspdf@latest/dist/jspdf.umd.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jspdf-autotable/3.5.16/jspdf.plugin.autotable.min.js"></script>
    <script src="../Recursos/js/General.js?v1"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/v/dt/dt-1.13.1/datatables.min.js"></script>
    <script>
  
var Tablas;
$.ajax({
  type: "GET",
  url: Url + 'Api/gestionGeneral',
  data: {"Tipo": "obtenerListadoTablas"},
  success: function(Datos, textStatus, xhr){

    // Establecemos datos
    Datos = $.parseJSON(Datos);
    Tablas = Datos;

    // Verificamos estado de la petición
    if(Datos['estado'] == 'exitoso'){

      $("#Contenido").append('<table id="Tablas" class="table" cellspacing="0" width="100%"><thead><tr><th>Nombre</th><th class="text-center">Acciones</th></tr></thead><tbody></tbody></table>');

      for(var i = 0; i < Datos['detalle'].length; i++){

        $("#Tablas tbody").append('<tr><td>' + Datos['detalle'][i] + '</td><td class="text-center"><i data-bs-toggle="tooltip" descargarTabla="' + Datos['detalle'][i] + '" data-bs-title="Descargar esta tabla unicamente" class="fa-solid fa-download"></i></td></tr>');
      }

      $('#Tablas').DataTable({
        "language": {
          "sProcessing":    "Procesando...",
          "sLengthMenu":    "Mostrar _MENU_ tablas",
          "sZeroRecords":   "No se encontraron resultados",
          "sEmptyTable":    "Ningún dato disponible en esta tabla",
          "sInfo":          "Mostrando tablas del _START_ al _END_ de un total de _TOTAL_ tablas",
          "sInfoEmpty":     "Mostrando tablas del 0 al 0 de un total de 0 tablas",
          "sInfoFiltered":  "(filtrado de un total de _MAX_ tablas)",
          "sInfoPostFix":   "",
          "sSearch":        "Buscar:",
          "sUrl":           "",
          "sInfoThousands":  ",",
          "sLoadingRecords": "Cargando...",
          "oPaginate": {
            "sFirst":    "Primero",
            "sLast":    "Último",
            "sNext":    "Siguiente",
            "sPrevious": "Anterior"
          },
          "oAria": {
            "sSortAscending":  ": Activar para ordenar la columna de manera ascendente",
            "sSortDescending": ": Activar para ordenar la columna de manera descendente"
          }
        }
      });

      quitarLoader(); 

      $("[descargarTabla]").on("click", function(){
        window.open(Url + 'Api/gestionGeneral?Tipo=descargaDeBackupEspecifico&Tabla=' + $(this).attr("descargarTabla"), '_blank');
      })

    }else if(Datos['estado'] == 'error'){
      errorLoader(Datos['detalle'], Datos['codigo']);
    }else{
      errorLoader();
    }
          
  },
  error: function(){
    errorLoader()
  }
})

function descargarBackup(){
  window.open(Url + 'Api/gestionGeneral?Tipo=descargaDeBackupTotal', '_blank');
}

    </script>

</body>
</html>