<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('gestion-general*usuarios');

  // Establecemos el permiso necesario
  seRequirePermiso('gestion_general_usuarios');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Gestión General ~ Usuarios</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="../Recursos/css/Estilos.css" rel="stylesheet">
  <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/dt/dt-1.13.1/datatables.min.css"/>

  <!-- Sweet2Alert -->
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.15/dist/sweetalert2.all.min.js"></script>

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->
 
        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

          <!-- Contenido -->
          <div id="Contenido" style="display: none">

            <!-- Titulo -->
            <div class="d-sm-flex align-items-center justify-content-between mb-4">
              <h1 class="h4 mb-0 text-gray-800">Gestión general - Usuarios</h1> 

              <!--<div>
                <a onclick="descargarBackup()"><button type="button" class="ml-2 btn btn-primary">Descargar Backup</button></a>
              </div>-->
            </div>
            <!-- Fin de Titulo -->

            <!-- Tabla -->
            <div class="row" style="justify-content: center">
              <div style="">
                <table style="display: none;" class="table-striped" id="tablaUsuarios"></table>  
              </div>
            </div>
            <!-- Fin de Tabla -->

          </div>
          <!-- Fin de Contenido --> 

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>";</script>
    <script src="../Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="../Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="../Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="../Recursos/js/Carga.js"></script>
    <script src="../Recursos/js/General.js?v1"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/v/dt/dt-1.13.1/datatables.min.js"></script>

<script>

var listadoUsuarios;

function idiomasEspeciales(){

  // Obtenemos los usuarios
  $.ajax({
    type: "GET",
    url: Url + 'Api/gestionGeneral',
    data: {"Tipo": "obtenerUsuarios"},
    success: function(Datos, textStatus, xhr){

      // Establecemos datos
      Datos = $.parseJSON(Datos);

      if(Datos['estado'] == 'exitoso'){

        // Copiamos los usuarios a la variable
        listadoUsuarios = Datos['detalle'];

        // Creamos tabla
        $("#tablaUsuarios").html(`<thead>
          <tr>
            <th>${obtenerItemIdioma("gestion-general.usuarios.tabla.Id")}</th>
            <th>${obtenerItemIdioma("gestion-general.usuarios.tabla.Nombre")}</th>
            <th>${obtenerItemIdioma("gestion-general.usuarios.tabla.DNI")}</th>
            <th>${obtenerItemIdioma("gestion-general.usuarios.tabla.Usuario")}</th>
            <th>${obtenerItemIdioma("gestion-general.usuarios.tabla.Correo")}</th>
            <th>${obtenerItemIdioma("gestion-general.usuarios.tabla.Institución")}</th>
            <th>${obtenerItemIdioma("gestion-general.usuarios.tabla.Estado")}</th>
            <th>${obtenerItemIdioma("gestion-general.usuarios.tabla.Permisos")}</th>
            <th>${obtenerItemIdioma("gestion-general.usuarios.tabla.Datos")}</th>
            <th>${obtenerItemIdioma("gestion-general.usuarios.tabla.Acciones")}</th>
          </tr>
        </thead><tbody></tbody>`);

        // Insertamos datos en la tabla
        var DatosTabla = "";
        for(var i = 0; i < Datos['detalle'].length; i++){
          var Permisos = "";
          for(var a = 0; a < Object.keys($.parseJSON(Datos['detalle'][i]['Permisos'])).length; a++){
            Permisos += `${Object.keys($.parseJSON(Datos['detalle'][i]['Permisos']))[a]}<br>`;
          }

          DatosTabla += `<tr>
            <td>${Datos['detalle'][i]['Id']}</td>
            <td>${Datos['detalle'][i]['Nombre']} ${Datos['detalle'][i]['Apellido']}</td>
            <td>${Number(Datos['detalle'][i]['DNI']).toLocaleString('es-ES', { style: 'decimal', useGrouping: true })}</td>
            <td><div style="display: flex; align-items: center"><img style="height: 2rem; margin-right: 0.25rem" src="${Url}Api/imagenDePerfil${Datos['detalle'][i]['ImagenPerfil']}"> @${Datos['detalle'][i]['Usuario']}</div></td>
            <td>${Datos['detalle'][i]['Correo']}</td>
            <td class="text-center"><img data-bs-toggle="popover" data-bs-trigger="hover focus" data-bs-title="${Datos['detalle'][i]['InstiNombreAbreviado']}" data-bs-content="${Datos['detalle'][i]['InstiNombre']}" style="height: 2rem; margin-right: 0.25rem" src="${Datos['detalle'][i]['InstiLogo']}"></td>
            <td class="text-center">${obtenerInsigniaTexto(Datos['detalle'][i]['Estado'])}</td>
            <td class="text-center"><i data-bs-toggle="popover" data-bs-html="true" data-bs-trigger="hover focus" data-bs-title="Permisos" data-bs-content="${Permisos}" class="fa-solid fa-eye"></i></td>
            <td class="text-center"><i class="fa-solid fa-eye"></i></td>
            <td></td>
          </tr>`;
        }
        $("#tablaUsuarios tbody").append(DatosTabla);

        // Quitamos leader
        quitarLoader();

        // Activamos tooltip
        $("[data-bs-toggle='tooltip']").tooltip();
        $("[data-bs-toggle='popover']").popover();

        // Mostramos tabla
        $("#tablaUsuarios").show();

        // Iniciamos tabla
        $('#tablaUsuarios').DataTable({
          scrollX: true,
          language: {
            "sProcessing": obtenerItemIdioma("gestion-general.usuarios.tabla.sProcessing"),
            "sLengthMenu": obtenerItemIdioma("gestion-general.usuarios.tabla.sLengthMenu"),
            "sZeroRecords": obtenerItemIdioma("gestion-general.usuarios.tabla.sZeroRecords"),
            "sEmptyTable": obtenerItemIdioma("gestion-general.usuarios.tabla.sEmptyTable"),
            "sInfo": obtenerItemIdioma("gestion-general.usuarios.tabla.sInfo"),
            "sInfoEmpty": obtenerItemIdioma("gestion-general.usuarios.tabla.sInfoEmpty"),
            "sInfoFiltered": obtenerItemIdioma("gestion-general.usuarios.tabla.sInfoFiltered"),
            "sInfoPostFix": obtenerItemIdioma("gestion-general.usuarios.tabla.sInfoPostFix"),
            "sSearch": obtenerItemIdioma("gestion-general.usuarios.tabla.sSearch"),
            "sUrl": obtenerItemIdioma("gestion-general.usuarios.tabla.sUrl"),
            "sInfoThousands": obtenerItemIdioma("gestion-general.usuarios.tabla.sInfoThousands"),
            "sLoadingRecords": obtenerItemIdioma("gestion-general.usuarios.tabla.sLoadingRecords"),
            "oPaginate": {
              "sFirst": obtenerItemIdioma("gestion-general.usuarios.tabla.sFirst"),
              "sLast": obtenerItemIdioma("gestion-general.usuarios.tabla.sLast"),
              "sNext": obtenerItemIdioma("gestion-general.usuarios.tabla.sNext"),
              "sPrevious": obtenerItemIdioma("gestion-general.usuarios.tabla.sPrevious")
            },
            "oAria": {
              "sSortAscending": obtenerItemIdioma("gestion-general.usuarios.tabla.sSortAscending"),
              "sSortDescending": obtenerItemIdioma("gestion-general.usuarios.tabla.sSortDescending")
            }
          }
        });

        // Responsive tabla.
        const verificarWidth = new ResizeObserver(entries => {
          for (let entry of entries) {
            console.log(entry.contentRect.width);
            $("#tablaUsuarios_wrapper").parent().css("width", entry.contentRect.width);
          }
        });
        verificarWidth.observe(document.getElementById("Contenido"));

        setTimeout(function(){
          $("#tablaUsuarios").parent().css("width",$("#Contenido").width());
        }, 500);

      }else if(Datos['estado'] == 'error'){
        errorLoader(Datos['detalle'], Datos['codigo']);
      }else{
        errorLoader();
      }

    },
    error: function(){
      errorLoader();
    }
  })

}

</script>

</body>
</html>