<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion("gestion-recursos");

  // Establecemos el permiso necesario
  seRequirePermiso('gestionRecursosFisicos');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Recursos Físicos</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="../Recursos/css/Estilos.css" rel="stylesheet">
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.15/dist/sweetalert2.all.min.js"></script>
  <link href="https://cdn.datatables.net/1.13.1/css/jquery.dataTables.min.css">
  <style>.container-fluid .popover{max-width: 100%!important}; #fichaRegistro .popover{max-width: 50vw!important}</style>


  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->

        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Titulo -->
          <div class="d-sm-flex align-items-center justify-content-between mb-4">
            <h1 class="h4 mb-0 text-gray-800">Listado de recursos físicos <small><b>(<a id="pagActual">Registros</a>)</b></small></h1>

            <div>
              <a id="circulación" type="button"  class="mt-1 mb-1 btn btn-primary btn-icon-split"><span class="icon text-white-50"><i class="fa-solid fa-arrows-repeat"></i></span> <span class="text">Circulación</span></a>
              <a onclick="descargarBackup()" type="button"  class="mt-1 mb-1 btn btn-primary btn-icon-split"><span class="icon text-white-50"><i class="fa-solid fa-file-arrow-down"></i></span> <span class="text">Descargar Backup</span></a>
              <a id="verRegistros" type="button"  class="mt-1 mb-1 btn btn-primary btn-icon-split"><span class="icon text-white-50"><i class="fa-solid fa-clipboard"></i></span> <span class="text">Ver Registros</span></a>
              <a id="verEjemplares" type="button"  class="mt-1 mb-1 btn btn-primary btn-icon-split"><span class="icon text-white-50"><i class="fa-solid fa-book-copy"></i></span> <span class="text">Ver Ejemplares</span></a>
              <a onclick="añadirRecurso()" type="button"  class="mt-1 mb-1 btn btn-primary btn-icon-split"><span class="icon text-white-50"><i class="fa-solid fa-book-medical"></i></span> <span class="text">Añadir recurso físico</span></a>
              <a onclick="busquedaAvanzada()" type="button"  class="mt-1 mb-1 btn btn-primary btn-icon-split"><span class="icon text-white-50"><i class="fa-solid fa-magnifying-glass"></i></span> <span class="text">Búsqueda avanzada <span class="badge text-bg-light">Muy pronto</span></span></a>
            </div>
          </div>

          <!-- Tabla -->
          <div id="ContenedorRegistros" style="border-radius: 15px; width: 100%; margin: 1rem; background-color: white; padding: 1rem;"></div>
          <!-- Fin de Tabla -->

          <!-- Tabla -->
          <div id="ContenedorResultadoBusqueda" style="display: none; border-radius: 15px; width: 100%; margin: 1rem; background-color: white; padding: 1rem;"></div>
          <!-- Fin de Tabla -->

          <!-- Tabla -->
          <div id="ContenedorEjemplares" style="display: none; border-radius: 15px; width: 100%; margin: 1rem; background-color: white; padding: 1rem;"></div>
          <!-- Fin de Tabla -->


        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>";</script>
    <script src="../Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="../Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="../Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="../Recursos/js/General.js"></script>
    <script src="./Recursos/js/Carga.js?v2"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    <script src="https://cdn.datatables.net/1.13.1/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.1/js/dataTables.bootstrap5.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/animejs@3.2.1/lib/anime.min.js"></script>
    <script src="../Recursos/js/gestionRecursosFisicos.js?v40<?php echo time(); ?>"></script>
    <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />
    <script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/js/select2.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
    <script src="https://unpkg.com/jspdf@latest/dist/jspdf.umd.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jspdf-autotable/3.5.16/jspdf.plugin.autotable.min.js"></script>
    <script src="../Recursos/js/gestionRecursosFisicos__EdiciónRegistro.js?v40<?php echo time(); ?>"></script>
    <script>
function descargarListado(){
  window.jsPDF = window.jspdf.jsPDF;
  var doc = new jsPDF();
  doc.autoTable({
    html: '#ListadoDescarga',
    startY: 20,
    margin: { top: 20 },
    tableWidth: 'auto',
    columnWidth: 'auto',
    pageBreak: 'auto'
  });
  doc.save('Usuarios.pdf');
}

    </script>
    <script>$("#verRegistros").click();</script>
    
</body>
</html>