<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion("gestion-recursosonline");

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Recursos Online</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="../Recursos/css/Estilos.css" rel="stylesheet">
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.15/dist/sweetalert2.all.min.js"></script>
  <link href="https://cdn.datatables.net/1.13.1/css/jquery.dataTables.min.css">


  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->

        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Titulo -->
          <div class="d-sm-flex align-items-center justify-content-between mb-4">
            <h1 class="h4 mb-0 text-gray-800">Listado de recursos online</h1> <a onclick="descargarBackup()"><button type="button" class="ml-2 btn btn-primary">Descargar Backup de Recursos Online</button></a>
          </div>

          <!-- Tabla -->
          <div style="border-radius: 15px; width: 100%; margin: 1rem; background-color: white; padding: 1rem;">
            <table class="table table-fluid" id="Recursos">
              <thead>
                <tr>
                  <th>MFN</th>
                  <th>Titulo</th>
                  <th>Subido por</th>
                  <th>Fecha de subida</th>
                  <th>Visitas</th>
                  <th class="text-center">Acciones</th></tr>
              </thead>
              <tbody>
              </tbody>
            </table>
            <h5 id="CargandoRecursos" class="text-center"><strong>Cargando recursos...</strong></h5>
          </div>
          <!-- Fin de Tabla -->

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>";</script>
    <script src="../Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="../Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="../Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="../Recursos/js/General.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    <script src="https://cdn.datatables.net/1.13.1/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.1/js/dataTables.bootstrap5.min.js"></script>
    <script>

Swal.fire({
  icon: 'info',
  allowOutsideClick: false,
  title: 'Aviso importante',
  html: 'Es fundamental realizar backups <u>periódicos</u> para garantizar la preservación de toda información valiosa. Por este motivo, se recomienda realizar backups de Usuarios, Recursos Online y Recursos Físicos <u>semanalmente</u> o <u>ante cualquier cambio significativo</u> a fin de contar siempre con un respaldo actualizado. Si bien SIBAU realiza backups semanales, es importante contar con uno propio adicional para mayor seguridad.<br><br><i>Agradecemos su comprensión y colaboración en este sentido.</i>',
confirmButtonText: "¡Lo entiendo!",
  footer: 'Para mas información escribenos a hola@sibau.com.ar'
})

var Recursos = '';
$.ajax({
  type: "GET",
  url: Url + 'Api/RecursosOnline?Tipo=ObtenerDeInstitucion',
  success: function(Datos, textStatus, xhr){

    // Establecemos datos
    Datos = $.parseJSON(Datos);

    Recursos = Datos['detalle'];
        
    // Verificamos estado de la petición
    if(Datos['estado'] == 'exitoso'){

        var Tabla = '';

        for(var i = 0; i < Datos['detalle'].length; i++){

        Tabla += "<tr><td>" + Datos['detalle'][i]['Id'] + "</td>";
        Tabla += "<td>" + Datos['detalle'][i]['Titulo'] + "</td>";
        Tabla += "<td>" + Datos['detalle'][i]['Usuario'] + "</td>";
        Tabla += "<td>" + Datos['detalle'][i]['Fecha'] + "</td>";
        Tabla += "<td>" + Datos['detalle'][i]['Visitas'] + "</td>";
        Tabla += "<td></td><i onclick='window.location.href = " + '"' + Url + "recurso/" + Datos['detalle'][i]['Id'] + '"' + "class='fa-duotone fa-arrow-up-right-from-square'></i></tr>";
                
        }

        $("#Recursos tbody").html(Tabla);

        if(Datos['detalle'] == '0'){
        $("#CargandoRecursos strong").html("Aun no hay recursos, agrega uno."); 
        }else{
        $("#CargandoRecursos").hide();
        $('#Recursos').DataTable({
            "language": {
            "sProcessing":    "Procesando...",
            "sLengthMenu":    "Mostrar _MENU_ registros",
            "sZeroRecords":   "No se encontraron resultados",
            "sEmptyTable":    "Ningún dato disponible en esta tabla",
            "sInfo":          "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
            "sInfoEmpty":     "Mostrando registros del 0 al 0 de un total de 0 registros",
            "sInfoFiltered":  "(filtrado de un total de _MAX_ registros)",
            "sInfoPostFix":   "",
            "sSearch":        "Buscar:",
            "sUrl":           "",
            "sInfoThousands":  ",",
            "sLoadingRecords": "Cargando...",
            "oPaginate": {
                "sFirst":    "Primero",
                "sLast":    "Último",
                "sNext":    "Siguiente",
                "sPrevious": "Anterior"
            },
            "oAria": {
                "sSortAscending":  ": Activar para ordenar la columna de manera ascendente",
                "sSortDescending": ": Activar para ordenar la columna de manera descendente"
            }
            }
        });
        }

    }else if(Datos['estado'] == 'error'){
        $("#CargandoRecursos strong").html(Datos['detalle'] + " [" + Datos['codigo'] + "]"); 
    }else{
        $("#CargandoRecursos strong").html("Hubo un error desconocido"); 
    }
          
  },
  error: function(){
    $("#CargandoRecursos strong").html("Ups.. Hubo un error al intentar cargar los recursos. Inténtelo de nuevo mas tarde, si aun no funciona comuníquese con soporte.")
  }
})


function descargarBackup(){
  window.open(Url + 'Api/RecursosOnline?Tipo=descargarBackup', '_blank');
}

</script>

</body>
</html>