<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('gestion-usuarios');

  // Establecemos el permiso necesario
  seRequirePermiso('gestionarUsuarios');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Usuarios</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="../Recursos/css/Estilos.css" rel="stylesheet">
  <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/dt/dt-1.13.1/datatables.min.css"/>

  <!-- Sweet2Alert -->
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.15/dist/sweetalert2.all.min.js"></script>

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->
 
        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

          <!-- Contenido -->
          <div id="Contenido" style="display: none">

            <!-- Contenedor superior -->
            <div class="row mb-5">

              <!-- Titulo -->
              <div class="d-sm-flex align-items-center justify-content-between mb-4">
                <h1 class="h4 mb-0 text-gray-800">Usuarios</h1> 

                <div>
                  <a onclick="descargarBackup()"><button type="button" class="ml-2 btn btn-primary">Descargar Backup</button></a>
                  <a onclick="descargarPDF()"><button type="button" class="ml-2 btn btn-primary">Descargar PDF</button></a>
                </div>
              </div>

            </div>
            <!-- Fin de Contenedor superior -->

            <!-- Tabla -->
            <table id="Usuarios" class="table" cellspacing="0" width="100%">
              <thead>
                <tr>
                  <th class="text-center" scope="col">Id</th>
                  <th>Nombre y apellido</th>
                  <th>DNI</th>
                  <th>Usuario</th>
                  <th>Correo</th>
                  <th>Registrado</th>
                  <th class="text-center">Rango</th>
                  <th class='text-center'>Acciones</th>
                </tr>
              </thead>
              <tbody>
              </tbody>
            </table>
            <table id="TablaPDF" style="display: none"><thead><tr><th>Id</th><th>Nombre y apellido</th><th>DNI</th><th>Usuario</th><th>Correo</th><th>Registrado</th></tr></thead><tbody></tbody></table>
            <!-- Fin de Tabla -->

          </div>
          <!-- Fin de Contenido --> 

          <!-- Confirmar eliminado -->
          <div class="modal fade" id="confirmarEliminación" tabindex="-1" aria-hidden="true">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h1 class="modal-title fs-5">Confirmar eliminado</h1>
                  <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                  <input type="hidden" id="IdEliminado" name="IdEliminado">
                  <p>A continuación seleccione que desea eliminar del usuario <strong>Bautista Izaguirre</strong> <small>[DNI: 47.695.606]</small></p>
                  <form id="eliminarUsuario">                    

                    <hr>

                    <div class="form-check mb-2 mt-2">
                      <input class="form-check-input" type="checkbox" value="" id="Usuario" name="Usuario">
                      <label class="form-check-label" for="Usuario">
                      Usuario completo
                      </label>
                      <a class="Etapa" id="EtapaUsuario"></a>
                    </div>

                    <hr>

                    <div class="form-check mb-2 mt-2">
                      <input class="form-check-input" type="checkbox" value="" id="Comentarios" name="Comentarios">
                      <label class="form-check-label" for="Comentarios">
                      10 Comentarios
                      </label>
                      <a class="Etapa" id="EtapaComentarios"></a>
                    </div>

                    <hr>

                    <div class="form-check mb-2 mt-2">
                      <input class="form-check-input" type="checkbox" value="" id="RecursosOnline" name="RecursosOnline">
                      <label class="form-check-label" for="RecursosOnline">
                      5 Recursos online
                      </label>
                      <a class="Etapa" id="EtapaRecursosOnline"></a>
                    </div>

                    <hr>

                    <div class="form-check mb-2 mt-2">
                      <input class="form-check-input" type="checkbox" value="" id="Valoraciones" name="Valoraciones">
                      <label class="form-check-label" for="Valoraciones">
                      8 Valoraciones
                      </label>
                      <a class="Etapa" id="EtapaValoraciones"></a>
                    </div>

                    <hr>

                    <div class="form-check mb-2 mt-2">
                      <input class="form-check-input" type="checkbox" value="" id="AulaVirtual" name="AulaVirtual">
                      <label class="form-check-label" for="AulaVirtual">
                      3 Preguntas en Aula Virtual
                      </label>
                      <a class="Etapa" id="EtapaAulaVirtual"></a>
                    </div>

                    <hr>

                    <div class="form-check mb-2 mt-2">
                      <input class="form-check-input" type="checkbox" value="" id="Chats" name="Chats">
                      <label class="form-check-label" for="Chats">
                      Chats privados
                      </label>
                      <a class="Etapa" id="EtapaChats"></a>
                    </div>
                  </form>

                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cerrar</button>
                  <button type="button" class="btn btn-danger">Confirmar</button>
                </div>
              </div>
            </div>
          </div>
          <!-- Fin de Confirmar eliminado -->

           <!-- Historial de acciones -->
           <div class="modal fade" id="historialDeAcciones" tabindex="-1" aria-hidden="true">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h1 class="modal-title fs-5">Historial de acciones del usuario ID: #<a id="IdUsuario"></a></h1>
                  <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                  <table id="historialDeAccionesTabla" class="display">
                    <thead>
                      <tr>
                        <th>Id</th>
                        <th>Tipo</th>
                        <th>Detalles</th>
                        <th>Fecha</th>
                      </tr>
                    </thead>
                    <tbody>
                      <!--<tr>
                        <td>Row 1 Data 1</td>
                        <td>Row 1 Data 2</td>
                      </tr>-->
                    </tbody>
                  </table>
                  <p id="Estado" class="text-center"><strong>Obteniendo permisos...</strong></p>
                </div>
              </div>
            </div>
          </div>
          <!-- Fin de Historial de acciones -->

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>";</script>
    <script src="../Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="../Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="../Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="../Recursos/js/Carga.js"></script>
    <script src="https://unpkg.com/jspdf@latest/dist/jspdf.umd.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jspdf-autotable/3.5.16/jspdf.plugin.autotable.min.js"></script>
    <script src="../Recursos/js/General.js?v1"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/v/dt/dt-1.13.1/datatables.min.js"></script>
    <script src="../Recursos/js/gestionUsuarios.js?t=<?php echo time() ?>"></script>

</body>
</html>