<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Hola <?php echo $_SESSION['Nombre'] ?></title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="./Recursos/css/Estilos.css" rel="stylesheet">
  <link href="./Recursos/css/Index.css" rel="stylesheet">

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

  <!-- Manifiesto -->
  <link rel="manifest" href="manifest.json">
  <link rel="apple-touch-icon" href="https://sibau.com.ar/Recursos/Logo.png">
  <meta name="apple-mobile-web-app-status-bar" content="#F8F9FC">
  <meta name="theme-color" content="#4E73DF">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

      
        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->
 
        <!-- Contenedor -->
        <div class="container-fluid">

            <!-- Contenedor superior -->
            <div class="row mb-5">

              <!-- Titulo -->
              <h2 class="text-center col h4 mb-0 text-gray-800 "><strong class="bienvenida"><p style="margin: 0; padding: 0" class="placeholder-glow"><span class="placeholder col-12" style="width: 50%;"></span></p></strong></h2>

            </div>
            <!-- Fin de Contenedor superior -->

            <!-- Búsqueda -->
            <div class="row">
              <div class="col-2"></div>
              <form style="display: inline-block!important" class="col-8 d-none form-inline mr-auto ml-md-3 my-2 my-md-0 mw-100 navbar-search">
                <div class="input-group BuscaPrincipal">
                  <input type="text" autocomplete="off" class="form-control bg-white border-0 small" id="busquedaPrincipal" placeholder="Buscador" aria-label="Search" aria-describedby="basic-addon2">
                  <div class="input-group-append">
                    <button class="btn btn-primary" type="button">
                      <i class="fas fa-search fa-sm"></i>
                    </button>
                  </div>
                </div>

                <div style="position: relative">
                  <div id="cuadroBusqueda" style="display: none; border-bottom-left-radius: 0.35rem; border-bottom-right-radius: 0.35rem; background-color: white; padding: 1rem;">

                  <div class="tipo-buscar" id="buscarRecursosFisicos"><p SibauMulti="Inicio.Buscador.buscar.fisicos"></p></div>
                  <div class="tipo-buscar" id="buscarRecursosOnline"><p SibauMulti="Inicio.Buscador.buscar.online"></p></div>
                  <div class="tipo-buscar" id="buscarUsuarios"><p SibauMulti="Inicio.Buscador.buscar.usuarios"></p></div>

                  </div>
                </div>

              </form> 
            </div>
            <!-- Fin de Búsqueda -->

            <hr style="margin-top: 2rem">

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

  <!-- Jquery -->
  <script src="./Recursos/vendor/jquery/jquery.min.js"></script>
  <script src="./Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>

  <!-- Bootstrap -->
  <script src="./Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    
  <!-- Generales -->
  <script src="./Recursos/js/Carga.js"></script>
  <script src="./Recursos/js/General.js?t=<?php echo time(); ?>"></script>
  
  <!-- Sweet2Alert -->
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.16/dist/sweetalert2.all.min.js"></script>

  <!-- Propios del archivo -->
  <script src="./Recursos/js/Index.js?t=<?php echo time(); ?>"></script>
  <script>quitarLoader();</script>

<script>

function buscarUsuarios(Búsqueda){
  $("#busquedaDeUsuarios").modal("hide");
  $("#busquedaDeUsuarios").remove();
  $("body").append('<div class="modal fade" id="busquedaDeUsuarios" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true"><div class="modal-dialog"><div class="modal-content"><div class="modal-header"><h1 class="modal-title fs-5" id="staticBackdropLabel">Búsqueda de usuarios</h1><button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button></div><div class="modal-body"><p style="margin: 1rem; text-align: center"><i class="fa-light fa-spinner-third fa-spin"></i> <i>Buscando</i></p></div></div></div></div>');
  $("#busquedaDeUsuarios").modal("show");

  $("#myModal").on('hide.bs.modal', function(){
    $("#busquedaDeUsuarios").remove();
  });

  $.ajax({
    type: "GET",
    url: Url + "Api/Usuarios",
    data: {"Tipo": "buscarUsuario","Busqueda": Búsqueda},
    success: function(Datos, textStatus, xhr){

      // Establecemos datos
      Datos = $.parseJSON(Datos);

      // Verificamos petición
      if(Datos['estado'] == 'exitoso'){

        if(Datos['detalle'].length > 0){
          $("#busquedaDeUsuarios p").remove();
          $("#busquedaDeUsuarios .modal-body").append("<h5>Resultados de tu busqueda:</h5>");

          for(var i = 0; i < Datos['detalle'].length; i++){
            $("#busquedaDeUsuarios .modal-body").append('<div usuario="@' + Datos['detalle'][i]['Usuario'] + '" class="CajaResultado mt-1"><img src="https://desarrollo.sibau.com.ar/Api/imagenDePerfil' + Datos['detalle'][i]['ImagenPerfil'] + '"><div class="Datos"><p class="Nombre">' + Datos['detalle'][i]['Nombre'] + ' ' + obtenerInsignia(Datos['detalle'][i]['Estado']) +  '</p><p class="Usuario">@' + Datos['detalle'][i]['Usuario'] + ' ⁓ <intitucion data-bs-toggle="tooltip" data-bs-title="' + Datos['detalle'][i]['InstitucionCompleta'] + '"><i class="fa-thin fa-school"></i> ' + Datos['detalle'][i]['Institucion'] + '</intitucion></p></div></div>');    
          }

          $(".CajaResultado").on("click", function(){
            window.location.href=Url + "perfil/" + $(this).attr("usuario");
          })

          $("[data-bs-toggle='tooltip']").tooltip();

        }else{
          $("#busquedaDeUsuarios p").html('<i style="color: #4e73df" class="fa-solid fa-magnifying-glass"></i> <b>No hubo resultados a tu busqueda.</b>');
        }

      }else if(Datos['estado'] == 'error'){
        $("#busquedaDeUsuarios p").html('<i class="fa-regular fa-xmark" style="color: red;"></i> <i>' + Datos['detalle'] + ' [' + Datos['codigo'] + ']</i>');
      }else{
        $("#busquedaDeUsuarios p").html('<i class="fa-regular fa-xmark" style="color: red;"></i> <i>Hubo un error desconocido.</i>');
      }
    },
    error: function(){
      $("#busquedaDeUsuarios p").html('<i class="fa-regular fa-xmark" style="color: red;"></i> <i>Hubo un error desconocido.</i>');
    }
  })
}

    </script>
    
    <?php if(isset($_GET['error'])){ ?>
      <script>
        Swal.fire({
          icon: 'error',
          title: 'Oops...',
          text: '<?php echo $_GET['error'] ?>',
        })
      </script>
    <?php } ?>


</body>
</html>