<?php

  // Importamos el sistema
  require("./sistema.php");

  // Importamos el sistema ingreso Google
  require("./sistemaGoogle.php");

  if(!isset($_GET['Despues'])){
    $Despues = "";
  }else{
    $Despues = $_GET['Despues'];
  }

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title SibauMulti="Ingresar.TituloNavegador">SIBAU - Ingresar</title>

  <!-- FontAwesome -->
  <script src="https://kit.fontawesome.com/7eb8e89503.js" crossorigin="anonymous"></script>
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="./Recursos/css/Estilos.css?v3" rel="stylesheet">
  <link href="./Recursos/css/Ingresar.css?v5" rel="stylesheet">

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

  <!-- Manifiesto -->
  <link rel="manifest" href="manifest.json">
  <link rel="apple-touch-icon" href="https://sibau.com.ar/Recursos/Logo.png">
  <meta name="apple-mobile-web-app-status-bar" content="#F8F9FC">
  <meta name="theme-color" content="#4E73DF">

</head>
<body class="bg-gradient-primary">
  <div class="container">
    <div class="row justify-content-center">
      <div class="col-xl-10 col-lg-12 col-md-9">
        <div class="card o-hidden border-0 shadow-lg my-5">
          <div class="card-body p-0">
            <div class="row">
              <div class="col-lg-6 d-none d-lg-block bg-login-image"></div>
              <div class="col-lg-6">
                <div class="p-5" style="position: relative">
                  <p style="position: absolute; bottom: 1rem; right: 1rem; margin: 0; color: #cfcfcf;"><?php echo obtenerVersion(); ?></p>
                  <div class="text-center">
                    <h1 class="h4 text-gray-900 mb-4"><dato SibauMulti="Ingresar.Titulo">¡Bienvenido de nuevo!</dato></h1>
                  </div>
                  <form class="user" id="FormularioIngreso">
                    <div class="form-group" id="RegistroUsuario">
                      <input type="text" class="form-control form-control-user" id="Usuario" name="Usuario" placeholder="Usuario, Correo o DNI">
                    </div>
                    <div class="form-group" id="RegistroContraseña">
                      <input type="password" class="form-control form-control-user" id="Contrasena" name="Contrasena" placeholder="Contraseña">
                    </div>
                    <button type="submit" SibauMulti="Ingresar.Ingresar" class="btn btn-primary btn-user btn-block Ingresar">Ingresar</button>
                    <p class="o"><span>o</span></p>
                    <div class="Social">
                      <div class="Opción" tipo="Google" style="border-color: #4285F4"><img src="./Recursos/img/Google.svg?v2"></div>
                      <div class="Opción" tipo="Qr" style="border-color: #4E73DF"><img src="./Recursos/img/Qr.svg?v2"></div>
                    </div>
                  </form>
                  <hr>
                  <div class="text-center">
                    <a class="small"  href="<?php echo $Configuracion['URL']['Panel'] ?>restablecerContraseña" SibauMulti="Ingresar.olvidoContraseña">¿Has olvidado tu contraseña?</a>
                  </div>
                  <div class="text-center">
                    <a class="small" href="<?php echo $Configuracion['URL']['Panel'] ?>registro" SibauMulti="Ingresar.crearCuenta">¡Crea una cuenta!</a>
                  </div>
                  <div class="text-center">
                    <a class="small" SibauMulti="Ingresar.politicaPrivacidad" href="https://sibau.com.ar/politica-privacidad.pdf">Política de privacidad</a>
                  </div>
                  <div class="text-center pt-3">
                    <img onclick="cambiarIdioma('ES')" style="height: 1rem" src="https://upload.wikimedia.org/wikipedia/commons/1/1a/Flag_of_Argentina.svg">
                    <img onclick="cambiarIdioma('PT')" style="height: 1rem" src="https://upload.wikimedia.org/wikipedia/commons/5/5c/Flag_of_Portugal.svg">
                    <img onclick="cambiarIdioma('DE')" style="height: 1rem" src="https://upload.wikimedia.org/wikipedia/commons/b/ba/Flag_of_Germany.svg">
                    <img onclick="cambiarIdioma('EN')" style="height: 1rem" src="https://upload.wikimedia.org/wikipedia/commons/8/83/Flag_of_the_United_Kingdom_%283-5%29.svg">
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <div id="legal"><a id="legalesTool" class="small">Todos los derechos reservados © <?php echo date('Y') ?> SIBAU. Diseñado y desarrollado por Bautista Izaguirre.</a></div>

  <!-- Ingreso con QR -->
  <div class="modal fade" id="modalIngresarConQR" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-body">
          <style>
            #QR img{
              width: 100%!important;
            }
          </style>
          <div id="CargaQR" class="text-center"><svg id="LogoLoader" height="15rem" viewBox="0 0 500 500" fill="none" xmlns="http://www.w3.org/2000/svg"><path id="LogoLinea1" d="M256 55.4252C222.218 60.0236 191.508 72.8336 165 94.615C158.788 99.7193 148.278 106.4 145.104 114.015C142.843 119.439 146.173 127.23 152.004 128.681C158.09 130.197 163.263 126.348 168 123.164C177.047 117.082 186.238 112.094 196 107.248C220.462 95.1045 249.838 88.5933 277 93.321C295.754 96.5852 314.708 104.71 330 115.924C341.767 124.552 351.702 139.276 368 136.532C379.563 134.584 391.034 122.459 385.991 110C382.724 101.931 372.856 94.4297 366 89.4198C335.407 67.0628 294.626 50.1674 256 55.4252Z" fill="#47B2E3"/><path id="LogoLinea2" d="M235 112.439C212.701 115.915 190.778 124.75 172.005 137.181C165.479 141.501 163.016 158.143 173.015 160.681C182.941 163.201 194.123 154.813 203 151.53C220.835 144.935 239.882 140.13 259 144.004C273.085 146.858 287.518 152.963 299 161.677C305.987 166.979 314.041 177.132 323.999 174.569C349.415 168.03 327.437 142.448 316.985 134.235C294.625 116.665 263.32 108.025 235 112.439Z" fill="#47B2E3"/><path id="LogoLinea3" d="M235 162.424C220.617 164.291 201.638 166.085 189.228 174.417C181.013 179.932 187.983 192.887 195 195.656C203.027 198.823 212.11 194.132 220 192.515C229.155 190.638 238.915 190.71 248 192.899C256.084 194.847 262.711 198.488 269 203.87C272.066 206.494 276.6 212.257 281 212.033C298.188 211.158 295.167 190.866 287.671 182.015C276.355 168.651 252.298 160.18 235 162.424Z" fill="#47B2E3"/><path d="M112 190.425C97.6499 192.379 84.302 194.703 71 200.694C67.5759 202.237 61.3145 203.541 59.0316 206.699C56.8402 209.731 59.0572 215.659 59.5756 219C61.231 229.669 62.9625 240.388 65 251C70.8027 281.222 75.2315 314.229 75.9853 345C76.2629 356.33 77.429 367.69 77.429 379C77.429 384.38 75.9166 390.058 78.858 395C85.4107 406.01 95.7543 412 108 412C134.035 412 161.23 411.482 186 420.815C212.381 430.755 228.36 451.5 259 446.866C277.984 443.995 291.403 427.628 309 420.811C327.246 413.742 347.604 412.031 367 412C385.751 411.97 405.231 414.365 416.968 395.996C421.903 388.272 418.485 374.83 419.09 366C420.75 341.758 421.142 317.122 424.425 293C427.425 270.962 431.473 249.037 434.285 227C434.944 221.842 439.882 209.759 435.643 205.699C428.481 198.84 412.43 195.249 403 193.12C364.877 184.51 324.048 195.441 290 213.255C279.31 218.848 268.976 224.618 259 231.424C255.796 233.61 250.088 239.519 246 239.115C242.615 238.781 239.583 234.688 237 232.76C230.135 227.635 222.646 223.098 215 219.248C185.595 204.441 145.997 185.797 112 190.425Z" fill="#6C7171"/><path d="M242 412V293V260C242 255.91 243.065 249.971 240.972 246.285C236.138 237.773 223.18 232.207 215 227.576C188.574 212.613 155.8 198.889 125 197.986C116.038 197.723 95.8384 194.897 88.6427 201.938C85.2368 205.27 90.4227 216.958 91.3488 221C95.5468 239.324 97.2784 258.403 99.8696 277C103.083 300.06 105.991 323.693 106 347C106.003 353.762 103.808 372.068 108.028 377.397C110.025 379.918 115.197 379 118 379C126.296 379.001 134.767 378.481 143 379.576C162.914 382.222 183.3 384.241 202 392.232C215.609 398.048 226.922 409.96 242 412Z" fill="#FEFEFE"/><path d="M249 412C268.855 411.59 285.385 394.231 304 388.09C331.11 379.145 360.817 379 389 379C387.738 363.304 389.842 347.598 390.91 332C393.942 287.738 399.774 244.662 408 201C367.215 188.607 316.02 204.63 281 226.316C272.818 231.383 254.553 239.12 250.603 248.3C248.858 252.358 250 258.657 250 263V297C250 335.337 249 373.744 249 412Z" fill="#FEFEFE"/></svg></div>
          <div id="PreQR" style="position: relative"><div style="display: flex; justify-content: center; align-items:center; position: absolute; width: 100%; height: 100%"><img style="width: 30%; height: 30%; border-radius: 1rem; background-color: white; padding: 1rem" src="https://sibau.com.ar/Recursos/Logo.svg"></div><div id="QR" class="text-center"></div></div>
          <p id="DetalleQR" class="text-center">Estamos generando un código QR... Aguarde un instante</p>
        </div>
      </div>
    </div>
  </div>

  <style>
  
    @media screen and (max-width: 1000px) {

      #correoNoConfirmado .ladoDerecho{
        flex: 0 0 100%;
        max-width: 100%;
      }

      #correoNoConfirmado .ladoIzquierdo{
        display: none;
      }

    }
  
  </style>

  <!-- Correo no verificado -->
  <div class="modal fade" id="correoNoConfirmado" tabindex="-1" aria-hidden="true">
    <div class="modal-dialog modal-xl">
      <div class="modal-content">
        <div class="modal-body row text-center" style="align-items: center">
          <div class="col-6 ladoIzquierdo" style="padding: 5rem"><img style="width: 100%" src="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/img/undraw_mail_re_duel.svg"></div>
          <div class="col-6 ladoDerecho" style="padding: 5rem"><h3 class="mb-3"><strong>Tu correo no fue verificado</strong></h3><p>Al momento de registrarte hemos enviado un correo electrónico con un link para validar tu cuenta. Busca el correo y verifique su cuenta.<br><br>En caso de que no te haya llegado el correo o lo hayas eliminado, puedes enviar un correo a <code onclick="window.location.href='mailto:hola@sibau.com.ar'">hola@sibau.com.ar</code></p><button onclick="window.location.href='https://mail.google.com'" class="btn btn-primary btn-user btn-block BotonesPaginadores">Abrir GMAIL</button></div>
        </div>
      </div>
    </div>
  </div>

  <div id="appleid-signin" data-color="black" data-border="true" data-type="sign in"></div>
  
  <!-- Scripts -->
  <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>"; var Despues = "<?php if(isset($_GET['Despues'])){echo $_GET['Despues'];} ?>";</script>
  <script src="./Recursos/vendor/jquery/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/qrcodejs/1.0.0/qrcode.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
  <script src="./Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
  <script src="./Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.15/dist/sweetalert2.all.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/js-cookie@3.0.1/dist/js.cookie.min.js"></script>
  <script src="./Recursos/js/General.js?t=<?php echo time(); ?>"></script>
  <script src="./Recursos/js/Ingresar.js?v3s"></script>
  <script>
    $(".Social [tipo='Google']").click(function(){
      window.location.href = "<?php echo $google_client->createAuthUrl(); ?>";
    })

    function idiomasEspeciales(){
      idiomaATTR("Ingresar.Usuario","#Usuario","placeholder");
      idiomaATTR("Ingresar.Contrasena","#Contrasena","placeholder");
      $("#legalesTool").text(`${obtenerItemIdioma("FooterPrimero")} © ${(new Date).getFullYear()} SIBAU ${obtenerItemIdioma("FooterAutor")}`);
      $("#legalesTool").tooltip('disable');
      $("#legalesTool").tooltip({"title": `${obtenerItemIdioma("FooterPrimero")} © ${(new Date).getFullYear()} SIBAU ${obtenerItemIdioma("FoterLargo")}`})
    }
  </script>

  <?php if(isset($_GET['code'])){ ?>
    
    <script>

      $.ajax({
        type: "GET",
        url: Url + 'Api/Usuarios?Tipo=ingresoGoogle&Codigo=<?php echo $_GET['code'] ?>',
        success: function(Datos, textStatus, xhr){

          Datos = $.parseJSON(Datos);

          if(Datos['estado'] == 'exitoso'){
            const Toast = Swal.mixin({
              toast: true,
              position: 'top-end',
              showConfirmButton: false,
              timer: 3000,
              timerProgressBar: true,
              didOpen: (toast) => {
                toast.addEventListener('mouseenter', Swal.stopTimer)
                toast.addEventListener('mouseleave', Swal.resumeTimer)
              }
            })
    
            Toast.fire({
              icon: 'success',
              title: 'Inicio de sesión exitoso.'
            })
    
            window.location.href = Url + Despues.replace('*', '/');
            
          }else if(Datos['estado'] == 'error'){
            const Toast=Swal.mixin({toast:!0,position:"top-end",showConfirmButton:!1,timer:3e3,timerProgressBar:!0,didOpen(e){e.addEventListener("mouseenter",Swal.stopTimer),e.addEventListener("mouseleave",Swal.resumeTimer)}});Toast.fire({icon:"error",title:"Error: " + Datos['detalle'] + " [" + Datos['codigo'] + "]"});

          }else{
            const Toast=Swal.mixin({toast:!0,position:"top-end",showConfirmButton:!1,timer:3e3,timerProgressBar:!0,didOpen(e){e.addEventListener("mouseenter",Swal.stopTimer),e.addEventListener("mouseleave",Swal.resumeTimer)}});Toast.fire({icon:"error",title:"Hubo un error al acceder con Google"});
          }

        },
        error: function(){
          const Toast=Swal.mixin({toast:!0,position:"top-end",showConfirmButton:!1,timer:3e3,timerProgressBar:!0,didOpen(e){e.addEventListener("mouseenter",Swal.stopTimer),e.addEventListener("mouseleave",Swal.resumeTimer)}});Toast.fire({icon:"error",title:"Hubo un error al acceder con Google"});
        }
      })

    </script>

  <?php } ?>

</body>
</html>