<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('mis-retiros');

  // Verificamos si la institución tiene habilitada la función
  verificarFunciónActual(8);

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title SibauMulti="misRetiros.tituloNavegador">SIBAU - Mis retiros</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="./Recursos/css/Estilos.css" rel="stylesheet">

  <!-- Select2 -->
  <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

  <!-- Menu lateral -->
  <?php include_once("./Recursos/navLateral.php") ?>
  <!-- Fin de Menu lateral -->

  <!-- Pagina -->
  <div id="content-wrapper" class="d-flex flex-column">
    <div id="content">

      <!-- Menu superior -->
      <?php include_once("./Recursos/navSuperior.php") ?>
      <!-- Fin de Nav -->

      <!-- Contenedor -->
      <div class="container-fluid">

        <!-- Loader -->
        <div id="Loader"></div>
        <!-- Fin de Loader -->

        <!-- Contenido -->
        <div style="display:none; justify-content: center;" id="Contenido" class="text-center row">

          <!-- Titulo -->
          <h2 class="Titulo col h4 mb-0 text-gray-800"><strong SibauMulti="misRetiros.titulo">Mis retiros</strong></h2>
          <p class="mb-2" SibauMulti="misRetiros.subtitulo"><span style='color: #26EC75'>• Devuelto</span> ⁓ <span style='color: #EC7C26'>• Pendiente de devolución</span> ⁓ <span style='color: #EC2626'>• Fuera de termino</span></p>

          <!-- Retiros -->
          <div class="Retiros row row-cols-1 row-cols-lg-2 row-cols-xl-3" style="justify-content:center">
<style>

.retiro{
  padding: 1rem;
  background-color: white;
  border-radius: 5px;
  border: 2px solid #26EC75;
  position: relative;
}

.retiro small{
  position: absolute;
  top: 1rem;
  right: 1rem;
}

.retiro h2{
  color: black;
  font-size: 500%;
}

.retiro div{
  width: 100%;
}

.devuelto{
  border: 2px solid #26EC75;
}

.pendiente{
  border: 2px solid #EC7C26;
}

.fuera{
  border: 2px solid #EC2626;
}

</style>
        
          </div>
          <!-- Fin de Retiros -->

        </div>
        <!-- Fin de Contenido -->

      </div>
      <!-- Fin de Contenedor -->

    </div>

    <!-- Footer -->
    <?php include_once("./Recursos/footer.php") ?>
    <!-- End of Footer -->

  </div>
  <!-- Fin de Pagina -->

  </div>

  <!-- Jquery -->
  <script src="./Recursos/vendor/jquery/jquery.min.js"></script>
  <script src="./Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>

  <!-- Bootstrap -->
  <script src="./Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    
  <!-- Generales -->
  <script src="./Recursos/js/Carga.js"></script>
  <script src="./Recursos/js/General.js?t=<?php echo time(); ?>"></script>
  
  <!-- Sweet2Alert -->
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.16/dist/sweetalert2.all.min.js"></script>

  <!-- Propios del archivo -->
  <script src="./Recursos/js/misRetiros.js?t=<?php echo time(); ?>"></script>
  <script>quitarLoader();</script>

</body>
</html>