<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('peliculas');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Películas</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="./Recursos/css/Estilos.css" rel="stylesheet">
  <link href="https://pagination.js.org/dist/2.6.0/pagination.css" rel="stylesheet">
  <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->
 
        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

          <!-- Contenido -->
          <div style="display:none" id="Contenido">

            <!-- Contenedor superior -->
            <div class="row text-center">

              <!-- Titulo -->
              <h2 class="col h4 mb-2 text-gray-800"><strong>Películas<br></strong></h2>

              <!-- Contenedor -->
              <div>

                <!-- Películas -->
                <div id="Peliculas" class="row row-cols-xl-4 g-4" style="justify-content:center">
              


                </div>
                <!-- Fin de Películas -->

              
              </div>
              <!-- Fin de Contenedor -->
            

            </div>
            <!-- Fin de Contenedor superior -->

          </div>
          <!-- Fin de Contenido -->

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

    <!-- Scripts -->
    <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>";</script>
    <script src="./Recursos/vendor/jquery/jquery.min.js"></script>
    <script src="./Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="./Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="./Recursos/js/General.js"></script>
    <script src="./Recursos/js/Carga.js?v2"></script>
    <script src="https://pagination.js.org/dist/2.6.0/pagination.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/js/select2.min.js"></script>
    <script>
    
// Obtenemos las peliculas
$.ajax({
  type: "GET",
  url: Url + "Api/Peliculas",
  data: {"Tipo": "obtenerPeliculas"},
  success: function(Datos, textStatus, xhr){
              
    // Establecemos los datos
    Datos = $.parseJSON(Datos);
  
    // Verificamos estado de la petición
    if(Datos['estado'] == 'exitoso'){

      for(var i = 0; i < Datos['detalle'].length; i++){
        var Generos = "";
        for(var a = 0; a < Datos['detalle'][i]['Generos'].length; a++){
          Generos += ` <span class='badge bg-primary'>${Datos['detalle'][i]['Generos'][a]}</span> `;
        }
        if(Datos['detalle'][i]['Generos'].length == 0){Generos = "";}
        $("#Peliculas").append(`<div onclick="window.location.href='${Url}pelicula/${Datos['detalle'][i]['Id']}'" class="col"><img style="width: 100%; border-radius: 10px" src="https://cdn-peliculas.sibau.com.ar/${Datos['detalle'][i]['Id']}/Portada.webp" data-bs-toggle="popover" data-bs-html="true" data-bs-trigger="hover focus" data-bs-title="${Datos['detalle'][i]['Titulo']}" data-bs-content="<b>Duración:</b> <i>${Datos['detalle'][i]['Duracion']}'</i><br><b>Calificación:</b> <i>${Datos['detalle'][i]['Calificacion']}</i><br><b>Genero:</b> <i>${Generos}</i><br><b>Resumen:</b> ${Datos['detalle'][i]['Resumen']}"></div>`);
      }

      $("[data-bs-toggle='popover']").popover();

      console.log(Datos);
      quitarLoader()
    }else if(Datos['estado'] == 'error'){
      errorLoader(`${Datos['detalle']} [${Datos['codigo']}]`);
    }else{
      errorLoader();
    }
  
  },
  error: function(){
    errorLoader();
  }
})
    
</script>

</body>
</html>