<?php

  // Importamos el sistema
  require("./sistema.php");

  // Indicamos que es necesario sesión
  seRequiereSesion('recursos-online');

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title SibauMulti="recursosOnline.tituloNavegador">SIBAU - Recursos en línea</title>

  <!-- FontAwesome -->
  <link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css">
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="./Recursos/css/Estilos.css?v2" rel="stylesheet">
  <link href="./Recursos/css/Recursos.css?v=<?php echo time(); ?>" rel="stylesheet">
  <link href="./Recursos/css/paginadorPropio.css?v1" rel="stylesheet">
  <style>
    .picker-dialog-bg{
      z-index: 1051!important;
    }

    .picker-dialog{
      z-index: 1051!important;
    }
  </style>

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

  <!-- Manifiesto -->
  <link rel="manifest" href="../manifest.json">
  <link rel="apple-touch-icon" href="https://sibau.com.ar/Recursos/Logo.png">
  <meta name="apple-mobile-web-app-status-bar" content="#F8F9FC">
  <meta name="theme-color" content="#4E73DF">

</head>
<body id="page-top">
  <div id="wrapper">

    <!-- Menu lateral -->
    <?php include_once("./Recursos/navLateral.php") ?>
    <!-- Fin de Menu lateral -->

    <!-- Pagina -->
    <div id="content-wrapper" class="d-flex flex-column">
      <div id="content">

        <!-- Menu superior -->
        <?php include_once("./Recursos/navSuperior.php") ?>
        <!-- Fin de Nav -->

        <!-- Contenedor -->
        <div class="container-fluid">

          <!-- Loader -->
          <div id="Loader"></div>
          <!-- Fin de Loader -->

          <!-- Contenido -->
          <div style="display:none" id="Contenido">

            <!-- Titulo -->
            <h2 class="titulo col h4 text-gray-800"><strong SibauMulti="recursosOnline.titulo"></strong> <small SibauMulti="recursosOnline.subtitulo"></small></h2>

            <!-- Contenedor superior -->
            <div style="display: flex; justify-content: flex-end" class="ContSuperior">

              <!-- Búsqueda -->
              <form id="BuscadorRecursos" class="d-sm-inline-block form-inline mr-auto ml-md-3 my-2 my-md-0 mw-100 navbar-search" style="width: 50%; margin: 0!important">
                <div style="border: 1px solid #4E73DF; border-radius: 0.35rem;" class="input-group">
                  <input type="text" class="form-control bg-light border-0 small" placeholder="Búsqueda de recursos..." aria-label="Search" aria-describedby="basic-addon2">
                  <div class="input-group-append">
                    <button class="btn btn-primary" type="button"><i class="fas fa-search fa-sm"></i></button>
                  </div>
                </div>
              </form>
              <!-- Fin de Búsqueda -->

              <!-- Botón -->
              <?php if($_SESSION['Permisos']['agregarRecursoOnline'] == true){ ?><button id="botonAñadirRecurso" onclick="añadirRecurso()" type="button" class="btn btn-primary" SibauMulti="recursosOnline.añadirRecurso">Añadir recurso</button><?php } ?>

              <!-- Categorias -->
              <select id="Categoria" class="form-select" style="width: 10rem; border: 2px solid #4e73df"></select>

            </div>
            <!-- Fin de Contenedor superior -->
            
            <!-- Paginas -->
            <style>pagina{margin-top: 1rem}</style>
            <paginas></paginas>

          </div>
          <!-- Fin de Contenido -->

        </div>
        <!-- Fin de Contenedor -->

      </div>

      <!-- Footer -->
      <?php include_once("./Recursos/footer.php") ?>
      <!-- End of Footer -->

    </div>
    <!-- Fin de Pagina -->

  </div>

  <!-- Jquery -->
  <script src="./Recursos/vendor/jquery/jquery.min.js"></script>
  <script src="./Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>

  <!-- Bootstrap -->
  <script src="./Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
    
  <!-- Generales -->
  <script src="./Recursos/js/Carga.js"></script>
  <script src="./Recursos/js/General.js?t=<?php echo time(); ?>"></script>
  
  <!-- Sweet2Alert -->
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.16/dist/sweetalert2.all.min.js"></script>

  <!-- Propios del archivo -->
  <script src="./Recursos/js/paginadorPropio.js?v3"></script>
  <script src="./Recursos/js/Recursos.js?v11<?php echo time() ?>"></script>
    
  <!-- Google Drive Api -->
  <script src="./Recursos/js/RecursosOnlineDrive.js?v11<?php echo time() ?>" onload="gapiLoaded()"></script>
  <script async defer src="https://apis.google.com/js/api.js" onload="gapiLoaded()"></script>
  <script async defer src="https://accounts.google.com/gsi/client" onload="gisLoaded()"></script>

  <script>

<?php if($_GET['Busqueda']){ ?>
  function idiomasEspeciales(){
    obtenerRecursos('<?php echo $_GET['Busqueda'] ?>');
    $(".ContSuperior #Categoria").append(`<option selected value="0">${obtenerItemIdioma("recursosOnline.categoria.0")}</option>`);
    for(var i = 0; i < Categorias.length; i++){
      $(".ContSuperior #Categoria").append(`<option value="${Categorias[i]}">${obtenerItemIdioma("recursosOnline.categoria." + Categorias[i])}</option>`);
    }
  } 
<?php }else{ ?> 
  function idiomasEspeciales(){
    obtenerRecursos();
    $(".ContSuperior #Categoria").append(`<option selected value="0">${obtenerItemIdioma("recursosOnline.categoria.0")}</option>`);
    for(var i = 0; i < Categorias.length; i++){
      $(".ContSuperior #Categoria").append(`<option value="${Categorias[i]}">${obtenerItemIdioma("recursosOnline.categoria." + Categorias[i])}</option>`);
    }
  } 
<?php } ?>

  </script>

</body>
</html>