<?php

  // Importamos el sistema
  require("./sistema.php");

?>
<!DOCTYPE html>
<html lang="es">
<head>

  <!-- UTF-8 -->
  <meta charset="utf-8">
  
  <!-- Edge -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  
  <!-- Responsive -->
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  
  <!-- Autor -->
  <meta name="author" content="Bautista Izaguirre">

  <!-- Titulo -->
  <title>SIBAU - Registro</title>

  <!-- FontAwesome -->
  <script src="https://kit.fontawesome.com/7eb8e89503.js" crossorigin="anonymous"></script>
  
  <!-- Fonts -->
  <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">

  <!-- Estilos -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <link href="./Recursos/css/Estilos.css" rel="stylesheet">
  <link href="./Recursos/css/Registro.css" rel="stylesheet">

  <!-- Icono -->
  <link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg">

</head>
<body class="bg-gradient-primary">
  <div class="container">
    <div class="card o-hidden border-0 shadow-lg my-5">
      <div class="card-body p-0">

        <!-- Paso 1 -->
        <div class="row Paso" paso="1">
          <div class="col-lg-5 d-none d-lg-block bg-register-image"></div>
          <div class="col-lg-7">
            <div class="p-5" style="position: relative">
              <p style="position: absolute; bottom: 1rem; right: 1rem; margin: 0; color: #cfcfcf;"><?php echo obtenerVersion(); ?></p>

              <!-- Titulo -->
              <div class="text-center mb-4">
                <h1 class="h4 text-gray-900 mb-0">¡Crea una cuenta!</h1>
                <i>Paso 1: Datos básicos</i>
              </div>

              <!-- Nombre -->
              <div class="form-group">
                <input type="text" class="form-control form-control-user Redondeado" id="Nombre" name="Nombre" placeholder="Nombre">
                <div id="ErrorNombre"></div>
              </div>

              <!-- Apellido -->
              <div class="form-group">
                <input type="text" class="form-control form-control-user Redondeado" id="Apellido" name="Apellido" placeholder="Apellido">
                <div id="ErrorApellido"></div>
              </div>

              <!-- DNI -->
              <div class="form-group">
                <input type="number" class="form-control form-control-user Redondeado" id="DNI" name="DNI" placeholder="Documento Nacional de Identidad">
                <div id="ErrorDNI"></div>
              </div>

              <!-- Instituciones -->
              <div class="form-group">
                <select name="Institucion" id="Institucion" class="form-select form-control-user Redondeado" style="padding: 1rem 0.75rem!important; color: #6e707e">
                  <option value="2">Escuela de Educación Secundaria Técnica N°1 de Vicente López</option>
                </select>
                <div id="ErrorInstitucion"></div>
              </div>
              
              <!-- Seleccion pagina -->
              <div style="display: flex; justify-content: flex-end">
                <div onclick="cambiarPagina('2')" style="padding-left: 1rem; width: 50%;"><button class="btn btn-primary btn-user btn-block BotonesPaginadores">Siguiente</button></div>
              </div>
              
              <hr>

              <!-- Links -->
              <div class="text-center">
                <a class="small" href="<?php echo $Configuracion['URL']['Panel'] ?>ingresar">¿Ya tienes una cuenta? ¡Ingresa!</a>
              </div>

            </div>
          </div>
        </div>
        <!-- Fin de Paso 1 -->

        <!-- Paso 2 -->
        <div class="row Paso" style="display:none" paso="2">
          <div class="col-lg-5 d-none d-lg-block bg-register-image"></div>
          <div class="col-lg-7">
            <div class="p-5" style="position: relative">
              <p style="position: absolute; bottom: 1rem; right: 1rem; margin: 0; color: #cfcfcf;"><?php echo obtenerVersion(); ?></p>

              <!-- Titulo -->
              <div class="text-center mb-4">
                <h1 class="h4 text-gray-900 mb-0">¡Crea una cuenta!</h1>
                <i>Paso 2: Datos de inicio de sesión</i>
              </div>

              <!-- Correo -->
              <div class="form-group">
                <input type="email" class="form-control form-control-user Redondeado" id="Correo" name="Correo" placeholder="Correo electronico">
                <div id="ErrorCorreo"></div>
              </div>

              <!-- Contraseña -->
              <div class="form-group">
                <input type="password" class="form-control form-control-user Redondeado" id="Contraseña" name="Contraseña" placeholder="Contraseña">
                <div id="ErrorContraseña"></div>
              </div>

              <!-- Repetir Contraseña -->
              <div class="form-group">
                <input type="password" class="form-control form-control-user Redondeado" id="RepetirContraseña" name="RepetirContraseña" placeholder="Repetir contraseña">
                <div id="ErrorRepetirContraseña"></div>
              </div>
              
              <!-- Seleccion pagina -->
              <div style="display: flex; justify-content: flex-end">
                <div onclick="cambiarPagina('1')" style="padding-left: 1rem; width: 50%;"><button class="btn btn-primary btn-user btn-block BotonesPaginadores">Atras</button></div>
                <div onclick="cambiarPagina('3')" style="padding-left: 1rem; width: 50%;"><button class="btn btn-primary btn-user btn-block BotonesPaginadores">Siguiente</button></div>
              </div>
              
              <hr>

              <!-- Links -->
              <div class="text-center">
                <a class="small" href="<?php echo $Configuracion['URL']['Panel'] ?>ingresar">¿Ya tienes una cuenta? ¡Ingresa!</a>
              </div>
              
            </div>
          </div>
        </div>
        <!-- Fin de Paso 2 -->

        <!-- Paso 3 -->
        <div class="row Paso" style="display:none" paso="3">
          <div class="col-lg-5 d-none d-lg-block bg-register-image"></div>
          <div class="col-lg-7">
            <div class="p-5" style="position: relative">
              <p style="position: absolute; bottom: 1rem; right: 1rem; margin: 0; color: #cfcfcf;"><?php echo obtenerVersion(); ?></p>

              <!-- Titulo -->
              <div class="text-center mb-4">
                <h1 class="h4 text-gray-900 mb-0">¡Crea una cuenta!</h1>
                <i>Paso 3: Personaliza tu perfil</i>
              </div>

              <!-- Usuario -->
              <div class="form-group">
                <input type="text" class="form-control form-control-user Redondeado" id="Usuario" name="Usuario" placeholder="Nombre de usuario">
              </div>

              <!-- Genero -->
              <div class="form-group">
                <select name="Genero" id="Genero" class="form-select form-control-user Redondeado" style="padding: 1rem 0.75rem!important; color: #6e707e">
                  <option disabled selected>Genero</option>
                  <option>Sin especificar</option>
                  <option>Masculino</option>
                  <option>Femenino</option>
                  <option>Otro</option>
                </select>
              </div>

              <!-- Telefono -->
              <div class="form-group">
                <input type="tel" class="form-control form-control-user Redondeado" id="Telefono" name="Telefono" placeholder="Telefono [OPCIONAL]">
              </div>
              
              <!-- Seleccion pagina -->
              <div style="display: flex; justify-content: flex-end">
                <div onclick="cambiarPagina('2')" style="padding-left: 1rem; width: 50%;"><button class="btn btn-primary btn-user btn-block BotonesPaginadores">Atras</button></div>
                <div onclick="cambiarPagina('4')" style="padding-left: 1rem; width: 50%;"><button class="btn btn-primary btn-user btn-block BotonesPaginadores">Siguiente</button></div>
              </div>
              
              <hr>

              <!-- Links -->
              <div class="text-center">
                <a class="small" href="<?php echo $Configuracion['URL']['Panel'] ?>ingresar">¿Ya tienes una cuenta? ¡Ingresa!</a>
              </div>
              
            </div>
          </div>
        </div>
        <!-- Fin de Paso 3 -->

        <div id="Perfil" class="row Paso" paso="4" style="display: none">
          <div class="col-lg-5 d-none d-lg-block" style="justify-content: center; border-right: 1px solid rgba(0, 0, 0, 0.1); display: flex!important; align-items: center">
            <img style="padding: 5rem" id="ImagenDePerfil" src="https://desarrollo.sibau.com.ar/Api/imagenDePerfil?ColorPiel=fac8b3&TipoPelo=2&ColorRemera=ffffff&ColorPelo=333333">
          </div>
          <div class="col-lg-7">
            <div class="p-5">
              <div class="text-center">
                <h1 class="h4 text-gray-900 mb-0">¡Crea una cuenta!</h1>
                <i class="mb-4">Paso 4: Personaliza tu imagen de perfil</i>
              </div>

              
                <label for="Pelo" class="form-label">Pelo</label>
                <div class="form-group">
                  <select class="form-select" id="TipoPelo">
                    <option value="2">Pelo #2</option>
                    <option disabled>Luego podrás canjear mas pelos y accesorios.</option>
                  </select>
                </div>

                <label for="Pelo" class="form-label">Color de pelo</label>
                <div class="form-group row" style="align-items: center">
                  <div class="col-10"><input type="color" class="form-control form-control-user" id="Pelo" name="Pelo" value="#333333"></div>
                  <div class="col-2" style="margin: auto">
                    <div class="form-check">
                      <input class="form-check-input" type="checkbox" value="" id="Calvo">
                      <label class="form-check-label" for="Calvo">Calvo</label>
                    </div>
                  </div>
                </div>

                <label for="Piel" class="form-label">Color de piel</label>
                <div class="form-group">
                  <input type="color" class="form-control form-control-user" id="Piel" name="Piel" value="#FAC8B3">
                </div>

                <label for="Remera" class="form-label">Color de remera</label>
                <div class="form-group">
                  <input type="color" class="form-control form-control-user" id="Remera" name="Remera" value="#FFFFFF">
                </div>

                <div class="text-center">
                  <p onclick="generarPersonaje()" style="color: #64C16D; transform: rotate(360deg); transition-duration: 1s;"><i class="fa-solid fa-arrows-rotate"></i> Generar aleatoriamente</p>
                </div>

              <!-- Seleccion pagina -->
              <div style="display: flex; justify-content: flex-end">
                <div onclick="cambiarPagina('3')" style="padding-left: 1rem; width: 50%;"><button class="btn btn-primary btn-user btn-block BotonesPaginadores">Atras</button></div>
                <div style="padding-left: 1rem; width: 50%;"><button class="btn btn-primary btn-user btn-block BotonesPaginadores" id="Registrarse">Registrarme</button></div>
              </div>

              <div class="text-center mt-1">
                <a class="small" style="color: #898996">Al hacer click en "Registrarme" aceptas los terminos de uso y condiciones de <img style="width: 11.2px" src="https://sibau.com.ar/Recursos/Logo.svg"> SIBAU<small>©</small></a>
              </div>


              <hr>

              <div class="text-center">
                <a class="small" href="<?php echo $Configuracion['URL']['Panel'] ?>ingresar">¿Ya tienes una cuenta? ¡Ingresa!</a>
              </div>
            </div>
          </div>


        </div>
      </div>
    </div>
  </div>

    <style>
  
    @media screen and (max-width: 1000px) {

      #Confirmacion .ladoDerecho{
        flex: 0 0 100%;
        max-width: 100%;
      }

      #Confirmacion .ladoIzquierdo{
        display: none;
      }

    }
  
  </style>

  <!-- Confirmacion -->
  <div class="modal fade" data-bs-backdrop="static" data-bs-keyboard="false" id="Confirmacion" tabindex="-1" aria-hidden="true" data-backdrop="static" data-keyboard="false">
    <div class="modal-dialog modal-xl">
      <div class="modal-content">
        <div class="modal-body row text-center" style="align-items: center">
          <div class="col-6 ladoIzquierdo" style="padding: 5rem"><img style="width: 100%" src="<?php echo $Configuracion['URL']['Panel'] ?>Recursos/img/undraw_mail_re_duel.svg"></div>
          <div class="col-6 ladoDerecho" style="padding: 5rem"><h3 class="mb-3"><strong>Tu cuenta fue creada con exito</strong></h3><p>Te has registrado de forma exitosa, ahora ve a tu correo electronico y confirma la cuenta en el mail que te acabamos de enviar.</p><button onclick="window.location.href='<?php echo $Configuracion['URL']['Panel'] ?>ingresar'" class="btn btn-primary btn-user btn-block BotonesPaginadores">Ya he verificado mi correo, ingresar</button></div>
        </div>
      </div>
    </div>
  </div>

  <!-- Scripts -->
  <script>var Url = "<?php echo $Configuracion['URL']['Panel'] ?>"; ApiUrl = "<?php echo $Configuracion['URL']['Panel'] ?>Api/";</script>
  <script src="./Recursos/vendor/jquery/jquery.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
  <script src="./Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
  <script src="./Recursos/vendor/jquery-easing/jquery.easing.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.6.15/dist/sweetalert2.all.min.js"></script>
  <script src="./Recursos/js/General.js"></script>
  <script src="./Recursos/js/Registro.js?GEN"></script>

  <script>
/*
    

    $("#FormularioRegistro").on("submit",function(e){

      // Evitamos que se envie el formulario
      e.preventDefault();

      // Deshabilitamos el Botón y cambiamos el texto.
      deshabilitarBotón()

      // Borramos los errores anteriores
      $("#error-form").remove();

      // Verificamos si el nombre esta vació
      if($("#FormularioRegistro #Nombre").val() == null || $("#FormularioRegistro #Nombre").val().length == 0 || /^\s+$/.test($("#FormularioRegistro #Nombre").val())){
        document.getElementById("RegistroNombre").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
        habilitarBotón();

      // Verificamos si el apellido esta vació
      }else if($("#FormularioRegistro #Apellido").val() == null || $("#FormularioRegistro #Apellido").val().length == 0 || /^\s+$/.test($("#FormularioRegistro #Apellido").val())){
        document.getElementById("RegistroApellido").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
        habilitarBotón();

      // Verificamos si el Documento esta vació
      }else if($("#FormularioRegistro #Documento").val() == null || $("#FormularioRegistro #Documento").val().length == 0 || /^\s+$/.test($("#FormularioRegistro #Documento").val())){
        document.getElementById("RegistroDocumento").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
        habilitarBotón();

      // Verificamos si el Usuario esta vació
      }else if($("#FormularioRegistro #Usuario").val() == null || $("#FormularioRegistro #Usuario").val().length == 0 || /^\s+$/.test($("#FormularioRegistro #Usuario").val())){
        document.getElementById("RegistroUsuario").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
        habilitarBotón();

      // Verificamos si el Correo esta vació
      }else if($("#FormularioRegistro #Correo").val() == null || $("#FormularioRegistro #Correo").val().length == 0 || /^\s+$/.test($("#FormularioRegistro #Correo").val())){
        document.getElementById("RegistroCorreo").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
        habilitarBotón();

      // Verificamos si la Contraseña esta vació
      }else if($("#FormularioRegistro #Contraseña").val() == null || $("#FormularioRegistro #Contraseña").val().length == 0 || /^\s+$/.test($("#FormularioRegistro #Contraseña").val())){
        document.getElementById("RegistroContraseña").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
        habilitarBotón();

      // Verificamos si la Confirmación de contraseña esta vació
      }else if($("#FormularioRegistro #ContraseñaConfirmación").val() == null || $("#FormularioRegistro #ContraseñaConfirmación").val().length == 0 || /^\s+$/.test($("#FormularioRegistro #ContraseñaConfirmación").val())){
        document.getElementById("RegistroContraseñaConfirmación").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
        habilitarBotón();

      // Verificamos que el Nombre cumpla con los requisitos
      }else if($("#FormularioRegistro #Nombre").val().length < 3 || $("#FormularioRegistro #Nombre").val().length > 20 || !/^([A-Z ])*$/.test($("#Nombre").val().toUpperCase())){
        document.getElementById("RegistroNombre").innerHTML += "<a id='error-form' data-bs-toggle='modal' data-bs-target='#Requisitos'>* Este campo no es valido. <i class='fa-solid fa-circle-info'></i></a>";
        habilitarBotón();

      // Verificamos que el Apellido cumpla con los requisitos
      }else if($("#FormularioRegistro #Apellido").val().length < 3 || $("#FormularioRegistro #Apellido").val().length > 50 || !/^([A-Z ])*$/.test($("#Nombre").val().toUpperCase())){
        document.getElementById("RegistroApellido").innerHTML += "<a id='error-form' data-bs-toggle='modal' data-bs-target='#Requisitos'>* Este campo no es valido. <i class='fa-solid fa-circle-info'></i></a>";
        habilitarBotón();

      // Verificamos que el Documento cumpla con los requisitos
      }else if($("#FormularioRegistro #Documento").val().length < 7 || $("#FormularioRegistro #Documento").val().length > 8 || !/^([0-9])*$/.test($("#Documento").val().toUpperCase())){
        document.getElementById("RegistroDocumento").innerHTML += "<a id='error-form' data-bs-toggle='modal' data-bs-target='#Requisitos'>* Este campo no es valido. <i class='fa-solid fa-circle-info'></i></a>";
        habilitarBotón();

      // Verificamos que el Usuario cumpla con los requisitos
      }else if($("#FormularioRegistro #Usuario").val().length < 5 || $("#FormularioRegistro #Usuario").val().length > 20 || !/^([0-9A-Z])*$/.test($("#Usuario").val().toUpperCase())){
        document.getElementById("RegistroUsuario").innerHTML += "<a id='error-form' data-bs-toggle='modal' data-bs-target='#Requisitos'>* Este campo no es valido. <i class='fa-solid fa-circle-info'></i></a>";
        habilitarBotón();

      // Verificamos que el Correo Electrónico cumpla con los requisitos
      }else if(!/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test($("#Correo").val().toUpperCase())){
        document.getElementById("RegistroCorreo").innerHTML += "<a id='error-form' data-bs-toggle='modal' data-bs-target='#Requisitos'>* Este campo no es valido. <i class='fa-solid fa-circle-info'></i></a>";
        habilitarBotón();

      // Verificamos que la Contraseña cumpla con los requisitos
      }else if($("#FormularioRegistro #Contraseña").val().length < 6 || $("#FormularioRegistro #Contraseña").val().length > 50 || !/[A-Z]/.test($("#FormularioRegistro #Contraseña").val()) || !/[a-z]/.test($("#FormularioRegistro #Contraseña").val()) || !/[0-9]/.test($("#FormularioRegistro #Contraseña").val())){
        document.getElementById("RegistroContraseña").innerHTML += "<a id='error-form' data-bs-toggle='modal' data-bs-target='#Requisitos'>* Este campo no es valido. <i class='fa-solid fa-circle-info'></i></a>";
        habilitarBotón();

      // Verificamos que la Confirmación de contraseña cumpla con los requisitos
      }else if($("#FormularioRegistro #ContraseñaConfirmación").val() !== $("#FormularioRegistro #Contraseña").val()){
        document.getElementById("RegistroContraseñaConfirmación").innerHTML += "<a id='error-form'>* No coincide con la contraseña</a>";
        habilitarBotón();

      }else{
        
        // Elevamos la petición al servidor Institucional.
        $.ajax({
          type: "POST",
          url: '<?php echo $Configuracion['URL']['Servidor']; ?>crearUsuario',
          data: $("#FormularioRegistro").serialize(),
          success: function(Respuesta){
            
            Respuesta = JSON.parse(Respuesta);

            if(Respuesta['detalle'] == 'Nombre-Vacio'){
              document.getElementById("RegistroNombre").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Apellido-Vacio'){
              document.getElementById("RegistroApellido").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Documento-Vacio'){
              document.getElementById("RegistroDocumento").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Usuario-Vacio'){
              document.getElementById("RegistroUsuario").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Correo-Vacio'){
              document.getElementById("RegistroCorreo").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Contraseña-Vacio'){
              document.getElementById("RegistroContraseña").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'ConfirmarContraseña-vacio'){
              document.getElementById("RegistroContraseñaConfirmación").innerHTML += "<a id='error-form'>* Este campo no puede estar vació.</a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Nombre-requisitos'){
              document.getElementById("RegistroNombre").innerHTML += "<a id='error-form' data-bs-toggle='modal' data-bs-target='#Requisitos'>* Este campo no es valido. <i class='fa-solid fa-circle-info'></i></a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Apellido-requisitos'){
              document.getElementById("RegistroApellido").innerHTML += "<a id='error-form' data-bs-toggle='modal' data-bs-target='#Requisitos'>* Este campo no es valido. <i class='fa-solid fa-circle-info'></i></a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Documento-requisitos'){
              document.getElementById("RegistroDocumento").innerHTML += "<a id='error-form' data-bs-toggle='modal' data-bs-target='#Requisitos'>* Este campo no es valido. <i class='fa-solid fa-circle-info'></i></a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Usuario-requisitos'){
              document.getElementById("RegistroUsuario").innerHTML += "<a id='error-form' data-bs-toggle='modal' data-bs-target='#Requisitos'>* Este campo no es valido. <i class='fa-solid fa-circle-info'></i></a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Contraseña-requisitos'){
              document.getElementById("RegistroContraseña").innerHTML += "<a id='error-form' data-bs-toggle='modal' data-bs-target='#Requisitos'>* Este campo no es valido. <i class='fa-solid fa-circle-info'></i></a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Interno'){
              const Toast=Swal.mixin({toast:!0,position:"top-end",showConfirmButton:!1,timer:3e3,timerProgressBar:!0,didOpen(e){e.addEventListener("mouseenter",Swal.stopTimer),e.addEventListener("mouseleave",Swal.resumeTimer)}});Toast.fire({icon:"error",title:"Hubo un error en la Central."});
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Institucion-Inexistente'){
              const Toast=Swal.mixin({toast:!0,position:"top-end",showConfirmButton:!1,timer:3e3,timerProgressBar:!0,didOpen(e){e.addEventListener("mouseenter",Swal.stopTimer),e.addEventListener("mouseleave",Swal.resumeTimer)}});Toast.fire({icon:"error",title:"La institucion es inexistente."});
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'InstitucionNoHabilitada'){
              const Toast=Swal.mixin({toast:!0,position:"top-end",showConfirmButton:!1,timer:3e3,timerProgressBar:!0,didOpen(e){e.addEventListener("mouseenter",Swal.stopTimer),e.addEventListener("mouseleave",Swal.resumeTimer)}});Toast.fire({icon:"error",title:"La institucion aun no se encuentra habilitada."});
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Dni-Duplicado'){
              document.getElementById("RegistroDocumento").innerHTML += "<a id='error-form'>* Este documento ya esta en uso.</a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Correo-Duplicado'){
              document.getElementById("RegistroCorreo").innerHTML += "<a id='error-form'>* Este correo ya esta en uso.</a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Usuario-Duplicado'){
              document.getElementById("RegistroUsuario").innerHTML += "<a id='error-form'>* Este usuario ya esta en uso.</a>";
              habilitarBotón();
            }else if(Respuesta['detalle'] == 'Contraseña-NoCoincide'){
              document.getElementById("RegistroContraseñaConfirmación").innerHTML += "<a id='error-form'>* Las contraseñas no son iguales.</a>";
              habilitarBotón();
            }else if(Respuesta['estado'] == "Exito"){
              deshabilitarBotón();
              $("#FormularioRegistro button").html('Te has registrado exitosamente');
              Swal.fire({
                icon: 'success',
                title: 'Te has registrado de forma exitosa.',
                allowOutsideClick: false,
                allowEscapeKey: false,
                allowEnterKey: false,
                showConfirmButton: false,
                text: 'Verifica tu correo electrónico, te hemos enviado un correo de confirmación. Abra el link que te enviamos para continuar en SIBAU',
              })
            }else{
              const Toast = Swal.mixin({
                toast: true,
                position: 'top-end',
                showConfirmButton: false,
                timer: 3000,
                timerProgressBar: true,
                didOpen: (toast) => {
                  toast.addEventListener('mouseenter', Swal.stopTimer)
                  toast.addEventListener('mouseleave', Swal.resumeTimer)
                }
              })

              Toast.fire({
                icon: 'error',
                title: 'Hubo un error desconocido.'
              })
              habilitarBotón();
              console.log(Respuesta);
            }


 
          },
          error: (function(){
            habilitarBotón();
            const Toast = Swal.mixin({
              toast: true,
              position: 'top-end',
              showConfirmButton: false,
              timer: 3000,
              timerProgressBar: true,
              didOpen: (toast) => {
                toast.addEventListener('mouseenter', Swal.stopTimer)
                toast.addEventListener('mouseleave', Swal.resumeTimer)
              }
            })

            Toast.fire({
              icon: 'error',
              title: 'Al parecer hubo un error en el servidor Institucional.'
            })

          })
       });

      }
        
    })*/
    
  </script>

  <div id="legal"><a data-bs-toggle="tooltip" data-bs-title="Todos los derechos reservados © <?php echo date('Y') ?> SIBAU. Diseñado y desarrollado por Bautista Izaguirre. Queda prohibida la reproducción total o parcial de este sitio web, su contenido, diseño y código fuente sin autorización expresa y por escrito de sus propietarios." class="small">Todos los derechos reservados © <?php echo date('Y') ?> SIBAU. Diseñado y desarrollado por Bautista Izaguirre.</a></div>

</body>
</html>