<?php 

/*********************************/
/*                               */
/* ARCHIVO DE CONFIGURACIONES DE */
/*             SIBAU             */
/*                               */
/*********************************/

/***********/
/* GENERAL */
/***********/

// Iniciamos sesión
session_set_cookie_params(604800);
session_start();

// Establecemos zona horaria
date_default_timezone_set("America/Argentina/Buenos_Aires");

// Establecemos encabezado
header("Access-Control-Allow-Origin: *");

// Verificamos si esta la sesión iniciada, en caso de estarlo establecemos el nombre de la institución
if(isset($_SESSION['Id'])){
  $Configuracion['Nombre'] = $_SESSION['InstitucionNombre'];
  $Configuracion['NombreAbreviado'] = $_SESSION['InstitucionAbreviado'];
}

// Establecemos url del Panel
$Configuracion['URL']['Panel'] = 'https://' . $_SERVER['HTTP_HOST'] . "/";

// Establecemos la versión del Software
$Configuracion['Versión'] = "v0.7.8";

// Establecemos variables utiles
$Fecha = date('Y-m-d H:i:s');
$IP = obtenerIP();





/*****************/
/* Base de datos */
/*****************/

require("BD.php");

// Establecemos las configuraciones de la institución
if(isset($_SESSION['Id'])){
  $Institución = $_SESSION['Institucion'];
  $ConfiguraciónFuncion = json_decode(mysqli_fetch_array(mysqli_query($Conexión, "SELECT Configuracion FROM `Instituciones` WHERE Id = $Institución"))[0], true);
}

/**********************************/
/* Configuración de Mantenimiento */
/**********************************/

$FuncionesMantenimeinto = array(
  false,
  true,
  false,
  false,
  false,
  false,
  false,
  false,
  false,
);

// Verificamos si quiere usar el DByPaass
if(isset($_GET['DByPaass'])){
  setcookie("DByPaass", $_GET['DByPaass']);
}

// Mostramos la pantalla de error si esta entrando al panel de desarrollo sin el DByPaass o si no esta usando la Aplicación.
if($_SERVER['HTTP_HOST'] == 'desarrollo.sibau.com.ar' AND $_SERVER['PHP_SELF'] !== "/Api/Aplicacion.php"){
  if($_COOKIE['DByPaass'] !== "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxMjM0NTY3ODkwIiwibmFtZSI6IkpvaG4gRG9lIiwiaWF0IjoxNTE2MjM5MDIyfQ.SflKxwRJSMeKKF2QT4fwpMeJf36POk6yJV_adQssw5c"){
    echo '<!DOCTYPE html><html lang="es"><head><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1,shrink-to-fit=no"><meta name="author" content="Bautista Izaguirre"><title>SIBAU - Servidor en desarrollo</title><script src="https://kit.fontawesome.com/7eb8e89503.js" crossorigin="anonymous"></script><link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet"><link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous"><link href="./Recursos/css/Estilos.css" rel="stylesheet"><link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg"><link rel="manifest" href="manifest.json"><link rel="apple-touch-icon" href="https://sibau.com.ar/Recursos/Logo.png"><meta name="apple-mobile-web-app-status-bar" content="#F8F9FC"><meta name="theme-color" content="#4E73DF"></head><body class="bg-gradient-primary"><style>@media (max-width:1000px){.S{width:100%!important}}</style><div class="container"><div class="row justify-content-center"><div class="col-xl-10 col-lg-12 col-md-9"><div class="card o-hidden border-0 shadow-lg my-5"><div class="card-body p-0"><div class="row"><div class="p-5"><div class="text-center S" style="width:50%;margin:auto"><h1 class="h4 text-gray-900 mb-4">¡Bienvenido de nuevo!</h1><a style="color:#000" href="">Lo sentimos, Acabas de acceder a un servidor de desarrollo!</a><div style="display:flex;margin-top:1.5rem;justify-content:center"><button type="submit" id="Boto" class="btn btn-primary btn-user btn-block">Ir al servidor de produccion</button></div></div></div></div></div></div></div></div></div><script>let l = document.getElementById("Boto").onclick = redireccionar;function redireccionar(){window.location.href = "https://panel.sibau.com.ar";}</script></body></html>';
    die();
  }
}





/***********************/
/* Funciones generales */
/***********************/

// Función: Se cierra sesión.
if(isset($_GET['Cierre'])){
  session_destroy();
  header("Location: " . $Configuracion['URL']['Panel'] . "ingresar.php");
}

// Función: Si ya tiene sesion y esta en ingreso o registro redireccionar.
if(isset($_SESSION['Id'])){
  if(substr($_SERVER['PHP_SELF'], strrpos($_SERVER['PHP_SELF'], '/')+1) == 'ingresar.php' OR substr($_SERVER['PHP_SELF'], strrpos($_SERVER['PHP_SELF'], '/')+1) == 'registro.php'){
    header("Location: " . $Configuracion['URL']['Panel']);
  }
}

// Función: Verifica si esta logeado, de lo contrario lo redirecciona al login.
function seRequiereSesion($Pagina){
  GLOBAL $Configuracion;
  if(!isset($_SESSION['Id'])){
    header("Location: " . $Configuracion['URL']['Panel'] . "ingresar?Despues=" . $Pagina);
    die();
  }
}

// Función: Verifica si el usuario tiene sesión iniciada, en caso contrario no deja usar la api.
function apiRequireSesion(){
  if(!isset($_SESSION['Id'])){
    $Respuesta['estado'] = 'error';
    $Respuesta['detalle'] = "Carece de credenciales válidas de autenticación para el recurso solicitado";
    $Respuesta['codigo'] = "API-401";
    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE));
    die();
  }
}

// Función: Verifica si el usuario tiene permisos requeridos.
if(!$_SESSION['PermisosActualizado']['Tiempo']){$_SESSION['PermisosActualizado']['Tiempo'] = $Fecha;}
if(!$_SESSION['PermisosActualizado']['Permisos']){if(isset($_SESSION['Id'])){$_SESSION['PermisosActualizado']['Permisos'] = $_SESSION['Permisos'];}else{$_SESSION['PermisosActualizado']['Permisos'] = array();}}
function verificarPermisos($Permiso){
  GLOBAL $Fecha;
  GLOBAL $_SESSION;
  GLOBAL $Conexión;
  if(isset($_SESSION['Id'])){
    if(strtotime($Fecha) - strtotime($_SESSION['PermisosActualizado']['Tiempo']) > 120) {
      $Resultado = mysqli_query($Conexión, "SELECT Permisos FROM `Usuarios` WHERE Id =" .  $_SESSION['Id']);
      if($Resultado){
        $_SESSION['PermisosActualizado']['Permisos'] = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);
        $_SESSION['PermisosActualizado']['Tiempo'] = $Fecha;
        if(isset($_SESSION['PermisosActualizado']['Permisos'][$Permiso]) AND ($_SESSION['PermisosActualizado']['Permisos'][$Permiso] == true OR $_SESSION['PermisosActualizado']['Permisos'][$Permiso] == 1 OR $_SESSION['PermisosActualizado']['Permisos'][$Permiso] == "1")){
          return true;
        }else{
          return false;
        }
      }else{
        return false;
      }
    }else{
      if(isset($_SESSION['PermisosActualizado']['Permisos'][$Permiso]) AND ($_SESSION['PermisosActualizado']['Permisos'][$Permiso] == true OR $_SESSION['PermisosActualizado']['Permisos'][$Permiso] == 1 OR $_SESSION['PermisosActualizado']['Permisos'][$Permiso] == "1")){
        return true;
      }else{
        return false;
      }
    }
  }else{
    return false;  
  }
}

// Función: Verifica si el usuario tiene permisos para acceder a la pagina.
function seRequirePermiso($Permiso){
  GLOBAL $Configuracion;
  GLOBAL $_SESSION;
  if(!verificarPermisos($Permiso)){
    http_response_code(403);
    header("Location: " . $Configuracion['URL']['Panel'] . "?error=Careces%20de%20permisos%20para%20acceder%20a%20ese%20sector.");
  }
}

// Función: Verificar si un link es seguro.
function linkSeguro($Url){
  $Links = array(
    'argentina.gob.ar' => array(
      'Seguro' => true,
      'Detalle' => 'Web oficial del estado argentina.'
    ),
    'sibau.com.ar' => array(
      'Seguro' => true,
      'Detalle' => 'SIBAU® Gestiones Bibliotecarias'
    ),
    'bautistaizaguirre.com' => array(
      'Seguro' => true,
      'Detalle' => 'Bautista Izaguirre, Desarrollador'
    )
  );
  
  if($Links[$Url]['Seguro'] == 1){
    return $Links[$Url]['Detalle'];
  }else{
    return '';
  }

}

// Función: Verifica que el texto introducido no contenga palabras malsonantes.
function verificarMalsonantes($Texto){
              
  $Malsonantes = array('PUTA', 'PUTO', 'PUT0', 'MOGÓLICO', 'MOGOLICO', 'IDIOTA', 'PELOTUDO', 'PELOTUDA', 'TROLO', 'TROLA', '卐', '卍', 'NAZI', 'NASI', 'NASHI', 'NASHE', 'MOGÓLICA', 'MOGOLICA', 'CONCHA', 'MIERDA', 'GEMIDO', 'GEMI2', 'IMBÉCIL', 'IMBECIL', 'CHOTO', 'CHOTA', 'PIJA', 'PINGO', 'PINGA', 'GIL', 'RETRASADO MENTAL', 'VISCO', 'BISCO', 'GORDO VIOLADO', 'FRACASADO', 'FRACASADA', 'NIGGA', 'PROSTITUTA', 'NOPOR', 'PORNO', 'FISURA', 'DROGADICTO', 'CHORRO', 'VIOLADOR', 'VIOLADORA', 'ABUSADOR', 'ABUSADORA', 'ACOSADOR', 'ACOSADORA', 'DROGADO', 'BOLUDO', 'BOLUDA', 'TARADO', 'TARADA', 'TANQUE DE COCACOLA', 'PORNOGRAFÍA', 'PORNOGRAFIA', 'PORONGA', 'PORRO', 'PROSTITUTO', 'LA RECONCHA DE TU MADRE Y LA DE TU HERMANA', 'PUTASOS', 'TARADITO', 'PUTITO', 'BOLUDITO', 'PELOTUDITO', 'FORRO', 'TARADITA', 'PUTITA', 'BOLUDITA', 'PELOTUDITA');
   
  foreach ($Malsonantes as $Insulto){
   
  if(preg_match("/$Insulto/i",$Texto)){
    return "Moderado";
  }}
  return "Exito";
}

// Función: Obtener la Ip del usuario.
function obtenerIP() {
  $Ip = '';
  if (getenv('HTTP_CLIENT_IP'))
    $Ip = getenv('HTTP_CLIENT_IP');
  else if(getenv('HTTP_X_FORWARDED_FOR'))
    $Ip = getenv('HTTP_X_FORWARDED_FOR');
  else if(getenv('HTTP_X_FORWARDED'))
    $Ip = getenv('HTTP_X_FORWARDED');
  else if(getenv('HTTP_FORWARDED_FOR'))
    $Ip = getenv('HTTP_FORWARDED_FOR');
  else if(getenv('HTTP_FORWARDED'))
    $Ip = getenv('HTTP_FORWARDED');
  else if(getenv('REMOTE_ADDR'))
    $Ip = getenv('REMOTE_ADDR');
  else
    $Ip = '0';
  return $Ip;
}

// Función: Obtiene la version del Software.
function obtenerVersion(){
  if($_SERVER['HTTP_HOST'] == "desarrollo.sibau.com.ar"){$GLOBALS["Configuracion"]['Versión'] .= "D";}
  return $GLOBALS["Configuracion"]['Versión'];
}

// Función: Guarda la acción realizada.
function guardarAccion($Usuario, $Tipo, $Detalles=null){

  $Fecha = $GLOBALS["Fecha"];

  /*
  
  1. Ingreso.
  2. Actualizar permisos.
  3. Ingreso con Google.
  4. Descargo Backup de Usuarios. 
  5. Ingreso con QR
  
  */

  if($Tipo == '1'){
    $Datos = json_encode(array("Ip" => obtenerIP(), "Navegador" => $_SERVER['HTTP_USER_AGENT']), JSON_UNESCAPED_UNICODE);
    mysqli_query($GLOBALS["Conexión"], "INSERT INTO `Usuarios__Acciones`(`IdUsuario`, `TipoDeAccion`, `Accion`, `Fecha`) VALUES ('$Usuario','1','$Datos','$Fecha')");
  }else if($Tipo == '2'){
    $Datos = json_encode(array("Ip" => obtenerIP(), "Navegador" => $_SERVER['HTTP_USER_AGENT'], "Detalles" => $Detalles), JSON_UNESCAPED_UNICODE);
    mysqli_query($GLOBALS["Conexión"], "INSERT INTO `Usuarios__Acciones`(`IdUsuario`, `TipoDeAccion`, `Accion`, `Fecha`) VALUES ('$Usuario','2','$Datos','$Fecha')");
  }else if($Tipo == '3'){
    $Datos = json_encode(array("Ip" => obtenerIP(), "Navegador" => $_SERVER['HTTP_USER_AGENT']));
    mysqli_query($GLOBALS["Conexión"], "INSERT INTO `Usuarios__Acciones`(`IdUsuario`, `TipoDeAccion`, `Accion`, `Fecha`) VALUES ('$Usuario','3','$Datos','$Fecha')");
  }else if($Tipo == '4'){
    $Datos = json_encode(array("Ip" => obtenerIP(), "Navegador" => $_SERVER['HTTP_USER_AGENT']));
    mysqli_query($GLOBALS["Conexión"], "INSERT INTO `Usuarios__Acciones`(`IdUsuario`, `TipoDeAccion`, `Accion`, `Fecha`) VALUES ('$Usuario','4','$Datos','$Fecha')");
  }else if($Tipo == '5'){
    $Datos = json_encode(array("Ip" => obtenerIP(), "Navegador" => $_SERVER['HTTP_USER_AGENT']));
    mysqli_query($GLOBALS["Conexión"], "INSERT INTO `Usuarios__Acciones`(`IdUsuario`, `TipoDeAccion`, `Accion`, `Fecha`) VALUES ('$Usuario','5','$Datos','$Fecha')");
  }
}

// Función: Obtiene la fecha y devuelve el tiempo transcurrido
function haceTiempo($Fecha){
  $timestamp = strtotime($Fecha);       
  $strTime = array("segundo", "minuto", "hora", "dia", "mes", "año");
  $length = array("60","60","24","30","12","10");
  $currentTime = time();
  if($currentTime >= $timestamp) {
    $diff = time()- $timestamp;
    for($i = 0; $diff >= $length[$i] && $i < count($length)-1; $i++) {
      $diff = $diff / $length[$i];
    }
    $diff = round($diff);
    return "Hace " . $diff . " " . $strTime[$i] . "(s)";
  }
}

// Función: Verifica si lo ingresado es el archivo actual
function verificarArchivoActual($Archivo){
  if(substr($_SERVER['PHP_SELF'], strrpos($_SERVER['PHP_SELF'], '/')+1) == $Archivo){
    return true;
  }else{
    return false;
  }
}

// Función: Obtener el archivo actual
function obtenerArchivoActual(){
  return substr($_SERVER['PHP_SELF'], strrpos($_SERVER['PHP_SELF'], '/')+1);
}

// Función: Verifica si la institución tiene habilitada una función.
function verificarFunción($Funcion){
  GLOBAL $ConfiguraciónFuncion;
  if($ConfiguraciónFuncion['Funciones'][$Funcion] == false OR $ConfiguraciónFuncion['Funciones'][$Funcion] == "false"){
    return false;
  }else if($ConfiguraciónFuncion['Funciones'][$Funcion] == true OR $ConfiguraciónFuncion['Funciones'][$Funcion] == "true"){
    return true;
  }else{
    return false;
  }
}

// Función: Verifica si la institución tiene habilitada la función, en caso de no tenerlo se predilección al inicio.
function verificarFunciónActual($Funcion){
  GLOBAL $ConfiguraciónFuncion;
  GLOBAL $Configuracion;
  GLOBAL $FuncionesMantenimeinto;
  if($FuncionesMantenimeinto[$Funcion] && $_SERVER['HTTP_HOST'] !== 'desarrollo.sibau.com.ar'){ ?>
    <!DOCTYPE html><html lang="es"><head><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1,shrink-to-fit=no"><meta name="author" content="Bautista Izaguirre"><title>SIBAU</title><link rel="stylesheet" href="https://site-assets.fontawesome.com/releases/v6.2.1/css/all.css"><link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet"><link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous"><link href="./Recursos/css/Estilos.css" rel="stylesheet"><link href="https://pagination.js.org/dist/2.6.0/pagination.css" rel="stylesheet"><link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet"><link rel="icon" href="https://sibau.com.ar/Recursos/Logo.svg"></head><body id="page-top"><div id="wrapper"> <?php include_once("./Recursos/navLateral.php") ?> <div id="content-wrapper" class="d-flex flex-column"><div id="content"> <?php include_once("./Recursos/navSuperior.php") ?> <div class="container-fluid"><div id="Loader"></div><div style="display:none" id="Contenido"><div class="row text-center"><h2 class="col h4 mb-2 text-gray-800"><strong>Función en mantenimiento<br></strong></h2><div><img class="mb-3 mt-3" style="width:50%" src="../Recursos/muyPronto.svg"><h5><b>Esta función se encuentra en mantenimiento, lamentamos los inconvenientes que esto pueda llegar a ocasionar.</b></h5></div></div></div></div></div> <?php include_once("./Recursos/footer.php") ?> </div></div><script>var Url="<?php echo $Configuracion['URL']['Panel'] ?>"</script><script src="./Recursos/vendor/jquery/jquery.min.js"></script><script src="./Recursos/vendor/bootstrap/js/bootstrap.bundle.min.js"></script><script src="./Recursos/vendor/jquery-easing/jquery.easing.min.js"></script><script src="./Recursos/js/General.js"></script><script src="./Recursos/js/Carga.js?v2"></script><script src="https://pagination.js.org/dist/2.6.0/pagination.js"></script><script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script><script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/js/select2.min.js"></script><script>quitarLoader()</script></body></html>
  <?php die(); }else{
    if($ConfiguraciónFuncion['Funciones'][$Funcion] == false OR $ConfiguraciónFuncion['Funciones'][$Funcion] == "false"){
      http_response_code(403);
      header("Location: " . $Configuracion['URL']['Panel'] . "?error=Esta%20funci%C3%B3n%20no%20esta%20habilitada%20para%20tu%20instituci%C3%B3n.");
    }
  }
}

// Función: Obtener el archivo actual
function verificarPermisosActualizados($Permiso){
  
  // Establecemos variables
  GLOBAL $Conexión;
  GLOBAL $_SESSION;
  $Usuario = $_SESSION['Id'];
  
  // Realizamos la petición
  $Sql = "SELECT `Permisos` FROM `Usuarios` WHERE Id = '$Usuario'";
  $Resultado = mysqli_query($Conexión, $Sql);

  // Verificamos estado de la petición
  if($Resultado){

    // Establecemos los datos
    $Datos = json_decode(mysqli_fetch_array($Resultado)['Permisos'], true);

    // Verificamos si el usuario tiene permisos
    if($Datos[$Permiso] == true){
      return true;
    }else{
      $Respuesta['estado'] = 'error';
      $Respuesta['detalle'] = 'Careces de permisos para para gestionar usuarios.';
      $Respuesta['codigo'] = 'API-403';
      print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
      return false;
    }

  }else{
    $Respuesta['estado'] = 'error';
    $Respuesta['detalle'] = 'Hubo un error interno';
    $Respuesta['codigo'] = 'API-194';
    print_r(json_encode($Respuesta, JSON_UNESCAPED_UNICODE)); 
    return false;
  }
}

// Función: Genera una notificación al usuario actual o a uno especifico.
function generarNotificación($Notificación, $Icono, $Usuario = null){

  GLOBAL $Fecha;
  GLOBAL $Conexión;

  // Verificar si hay usuario establecido
  if($Usuario == null){
    $Usuario = $_SESSION['Id'];
  }

  // Insertamos la notificación
  $Resultado = mysqli_query($Conexión, "INSERT INTO `Notificaciones`(`Usuario`, `Notificacion`, `Icono`, `Fecha`) VALUES ('$Usuario', '$Notificación', '$Icono', '$Fecha')");
  echo mysqli_error($Conexión);
}

?>